
#include <string.h>
#include <stdio.h>

#include "php.h"
#include "zend_extensions.h"
#include "zend_compile.h"
#include "zend_API.h"
#include "zend_ini.h"

/* export: #include "xcache.h" :export */
#include "xcache.h"
/* export: #include "mod_cacher/xc_cache.h" :export */
#include "mod_cacher/xc_cache.h"
/* export: #include "xcache/xc_shm.h" :export */
#include "xcache/xc_shm.h"
/* export: #include "xcache/xc_allocator.h" :export */
#include "xcache/xc_allocator.h"
#include "xcache/xc_const_string.h"
#include "xcache/xc_utils.h"
#include "util/xc_align.h"
#include "xc_processor.h"
#include "xcache_globals.h"

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
extern unsigned int zend_hash_canary;
#endif





















#undef NDEBUG
#include <assert.h>















































































































































































































































































































































































































































































































































































































































#ifndef NDEBUG
#	undef inline
#define inline
#endif

typedef zval *zval_ptr;
typedef zval *zval_ptr_nullable;
typedef char *xc_ztstring;
#ifdef ZEND_ENGINE_2_4
typedef zend_trait_alias *zend_trait_alias_ptr;
typedef zend_trait_precedence *zend_trait_precedence_ptr;
#endif
#ifdef ZEND_ENGINE_2_3
typedef int last_brk_cont_t;
#else
typedef zend_uint last_brk_cont_t;
#endif

typedef zend_uchar xc_zval_type_t;
typedef int xc_op_type;
typedef zend_uchar xc_opcode;
#ifdef IS_UNICODE
typedef UChar zstr_uchar;
#endif
typedef char  zstr_char;

#define MAX_DUP_STR_LEN 256
/* export: typedef struct _xc_processor_t xc_processor_t; :export {{{ */
struct _xc_processor_t {
	char *p;
	size_t size;
	HashTable strings;
	HashTable zvalptrs;
	zend_bool reference; /* enable if to deal with reference */
	zend_bool have_references;
	const xc_entry_php_t *entry_php_src;
	const xc_entry_php_t *entry_php_dst;
	const xc_entry_data_php_t *php_src;
	const xc_entry_data_php_t *php_dst;
	xc_shm_t                  *shm;
	xc_allocator_t            *allocator;
	const zend_class_entry *cache_ce;
	zend_ulong cache_class_index;

	const zend_op_array    *active_op_array_src;
	zend_op_array          *active_op_array_dst;
	const zend_class_entry *active_class_entry_src;
	zend_class_entry       *active_class_entry_dst;
	zend_uint                 active_class_index;
	zend_uint                 active_op_array_index;
	const xc_op_array_info_t *active_op_array_infos_src;

	zend_bool readonly_protection; /* wheather it's present */

#ifndef NDEBUG
		xc_stack_t allocsizes;
#endif

};
/* }}} */
/* export: typedef struct _xc_dasm_t { const zend_op_array *active_op_array_src; } xc_dasm_t; :export {{{ */
/* }}} */
/* {{{ memsetptr */

#ifndef NDEBUG
		static void *memsetptr(void *mem, void *content, size_t n)
{
	void **p = (void **) mem;
	void **end = (void **) ((char *) mem + n);
	while (p < end - sizeof(content)) {
		*p = content;
		p += sizeof(content);
	}
	if (p < end) {
		memset(p, -1, end - p);
	}
	return mem;
}

#endif

/* }}} */
#ifdef HAVE_XCACHE_DPRINT
static void xc_dprint_indent(int indent) /* {{{ */
{
	int i;
	for (i = 0; i < indent; i ++) {
		fprintf(stderr, "  ");
	}
}
/* }}} */
static void xc_dprint_str_len(const char *str, int len) /* {{{ */
{
	const unsigned char *p = (const unsigned char *) str;
	int i;
	for (i = 0; i < len; i ++) {
		if (p[i] < 32 || p[i] == 127) {
			fprintf(stderr, "\\%03o", (unsigned int) p[i]);
		}
		else {
			fputc(p[i], stderr);
		}
	}
}
/* }}} */
#endif
/* {{{ xc_zstrlen_char */
static inline size_t xc_zstrlen_char(const_zstr s)
{
	return strlen(ZSTR_S(s));
}
/* }}} */
#ifdef IS_UNICODE
/* {{{ xc_zstrlen_uchar */
static inline size_t xc_zstrlen_uchar(zstr s)
{
	return u_strlen(ZSTR_U(s));
}
/* }}} */
/* {{{ xc_zstrlen */
static inline size_t xc_zstrlen(int type, const_zstr s)
{
	return type == IS_UNICODE ? xc_zstrlen_uchar(s) : xc_zstrlen_char(s);
}
/* }}} */
#else
/* {{{ xc_zstrlen */
#define xc_zstrlen(dummy, s) xc_zstrlen_char(s)
/* }}} */
#endif
/* {{{ xc_calc_string_n */
 
#undef C_RELAYLINE
#define C_RELAYLINE

#ifndef NDEBUG
		
#undef C_RELAYLINE
#define C_RELAYLINE , __LINE__

#endif

static inline void xc_calc_string_n(xc_processor_t *processor, zend_uchar type, const_zstr str, long size 
#ifndef NDEBUG
		, int relayline
#endif
) {
	
	size_t realsize = UNISW(size, (type == IS_UNICODE) ? UBYTES(size) : size);
	long dummy = 1;

	if (realsize > MAX_DUP_STR_LEN) {
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(char) * realsize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (relayline));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(char) * realsize;
	
	
	
	
	
	

	}
	else if (zend_u_hash_add(&processor->strings, type, str, (uint) size, (void *) &dummy, sizeof(dummy), NULL) == SUCCESS) {
		/* new string */
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(char) * realsize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (relayline));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(char) * realsize;
	
	
	
	
	
	

	} 
	
#ifndef NDEBUG
		
		else {
					}
	
#endif

	
}
/* }}} */
/* {{{ xc_store_string_n */
 
static inline zstr xc_store_string_n(xc_processor_t *processor, zend_uchar type, const_zstr str, long size 
#ifndef NDEBUG
		, int relayline
#endif
) {
	
	size_t realsize = UNISW(size, (type == IS_UNICODE) ? UBYTES(size) : size);
	zstr ret, *pret;

	if (realsize > MAX_DUP_STR_LEN) {
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `ZSTR_V(ret)',`char',`realsize' at line %d\n", relayline);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(char) * realsize;
				if (expect != real) {
					fprintf(stderr, "mismatch `ZSTR_V(ret)',`char',`realsize' at line %d(was %lu): real %lu - expect %lu = %lu\n", relayline, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		ZSTR_V(ret) = (char *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(ZSTR_V(ret), (void *) (unsigned long) relayline, sizeof(char) * realsize);
#endif

			
		processor->p += sizeof(char) * realsize;

		
	
	
	
	
	

		memcpy(ZSTR_V(ret), ZSTR_V(str), realsize);
		return ret;
	}

	if (zend_u_hash_find(&processor->strings, type, str, (uint) size, (void **) &pret) == SUCCESS) {
		return *pret;
	}

	/* new string */
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `ZSTR_V(ret)',`char',`realsize' at line %d\n", relayline);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(char) * realsize;
				if (expect != real) {
					fprintf(stderr, "mismatch `ZSTR_V(ret)',`char',`realsize' at line %d(was %lu): real %lu - expect %lu = %lu\n", relayline, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		ZSTR_V(ret) = (char *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(ZSTR_V(ret), (void *) (unsigned long) relayline, sizeof(char) * realsize);
#endif

			
		processor->p += sizeof(char) * realsize;

		
	
	
	
	
	

	memcpy(ZSTR_V(ret), ZSTR_V(str), realsize);
	zend_u_hash_add(&processor->strings, type, str, (uint) size, (void *) &ret, sizeof(zstr), NULL);
	return ret;

	
}
/* }}} */
/* {{{ xc_get_class_num
 * return class_index + 1
 */
static zend_ulong xc_get_class_num(xc_processor_t *processor, zend_class_entry *ce) {
	zend_uint i;
	const xc_entry_data_php_t *php = processor->php_src;
	zend_class_entry *ceptr;

	if (processor->cache_ce == ce) {
		return processor->cache_class_index + 1;
	}
	for (i = 0; i < php->classinfo_cnt; i ++) {
		ceptr = CestToCePtr(php->classinfos[i].cest);
		if (ZCEP_REFCOUNT_PTR(ceptr) == ZCEP_REFCOUNT_PTR(ce)) {
			processor->cache_ce = ceptr;
			processor->cache_class_index = i;
			return i + 1;
		}
	}
	assert(0);
	return (zend_ulong) -1;
}

/* }}} */
/* {{{ xc_get_class */
#ifdef ZEND_ENGINE_2
static zend_class_entry *xc_get_class(xc_processor_t *processor, zend_ulong class_num) {
	/* must be parent or currrent class */
	assert(class_num <= processor->active_class_index + 1);
	return CestToCePtr(processor->php_dst->classinfos[class_num - 1].cest);
}
#endif

/* }}} */
#ifdef ZEND_ENGINE_2
/* fix method on store */
static void xc_fix_method(xc_processor_t *processor, zend_op_array *dst TSRMLS_DC) /* {{{ */
{
	zend_function *zf = (zend_function *) dst;
	zend_class_entry *ce = processor->active_class_entry_dst;
	const zend_class_entry *srcce = processor->active_class_entry_src;

	/* Fixing up the default functions for objects here since
	 * we need to compare with the newly allocated functions
	 *
	 * caveat: a sub-class method can have the same name as the
	 * parent~s constructor and create problems.
	 */

	if (zf->common.fn_flags & ZEND_ACC_CTOR) {
		if (!ce->constructor) {
			ce->constructor = zf;
		}
	}
	else if (zf->common.fn_flags & ZEND_ACC_DTOR) {
		ce->destructor = zf;
	}
	else if (zf->common.fn_flags & ZEND_ACC_CLONE) {
		ce->clone = zf;
	}
	else {
	
#ifdef IS_UNICODE
		if (UG(unicode)) {
#define SET_IF_SAME_NAME(member) \
			do { \
				if (srcce->member && u_strcmp(ZSTR_U(zf->common.function_name), ZSTR_U(srcce->member->common.function_name)) == 0) { \
					ce->member = zf; \
				} \
			} \
			while(0)

			
		SET_IF_SAME_NAME(__get);
		SET_IF_SAME_NAME(__set);
#ifdef ZEND_ENGINE_2_1
		SET_IF_SAME_NAME(__unset);
		SET_IF_SAME_NAME(__isset);
#endif
		SET_IF_SAME_NAME(__call);
#ifdef ZEND_CALLSTATIC_FUNC_NAME
		SET_IF_SAME_NAME(__callstatic);
#endif
#if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
		SET_IF_SAME_NAME(__tostring);
#endif
#if defined(ZEND_ENGINE_2_6)
		SET_IF_SAME_NAME(__debugInfo);
#endif
	
#undef SET_IF_SAME_NAME
		}
		else
#endif
		do {
#define SET_IF_SAME_NAME(member) \
			do { \
				if (srcce->member && strcmp(ZSTR_S(zf->common.function_name), ZSTR_S(srcce->member->common.function_name)) == 0) { \
					ce->member = zf; \
				} \
			} \
			while(0)

			
		SET_IF_SAME_NAME(__get);
		SET_IF_SAME_NAME(__set);
#ifdef ZEND_ENGINE_2_1
		SET_IF_SAME_NAME(__unset);
		SET_IF_SAME_NAME(__isset);
#endif
		SET_IF_SAME_NAME(__call);
#ifdef ZEND_CALLSTATIC_FUNC_NAME
		SET_IF_SAME_NAME(__callstatic);
#endif
#if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
		SET_IF_SAME_NAME(__tostring);
#endif
#if defined(ZEND_ENGINE_2_6)
		SET_IF_SAME_NAME(__debugInfo);
#endif
	
#undef SET_IF_SAME_NAME
		} while (0);

	

	}
}
/* }}} */
#endif
/* {{{ call op_array ctor handler */
extern zend_bool xc_have_op_array_ctor;
static void xc_zend_extension_op_array_ctor_handler(zend_extension *extension, zend_op_array *op_array TSRMLS_DC)
{
	if (extension->op_array_ctor) {
		extension->op_array_ctor(op_array);
	}
}
/* }}} */
/* {{{ field name checker */

#ifndef NDEBUG
		static int xc_check_names(const char *file, int line, const char *functionName, const char **assert_names, size_t assert_names_count, HashTable *done_names)
{
	int errors = 0;
	if (assert_names_count) {
		size_t i;
		Bucket *b;

		for (i = 0; i < assert_names_count; ++i) {
			if (!zend_u_hash_exists(done_names, IS_STRING, assert_names[i], (uint) strlen(assert_names[i]) + 1)) {
				fprintf(stderr
					, "Error: missing field at %s #%d %s : %s\n"
					, file, line, functionName
					, assert_names[i]
					);
				++errors;
			}
		}

		for (b = done_names->pListHead; b != NULL; b = b->pListNext) {
			int known = 0;
			for (i = 0; i < assert_names_count; ++i) {
				if (strcmp(assert_names[i], BUCKET_KEY_S(b)) == 0) {
					known = 1;
					break;
				}
			}
			if (!known) {
				fprintf(stderr
					, "Error: unknown field at %s #%d %s : %s\n"
					, file, line, functionName
					, BUCKET_KEY_S(b)
					);
				++errors;
			}
		}
	}
	return errors;
}

#endif

/* }}} */


/* export: xc_entry_var_t *xc_processor_store_xc_entry_var_t(xc_shm_t *shm, xc_allocator_t *allocator, xc_entry_var_t *src TSRMLS_DC); :export {{{ */
xc_entry_var_t *xc_processor_store_xc_entry_var_t(xc_shm_t *shm, xc_allocator_t *allocator, xc_entry_var_t *src TSRMLS_DC) {
	xc_entry_var_t *dst;
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	processor.reference = 1;
	processor.shm = shm;
	processor.allocator = allocator;

	
#ifndef NDEBUG
		xc_stack_init(&processor.allocsizes);
#endif


	/* calc size */ {
		zend_hash_init(&processor.strings, 0, NULL, NULL, 0);
		if (processor.reference) {
			zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
		}

		processor.size = 0;
		/* allocate */
		processor.size = ALIGN(processor.size + sizeof(src[0]));

		xc_calc_xc_entry_var_t(&processor, src TSRMLS_CC);
		if (processor.reference) {
			zend_hash_destroy(&processor.zvalptrs);
		}
		zend_hash_destroy(&processor.strings);
	}
	src->entry.size = processor.size;
	src->have_references = processor.have_references;

	
#ifndef NDEBUG
		xc_stack_reverse(&processor.allocsizes);
#endif

	/* store {{{ */
	{
		
#ifndef NDEBUG
		char *oldp;
#endif

		zend_hash_init(&processor.strings, 0, NULL, NULL, 0);
		if (processor.reference) {
			zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
		}

		/* allocator :) */
		processor.p = (char *) processor.allocator->vtable->malloc(processor.allocator, processor.size);
		if (processor.p == NULL) {
			dst = NULL;
			goto err_alloc;
		}
		
#ifndef NDEBUG
		oldp = processor.p;
#endif

		assert(processor.p == (char *) ALIGN(processor.p));

		/* allocate */
		dst = (xc_entry_var_t *) processor.p;
		processor.p = (char *) ALIGN(processor.p + sizeof(dst[0]));

		xc_store_xc_entry_var_t(&processor, dst, src TSRMLS_CC);
		
#ifndef NDEBUG
		 {
			size_t unexpected = processor.p - oldp;
			size_t expected = processor.size;
			if (unexpected != processor.size) {
				fprintf(stderr, "unexpected:%lu - expected:%lu = %ld != 0\n", (unsigned long) unexpected, (unsigned long) expected, (long) unexpected - expected);
				abort();
			}
		}
#endif

err_alloc:
		if (processor.reference) {
			zend_hash_destroy(&processor.zvalptrs);
		}
		zend_hash_destroy(&processor.strings);
	}
	/* }}} */

	
#ifndef NDEBUG
		xc_stack_destroy(&processor.allocsizes);
#endif


	return dst;
}
/* }}} */


/* export: xc_entry_php_t *xc_processor_store_xc_entry_php_t(xc_shm_t *shm, xc_allocator_t *allocator, xc_entry_php_t *src TSRMLS_DC); :export {{{ */
xc_entry_php_t *xc_processor_store_xc_entry_php_t(xc_shm_t *shm, xc_allocator_t *allocator, xc_entry_php_t *src TSRMLS_DC) {
	xc_entry_php_t *dst;
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	processor.reference = 1;
	processor.shm = shm;
	processor.allocator = allocator;

	
#ifndef NDEBUG
		xc_stack_init(&processor.allocsizes);
#endif


	/* calc size */ {
		zend_hash_init(&processor.strings, 0, NULL, NULL, 0);
		if (processor.reference) {
			zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
		}

		processor.size = 0;
		/* allocate */
		processor.size = ALIGN(processor.size + sizeof(src[0]));

		xc_calc_xc_entry_php_t(&processor, src TSRMLS_CC);
		if (processor.reference) {
			zend_hash_destroy(&processor.zvalptrs);
		}
		zend_hash_destroy(&processor.strings);
	}
	src->entry.size = processor.size;
	

	
#ifndef NDEBUG
		xc_stack_reverse(&processor.allocsizes);
#endif

	/* store {{{ */
	{
		
#ifndef NDEBUG
		char *oldp;
#endif

		zend_hash_init(&processor.strings, 0, NULL, NULL, 0);
		if (processor.reference) {
			zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
		}

		/* allocator :) */
		processor.p = (char *) processor.allocator->vtable->malloc(processor.allocator, processor.size);
		if (processor.p == NULL) {
			dst = NULL;
			goto err_alloc;
		}
		
#ifndef NDEBUG
		oldp = processor.p;
#endif

		assert(processor.p == (char *) ALIGN(processor.p));

		/* allocate */
		dst = (xc_entry_php_t *) processor.p;
		processor.p = (char *) ALIGN(processor.p + sizeof(dst[0]));

		xc_store_xc_entry_php_t(&processor, dst, src TSRMLS_CC);
		
#ifndef NDEBUG
		 {
			size_t unexpected = processor.p - oldp;
			size_t expected = processor.size;
			if (unexpected != processor.size) {
				fprintf(stderr, "unexpected:%lu - expected:%lu = %ld != 0\n", (unsigned long) unexpected, (unsigned long) expected, (long) unexpected - expected);
				abort();
			}
		}
#endif

err_alloc:
		if (processor.reference) {
			zend_hash_destroy(&processor.zvalptrs);
		}
		zend_hash_destroy(&processor.strings);
	}
	/* }}} */

	
#ifndef NDEBUG
		xc_stack_destroy(&processor.allocsizes);
#endif


	return dst;
}
/* }}} */


/* export: xc_entry_data_php_t *xc_processor_store_xc_entry_data_php_t(xc_shm_t *shm, xc_allocator_t *allocator, xc_entry_data_php_t *src TSRMLS_DC); :export {{{ */
xc_entry_data_php_t *xc_processor_store_xc_entry_data_php_t(xc_shm_t *shm, xc_allocator_t *allocator, xc_entry_data_php_t *src TSRMLS_DC) {
	xc_entry_data_php_t *dst;
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	processor.reference = 1;
	processor.shm = shm;
	processor.allocator = allocator;

	
#ifndef NDEBUG
		xc_stack_init(&processor.allocsizes);
#endif


	/* calc size */ {
		zend_hash_init(&processor.strings, 0, NULL, NULL, 0);
		if (processor.reference) {
			zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
		}

		processor.size = 0;
		/* allocate */
		processor.size = ALIGN(processor.size + sizeof(src[0]));

		xc_calc_xc_entry_data_php_t(&processor, src TSRMLS_CC);
		if (processor.reference) {
			zend_hash_destroy(&processor.zvalptrs);
		}
		zend_hash_destroy(&processor.strings);
	}
	src->size = processor.size;
	src->have_references = processor.have_references;
	

	
#ifndef NDEBUG
		xc_stack_reverse(&processor.allocsizes);
#endif

	/* store {{{ */
	{
		
#ifndef NDEBUG
		char *oldp;
#endif

		zend_hash_init(&processor.strings, 0, NULL, NULL, 0);
		if (processor.reference) {
			zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
		}

		/* allocator :) */
		processor.p = (char *) processor.allocator->vtable->malloc(processor.allocator, processor.size);
		if (processor.p == NULL) {
			dst = NULL;
			goto err_alloc;
		}
		
#ifndef NDEBUG
		oldp = processor.p;
#endif

		assert(processor.p == (char *) ALIGN(processor.p));

		/* allocate */
		dst = (xc_entry_data_php_t *) processor.p;
		processor.p = (char *) ALIGN(processor.p + sizeof(dst[0]));

		xc_store_xc_entry_data_php_t(&processor, dst, src TSRMLS_CC);
		
#ifndef NDEBUG
		 {
			size_t unexpected = processor.p - oldp;
			size_t expected = processor.size;
			if (unexpected != processor.size) {
				fprintf(stderr, "unexpected:%lu - expected:%lu = %ld != 0\n", (unsigned long) unexpected, (unsigned long) expected, (long) unexpected - expected);
				abort();
			}
		}
#endif

err_alloc:
		if (processor.reference) {
			zend_hash_destroy(&processor.zvalptrs);
		}
		zend_hash_destroy(&processor.strings);
	}
	/* }}} */

	
#ifndef NDEBUG
		xc_stack_destroy(&processor.allocsizes);
#endif


	return dst;
}
/* }}} */

/* export: xc_entry_php_t *xc_processor_restore_xc_entry_php_t(xc_entry_php_t *dst, const xc_entry_php_t *src TSRMLS_DC); :export {{{ */
xc_entry_php_t *xc_processor_restore_xc_entry_php_t(xc_entry_php_t *dst, const xc_entry_php_t *src TSRMLS_DC) {
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	xc_restore_xc_entry_php_t(&processor, dst, src TSRMLS_CC);

	return dst;
}
/* }}} */
/* export: xc_entry_data_php_t *xc_processor_restore_xc_entry_data_php_t(const xc_entry_php_t *entry_php, xc_entry_data_php_t *dst, const xc_entry_data_php_t *src, zend_bool readonly_protection TSRMLS_DC); :export {{{ */
xc_entry_data_php_t *xc_processor_restore_xc_entry_data_php_t(const xc_entry_php_t *entry_php, xc_entry_data_php_t *dst, const xc_entry_data_php_t *src, zend_bool readonly_protection TSRMLS_DC) {
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	processor.readonly_protection = readonly_protection;
	/* this function is used for php data only */
	if (src->have_references) {
		processor.reference = 1;
	}
	processor.entry_php_src = entry_php;

	if (processor.reference) {
		zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
	}
	xc_restore_xc_entry_data_php_t(&processor, dst, src TSRMLS_CC);
	if (processor.reference) {
		zend_hash_destroy(&processor.zvalptrs);
	}
	return dst;
}
/* }}} */
/* export: xc_entry_var_t *xc_processor_restore_xc_entry_var_t(xc_entry_var_t *dst, const xc_entry_var_t *src TSRMLS_DC); :export {{{ */
xc_entry_var_t *xc_processor_restore_xc_entry_var_t(xc_entry_var_t *dst, const xc_entry_var_t *src TSRMLS_DC) {
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	xc_restore_xc_entry_var_t(&processor, dst, src TSRMLS_CC);

	return dst;
}
/* }}} */
/* export: zval *xc_processor_restore_zval(zval *dst, const zval *src, zend_bool have_references TSRMLS_DC); :export {{{ */
zval *xc_processor_restore_zval(zval *dst, const zval *src, zend_bool have_references TSRMLS_DC) {
	xc_processor_t processor;

	memset(&processor, 0, sizeof(processor));
	processor.reference = have_references;

	if (processor.reference) {
		zend_hash_init(&processor.zvalptrs, 0, NULL, NULL, 0);
				zend_hash_add(&processor.zvalptrs, (char *)src, sizeof(src), (void*)&dst, sizeof(dst), NULL);
	}
	xc_restore_zval(&processor, dst, src TSRMLS_CC);
	if (processor.reference) {
		zend_hash_destroy(&processor.zvalptrs);
	}

	return dst;
}
/* }}} */
/* export: void xc_dprint(xc_entry_php_t *src, int indent TSRMLS_DC); :export {{{ */
#ifdef HAVE_XCACHE_DPRINT
void xc_dprint(xc_entry_php_t *src, int indent TSRMLS_DC) {
	
	xc_dprint_xc_entry_php_t(src, indent TSRMLS_CC);
}
#endif
/* }}} */



  /* {{{ Pre-declare */
 	  	 	void 	xc_calc_zval( 		 		xc_processor_t *processor, const zval * const src 		 		 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_calc_zval_ptr( 		 		xc_processor_t *processor, const zval_ptr * const src 		 		 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_calc_zval_ptr_nullable( 		 		xc_processor_t *processor, const zval_ptr_nullable * const src 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_calc_zend_op_array( 		 		xc_processor_t *processor, const zend_op_array * const src 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_calc_zend_class_entry( 		 		xc_processor_t *processor, const zend_class_entry * const src 		 		 		 		TSRMLS_DC 	); 	
#ifdef HAVE_XCACHE_CONSTANT
 	  	 	static void inline 	xc_calc_zend_constant( 		 		xc_processor_t *processor, const zend_constant * const src 		 		 		 		TSRMLS_DC 	); 	
#endif
 	  	 	void 	xc_calc_zend_function( 		 		xc_processor_t *processor, const zend_function * const src 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_calc_xc_entry_var_t( 		 		xc_processor_t *processor, const xc_entry_var_t * const src 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_calc_xc_entry_php_t( 		 		xc_processor_t *processor, const xc_entry_php_t * const src 		 		 		 		TSRMLS_DC 	); 	
#ifdef ZEND_ENGINE_2
 	  	 	static void inline 	xc_calc_zend_property_info( 		 		xc_processor_t *processor, const zend_property_info * const src 		 		 		 		TSRMLS_DC 	); 	
#endif
/* }}} */
#ifdef IS_CV

	
	

/* {{{ xc_calc_zend_compiled_variable */
	
 	  	 	static void inline 	xc_calc_zend_compiled_variable( 		 		xc_processor_t *processor, const zend_compiled_variable * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_compiled_variable*)NULL)->name) + sizeof(((zend_compiled_variable*)NULL)->name_len) + sizeof(((zend_compiled_variable*)NULL)->hash_value)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","hash_value" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(int,name_len) */

	assert(sizeof(int) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->name, src->name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,hash_value) */

	assert(sizeof(ulong) == sizeof(src->hash_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_compiled_variable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zend_uint */
	
 	  	 	static void inline 	xc_calc_zend_uint( 		 		xc_processor_t *processor, const zend_uint * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_uint), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_uint", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifndef ZEND_ENGINE_2

	
	

/* {{{ xc_calc_int */
	
 	  	 	static void inline 	xc_calc_int( 		 		xc_processor_t *processor, const int * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(int), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_int", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_calc_zend_try_catch_element */
	
 	  	 	static void inline 	xc_calc_zend_try_catch_element( 		 		xc_processor_t *processor, const zend_try_catch_element * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_try_catch_element*)NULL)->try_op) + sizeof(((zend_try_catch_element*)NULL)->catch_op) + sizeof(((zend_try_catch_element*)NULL)->finally_op) + sizeof(((zend_try_catch_element*)NULL)->finally_end)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "try_op","catch_op","finally_op","finally_end" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,try_op) */

	assert(sizeof(zend_uint) == sizeof(src->try_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_op", sizeof("try_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_op", sizeof("try_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,catch_op) */

	assert(sizeof(zend_uint) == sizeof(src->catch_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "catch_op", sizeof("catch_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "catch_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "catch_op", sizeof("catch_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->catch_op);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,finally_op) */

	assert(sizeof(zend_uint) == sizeof(src->finally_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_op", sizeof("finally_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_op", sizeof("finally_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,finally_end) */

	assert(sizeof(zend_uint) == sizeof(src->finally_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_end", sizeof("finally_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_end", sizeof("finally_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_end);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_try_catch_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zend_brk_cont_element */
	
 	  	 	static void inline 	xc_calc_zend_brk_cont_element( 		 		xc_processor_t *processor, const zend_brk_cont_element * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_brk_cont_element*)NULL)->start) + sizeof(((zend_brk_cont_element*)NULL)->cont) + sizeof(((zend_brk_cont_element*)NULL)->brk) + sizeof(((zend_brk_cont_element*)NULL)->parent)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "start","cont","brk","parent" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
		#ifdef ZEND_ENGINE_2_2
		
	/* PROCESS(int,start) */

	assert(sizeof(int) == sizeof(src->start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start", sizeof("start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start", sizeof("start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(int,cont) */

	assert(sizeof(int) == sizeof(src->cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cont", sizeof("cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cont", sizeof("cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cont);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,brk) */

	assert(sizeof(int) == sizeof(src->brk));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk", sizeof("brk"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk", sizeof("brk"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,parent) */

	assert(sizeof(int) == sizeof(src->parent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_brk_cont_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	
	

/* {{{ xc_calc_HashTable_zval_ptr */
	
 	  	 	static void inline 	xc_calc_HashTable_zval_ptr( 		 		xc_processor_t *processor, const HashTable * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
		
		
	

				
				Bucket *srcBucket;
		
		zend_bool first = 1;
				
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(Bucket*) * src->nTableSize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(Bucket*) * src->nTableSize;
	
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(char) * bucketsize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(char) * bucketsize;
	
	
	
	
	
	

			
			
			if (sizeof(void *) == sizeof(zval_ptr)) {
				
								
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  ((zval_ptr*)srcBucket->pData))[0]));
	

	

	xc_calc_zval_ptr(
		
		processor,   ((zval_ptr*)srcBucket->pData)
		
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof(( ((zval_ptr*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zval_ptr)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zval_ptr);
	
	
	
	
	
	


	

	xc_calc_zval_ptr(
		
		processor,  ((zval_ptr*)srcBucket->pData)
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}

			if (first) {
				
				first = 0;
			}

			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_HashTable_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	
	

/* {{{ xc_calc_HashTable_zend_function */
	
		/* export:  	  	 	void 	xc_calc_HashTable_zend_function( 		 		xc_processor_t *processor, const HashTable * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_HashTable_zend_function( 		 		xc_processor_t *processor, const HashTable * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
		
		
	

				
				Bucket *srcBucket;
		
		zend_bool first = 1;
				
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(Bucket*) * src->nTableSize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(Bucket*) * src->nTableSize;
	
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(char) * bucketsize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(char) * bucketsize;
	
	
	
	
	
	

			
			
			if (sizeof(void *) == sizeof(zend_function)) {
				
								
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_function) == sizeof((  ((zend_function*)srcBucket->pData))[0]));
	

	

	xc_calc_zend_function(
		
		processor,   ((zend_function*)srcBucket->pData)
		
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_function) == sizeof(( ((zend_function*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_function)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_function);
	
	
	
	
	
	


	

	xc_calc_zend_function(
		
		processor,  ((zend_function*)srcBucket->pData)
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}

			if (first) {
				
				first = 0;
			}

			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_function : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_HashTable_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2

	
	
	

/* {{{ xc_calc_HashTable_zend_property_info */
	
 	  	 	static void inline 	xc_calc_HashTable_zend_property_info( 		 		xc_processor_t *processor, const HashTable * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
		
		
	

				
				Bucket *srcBucket;
		
		zend_bool first = 1;
				
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(Bucket*) * src->nTableSize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(Bucket*) * src->nTableSize;
	
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(char) * bucketsize));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(char) * bucketsize;
	
	
	
	
	
	

			
			
			if (sizeof(void *) == sizeof(zend_property_info)) {
				
								
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof((  ((zend_property_info*)srcBucket->pData))[0]));
	

	

	xc_calc_zend_property_info(
		
		processor,   ((zend_property_info*)srcBucket->pData)
		
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof(( ((zend_property_info*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_property_info)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_property_info);
	
	
	
	
	
	


	

	xc_calc_zend_property_info(
		
		processor,  ((zend_property_info*)srcBucket->pData)
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}

			if (first) {
				
				first = 0;
			}

			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_HashTable_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif
#ifdef IS_CONSTANT_AST


	
	

/* {{{ xc_calc_zend_ast */
	
		/* export:  	  	 	void 	xc_calc_zend_ast( 		 		xc_processor_t *processor, const zend_ast * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_zend_ast( 		 		xc_processor_t *processor, const zend_ast * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_ast*)NULL)->kind) + sizeof(((zend_ast*)NULL)->children) + sizeof(((zend_ast*)NULL)->u)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "kind","children","u" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				zend_ushort i;
			
	/* PROCESS(zend_ushort,kind) */

	assert(sizeof(zend_ushort) == sizeof(src->kind));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "kind", sizeof("kind"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "kind"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "kind", sizeof("kind"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->kind);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_ushort,children) */

	assert(sizeof(zend_ushort) == sizeof(src->children));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "children", sizeof("children"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "children"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "children", sizeof("children"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->children);
	xc_autocheck_done_count ++;

#endif



	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


		
	
	

			if (src->kind == ZEND_CONST) {
				assert(src->u.val);
				
				
	
	/* STRUCT_P_EX(zval,dst->u.val,src->u.val,[],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src->u.val)[0]));
	

	

	xc_calc_zval(
		
		processor,   src->u.val
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}
			else {
				for (i = 0; i < src->children; ++i) {
					zend_ast *src_ast = (&src->u.child)[i];
					if (src_ast) {
						{
	
		size_t zend_ast_size = (src_ast->kind == ZEND_CONST)
		 ? sizeof(zend_ast) + sizeof(zval)
		 : sizeof(zend_ast) + sizeof(zend_ast *) * (src_ast->children - 1);
	

	
	
							
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (zend_ast_size));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += zend_ast_size;
	
	
	
	
	
	

							
	
	/* STRUCT_P_EX(zend_ast,(&dst->u.child)[i],src_ast,[],, ) */

	
	

	
	assert(sizeof(zend_ast) == sizeof((  src_ast)[0]));
	

	

	xc_calc_zend_ast(
		
		processor,   src_ast
		
		
		
		TSRMLS_CC
	);

	

	
	

						
	
}

						
					}
					else {
						
					}
				}
			}
		
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_ast", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zval */
	
		/* export:  	  	 	void 	xc_calc_zval( 		 		xc_processor_t *processor, const zval * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_zval( 		 		xc_processor_t *processor, const zval * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zval*)NULL)->value) + sizeof(((zval*)NULL)->refcount__gc) + sizeof(((zval*)NULL)->type) + sizeof(((zval*)NULL)->is_ref__gc)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","refcount__gc","type","is_ref__gc" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
				/* Variable information */
		
	
	

		switch ((Z_TYPE_P(src) & IS_CONSTANT_TYPE_MASK)) {
			case IS_LONG:
			case IS_RESOURCE:
			case IS_BOOL:
					
	/* PROCESS(long,value.lval) */

	assert(sizeof(long) == sizeof(src->value.lval));
		
	
	
	

	

				break;
			case IS_DOUBLE:
					
	/* PROCESS(double,value.dval) */

	assert(sizeof(double) == sizeof(src->value.dval));
		
	
	
	

	

				break;
			case IS_NULL:
				
				break;

			case IS_CONSTANT:
#ifdef IS_UNICODE
				if (UG(unicode)) {
					goto proc_unicode;
				}
#endif
			case IS_STRING:
#ifdef FLAG_IS_BC
			case FLAG_IS_BC:
#endif
					
	/* PROCESS(int,value.str.len) */

	assert(sizeof(int) == sizeof(src->value.str.len));
		
	
	
	

	

				
	/* PROC_STRING_L(value.str.val,value.str.len) */
 
	/* PROC_STRING_N(value.str.val,value.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->value.str.val == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->value.str.val), src->value.str.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

				break;
#ifdef IS_UNICODE
			case IS_UNICODE:
proc_unicode:
					
	/* PROCESS(int32_t,value.uni.len) */

	assert(sizeof(int32_t) == sizeof(src->value.uni.len));
		
	
	
	

	

				
	/* PROC_ZSTRING_L(1,value.uni.val,value.uni.len) */
 
	
	/* PROC_ZSTRING_N(1,value.uni.val,value.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->value.uni.val) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->value.uni.val, src->value.uni.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->value.uni.val) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->value.uni.val, src->value.uni.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

				break;
#endif

			case IS_ARRAY:
#ifdef IS_CONSTANT_ARRAY
			case IS_CONSTANT_ARRAY:
#endif
				assert(src->value.ht);
				
	
	/* STRUCT_P(HashTable,value.ht,HashTable_zval_ptr) */

	if (src->value.ht) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.ht'),SRC(`value.ht'),value.ht,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.ht)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(HashTable)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(HashTable);
	
	
	
	
	
	


	

	xc_calc_HashTable_zval_ptr(
		
		processor,  src->value.ht
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.ht == NULL);

	}
	

				break;

#ifdef IS_CONSTANT_AST
			case IS_CONSTANT_AST:
				assert(src->value.ast);
				{
	
		size_t zend_ast_size = (src->value.ast->kind == ZEND_CONST)
		 ? sizeof(zend_ast) + sizeof(zval)
		 : sizeof(zend_ast) + sizeof(zend_ast *) * (src->value.ast->children - 1);
	

	
	
	
	/* STRUCT_P(zend_ast,value.ast) */

	if (src->value.ast) {
		
		
	
	/* STRUCT_P_EX(zend_ast,DST(`value.ast'),SRC(`value.ast'),value.ast,) */

	
	

	
	assert(sizeof(zend_ast) == sizeof(( src->value.ast)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (zend_ast_size));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += zend_ast_size;
	
	
	
	
	
	


	

	xc_calc_zend_ast(
		
		processor,  src->value.ast
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.ast == NULL);

	}
	

	
}

				break;
#endif

			case IS_OBJECT:
				
				#ifndef ZEND_ENGINE_2
				
	
	/* STRUCT_P(zend_class_entry,value.obj.ce) */

	if (src->value.obj.ce) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`value.obj.ce'),SRC(`value.obj.ce'),value.obj.ce,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->value.obj.ce)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_class_entry)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_class_entry);
	
	
	
	
	
	


	

	xc_calc_zend_class_entry(
		
		processor,  src->value.obj.ce
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.obj.ce == NULL);

	}
	

				
	
	/* STRUCT_P(HashTable,value.obj.properties,HashTable_zval_ptr) */

	if (src->value.obj.properties) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.obj.properties'),SRC(`value.obj.properties'),value.obj.properties,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.obj.properties)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(HashTable)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(HashTable);
	
	
	
	
	
	


	

	xc_calc_HashTable_zval_ptr(
		
		processor,  src->value.obj.properties
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.obj.properties == NULL);

	}
	

#endif
				break;

			default:
				assert(0);
		}
		
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(xc_zval_type_t,type) */

	assert(sizeof(xc_zval_type_t) == sizeof(src->type));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uchar,is_ref__gc) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref__gc));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref__gc", sizeof("is_ref__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref__gc", sizeof("is_ref__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref__gc);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_uchar,is_ref) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref", sizeof("is_ref"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref", sizeof("is_ref"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uint,refcount__gc) */

	assert(sizeof(zend_uint) == sizeof(src->refcount__gc));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount__gc", sizeof("refcount__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount__gc", sizeof("refcount__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount__gc);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2)
			
	/* PROCESS(zend_uint,refcount) */

	assert(sizeof(zend_uint) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_ushort,refcount) */

	assert(sizeof(zend_ushort) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zval", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_zval_ptr */
	
 	  	 	static void inline 	xc_calc_zval_ptr( 		 		xc_processor_t *processor, const zval_ptr * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
		do {
			
				if (processor->reference) {
					zval_ptr *ppzv;
					if (zend_hash_find(&processor->zvalptrs, (char *) &src[0], sizeof(src[0]), (void **) &ppzv) == SUCCESS) {
						
						processor->have_references = 1;
						
						
						break;
					}
				}
			
			
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zval)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zval);
	
	
	
	
	
	

			
				if (processor->reference) {
					
						/* make dummy */
						zval_ptr pzv = (zval_ptr)-1;
					
					if (zend_hash_add(&processor->zvalptrs, (char *) &src[0], sizeof(src[0]), (void *) &pzv, sizeof(pzv), NULL) == SUCCESS) {
						/* first add, go on */
											}
					else {
						assert(0);
					}
				}
			
			
			
			
	
	/* STRUCT_P_EX(zval,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src[0])[0]));
	

	

	xc_calc_zval(
		
		processor,   src[0]
		
		
		
		TSRMLS_CC
	);

	

	
	

			
		} while (0);
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_zval_ptr_nullable */
	
 	  	 	static void inline 	xc_calc_zval_ptr_nullable( 		 		xc_processor_t *processor, const zval_ptr_nullable * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr_nullable), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			if (src[0]) {
		
		
	
	/* STRUCT_P_EX(zval_ptr,dst,src,,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  src)[0]));
	

	xc_calc_zval_ptr(
		
		processor,   src
		
		
		
		TSRMLS_CC
	);

	
	

		
	}
	else {
		
	}
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr_nullable);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zval_ptr_nullable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_calc_zend_arg_info */
	
 	  	 	static void inline 	xc_calc_zend_arg_info( 		 		xc_processor_t *processor, const zend_arg_info * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_arg_info*)NULL)->name) + sizeof(((zend_arg_info*)NULL)->name_len) + sizeof(((zend_arg_info*)NULL)->class_name) + sizeof(((zend_arg_info*)NULL)->class_name_len) + sizeof(((zend_arg_info*)NULL)->type_hint) + sizeof(((zend_arg_info*)NULL)->pass_by_reference) + sizeof(((zend_arg_info*)NULL)->allow_null) + sizeof(((zend_arg_info*)NULL)->is_variadic)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","class_name","class_name_len","type_hint","pass_by_reference","allow_null","is_variadic" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,name_len) */

	assert(sizeof(zend_uint) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->name, src->name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(zend_uint,class_name_len) */

	assert(sizeof(zend_uint) == sizeof(src->class_name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name_len", sizeof("class_name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name_len", sizeof("class_name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,class_name,class_name_len) */
 
	
	/* PROC_ZSTRING_N(,class_name,class_name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->class_name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->class_name, src->class_name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->class_name, src->class_name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->class_name, src->class_name_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,type_hint) */

	assert(sizeof(zend_uchar) == sizeof(src->type_hint));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type_hint", sizeof("type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type_hint", sizeof("type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type_hint);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2_1)
		
	/* PROCESS(zend_bool,array_type_hint) */

	assert(sizeof(zend_bool) == sizeof(src->array_type_hint));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "array_type_hint", sizeof("array_type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "array_type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "array_type_hint", sizeof("array_type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->array_type_hint);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_uchar,pass_by_reference) */

	assert(sizeof(zend_uchar) == sizeof(src->pass_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,allow_null) */

	assert(sizeof(zend_bool) == sizeof(src->allow_null));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "allow_null", sizeof("allow_null"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "allow_null"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "allow_null", sizeof("allow_null"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->allow_null);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_bool,is_variadic) */

	assert(sizeof(zend_bool) == sizeof(src->is_variadic));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_variadic", sizeof("is_variadic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "is_variadic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_variadic", sizeof("is_variadic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_variadic);
	xc_autocheck_done_count ++;

#endif



	

#else
		
	/* PROCESS(zend_bool,pass_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,return_reference) */

	assert(sizeof(zend_bool) == sizeof(src->return_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,required_num_args) */

	assert(sizeof(int) == sizeof(src->required_num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_arg_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_calc_zend_constant */
	
 	  	 	static void inline 	xc_calc_zend_constant( 		 		xc_processor_t *processor, const zend_constant * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_constant*)NULL)->value) + sizeof(((zend_constant*)NULL)->flags) + sizeof(((zend_constant*)NULL)->name) + sizeof(((zend_constant*)NULL)->name_len) + sizeof(((zend_constant*)NULL)->module_number)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","flags","name","name_len","module_number" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(zval,value) */

	assert(sizeof(zval) == sizeof(src->value));
	
	
	
	/* STRUCT_P_EX(zval,DST(`value'),SRC(`value'),value,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->value)[0]));
	

	

	xc_calc_zval(
		
		processor, & src->value
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(int,flags) */

	assert(sizeof(int) == sizeof(src->flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,name_len) */

	assert(sizeof(uint) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	/* PROC_ZSTRING_N(,name,name_len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->name, src->name_len C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_len C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_len C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(int,module_number) */

	assert(sizeof(int) == sizeof(src->module_number));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module_number", sizeof("module_number"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "module_number"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module_number", sizeof("module_number"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module_number);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_constant", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zend_function */
	
		/* export:  	  	 	void 	xc_calc_zend_function( 		 		xc_processor_t *processor, const zend_function * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_zend_function( 		 		xc_processor_t *processor, const zend_function * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_function), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	

	switch (src->type) {
	case ZEND_INTERNAL_FUNCTION:
	case ZEND_OVERLOADED_FUNCTION:
		
		break;

	case ZEND_USER_FUNCTION:
	case ZEND_EVAL_CODE:
		
		
	
	/* STRUCT(zend_op_array,op_array) */

	assert(sizeof(zend_op_array) == sizeof(src->op_array));
	
	
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,,&) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof((& src->op_array)[0]));
	

	

	xc_calc_zend_op_array(
		
		processor, & src->op_array
		
		
		
		TSRMLS_CC
	);

	

	
	

	

		break;

	default:
		assert(0);
	}
	
	
	

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_calc_zend_property_info */
	
 	  	 	static void inline 	xc_calc_zend_property_info( 		 		xc_processor_t *processor, const zend_property_info * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_property_info*)NULL)->flags) + sizeof(((zend_property_info*)NULL)->name) + sizeof(((zend_property_info*)NULL)->name_length) + sizeof(((zend_property_info*)NULL)->h) + sizeof(((zend_property_info*)NULL)->offset) + sizeof(((zend_property_info*)NULL)->doc_comment) + sizeof(((zend_property_info*)NULL)->doc_comment_len) + sizeof(((zend_property_info*)NULL)->ce)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "flags","name","name_length","h","offset","doc_comment","doc_comment_len","ce" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,flags) */

	assert(sizeof(zend_uint) == sizeof(src->flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,name_length) */

	assert(sizeof(int) == sizeof(src->name_length));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->name, src->name_length + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(int,offset) */

	assert(sizeof(int) == sizeof(src->offset));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "offset", sizeof("offset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "offset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "offset", sizeof("offset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->offset);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
	#if defined(ZEND_ENGINE_2_2)
	
	if (src->ce) {
		
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->ce == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif


#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_calc_zend_trait_method_reference */
	
 	  	 	static void inline 	xc_calc_zend_trait_method_reference( 		 		xc_processor_t *processor, const zend_trait_method_reference * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_method_reference*)NULL)->method_name) + sizeof(((zend_trait_method_reference*)NULL)->mname_len) + sizeof(((zend_trait_method_reference*)NULL)->ce) + sizeof(((zend_trait_method_reference*)NULL)->class_name) + sizeof(((zend_trait_method_reference*)NULL)->cname_len)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "method_name","mname_len","ce","class_name","cname_len" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(unsigned int,mname_len) */

	assert(sizeof(unsigned int) == sizeof(src->mname_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "mname_len", sizeof("mname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "mname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "mname_len", sizeof("mname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->mname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(method_name,mname_len) */
 
	/* PROC_STRING_N(method_name,mname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "method_name", sizeof("method_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "method_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "method_name", sizeof("method_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->method_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->method_name == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->method_name), src->mname_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

	
	
	
	
	assert(src->ce == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,cname_len) */

	assert(sizeof(unsigned int) == sizeof(src->cname_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cname_len", sizeof("cname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "cname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cname_len", sizeof("cname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(class_name,cname_len) */
 
	/* PROC_STRING_N(class_name,cname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->class_name == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->class_name), src->cname_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_trait_method_reference", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_zend_trait_alias */
	
 	  	 	static void inline 	xc_calc_zend_trait_alias( 		 		xc_processor_t *processor, const zend_trait_alias * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_alias*)NULL)->trait_method) + sizeof(((zend_trait_alias*)NULL)->alias) + sizeof(((zend_trait_alias*)NULL)->alias_len) + sizeof(((zend_trait_alias*)NULL)->modifiers)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","alias","alias_len","modifiers" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_trait_method_reference)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_trait_method_reference);
	
	
	
	
	
	


	

	xc_calc_zend_trait_method_reference(
		
		processor,  src->trait_method
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,alias_len) */

	assert(sizeof(unsigned int) == sizeof(src->alias_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias_len", sizeof("alias_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias_len", sizeof("alias_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(alias,alias_len) */
 
	/* PROC_STRING_N(alias,alias_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias", sizeof("alias"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias", sizeof("alias"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->alias == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->alias), src->alias_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,modifiers) */

	assert(sizeof(zend_uint) == sizeof(src->modifiers));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "modifiers", sizeof("modifiers"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "modifiers"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "modifiers", sizeof("modifiers"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->modifiers);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_trait_alias", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_zend_trait_precedence */
	
 	  	 	static void inline 	xc_calc_zend_trait_precedence( 		 		xc_processor_t *processor, const zend_trait_precedence * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_precedence*)NULL)->trait_method) + sizeof(((zend_trait_precedence*)NULL)->exclude_from_classes)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","exclude_from_classes" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_trait_method_reference)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_trait_method_reference);
	
	
	
	
	
	


	

	xc_calc_zend_trait_method_reference(
		
		processor,  src->trait_method
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		if (src->exclude_from_classes) {
		int LOOPCOUNTER;
		
						
				size_t count = 0;
				while (src->exclude_from_classes[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_ztstring) * count));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_ztstring) * count;
	
	
	
	
	
	

			

			for (LOOPCOUNTER = 0;
					src->exclude_from_classes[LOOPCOUNTER];
					++LOOPCOUNTER) {
				
	
	

					
					
						
	/* PROCESS(xc_ztstring,exclude_from_classes) */

	assert(sizeof(xc_ztstring) == sizeof((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]));
		
	
	/* PROC_STRING(exclude_from_classes) */
 
	
	
	
	
	
	
	
	
	if ((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER] == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]), strlen((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

	

	

					
					
				
	
	

			}
						
				
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->exclude_from_classes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif



	}

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_trait_precedence", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_zend_trait_alias_ptr */
	
 	  	 	static void inline 	xc_calc_zend_trait_alias_ptr( 		 		xc_processor_t *processor, const zend_trait_alias_ptr * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_alias), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_trait_alias)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_trait_alias);
	
	
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_alias,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_alias) == sizeof((  src[0])[0]));
	

	

	xc_calc_zend_trait_alias(
		
		processor,   src[0]
		
		
		
		TSRMLS_CC
	);

	

	
	

		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_alias);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_trait_alias_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_zend_trait_precedence_ptr */
	
 	  	 	static void inline 	xc_calc_zend_trait_precedence_ptr( 		 		xc_processor_t *processor, const zend_trait_precedence_ptr * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_precedence), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_trait_precedence)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_trait_precedence);
	
	
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_precedence,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_precedence) == sizeof((  src[0])[0]));
	

	

	xc_calc_zend_trait_precedence(
		
		processor,   src[0]
		
		
		
		TSRMLS_CC
	);

	

	
	

		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_precedence);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_trait_precedence_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zend_class_entry */
	
		/* export:  	  	 	void 	xc_calc_zend_class_entry( 		 		xc_processor_t *processor, const zend_class_entry * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_zend_class_entry( 		 		xc_processor_t *processor, const zend_class_entry * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_class_entry*)NULL)->type) + sizeof(((zend_class_entry*)NULL)->name) + sizeof(((zend_class_entry*)NULL)->name_length) + sizeof(((zend_class_entry*)NULL)->parent) + sizeof(((zend_class_entry*)NULL)->refcount) + sizeof(((zend_class_entry*)NULL)->ce_flags) + sizeof(((zend_class_entry*)NULL)->function_table) + sizeof(((zend_class_entry*)NULL)->properties_info) + sizeof(((zend_class_entry*)NULL)->default_properties_table) + sizeof(((zend_class_entry*)NULL)->default_static_members_table) + sizeof(((zend_class_entry*)NULL)->static_members_table) + sizeof(((zend_class_entry*)NULL)->constants_table) + sizeof(((zend_class_entry*)NULL)->default_properties_count) + sizeof(((zend_class_entry*)NULL)->default_static_members_count) + sizeof(((zend_class_entry*)NULL)->constructor) + sizeof(((zend_class_entry*)NULL)->destructor) + sizeof(((zend_class_entry*)NULL)->clone) + sizeof(((zend_class_entry*)NULL)->__get) + sizeof(((zend_class_entry*)NULL)->__set) + sizeof(((zend_class_entry*)NULL)->__unset) + sizeof(((zend_class_entry*)NULL)->__isset) + sizeof(((zend_class_entry*)NULL)->__call) + sizeof(((zend_class_entry*)NULL)->__callstatic) + sizeof(((zend_class_entry*)NULL)->__tostring) + sizeof(((zend_class_entry*)NULL)->__debugInfo) + sizeof(((zend_class_entry*)NULL)->serialize_func) + sizeof(((zend_class_entry*)NULL)->unserialize_func) + sizeof(((zend_class_entry*)NULL)->iterator_funcs) + sizeof(((zend_class_entry*)NULL)->create_object) + sizeof(((zend_class_entry*)NULL)->get_iterator) + sizeof(((zend_class_entry*)NULL)->interface_gets_implemented) + sizeof(((zend_class_entry*)NULL)->get_static_method) + sizeof(((zend_class_entry*)NULL)->serialize) + sizeof(((zend_class_entry*)NULL)->unserialize) + sizeof(((zend_class_entry*)NULL)->interfaces) + sizeof(((zend_class_entry*)NULL)->num_interfaces) + sizeof(((zend_class_entry*)NULL)->traits) + sizeof(((zend_class_entry*)NULL)->num_traits) + sizeof(((zend_class_entry*)NULL)->trait_aliases) + sizeof(((zend_class_entry*)NULL)->trait_precedences) + sizeof(((zend_class_entry*)NULL)->info)  ), assert_count = 41;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","name","name_length","parent","refcount","ce_flags","function_table","properties_info","default_properties_table","default_static_members_table","static_members_table","constants_table","default_properties_count","default_static_members_count","constructor","destructor","clone","__get","__set","__unset","__isset","__call","__callstatic","__tostring","__debugInfo","serialize_func","unserialize_func","iterator_funcs","create_object","get_iterator","interface_gets_implemented","get_static_method","serialize","unserialize","interfaces","num_interfaces","traits","num_traits","trait_aliases","trait_precedences","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
		processor->active_class_entry_src = src;
		
	
		
	/* PROCESS(char,type) */

	assert(sizeof(char) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,name_length) */

	assert(sizeof(zend_uint) == sizeof(src->name_length));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->name, src->name_length + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	if (src->parent) {
		
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->parent == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif


	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(int,refcount) */

	assert(sizeof(int) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
	
	
	/* STRUCT_P(int,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(int,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(int) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(int)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(int);
	
	
	
	
	
	


	

	xc_calc_int(
		
		processor,  src->refcount
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,constants_updated) */

	assert(sizeof(zend_bool) == sizeof(src->constants_updated));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_updated", sizeof("constants_updated"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_updated"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_updated", sizeof("constants_updated"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_updated);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,ce_flags) */

	assert(sizeof(zend_uint) == sizeof(src->ce_flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce_flags", sizeof("ce_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "ce_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce_flags", sizeof("ce_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce_flags);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,properties_info,HashTable_zend_property_info) */

	assert(sizeof(HashTable) == sizeof(src->properties_info));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`properties_info'),SRC(`properties_info'),properties_info,HashTable_zend_property_info,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->properties_info)[0]));
	

	

	xc_calc_HashTable_zend_property_info(
		
		processor, & src->properties_info
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "properties_info", sizeof("properties_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "properties_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "properties_info", sizeof("properties_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->properties_info);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2_4
	
	if (src->default_properties_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zval_ptr_nullable) * src->default_properties_count));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zval_ptr_nullable) * src->default_properties_count;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->default_properties_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_properties_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_properties_table[i]));
	
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_properties_table[LOOPCOUNTER]'),SRC(`default_properties_table[LOOPCOUNTER]'),default_properties_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_properties_table[i])[0]));
	

	

	xc_calc_zval_ptr_nullable(
		
		processor, & src->default_properties_table[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_properties_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_properties_count) */

	assert(sizeof(int) == sizeof(src->default_properties_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_count", sizeof("default_properties_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_count", sizeof("default_properties_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_count);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->default_static_members_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zval_ptr_nullable) * src->default_static_members_count));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zval_ptr_nullable) * src->default_static_members_count;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->default_static_members_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_static_members_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_static_members_table[i]));
	
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_static_members_table[LOOPCOUNTER]'),SRC(`default_static_members_table[LOOPCOUNTER]'),default_static_members_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_static_members_table[i])[0]));
	

	

	xc_calc_zval_ptr_nullable(
		
		processor, & src->default_static_members_table[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_static_members_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_static_members_count) */

	assert(sizeof(int) == sizeof(src->default_static_members_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_count", sizeof("default_static_members_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_count", sizeof("default_static_members_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_count);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members_table", sizeof("static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members_table", sizeof("static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members_table);
	xc_autocheck_done_count ++;

#endif


#else
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "builtin_functions", sizeof("builtin_functions"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "builtin_functions"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "builtin_functions", sizeof("builtin_functions"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->builtin_functions);
	xc_autocheck_done_count ++;

#endif


	
	
	/* STRUCT(HashTable,default_properties,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_properties));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_properties'),SRC(`default_properties'),default_properties,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_properties)[0]));
	

	

	xc_calc_HashTable_zval_ptr(
		
		processor, & src->default_properties
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties", sizeof("default_properties"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties", sizeof("default_properties"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties);
	xc_autocheck_done_count ++;

#endif



#	ifdef ZEND_ENGINE_2_1
	
	
	/* STRUCT(HashTable,default_static_members,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_static_members));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_static_members'),SRC(`default_static_members'),default_static_members,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_static_members)[0]));
	

	

	xc_calc_HashTable_zval_ptr(
		
		processor, & src->default_static_members
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members", sizeof("default_static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members", sizeof("default_static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif


#	elif defined(ZEND_ENGINE_2)
	
	
	/* STRUCT_P(HashTable,static_members,HashTable_zval_ptr) */

	if (src->static_members) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_members'),SRC(`static_members'),static_members,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_members)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(HashTable)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(HashTable);
	
	
	
	
	
	


	

	xc_calc_HashTable_zval_ptr(
		
		processor,  src->static_members
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->static_members == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif



#	endif
#endif /* ZEND_ENGINE_2_4 */

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,constants_table,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->constants_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`constants_table'),SRC(`constants_table'),constants_table,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->constants_table)[0]));
	

	

	xc_calc_HashTable_zval_ptr(
		
		processor, & src->constants_table
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_table", sizeof("constants_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_table", sizeof("constants_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_table);
	xc_autocheck_done_count ++;

#endif




#ifdef ZEND_ENGINE_2_2
		
	
	
	
	assert(src->interfaces == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_interfaces == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif




#	ifdef ZEND_ENGINE_2_4
		
	
	
	
	assert(src->traits == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "traits", sizeof("traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "traits", sizeof("traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->traits);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_traits == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_traits", sizeof("num_traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_traits", sizeof("num_traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_traits);
	xc_autocheck_done_count ++;

#endif



	
	if (src->trait_aliases) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_aliases[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_trait_alias_ptr) * count));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_trait_alias_ptr) * count;
	
	
	
	
	
	

			

			for (i = 0;
					src->trait_aliases[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_alias_ptr,trait_aliases[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_alias_ptr) == sizeof(src->trait_aliases[i]));
	
	
	
	/* STRUCT_P_EX(zend_trait_alias_ptr,DST(`trait_aliases[LOOPCOUNTER]'),SRC(`trait_aliases[LOOPCOUNTER]'),trait_aliases[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_alias_ptr) == sizeof((& src->trait_aliases[i])[0]));
	

	

	xc_calc_zend_trait_alias_ptr(
		
		processor, & src->trait_aliases[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_alias_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_aliases == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif



	}

	
	if (src->trait_precedences) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_precedences[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_trait_precedence_ptr) * count));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_trait_precedence_ptr) * count;
	
	
	
	
	
	

			

			for (i = 0;
					src->trait_precedences[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_precedence_ptr,trait_precedences[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_precedence_ptr) == sizeof(src->trait_precedences[i]));
	
	
	
	/* STRUCT_P_EX(zend_trait_precedence_ptr,DST(`trait_precedences[LOOPCOUNTER]'),SRC(`trait_precedences[LOOPCOUNTER]'),trait_precedences[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_precedence_ptr) == sizeof((& src->trait_precedences[i])[0]));
	

	

	xc_calc_zend_trait_precedence_ptr(
		
		processor, & src->trait_precedences[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_trait_precedence_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_precedences == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif



	}

#	endif
#else
	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif


	
		
	/* PROCESS(zend_uint,num_interfaces) */

	assert(sizeof(zend_uint) == sizeof(src->num_interfaces));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif



	

#endif

#	ifdef ZEND_ENGINE_2_4
	
	
	

	
	/* PROC_STRING(info.user.filename) */
 
	
	
	
	
	
	
	
	
	if (src->info.user.filename == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->info.user.filename), strlen(src->info.user.filename) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,info.user.line_start) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_start));
		
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.line_end) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_end));
		
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.doc_comment_len));
		
	
	
	

	

	
	/* PROC_ZSTRING_L(,info.user.doc_comment,info.user.doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,info.user.doc_comment,info.user.doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->info.user.doc_comment, src->info.user.doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->info.user.doc_comment, src->info.user.doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->info.user.doc_comment, src->info.user.doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif


#	else
	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->filename), strlen(src->filename) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#	endif

	/* # NOT DONE */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize_func", sizeof("serialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize_func", sizeof("serialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize_func);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize_func", sizeof("unserialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize_func", sizeof("unserialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize_func);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "iterator_funcs", sizeof("iterator_funcs"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "iterator_funcs"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "iterator_funcs", sizeof("iterator_funcs"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->iterator_funcs);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "create_object", sizeof("create_object"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "create_object"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "create_object", sizeof("create_object"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->create_object);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_iterator", sizeof("get_iterator"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_iterator"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_iterator", sizeof("get_iterator"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_iterator);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interface_gets_implemented", sizeof("interface_gets_implemented"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interface_gets_implemented"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interface_gets_implemented", sizeof("interface_gets_implemented"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interface_gets_implemented);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_ENGINE_2_3
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_static_method", sizeof("get_static_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_static_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_static_method", sizeof("get_static_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_static_method);
	xc_autocheck_done_count ++;

#endif


#	endif
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize", sizeof("serialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize", sizeof("serialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize", sizeof("unserialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize", sizeof("unserialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize);
	xc_autocheck_done_count ++;

#endif


#	endif
	/* deal with it inside xc_fix_method */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constructor", sizeof("constructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constructor", sizeof("constructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "destructor", sizeof("destructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "destructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "destructor", sizeof("destructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->destructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "clone", sizeof("clone"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "clone"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "clone", sizeof("clone"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->clone);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__get", sizeof("__get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__get", sizeof("__get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__set", sizeof("__set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__set", sizeof("__set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__set);
	xc_autocheck_done_count ++;

#endif


/* should be >5.1 */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__unset", sizeof("__unset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__unset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__unset", sizeof("__unset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__unset);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__isset", sizeof("__isset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__isset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__isset", sizeof("__isset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__isset);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__call", sizeof("__call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__call", sizeof("__call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__call);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_CALLSTATIC_FUNC_NAME
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__callstatic", sizeof("__callstatic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__callstatic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__callstatic", sizeof("__callstatic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__callstatic);
	xc_autocheck_done_count ++;

#endif


#	endif
# if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__tostring", sizeof("__tostring"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__tostring"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__tostring", sizeof("__tostring"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__tostring);
	xc_autocheck_done_count ++;

#endif


# endif
# if defined(ZEND_ENGINE_2_6)
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__debugInfo", sizeof("__debugInfo"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__debugInfo"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__debugInfo", sizeof("__debugInfo"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__debugInfo);
	xc_autocheck_done_count ++;

#endif


# endif
#	ifndef ZEND_ENGINE_2_4
	/* # NOT DONE */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module", sizeof("module"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "module"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module", sizeof("module"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module);
	xc_autocheck_done_count ++;

#endif


#	endif
#else /* ZEND_ENGINE_2 */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_function_call", sizeof("handle_function_call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_function_call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_function_call", sizeof("handle_function_call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_function_call);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_get", sizeof("handle_property_get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_get", sizeof("handle_property_get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_set", sizeof("handle_property_set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_set", sizeof("handle_property_set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_set);
	xc_autocheck_done_count ++;

#endif


#endif
		
	
	/* STRUCT(HashTable,function_table,HashTable_zend_function) */

	assert(sizeof(HashTable) == sizeof(src->function_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`function_table'),SRC(`function_table'),function_table,HashTable_zend_function,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->function_table)[0]));
	

	

	xc_calc_HashTable_zend_function(
		
		processor, & src->function_table
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_table", sizeof("function_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "function_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_table", sizeof("function_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_table);
	xc_autocheck_done_count ++;

#endif



	
	
		processor->active_class_entry_src = NULL;
		
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_class_entry", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4


#else

	
	

/* {{{ xc_calc_znode */
	
 	  	 	static void inline 	xc_calc_znode( 		 		xc_processor_t *processor, const znode * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((znode*)NULL)->op_type) + sizeof(((znode*)NULL)->u) + sizeof(((znode*)NULL)->EA)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "op_type","u","EA" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(xc_op_type,op_type) */

	assert(sizeof(xc_op_type) == sizeof(src->op_type));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_type", sizeof("op_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_znode : %s\n"
				, __FILE__, __LINE__
				, "op_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_type", sizeof("op_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_type);
	xc_autocheck_done_count ++;

#endif




	


#ifdef IS_CV
#	define XCACHE_IS_CV IS_CV
#else
/* compatible with zend optimizer */
#	define XCACHE_IS_CV 16
#endif
	assert(src->op_type == IS_CONST ||
		src->op_type == IS_VAR ||
		src->op_type == XCACHE_IS_CV ||
		src->op_type == IS_TMP_VAR ||
		src->op_type == IS_UNUSED);
		
	
	

	switch (src->op_type) {
		case IS_CONST:
			
	
	/* STRUCT(zval,u.constant) */

	assert(sizeof(zval) == sizeof(src->u.constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`u.constant'),SRC(`u.constant'),u.constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->u.constant)[0]));
	

	

	xc_calc_zval(
		
		processor, & src->u.constant
		
		
		
		TSRMLS_CC
	);

	

	
	

	

			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case XCACHE_IS_CV:
				
	/* PROCESS(zend_uint,u.var) */

	assert(sizeof(zend_uint) == sizeof(src->u.var));
		
	
	
	

	

				
	/* PROCESS(zend_uint,u.EA.type) */

	assert(sizeof(zend_uint) == sizeof(src->u.EA.type));
		
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,u.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->u.opline_num));
		
	
	
	

	

#ifndef ZEND_ENGINE_2
				
	/* PROCESS(zend_uint,u.fetch_type) */

	assert(sizeof(zend_uint) == sizeof(src->u.fetch_type));
		
	
	
	

	

#endif
				
	/* PROCESS(zend_uint,u.EA.type) */

	assert(sizeof(zend_uint) == sizeof(src->u.EA.type));
		
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_znode : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


#if 0
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "EA", sizeof("EA"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_znode : %s\n"
				, __FILE__, __LINE__
				, "EA"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "EA", sizeof("EA"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->EA);
	xc_autocheck_done_count ++;

#endif


#endif
#undef XCACHE_IS_CV

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_znode", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zend_op */
	
		/* export:  	  	 	void 	xc_calc_zend_op( 		 		xc_processor_t *processor, const zend_op * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_zend_op( 		 		xc_processor_t *processor, const zend_op * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op*)NULL)->handler) + sizeof(((zend_op*)NULL)->op1) + sizeof(((zend_op*)NULL)->op2) + sizeof(((zend_op*)NULL)->result) + sizeof(((zend_op*)NULL)->extended_value) + sizeof(((zend_op*)NULL)->lineno) + sizeof(((zend_op*)NULL)->opcode) + sizeof(((zend_op*)NULL)->op1_type) + sizeof(((zend_op*)NULL)->op2_type) + sizeof(((zend_op*)NULL)->result_type)  ), assert_count = 10;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "handler","op1","op2","result","extended_value","lineno","opcode","op1_type","op2_type","result_type" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(xc_opcode,opcode) */

	assert(sizeof(xc_opcode) == sizeof(src->opcode));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcode", sizeof("opcode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcode", sizeof("opcode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcode);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_4
	
	switch (src->opcode) {
	case ZEND_BIND_TRAITS:
		((zend_op *) src)->op2_type = IS_UNUSED;
		break;
	}
	
	#ifndef NDEBUG
	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
		case IS_CONST:
			
					
	/* PROCESS(zend_uint,result.constant) */

	assert(sizeof(zend_uint) == sizeof(src->result.constant));
		
	
	
	

	

			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,result.var) */

	assert(sizeof(zend_uint) == sizeof(src->result.var));
		
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,result.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->result.opline_num));
		
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op1_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op1_type )) {
		case IS_CONST:
			
				
					
							
	/* PROCESS(zend_uint,op1.constant) */

	assert(sizeof(zend_uint) == sizeof(src->op1.constant));
		
	
	
	

	

					
				
			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,op1.var) */

	assert(sizeof(zend_uint) == sizeof(src->op1.var));
		
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,op1.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->op1.opline_num));
		
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op2_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op2_type )) {
		case IS_CONST:
			
				
					
							
	/* PROCESS(zend_uint,op2.constant) */

	assert(sizeof(zend_uint) == sizeof(src->op2.constant));
		
	
	
	

	

					
				
			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,op2.var) */

	assert(sizeof(zend_uint) == sizeof(src->op2.var));
		
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,op2.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->op2.opline_num));
		
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(znode,result) */

	assert(sizeof(znode) == sizeof(src->result));
	
	
	
	/* STRUCT_P_EX(znode,DST(`result'),SRC(`result'),result,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->result)[0]));
	

	

	xc_calc_znode(
		
		processor, & src->result
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op1) */

	assert(sizeof(znode) == sizeof(src->op1));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op1'),SRC(`op1'),op1,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op1)[0]));
	

	

	xc_calc_znode(
		
		processor, & src->op1
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op2) */

	assert(sizeof(znode) == sizeof(src->op2));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op2'),SRC(`op2'),op2,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op2)[0]));
	

	

	xc_calc_znode(
		
		processor, & src->op2
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#endif
		
	/* PROCESS(ulong,extended_value) */

	assert(sizeof(ulong) == sizeof(src->extended_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "extended_value", sizeof("extended_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "extended_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "extended_value", sizeof("extended_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->extended_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,op1_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op1_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1_type", sizeof("op1_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1_type", sizeof("op1_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,op2_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op2_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2_type", sizeof("op2_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2_type", sizeof("op2_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,result_type) */

	assert(sizeof(zend_uchar) == sizeof(src->result_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result_type", sizeof("result_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result_type", sizeof("result_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(opcode_handler_t,handler) */

	assert(sizeof(opcode_handler_t) == sizeof(src->handler));
	/* is copying enough? */
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handler", sizeof("handler"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "handler"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handler", sizeof("handler"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handler);
	xc_autocheck_done_count ++;

#endif


	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_op", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_calc_zend_literal */
	
 	  	 	static void inline 	xc_calc_zend_literal( 		 		xc_processor_t *processor, const zend_literal * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_literal*)NULL)->constant) + sizeof(((zend_literal*)NULL)->hash_value) + sizeof(((zend_literal*)NULL)->cache_slot)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "constant","hash_value","cache_slot" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(zval,constant) */

	assert(sizeof(zval) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->constant)[0]));
	

	

	xc_calc_zval(
		
		processor, & src->constant
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(zend_ulong,hash_value) */

	assert(sizeof(zend_ulong) == sizeof(src->hash_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,cache_slot) */

	assert(sizeof(zend_uint) == sizeof(src->cache_slot));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cache_slot", sizeof("cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cache_slot", sizeof("cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cache_slot);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_literal", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_calc_zend_op_array */
	
		/* export:  	  	 	void 	xc_calc_zend_op_array( 		 		xc_processor_t *processor, const zend_op_array * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_zend_op_array( 		 		xc_processor_t *processor, const zend_op_array * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op_array*)NULL)->type) + sizeof(((zend_op_array*)NULL)->function_name) + sizeof(((zend_op_array*)NULL)->scope) + sizeof(((zend_op_array*)NULL)->fn_flags) + sizeof(((zend_op_array*)NULL)->prototype) + sizeof(((zend_op_array*)NULL)->num_args) + sizeof(((zend_op_array*)NULL)->required_num_args) + sizeof(((zend_op_array*)NULL)->arg_info) + sizeof(((zend_op_array*)NULL)->refcount) + sizeof(((zend_op_array*)NULL)->opcodes) + sizeof(((zend_op_array*)NULL)->last) + sizeof(((zend_op_array*)NULL)->vars) + sizeof(((zend_op_array*)NULL)->last_var) + sizeof(((zend_op_array*)NULL)->T) + sizeof(((zend_op_array*)NULL)->nested_calls) + sizeof(((zend_op_array*)NULL)->used_stack) + sizeof(((zend_op_array*)NULL)->brk_cont_array) + sizeof(((zend_op_array*)NULL)->last_brk_cont) + sizeof(((zend_op_array*)NULL)->try_catch_array) + sizeof(((zend_op_array*)NULL)->last_try_catch) + sizeof(((zend_op_array*)NULL)->has_finally_block) + sizeof(((zend_op_array*)NULL)->static_variables) + sizeof(((zend_op_array*)NULL)->this_var) + sizeof(((zend_op_array*)NULL)->filename) + sizeof(((zend_op_array*)NULL)->line_start) + sizeof(((zend_op_array*)NULL)->line_end) + sizeof(((zend_op_array*)NULL)->doc_comment) + sizeof(((zend_op_array*)NULL)->doc_comment_len) + sizeof(((zend_op_array*)NULL)->early_binding) + sizeof(((zend_op_array*)NULL)->literals) + sizeof(((zend_op_array*)NULL)->last_literal) + sizeof(((zend_op_array*)NULL)->run_time_cache) + sizeof(((zend_op_array*)NULL)->last_cache_slot) + sizeof(((zend_op_array*)NULL)->reserved)  ), assert_count = 34;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","function_name","scope","fn_flags","prototype","num_args","required_num_args","arg_info","refcount","opcodes","last","vars","last_var","T","nested_calls","used_stack","brk_cont_array","last_brk_cont","try_catch_array","last_try_catch","has_finally_block","static_variables","this_var","filename","line_start","line_end","doc_comment","doc_comment_len","early_binding","literals","last_literal","run_time_cache","last_cache_slot","reserved" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	{
	
	do {
	
	/* Common elements */
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING(,function_name) */
 
	
	/* PROC_ZSTRING_N(,function_name,,strlen) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->function_name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->function_name, xc_zstrlen_uchar (src->function_name) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->function_name, xc_zstrlen_char (src->function_name) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->function_name, xc_zstrlen_char (src->function_name) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,fn_flags) */

	assert(sizeof(zend_uint) == sizeof(src->fn_flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "fn_flags", sizeof("fn_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "fn_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "fn_flags", sizeof("fn_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->fn_flags);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->arg_info) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_arg_info) * src->num_args));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_arg_info) * src->num_args;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->num_args;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_arg_info,arg_info[LOOPCOUNTER],) */

	assert(sizeof(zend_arg_info) == sizeof(src->arg_info[i]));
	
	
	
	/* STRUCT_P_EX(zend_arg_info,DST(`arg_info[LOOPCOUNTER]'),SRC(`arg_info[LOOPCOUNTER]'),arg_info[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_arg_info) == sizeof((& src->arg_info[i])[0]));
	

	

	xc_calc_zend_arg_info(
		
		processor, & src->arg_info[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->arg_info == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,num_args) */

	assert(sizeof(zend_uint) == sizeof(src->num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_args", sizeof("num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_args", sizeof("num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_args);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,required_num_args) */

	assert(sizeof(zend_uint) == sizeof(src->required_num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,pass_rest_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_rest_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_rest_by_reference", sizeof("pass_rest_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "pass_rest_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_rest_by_reference", sizeof("pass_rest_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_rest_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
	if (src->arg_types) {
		
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_uchar) * src->arg_types[0] + 1));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_uchar) * src->arg_types[0] + 1;
	
	
	
	
	
	

		
		
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->arg_types == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif



	}
#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(unsigned char,return_reference) */

	assert(sizeof(unsigned char) == sizeof(src->return_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* END of common elements */
#ifdef IS_UNICODE
	#endif

	
	
	/* STRUCT_P(zend_uint,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(zend_uint,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(zend_uint) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_uint)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_uint);
	
	
	
	
	
	


	

	xc_calc_zend_uint(
		
		processor,  src->refcount
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	if (src->literals) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_literal) * src->last_literal));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_literal) * src->last_literal;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_literal;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_literal,literals[LOOPCOUNTER],) */

	assert(sizeof(zend_literal) == sizeof(src->literals[i]));
	
	
	
	/* STRUCT_P_EX(zend_literal,DST(`literals[LOOPCOUNTER]'),SRC(`literals[LOOPCOUNTER]'),literals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_literal) == sizeof((& src->literals[i])[0]));
	

	

	xc_calc_zend_literal(
		
		processor, & src->literals[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_literal) */

	assert(sizeof(int) == sizeof(src->last_literal));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_literal", sizeof("last_literal"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_literal"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_literal", sizeof("last_literal"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_literal);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
	if (src->opcodes) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_op) * src->last));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_op) * src->last;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_op,opcodes[LOOPCOUNTER],) */

	assert(sizeof(zend_op) == sizeof(src->opcodes[i]));
	
	
	
	/* STRUCT_P_EX(zend_op,DST(`opcodes[LOOPCOUNTER]'),SRC(`opcodes[LOOPCOUNTER]'),opcodes[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_op) == sizeof((& src->opcodes[i])[0]));
	

	

	xc_calc_zend_op(
		
		processor, & src->opcodes[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->opcodes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,last) */

	assert(sizeof(zend_uint) == sizeof(src->last));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last", sizeof("last"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last", sizeof("last"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,size) */

	assert(sizeof(zend_uint) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef IS_CV
	
	if (src->vars) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_compiled_variable) * src->last_var));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_compiled_variable) * src->last_var;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_var;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_compiled_variable,vars[LOOPCOUNTER],) */

	assert(sizeof(zend_compiled_variable) == sizeof(src->vars[i]));
	
	
	
	/* STRUCT_P_EX(zend_compiled_variable,DST(`vars[LOOPCOUNTER]'),SRC(`vars[LOOPCOUNTER]'),vars[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_compiled_variable) == sizeof((& src->vars[i])[0]));
	

	

	xc_calc_zend_compiled_variable(
		
		processor, & src->vars[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->vars == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_var) */

	assert(sizeof(int) == sizeof(src->last_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_var", sizeof("last_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_var", sizeof("last_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_var);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,size_var) */

	assert(sizeof(zend_uint) == sizeof(src->size_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size_var", sizeof("size_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size_var", sizeof("size_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size_var);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
		
#endif

		
	/* PROCESS(zend_uint,T) */

	assert(sizeof(zend_uint) == sizeof(src->T));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "T", sizeof("T"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "T"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "T", sizeof("T"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->T);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,nested_calls) */

	assert(sizeof(zend_uint) == sizeof(src->nested_calls));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nested_calls", sizeof("nested_calls"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "nested_calls"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nested_calls", sizeof("nested_calls"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nested_calls);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,used_stack) */

	assert(sizeof(zend_uint) == sizeof(src->used_stack));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "used_stack", sizeof("used_stack"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "used_stack"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "used_stack", sizeof("used_stack"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->used_stack);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	if (src->brk_cont_array) {
		last_brk_cont_t i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_brk_cont_element) * src->last_brk_cont));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_brk_cont_element) * src->last_brk_cont;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_brk_cont;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_brk_cont_element,brk_cont_array[LOOPCOUNTER],) */

	assert(sizeof(zend_brk_cont_element) == sizeof(src->brk_cont_array[i]));
	
	
	
	/* STRUCT_P_EX(zend_brk_cont_element,DST(`brk_cont_array[LOOPCOUNTER]'),SRC(`brk_cont_array[LOOPCOUNTER]'),brk_cont_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_brk_cont_element) == sizeof((& src->brk_cont_array[i])[0]));
	

	

	xc_calc_zend_brk_cont_element(
		
		processor, & src->brk_cont_array[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->brk_cont_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(last_brk_cont_t,last_brk_cont) */

	assert(sizeof(last_brk_cont_t) == sizeof(src->last_brk_cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_brk_cont", sizeof("last_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_brk_cont", sizeof("last_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_brk_cont);
	xc_autocheck_done_count ++;

#endif




	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,current_brk_cont) */

	assert(sizeof(zend_uint) == sizeof(src->current_brk_cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "current_brk_cont", sizeof("current_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "current_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "current_brk_cont", sizeof("current_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->current_brk_cont);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifndef ZEND_ENGINE_2
		
	/* PROCESS(zend_bool,uses_globals) */

	assert(sizeof(zend_bool) == sizeof(src->uses_globals));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_globals", sizeof("uses_globals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_globals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_globals", sizeof("uses_globals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_globals);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	if (src->try_catch_array) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_try_catch_element) * src->last_try_catch));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_try_catch_element) * src->last_try_catch;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_try_catch;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_try_catch_element,try_catch_array[LOOPCOUNTER],) */

	assert(sizeof(zend_try_catch_element) == sizeof(src->try_catch_array[i]));
	
	
	
	/* STRUCT_P_EX(zend_try_catch_element,DST(`try_catch_array[LOOPCOUNTER]'),SRC(`try_catch_array[LOOPCOUNTER]'),try_catch_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_try_catch_element) == sizeof((& src->try_catch_array[i])[0]));
	

	

	xc_calc_zend_try_catch_element(
		
		processor, & src->try_catch_array[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->try_catch_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_try_catch) */

	assert(sizeof(int) == sizeof(src->last_try_catch));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_try_catch", sizeof("last_try_catch"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_try_catch"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_try_catch", sizeof("last_try_catch"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_try_catch);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_bool,has_finally_block) */

	assert(sizeof(zend_bool) == sizeof(src->has_finally_block));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "has_finally_block", sizeof("has_finally_block"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "has_finally_block"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "has_finally_block", sizeof("has_finally_block"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->has_finally_block);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	
	/* STRUCT_P(HashTable,static_variables,HashTable_zval_ptr) */

	if (src->static_variables) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_variables'),SRC(`static_variables'),static_variables,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_variables)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(HashTable)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(HashTable);
	
	
	
	
	
	


	

	xc_calc_HashTable_zval_ptr(
		
		processor,  src->static_variables
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->static_variables == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_variables", sizeof("static_variables"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "static_variables"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_variables", sizeof("static_variables"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_variables);
	xc_autocheck_done_count ++;

#endif




#ifndef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start_op", sizeof("start_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "start_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start_op", sizeof("start_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start_op);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,backpatch_count) */

	assert(sizeof(int) == sizeof(src->backpatch_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "backpatch_count", sizeof("backpatch_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "backpatch_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "backpatch_count", sizeof("backpatch_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->backpatch_count);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_3
		
	/* PROCESS(zend_uint,this_var) */

	assert(sizeof(zend_uint) == sizeof(src->this_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "this_var", sizeof("this_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "this_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "this_var", sizeof("this_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->this_var);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,done_pass_two) */

	assert(sizeof(zend_bool) == sizeof(src->done_pass_two));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "done_pass_two", sizeof("done_pass_two"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "done_pass_two"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "done_pass_two", sizeof("done_pass_two"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->done_pass_two);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* 5.0 <= ver < 5.3 */
#if defined(ZEND_ENGINE_2) && !defined(ZEND_ENGINE_2_3)
		
	/* PROCESS(zend_bool,uses_this) */

	assert(sizeof(zend_bool) == sizeof(src->uses_this));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_this", sizeof("uses_this"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_this"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_this", sizeof("uses_this"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_this);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->filename), strlen(src->filename) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
	
		
	/* PROC_STRING(script_encoding) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "script_encoding", sizeof("script_encoding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "script_encoding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "script_encoding", sizeof("script_encoding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->script_encoding);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->script_encoding == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->script_encoding), strlen(src->script_encoding) + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

	
#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
#ifdef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_uint,early_binding) */

	assert(sizeof(zend_uint) == sizeof(src->early_binding));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "early_binding", sizeof("early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "early_binding", sizeof("early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->early_binding);
	xc_autocheck_done_count ++;

#endif



	
;
#endif

	/* reserved */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "reserved", sizeof("reserved"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "reserved"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "reserved", sizeof("reserved"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->reserved);
	xc_autocheck_done_count ++;

#endif


#if defined(HARDENING_PATCH) && HARDENING_PATCH
		
	/* PROCESS(zend_bool,created_by_eval) */

	assert(sizeof(zend_bool) == sizeof(src->created_by_eval));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "created_by_eval", sizeof("created_by_eval"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "created_by_eval"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "created_by_eval", sizeof("created_by_eval"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->created_by_eval);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "run_time_cache", sizeof("run_time_cache"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "run_time_cache"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "run_time_cache", sizeof("run_time_cache"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->run_time_cache);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,last_cache_slot) */

	assert(sizeof(int) == sizeof(src->last_cache_slot));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_cache_slot", sizeof("last_cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_cache_slot", sizeof("last_cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_cache_slot);
	xc_autocheck_done_count ++;

#endif



	

#endif
	} while (0);
	

#ifdef ZEND_ENGINE_2
		
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "prototype", sizeof("prototype"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "prototype"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "prototype", sizeof("prototype"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->prototype);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2
	
	if (src->scope) {
		
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->scope == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "scope", sizeof("scope"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "scope"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "scope", sizeof("scope"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->scope);
	xc_autocheck_done_count ++;

#endif


	
#endif

	
	}
	
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_zend_op_array", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_calc_xc_constinfo_t */
	
 	  	 	static void inline 	xc_calc_xc_constinfo_t( 		 		xc_processor_t *processor, const xc_constinfo_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_constinfo_t*)NULL)->key) + sizeof(((xc_constinfo_t*)NULL)->key_size) + sizeof(((xc_constinfo_t*)NULL)->h) + sizeof(((xc_constinfo_t*)NULL)->constant)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","constant" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
	
	/* STRUCT(zend_constant,constant) */

	assert(sizeof(zend_constant) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zend_constant,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zend_constant) == sizeof((& src->constant)[0]));
	

	

	xc_calc_zend_constant(
		
		processor, & src->constant
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_constinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_calc_xc_op_array_info_detail_t */
	
 	  	 	static void inline 	xc_calc_xc_op_array_info_detail_t( 		 		xc_processor_t *processor, const xc_op_array_info_detail_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_detail_t*)NULL)->index) + sizeof(((xc_op_array_info_detail_t*)NULL)->info)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "index","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,index) */

	assert(sizeof(zend_uint) == sizeof(src->index));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "index", sizeof("index"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "index"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "index", sizeof("index"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->index);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,info) */

	assert(sizeof(zend_uint) == sizeof(src->info));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_op_array_info_detail_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_xc_op_array_info_t */
	
 	  	 	static void inline 	xc_calc_xc_op_array_info_t( 		 		xc_processor_t *processor, const xc_op_array_info_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_t*)NULL)->literalinfo_cnt) + sizeof(((xc_op_array_info_t*)NULL)->literalinfos)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "literalinfo_cnt","literalinfos" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
		#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,literalinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->literalinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfo_cnt", sizeof("literalinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfo_cnt", sizeof("literalinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->literalinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_op_array_info_detail_t) * src->literalinfo_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_op_array_info_detail_t) * src->literalinfo_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->literalinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_detail_t,literalinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_detail_t) == sizeof(src->literalinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_detail_t,DST(`literalinfos[LOOPCOUNTER]'),SRC(`literalinfos[LOOPCOUNTER]'),literalinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_detail_t) == sizeof((& src->literalinfos[i])[0]));
	

	

	xc_calc_xc_op_array_info_detail_t(
		
		processor, & src->literalinfos[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literalinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif



	}

#else
		
	/* PROCESS(zend_uint,oplineinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->oplineinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfo_cnt", sizeof("oplineinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfo_cnt", sizeof("oplineinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->oplineinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_op_array_info_detail_t) * src->oplineinfo_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_op_array_info_detail_t) * src->oplineinfo_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->oplineinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_detail_t,oplineinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_detail_t) == sizeof(src->oplineinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_detail_t,DST(`oplineinfos[LOOPCOUNTER]'),SRC(`oplineinfos[LOOPCOUNTER]'),oplineinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_detail_t) == sizeof((& src->oplineinfos[i])[0]));
	

	

	xc_calc_xc_op_array_info_detail_t(
		
		processor, & src->oplineinfos[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->oplineinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_op_array_info_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	

/* {{{ xc_calc_xc_funcinfo_t */
	
		/* export:  	  	 	void 	xc_calc_xc_funcinfo_t( 		 		xc_processor_t *processor, const xc_funcinfo_t * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_xc_funcinfo_t( 		 		xc_processor_t *processor, const xc_funcinfo_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_funcinfo_t*)NULL)->key) + sizeof(((xc_funcinfo_t*)NULL)->key_size) + sizeof(((xc_funcinfo_t*)NULL)->h) + sizeof(((xc_funcinfo_t*)NULL)->op_array_info) + sizeof(((xc_funcinfo_t*)NULL)->func)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","op_array_info","func" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	

	xc_calc_xc_op_array_info_t(
		
		processor, & src->op_array_info
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT(zend_function,func) */

	assert(sizeof(zend_function) == sizeof(src->func));
	
	
	
	/* STRUCT_P_EX(zend_function,DST(`func'),SRC(`func'),func,,&) */

	
	

	
	assert(sizeof(zend_function) == sizeof((& src->func)[0]));
	

	

	xc_calc_zend_function(
		
		processor, & src->func
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "func", sizeof("func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "func", sizeof("func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->func);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_funcinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_xc_classinfo_t */
	
		/* export:  	  	 	void 	xc_calc_xc_classinfo_t( 		 		xc_processor_t *processor, const xc_classinfo_t * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_xc_classinfo_t( 		 		xc_processor_t *processor, const xc_classinfo_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_classinfo_t*)NULL)->key) + sizeof(((xc_classinfo_t*)NULL)->key_size) + sizeof(((xc_classinfo_t*)NULL)->h) + sizeof(((xc_classinfo_t*)NULL)->methodinfo_cnt) + sizeof(((xc_classinfo_t*)NULL)->methodinfos) + sizeof(((xc_classinfo_t*)NULL)->cest)  ), assert_count = 6;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","methodinfo_cnt","methodinfos","cest" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,methodinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->methodinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfo_cnt", sizeof("methodinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfo_cnt", sizeof("methodinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->methodinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_op_array_info_t) * src->methodinfo_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_op_array_info_t) * src->methodinfo_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->methodinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_t,methodinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->methodinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`methodinfos[LOOPCOUNTER]'),SRC(`methodinfos[LOOPCOUNTER]'),methodinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->methodinfos[i])[0]));
	

	

	xc_calc_xc_op_array_info_t(
		
		processor, & src->methodinfos[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->methodinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif



	}

	
	
#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT_P(zend_class_entry,cest) */

	if (src->cest) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->cest)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_class_entry)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_class_entry);
	
	
	
	
	
	


	

	xc_calc_zend_class_entry(
		
		processor,  src->cest
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->cest == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(zend_class_entry,cest) */

	assert(sizeof(zend_class_entry) == sizeof(src->cest));
	
	
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,,&) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof((& src->cest)[0]));
	

	

	xc_calc_zend_class_entry(
		
		processor, & src->cest
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(int,oplineno) */

	assert(sizeof(int) == sizeof(src->oplineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineno", sizeof("oplineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "oplineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineno", sizeof("oplineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineno);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_classinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2_1

	
	

/* {{{ xc_calc_xc_autoglobal_t */
	
 	  	 	static void inline 	xc_calc_xc_autoglobal_t( 		 		xc_processor_t *processor, const xc_autoglobal_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_autoglobal_t*)NULL)->key) + sizeof(((xc_autoglobal_t*)NULL)->key_len) + sizeof(((xc_autoglobal_t*)NULL)->h)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_len","h" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_len) */

	assert(sizeof(zend_uint) == sizeof(src->key_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_len", sizeof("key_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_len", sizeof("key_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_len);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	/* PROC_ZSTRING_L(type,key,key_len) */
 
	
	/* PROC_ZSTRING_N(type,key,key_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->key, src->key_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->key, src->key_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_autoglobal_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


#ifdef XCACHE_ERROR_CACHING

	
	

/* {{{ xc_calc_xc_compilererror_t */
	
 	  	 	static void inline 	xc_calc_xc_compilererror_t( 		 		xc_processor_t *processor, const xc_compilererror_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_compilererror_t*)NULL)->type) + sizeof(((xc_compilererror_t*)NULL)->lineno) + sizeof(((xc_compilererror_t*)NULL)->error_len) + sizeof(((xc_compilererror_t*)NULL)->error)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","lineno","error_len","error" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
				
	/* PROCESS(int,type) */

	assert(sizeof(int) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,error_len) */

	assert(sizeof(int) == sizeof(src->error_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error_len", sizeof("error_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error_len", sizeof("error_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(error,error_len) */
 
	/* PROC_STRING_N(error,error_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error", sizeof("error"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error", sizeof("error"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->error == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->error), src->error_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_compilererror_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_calc_xc_entry_data_php_t */
	
		/* export:  	  	 	void 	xc_calc_xc_entry_data_php_t( 		 		xc_processor_t *processor, const xc_entry_data_php_t * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_xc_entry_data_php_t( 		 		xc_processor_t *processor, const xc_entry_data_php_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_data_php_t*)NULL)->next) + sizeof(((xc_entry_data_php_t*)NULL)->hvalue) + sizeof(((xc_entry_data_php_t*)NULL)->md5) + sizeof(((xc_entry_data_php_t*)NULL)->refcount) + sizeof(((xc_entry_data_php_t*)NULL)->hits) + sizeof(((xc_entry_data_php_t*)NULL)->size) + sizeof(((xc_entry_data_php_t*)NULL)->op_array_info) + sizeof(((xc_entry_data_php_t*)NULL)->op_array) + sizeof(((xc_entry_data_php_t*)NULL)->constinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->constinfos) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfos) + sizeof(((xc_entry_data_php_t*)NULL)->classinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->classinfos) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobal_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobals) + sizeof(((xc_entry_data_php_t*)NULL)->compilererror_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->compilererrors) + sizeof(((xc_entry_data_php_t*)NULL)->have_references)  ), assert_count = 19;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","hvalue","md5","refcount","hits","size","op_array_info","op_array","constinfo_cnt","constinfos","funcinfo_cnt","funcinfos","classinfo_cnt","classinfos","autoglobal_cnt","autoglobals","compilererror_cnt","compilererrors","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			

	/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(xc_hash_value_t,hvalue) */

	assert(sizeof(xc_hash_value_t) == sizeof(src->hvalue));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hvalue", sizeof("hvalue"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hvalue"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hvalue", sizeof("hvalue"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hvalue);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(xc_md5sum_t,md5) */

	assert(sizeof(xc_md5sum_t) == sizeof(src->md5));
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "md5", sizeof("md5"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "md5"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "md5", sizeof("md5"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->md5);
	xc_autocheck_done_count ++;

#endif


	

		
	/* PROCESS(zend_ulong,refcount) */

	assert(sizeof(zend_ulong) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	

	xc_calc_xc_op_array_info_t(
		
		processor, & src->op_array_info
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT_P(zend_op_array,op_array) */

	if (src->op_array) {
		
		
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof(( src->op_array)[0]));
	
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(zend_op_array)));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(zend_op_array);
	
	
	
	
	
	


	

	xc_calc_zend_op_array(
		
		processor,  src->op_array
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->op_array == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array", sizeof("op_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array", sizeof("op_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array);
	xc_autocheck_done_count ++;

#endif




#ifdef HAVE_XCACHE_CONSTANT
		
	/* PROCESS(zend_uint,constinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->constinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfo_cnt", sizeof("constinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfo_cnt", sizeof("constinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->constinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_constinfo_t) * src->constinfo_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_constinfo_t) * src->constinfo_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->constinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_constinfo_t,constinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_constinfo_t) == sizeof(src->constinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_constinfo_t,DST(`constinfos[LOOPCOUNTER]'),SRC(`constinfos[LOOPCOUNTER]'),constinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_constinfo_t) == sizeof((& src->constinfos[i])[0]));
	

	

	xc_calc_xc_constinfo_t(
		
		processor, & src->constinfos[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->constinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
	/* PROCESS(zend_uint,funcinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->funcinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfo_cnt", sizeof("funcinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfo_cnt", sizeof("funcinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->funcinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_funcinfo_t) * src->funcinfo_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_funcinfo_t) * src->funcinfo_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->funcinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_funcinfo_t,funcinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_funcinfo_t) == sizeof(src->funcinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_funcinfo_t,DST(`funcinfos[LOOPCOUNTER]'),SRC(`funcinfos[LOOPCOUNTER]'),funcinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_funcinfo_t) == sizeof((& src->funcinfos[i])[0]));
	

	

	xc_calc_xc_funcinfo_t(
		
		processor, & src->funcinfos[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->funcinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif



	}


		
	/* PROCESS(zend_uint,classinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->classinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfo_cnt", sizeof("classinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfo_cnt", sizeof("classinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->classinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_classinfo_t) * src->classinfo_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_classinfo_t) * src->classinfo_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->classinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_classinfo_t,classinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_classinfo_t) == sizeof(src->classinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_classinfo_t,DST(`classinfos[LOOPCOUNTER]'),SRC(`classinfos[LOOPCOUNTER]'),classinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_classinfo_t) == sizeof((& src->classinfos[i])[0]));
	

	

	xc_calc_xc_classinfo_t(
		
		processor, & src->classinfos[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->classinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif



	}

#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(zend_uint,autoglobal_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->autoglobal_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobal_cnt", sizeof("autoglobal_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobal_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobal_cnt", sizeof("autoglobal_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobal_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->autoglobals) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_autoglobal_t) * src->autoglobal_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_autoglobal_t) * src->autoglobal_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->autoglobal_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_autoglobal_t,autoglobals[LOOPCOUNTER],) */

	assert(sizeof(xc_autoglobal_t) == sizeof(src->autoglobals[i]));
	
	
	
	/* STRUCT_P_EX(xc_autoglobal_t,DST(`autoglobals[LOOPCOUNTER]'),SRC(`autoglobals[LOOPCOUNTER]'),autoglobals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_autoglobal_t) == sizeof((& src->autoglobals[i])[0]));
	

	

	xc_calc_xc_autoglobal_t(
		
		processor, & src->autoglobals[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->autoglobals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifdef XCACHE_ERROR_CACHING
		
	/* PROCESS(zend_uint,compilererror_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->compilererror_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererror_cnt", sizeof("compilererror_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererror_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererror_cnt", sizeof("compilererror_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererror_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->compilererrors) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
		
#ifndef NDEBUG
		
			xc_stack_push(&processor->allocsizes, (void *) (long) (sizeof(xc_compilererror_t) * src->compilererror_cnt));
			xc_stack_push(&processor->allocsizes, (void *) (long) (__LINE__));
		
#endif

		processor->size = (size_t) ALIGN(processor->size);
		processor->size += sizeof(xc_compilererror_t) * src->compilererror_cnt;
	
	
	
	
	
	

			

			for (i = 0;
					i < src->compilererror_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_compilererror_t,compilererrors[LOOPCOUNTER],) */

	assert(sizeof(xc_compilererror_t) == sizeof(src->compilererrors[i]));
	
	
	
	/* STRUCT_P_EX(xc_compilererror_t,DST(`compilererrors[LOOPCOUNTER]'),SRC(`compilererrors[LOOPCOUNTER]'),compilererrors[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_compilererror_t) == sizeof((& src->compilererrors[i])[0]));
	

	

	xc_calc_xc_compilererror_t(
		
		processor, & src->compilererrors[i]
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->compilererrors == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_bool,have_early_binding) */

	assert(sizeof(zend_bool) == sizeof(src->have_early_binding));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_early_binding", sizeof("have_early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_early_binding", sizeof("have_early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_early_binding);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_entry_data_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_xc_entry_t */
	
 	  	 	static void inline 	xc_calc_xc_entry_t( 		 		xc_processor_t *processor, const xc_entry_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_t*)NULL)->next) + sizeof(((xc_entry_t*)NULL)->size) + sizeof(((xc_entry_t*)NULL)->ctime) + sizeof(((xc_entry_t*)NULL)->atime) + sizeof(((xc_entry_t*)NULL)->dtime) + sizeof(((xc_entry_t*)NULL)->hits) + sizeof(((xc_entry_t*)NULL)->ttl) + sizeof(((xc_entry_t*)NULL)->name)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","size","ctime","atime","dtime","hits","ttl","name" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(time_t,ctime) */

	assert(sizeof(time_t) == sizeof(src->ctime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ctime", sizeof("ctime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ctime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ctime", sizeof("ctime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ctime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,atime) */

	assert(sizeof(time_t) == sizeof(src->atime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "atime", sizeof("atime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "atime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "atime", sizeof("atime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->atime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,dtime) */

	assert(sizeof(time_t) == sizeof(src->dtime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dtime", sizeof("dtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "dtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dtime", sizeof("dtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(long,ttl) */

	assert(sizeof(long) == sizeof(src->ttl));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ttl", sizeof("ttl"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ttl"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ttl", sizeof("ttl"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ttl);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif

 
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_entry_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_xc_entry_php_t */
	
		/* export:  	  	 	void 	xc_calc_xc_entry_php_t( 		 		xc_processor_t *processor, const xc_entry_php_t * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_xc_entry_php_t( 		 		xc_processor_t *processor, const xc_entry_php_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_php_t*)NULL)->entry) + sizeof(((xc_entry_php_t*)NULL)->php) + sizeof(((xc_entry_php_t*)NULL)->refcount) + sizeof(((xc_entry_php_t*)NULL)->file_mtime) + sizeof(((xc_entry_php_t*)NULL)->file_size) + sizeof(((xc_entry_php_t*)NULL)->file_device) + sizeof(((xc_entry_php_t*)NULL)->file_inode) + sizeof(((xc_entry_php_t*)NULL)->filepath_len) + sizeof(((xc_entry_php_t*)NULL)->filepath) + sizeof(((xc_entry_php_t*)NULL)->dirpath_len) + sizeof(((xc_entry_php_t*)NULL)->dirpath)  ), assert_count = 11;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","php","refcount","file_mtime","file_size","file_device","file_inode","filepath_len","filepath","dirpath_len","dirpath" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_calc_xc_entry_t(
		
		processor, & src->entry
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif



	
	
	

			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

		
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->entry.name.str.val), src->entry.name.str.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		
	
	
	


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "php", sizeof("php"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "php"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "php", sizeof("php"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->php);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(long,refcount) */

	assert(sizeof(long) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,file_mtime) */

	assert(sizeof(time_t) == sizeof(src->file_mtime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_mtime", sizeof("file_mtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_mtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_mtime", sizeof("file_mtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_mtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_size) */

	assert(sizeof(size_t) == sizeof(src->file_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_size", sizeof("file_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_size", sizeof("file_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_size);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_device) */

	assert(sizeof(size_t) == sizeof(src->file_device));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_device", sizeof("file_device"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_device"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_device", sizeof("file_device"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_device);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_inode) */

	assert(sizeof(size_t) == sizeof(src->file_inode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_inode", sizeof("file_inode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_inode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_inode", sizeof("file_inode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_inode);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(size_t,filepath_len) */

	assert(sizeof(size_t) == sizeof(src->filepath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath_len", sizeof("filepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath_len", sizeof("filepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(filepath,filepath_len) */
 
	/* PROC_STRING_N(filepath,filepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath", sizeof("filepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath", sizeof("filepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filepath == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->filepath), src->filepath_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(size_t,dirpath_len) */

	assert(sizeof(size_t) == sizeof(src->dirpath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath_len", sizeof("dirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath_len", sizeof("dirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(dirpath,dirpath_len) */
 
	/* PROC_STRING_N(dirpath,dirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath", sizeof("dirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath", sizeof("dirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->dirpath == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->dirpath), src->dirpath_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
		
	/* PROCESS(int,ufilepath_len) */

	assert(sizeof(int) == sizeof(src->ufilepath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath_len", sizeof("ufilepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath_len", sizeof("ufilepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(ufilepath,ufilepath_len) */
 
	/* PROC_USTRING_N(ufilepath,ufilepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath", sizeof("ufilepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath", sizeof("ufilepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->ufilepath == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, ZSTR(src->ufilepath), src->ufilepath_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(int,udirpath_len) */

	assert(sizeof(int) == sizeof(src->udirpath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath_len", sizeof("udirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath_len", sizeof("udirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(udirpath,udirpath_len) */
 
	/* PROC_USTRING_N(udirpath,udirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath", sizeof("udirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath", sizeof("udirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->udirpath == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, ZSTR(src->udirpath), src->udirpath_len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_entry_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_calc_xc_entry_var_t */
	
		/* export:  	  	 	void 	xc_calc_xc_entry_var_t( 		 		xc_processor_t *processor, const xc_entry_var_t * const src 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_calc_xc_entry_var_t( 		 		xc_processor_t *processor, const xc_entry_var_t * const src 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_var_t*)NULL)->entry) + sizeof(((xc_entry_var_t*)NULL)->value) + sizeof(((xc_entry_var_t*)NULL)->have_references)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","value","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_calc_xc_entry_t(
		
		processor, & src->entry
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif




#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,name_type) */

	assert(sizeof(zend_uchar) == sizeof(src->name_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_type", sizeof("name_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "name_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_type", sizeof("name_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	
	

#ifdef IS_UNICODE
		if (src->name_type == IS_UNICODE) {
				
	/* PROCESS(int32_t,entry.name.ustr.len) */

	assert(sizeof(int32_t) == sizeof(src->entry.name.ustr.len));
		
	
	
	

	

		}
		else {
				
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

		}
#else
			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

#endif
		
#ifdef IS_UNICODE
			
	/* PROC_ZSTRING_L(name_type,entry.name.uni.val,entry.name.uni.len) */
 
	
	/* PROC_ZSTRING_N(name_type,entry.name.uni.val,entry.name.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
		if (src->name_type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_UNICODE, src->entry.name.uni.val, src->entry.name.uni.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->entry.name.uni.val, src->entry.name.uni.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, src->entry.name.uni.val, src->entry.name.uni.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#else
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
	}
	else {
		
		xc_calc_string_n(processor, IS_STRING, ZSTR(src->entry.name.str.val), src->entry.name.str.len + 1 C_RELAYLINE);
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
		
	
	
	

	
	
	
	
	/* STRUCT_P_EX(zval_ptr,dst->value,src->value,value,,&) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((& src->value)[0]));
	

	

	xc_calc_zval_ptr(
		
		processor, & src->value
		
		
		
		TSRMLS_CC
	);

	

	
	

		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_calc_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_calc_xc_entry_var_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_calc_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_calc_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



  /* {{{ Pre-declare */
 	  	 	void 	xc_store_zval( 		 		 		xc_processor_t *processor, zval *dst, const zval * const src 		 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_store_zval_ptr( 		 		 		xc_processor_t *processor, zval_ptr *dst, const zval_ptr * const src 		 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_store_zval_ptr_nullable( 		 		 		xc_processor_t *processor, zval_ptr_nullable *dst, const zval_ptr_nullable * const src 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_store_zend_op_array( 		 		 		xc_processor_t *processor, zend_op_array *dst, const zend_op_array * const src 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_store_zend_class_entry( 		 		 		xc_processor_t *processor, zend_class_entry *dst, const zend_class_entry * const src 		 		 		TSRMLS_DC 	); 	
#ifdef HAVE_XCACHE_CONSTANT
 	  	 	static void inline 	xc_store_zend_constant( 		 		 		xc_processor_t *processor, zend_constant *dst, const zend_constant * const src 		 		 		TSRMLS_DC 	); 	
#endif
 	  	 	void 	xc_store_zend_function( 		 		 		xc_processor_t *processor, zend_function *dst, const zend_function * const src 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_store_xc_entry_var_t( 		 		 		xc_processor_t *processor, xc_entry_var_t *dst, const xc_entry_var_t * const src 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_store_xc_entry_php_t( 		 		 		xc_processor_t *processor, xc_entry_php_t *dst, const xc_entry_php_t * const src 		 		 		TSRMLS_DC 	); 	
#ifdef ZEND_ENGINE_2
 	  	 	static void inline 	xc_store_zend_property_info( 		 		 		xc_processor_t *processor, zend_property_info *dst, const zend_property_info * const src 		 		 		TSRMLS_DC 	); 	
#endif
/* }}} */
#ifdef IS_CV

	
	

/* {{{ xc_store_zend_compiled_variable */
	
 	  	 	static void inline 	xc_store_zend_compiled_variable( 		 		 		xc_processor_t *processor, zend_compiled_variable *dst, const zend_compiled_variable * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_compiled_variable*)NULL)->name) + sizeof(((zend_compiled_variable*)NULL)->name_len) + sizeof(((zend_compiled_variable*)NULL)->hash_value)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","hash_value" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_compiled_variable));
			do {
		

		
				
	/* PROCESS(int,name_len) */

	assert(sizeof(int) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->name, src->name_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,hash_value) */

	assert(sizeof(ulong) == sizeof(src->hash_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_compiled_variable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zend_uint */
	
 	  	 	static void inline 	xc_store_zend_uint( 		 		 		xc_processor_t *processor, zend_uint *dst, const zend_uint * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_uint), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_uint));
			do {
		

		
			dst[0] = src[0];
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_uint", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifndef ZEND_ENGINE_2

	
	

/* {{{ xc_store_int */
	
 	  	 	static void inline 	xc_store_int( 		 		 		xc_processor_t *processor, int *dst, const int * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(int), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(int));
			do {
		

		
			*dst = *src;
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_int", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_store_zend_try_catch_element */
	
 	  	 	static void inline 	xc_store_zend_try_catch_element( 		 		 		xc_processor_t *processor, zend_try_catch_element *dst, const zend_try_catch_element * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_try_catch_element*)NULL)->try_op) + sizeof(((zend_try_catch_element*)NULL)->catch_op) + sizeof(((zend_try_catch_element*)NULL)->finally_op) + sizeof(((zend_try_catch_element*)NULL)->finally_end)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "try_op","catch_op","finally_op","finally_end" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_try_catch_element));
			do {
		

		
				
	/* PROCESS(zend_uint,try_op) */

	assert(sizeof(zend_uint) == sizeof(src->try_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_op", sizeof("try_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_op", sizeof("try_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,catch_op) */

	assert(sizeof(zend_uint) == sizeof(src->catch_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "catch_op", sizeof("catch_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "catch_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "catch_op", sizeof("catch_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->catch_op);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,finally_op) */

	assert(sizeof(zend_uint) == sizeof(src->finally_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_op", sizeof("finally_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_op", sizeof("finally_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,finally_end) */

	assert(sizeof(zend_uint) == sizeof(src->finally_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_end", sizeof("finally_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_end", sizeof("finally_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_end);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_try_catch_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zend_brk_cont_element */
	
 	  	 	static void inline 	xc_store_zend_brk_cont_element( 		 		 		xc_processor_t *processor, zend_brk_cont_element *dst, const zend_brk_cont_element * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_brk_cont_element*)NULL)->start) + sizeof(((zend_brk_cont_element*)NULL)->cont) + sizeof(((zend_brk_cont_element*)NULL)->brk) + sizeof(((zend_brk_cont_element*)NULL)->parent)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "start","cont","brk","parent" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_brk_cont_element));
			do {
		

		
		#ifdef ZEND_ENGINE_2_2
		
	/* PROCESS(int,start) */

	assert(sizeof(int) == sizeof(src->start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start", sizeof("start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start", sizeof("start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(int,cont) */

	assert(sizeof(int) == sizeof(src->cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cont", sizeof("cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cont", sizeof("cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cont);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,brk) */

	assert(sizeof(int) == sizeof(src->brk));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk", sizeof("brk"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk", sizeof("brk"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,parent) */

	assert(sizeof(int) == sizeof(src->parent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_brk_cont_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	
	

/* {{{ xc_store_HashTable_zval_ptr */
	
 	  	 	static void inline 	xc_store_HashTable_zval_ptr( 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(HashTable));
			do {
		

		
		
		
	

				
				Bucket *srcBucket;
		Bucket *pnew = NULL, *prev = NULL;
		zend_bool first = 1;
				uint n;
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		dst->pInternalPointer = NULL;	/* Used for element traversal */ 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		dst->pListHead = NULL; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`arBuckets')',`Bucket*',`src->nTableSize',`1',`' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(Bucket*) * src->nTableSize;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`arBuckets')',`Bucket*',`src->nTableSize',`1',`' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->arBuckets = (Bucket* *) (processor->p = (char *) ALIGN(processor->p));
		
				memset(dst->arBuckets, 0, sizeof(Bucket*) * src->nTableSize);
		
		processor->p += sizeof(Bucket*) * src->nTableSize;

		
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `pnew',`char',`bucketsize',`',`Bucket' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(char) * bucketsize;
				if (expect != real) {
					fprintf(stderr, "mismatch `pnew',`char',`bucketsize',`',`Bucket' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		pnew = (Bucket *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(pnew, (void *) (unsigned long) __LINE__, sizeof(char) * bucketsize);
#endif

			
		processor->p += sizeof(char) * bucketsize;

		
	
	
	
	
	

			
#ifdef ZEND_ENGINE_2_4
				memcpy(pnew, srcBucket, BUCKET_HEAD_SIZE(Bucket));
				if (BUCKET_KEY_SIZE(srcBucket)) {
					memcpy((char *) (pnew + 1), srcBucket->arKey, BUCKET_KEY_SIZE(srcBucket));
					pnew->arKey = (const char *) (pnew + 1);
				}
				else {
					pnew->arKey = NULL;
				}
#else
				memcpy(pnew, srcBucket, bucketsize);
#endif
				n = srcBucket->h & src->nTableMask;
				/* pnew into hash node chain */
				pnew->pLast = NULL;
				pnew->pNext = dst->arBuckets[n];
				if (pnew->pNext) {
					pnew->pNext->pLast = pnew;
				}
				dst->arBuckets[n] = pnew;
			
			
			if (sizeof(void *) == sizeof(zval_ptr)) {
				pnew->pData = &pnew->pDataPtr;
								
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  ((zval_ptr*)srcBucket->pData))[0]));
	

	

	xc_store_zval_ptr(
		
		
		processor,   pnew->pData,   ((zval_ptr*)srcBucket->pData)
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof(( ((zval_ptr*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `pnew->pData',`zval_ptr' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zval_ptr);
				if (expect != real) {
					fprintf(stderr, "mismatch `pnew->pData',`zval_ptr' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		pnew->pData = (zval_ptr *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(pnew->pData, (void *) (unsigned long) __LINE__, sizeof(zval_ptr));
#endif

			
		processor->p += sizeof(zval_ptr);

		
	
	
	
	
	


	

	xc_store_zval_ptr(
		
		
		processor,  pnew->pData,  ((zval_ptr*)srcBucket->pData)
		
		
		TSRMLS_CC
	);

	

	
	
	pnew->pData = (zval_ptr *) processor->shm->handlers->to_readonly(processor->shm, (void *)pnew->pData);


				pnew->pDataPtr = NULL;
			}

			if (first) {
				dst->pListHead = pnew;
				first = 0;
			}

			
				/* flat link */
				pnew->pListLast = prev;
				pnew->pListNext = NULL;
				if (prev) {
					prev->pListNext = pnew;
				}
				prev = pnew;
			
		}
		
	
	

				
	dst->arBuckets = (Bucket * *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->arBuckets);

#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		dst->pListTail = pnew; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		dst->pDestructor = src->pDestructor; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_HashTable_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	
	

/* {{{ xc_store_HashTable_zend_function */
	
		/* export:  	  	 	void 	xc_store_HashTable_zend_function( 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_HashTable_zend_function( 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(HashTable));
			do {
		

		
		
		
	

				
				Bucket *srcBucket;
		Bucket *pnew = NULL, *prev = NULL;
		zend_bool first = 1;
				uint n;
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		dst->pInternalPointer = NULL;	/* Used for element traversal */ 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		dst->pListHead = NULL; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`arBuckets')',`Bucket*',`src->nTableSize',`1',`' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(Bucket*) * src->nTableSize;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`arBuckets')',`Bucket*',`src->nTableSize',`1',`' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->arBuckets = (Bucket* *) (processor->p = (char *) ALIGN(processor->p));
		
				memset(dst->arBuckets, 0, sizeof(Bucket*) * src->nTableSize);
		
		processor->p += sizeof(Bucket*) * src->nTableSize;

		
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `pnew',`char',`bucketsize',`',`Bucket' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(char) * bucketsize;
				if (expect != real) {
					fprintf(stderr, "mismatch `pnew',`char',`bucketsize',`',`Bucket' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		pnew = (Bucket *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(pnew, (void *) (unsigned long) __LINE__, sizeof(char) * bucketsize);
#endif

			
		processor->p += sizeof(char) * bucketsize;

		
	
	
	
	
	

			
#ifdef ZEND_ENGINE_2_4
				memcpy(pnew, srcBucket, BUCKET_HEAD_SIZE(Bucket));
				if (BUCKET_KEY_SIZE(srcBucket)) {
					memcpy((char *) (pnew + 1), srcBucket->arKey, BUCKET_KEY_SIZE(srcBucket));
					pnew->arKey = (const char *) (pnew + 1);
				}
				else {
					pnew->arKey = NULL;
				}
#else
				memcpy(pnew, srcBucket, bucketsize);
#endif
				n = srcBucket->h & src->nTableMask;
				/* pnew into hash node chain */
				pnew->pLast = NULL;
				pnew->pNext = dst->arBuckets[n];
				if (pnew->pNext) {
					pnew->pNext->pLast = pnew;
				}
				dst->arBuckets[n] = pnew;
			
			
			if (sizeof(void *) == sizeof(zend_function)) {
				pnew->pData = &pnew->pDataPtr;
								
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_function) == sizeof((  ((zend_function*)srcBucket->pData))[0]));
	

	

	xc_store_zend_function(
		
		
		processor,   pnew->pData,   ((zend_function*)srcBucket->pData)
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_function) == sizeof(( ((zend_function*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `pnew->pData',`zend_function' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_function);
				if (expect != real) {
					fprintf(stderr, "mismatch `pnew->pData',`zend_function' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		pnew->pData = (zend_function *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(pnew->pData, (void *) (unsigned long) __LINE__, sizeof(zend_function));
#endif

			
		processor->p += sizeof(zend_function);

		
	
	
	
	
	


	

	xc_store_zend_function(
		
		
		processor,  pnew->pData,  ((zend_function*)srcBucket->pData)
		
		
		TSRMLS_CC
	);

	

	
	
	pnew->pData = (zend_function *) processor->shm->handlers->to_readonly(processor->shm, (void *)pnew->pData);


				pnew->pDataPtr = NULL;
			}

			if (first) {
				dst->pListHead = pnew;
				first = 0;
			}

			
				/* flat link */
				pnew->pListLast = prev;
				pnew->pListNext = NULL;
				if (prev) {
					prev->pListNext = pnew;
				}
				prev = pnew;
			
		}
		
	
	

				
	dst->arBuckets = (Bucket * *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->arBuckets);

#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		dst->pListTail = pnew; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		dst->pDestructor = src->pDestructor; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_function : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_HashTable_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2

	
	
	

/* {{{ xc_store_HashTable_zend_property_info */
	
 	  	 	static void inline 	xc_store_HashTable_zend_property_info( 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(HashTable));
			do {
		

		
		
		
	

				
				Bucket *srcBucket;
		Bucket *pnew = NULL, *prev = NULL;
		zend_bool first = 1;
				uint n;
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		dst->pInternalPointer = NULL;	/* Used for element traversal */ 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		dst->pListHead = NULL; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`arBuckets')',`Bucket*',`src->nTableSize',`1',`' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(Bucket*) * src->nTableSize;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`arBuckets')',`Bucket*',`src->nTableSize',`1',`' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->arBuckets = (Bucket* *) (processor->p = (char *) ALIGN(processor->p));
		
				memset(dst->arBuckets, 0, sizeof(Bucket*) * src->nTableSize);
		
		processor->p += sizeof(Bucket*) * src->nTableSize;

		
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `pnew',`char',`bucketsize',`',`Bucket' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(char) * bucketsize;
				if (expect != real) {
					fprintf(stderr, "mismatch `pnew',`char',`bucketsize',`',`Bucket' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		pnew = (Bucket *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(pnew, (void *) (unsigned long) __LINE__, sizeof(char) * bucketsize);
#endif

			
		processor->p += sizeof(char) * bucketsize;

		
	
	
	
	
	

			
#ifdef ZEND_ENGINE_2_4
				memcpy(pnew, srcBucket, BUCKET_HEAD_SIZE(Bucket));
				if (BUCKET_KEY_SIZE(srcBucket)) {
					memcpy((char *) (pnew + 1), srcBucket->arKey, BUCKET_KEY_SIZE(srcBucket));
					pnew->arKey = (const char *) (pnew + 1);
				}
				else {
					pnew->arKey = NULL;
				}
#else
				memcpy(pnew, srcBucket, bucketsize);
#endif
				n = srcBucket->h & src->nTableMask;
				/* pnew into hash node chain */
				pnew->pLast = NULL;
				pnew->pNext = dst->arBuckets[n];
				if (pnew->pNext) {
					pnew->pNext->pLast = pnew;
				}
				dst->arBuckets[n] = pnew;
			
			
			if (sizeof(void *) == sizeof(zend_property_info)) {
				pnew->pData = &pnew->pDataPtr;
								
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof((  ((zend_property_info*)srcBucket->pData))[0]));
	

	

	xc_store_zend_property_info(
		
		
		processor,   pnew->pData,   ((zend_property_info*)srcBucket->pData)
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof(( ((zend_property_info*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `pnew->pData',`zend_property_info' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_property_info);
				if (expect != real) {
					fprintf(stderr, "mismatch `pnew->pData',`zend_property_info' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		pnew->pData = (zend_property_info *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(pnew->pData, (void *) (unsigned long) __LINE__, sizeof(zend_property_info));
#endif

			
		processor->p += sizeof(zend_property_info);

		
	
	
	
	
	


	

	xc_store_zend_property_info(
		
		
		processor,  pnew->pData,  ((zend_property_info*)srcBucket->pData)
		
		
		TSRMLS_CC
	);

	

	
	
	pnew->pData = (zend_property_info *) processor->shm->handlers->to_readonly(processor->shm, (void *)pnew->pData);


				pnew->pDataPtr = NULL;
			}

			if (first) {
				dst->pListHead = pnew;
				first = 0;
			}

			
				/* flat link */
				pnew->pListLast = prev;
				pnew->pListNext = NULL;
				if (prev) {
					prev->pListNext = pnew;
				}
				prev = pnew;
			
		}
		
	
	

				
	dst->arBuckets = (Bucket * *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->arBuckets);

#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		dst->pListTail = pnew; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		dst->pDestructor = src->pDestructor; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_HashTable_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif
#ifdef IS_CONSTANT_AST


	
	

/* {{{ xc_store_zend_ast */
	
		/* export:  	  	 	void 	xc_store_zend_ast( 		 		 		xc_processor_t *processor, zend_ast *dst, const zend_ast * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_zend_ast( 		 		 		xc_processor_t *processor, zend_ast *dst, const zend_ast * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_ast*)NULL)->kind) + sizeof(((zend_ast*)NULL)->children) + sizeof(((zend_ast*)NULL)->u)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "kind","children","u" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_ast));
			do {
		

		
				zend_ushort i;
			
	/* PROCESS(zend_ushort,kind) */

	assert(sizeof(zend_ushort) == sizeof(src->kind));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "kind", sizeof("kind"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "kind"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "kind", sizeof("kind"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->kind);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_ushort,children) */

	assert(sizeof(zend_ushort) == sizeof(src->children));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "children", sizeof("children"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "children"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "children", sizeof("children"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->children);
	xc_autocheck_done_count ++;

#endif



	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


		
	
	

			if (src->kind == ZEND_CONST) {
				assert(src->u.val);
				
					dst->u.val = (zval *) (dst + 1);
					memcpy(dst->u.val, src->u.val, sizeof(zval));
				
				
	
	/* STRUCT_P_EX(zval,dst->u.val,src->u.val,[],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src->u.val)[0]));
	

	

	xc_store_zval(
		
		
		processor,   dst->u.val,   src->u.val
		
		
		TSRMLS_CC
	);

	

	
	

				
	dst->u.val = (zval *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->u.val);

			}
			else {
				for (i = 0; i < src->children; ++i) {
					zend_ast *src_ast = (&src->u.child)[i];
					if (src_ast) {
						{
	
		size_t zend_ast_size = (src_ast->kind == ZEND_CONST)
		 ? sizeof(zend_ast) + sizeof(zval)
		 : sizeof(zend_ast) + sizeof(zend_ast *) * (src_ast->children - 1);
	

	
	
							
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `(&dst->u.child)[i]',`zend_ast' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = zend_ast_size;
				if (expect != real) {
					fprintf(stderr, "mismatch `(&dst->u.child)[i]',`zend_ast' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		(&dst->u.child)[i] = (zend_ast *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr((&dst->u.child)[i], (void *) (unsigned long) __LINE__, zend_ast_size);
#endif

			
		processor->p += zend_ast_size;

		
	
	
	
	
	

							
	
	/* STRUCT_P_EX(zend_ast,(&dst->u.child)[i],src_ast,[],, ) */

	
	

	
	assert(sizeof(zend_ast) == sizeof((  src_ast)[0]));
	

	

	xc_store_zend_ast(
		
		
		processor,   (&dst->u.child)[i],   src_ast
		
		
		TSRMLS_CC
	);

	

	
	

						
	
}

						
	(&dst->u.child)[i] = (zend_ast *) processor->shm->handlers->to_readonly(processor->shm, (void *)(&dst->u.child)[i]);

					}
					else {
						(&dst->u.child)[i] = NULL;
					}
				}
			}
		
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_ast", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zval */
	
		/* export:  	  	 	void 	xc_store_zval( 		 		 		xc_processor_t *processor, zval *dst, const zval * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_zval( 		 		 		xc_processor_t *processor, zval *dst, const zval * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zval*)NULL)->value) + sizeof(((zval*)NULL)->refcount__gc) + sizeof(((zval*)NULL)->type) + sizeof(((zval*)NULL)->is_ref__gc)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","refcount__gc","type","is_ref__gc" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zval));
			do {
		

		
			
				/* Variable information */
		
	
	

		switch ((Z_TYPE_P(src) & IS_CONSTANT_TYPE_MASK)) {
			case IS_LONG:
			case IS_RESOURCE:
			case IS_BOOL:
					
	/* PROCESS(long,value.lval) */

	assert(sizeof(long) == sizeof(src->value.lval));
		
	
	
	

	

				break;
			case IS_DOUBLE:
					
	/* PROCESS(double,value.dval) */

	assert(sizeof(double) == sizeof(src->value.dval));
		
	
	
	

	

				break;
			case IS_NULL:
				
				break;

			case IS_CONSTANT:
#ifdef IS_UNICODE
				if (UG(unicode)) {
					goto proc_unicode;
				}
#endif
			case IS_STRING:
#ifdef FLAG_IS_BC
			case FLAG_IS_BC:
#endif
					
	/* PROCESS(int,value.str.len) */

	assert(sizeof(int) == sizeof(src->value.str.len));
		
	
	
	

	

				
	/* PROC_STRING_L(value.str.val,value.str.len) */
 
	/* PROC_STRING_N(value.str.val,value.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->value.str.val == NULL) {
		
		
	}
	else {
		
		
		dst->value.str.val =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->value.str.val), src->value.str.len + 1 C_RELAYLINE));
		
		
	dst->value.str.val = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->value.str.val);

		
	}
	
	
	
	
	
	
	

				break;
#ifdef IS_UNICODE
			case IS_UNICODE:
proc_unicode:
					
	/* PROCESS(int32_t,value.uni.len) */

	assert(sizeof(int32_t) == sizeof(src->value.uni.len));
		
	
	
	

	

				
	/* PROC_ZSTRING_L(1,value.uni.val,value.uni.len) */
 
	
	/* PROC_ZSTRING_N(1,value.uni.val,value.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->value.uni.val) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->value.uni.val) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->value.uni.val, src->value.uni.len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->value.uni.val) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->value.uni.val));

		
	}
	
	
	
	
	
	
	

	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->value.uni.val) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->value.uni.val) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->value.uni.val, src->value.uni.len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->value.uni.val) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->value.uni.val));

		
	}
	
	
	
	
	
	
	

#endif
	

				break;
#endif

			case IS_ARRAY:
#ifdef IS_CONSTANT_ARRAY
			case IS_CONSTANT_ARRAY:
#endif
				assert(src->value.ht);
				
	
	/* STRUCT_P(HashTable,value.ht,HashTable_zval_ptr) */

	if (src->value.ht) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.ht'),SRC(`value.ht'),value.ht,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.ht)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`value.ht')',`HashTable' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(HashTable);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`value.ht')',`HashTable' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->value.ht = (HashTable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->value.ht, (void *) (unsigned long) __LINE__, sizeof(HashTable));
#endif

			
		processor->p += sizeof(HashTable);

		
	
	
	
	
	


	

	xc_store_HashTable_zval_ptr(
		
		
		processor,  dst->value.ht,  src->value.ht
		
		
		TSRMLS_CC
	);

	

	
	
	dst->value.ht = (HashTable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->value.ht);


	}
	else {
		
		
	
	
	assert(src->value.ht == NULL);

	}
	

				break;

#ifdef IS_CONSTANT_AST
			case IS_CONSTANT_AST:
				assert(src->value.ast);
				{
	
		size_t zend_ast_size = (src->value.ast->kind == ZEND_CONST)
		 ? sizeof(zend_ast) + sizeof(zval)
		 : sizeof(zend_ast) + sizeof(zend_ast *) * (src->value.ast->children - 1);
	

	
	
	
	/* STRUCT_P(zend_ast,value.ast) */

	if (src->value.ast) {
		
		
	
	/* STRUCT_P_EX(zend_ast,DST(`value.ast'),SRC(`value.ast'),value.ast,) */

	
	

	
	assert(sizeof(zend_ast) == sizeof(( src->value.ast)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`value.ast')',`zend_ast' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = zend_ast_size;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`value.ast')',`zend_ast' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->value.ast = (zend_ast *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->value.ast, (void *) (unsigned long) __LINE__, zend_ast_size);
#endif

			
		processor->p += zend_ast_size;

		
	
	
	
	
	


	

	xc_store_zend_ast(
		
		
		processor,  dst->value.ast,  src->value.ast
		
		
		TSRMLS_CC
	);

	

	
	
	dst->value.ast = (zend_ast *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->value.ast);


	}
	else {
		
		
	
	
	assert(src->value.ast == NULL);

	}
	

	
}

				break;
#endif

			case IS_OBJECT:
				
				#ifndef ZEND_ENGINE_2
				
	
	/* STRUCT_P(zend_class_entry,value.obj.ce) */

	if (src->value.obj.ce) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`value.obj.ce'),SRC(`value.obj.ce'),value.obj.ce,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->value.obj.ce)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`value.obj.ce')',`zend_class_entry' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_class_entry);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`value.obj.ce')',`zend_class_entry' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->value.obj.ce = (zend_class_entry *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->value.obj.ce, (void *) (unsigned long) __LINE__, sizeof(zend_class_entry));
#endif

			
		processor->p += sizeof(zend_class_entry);

		
	
	
	
	
	


	

	xc_store_zend_class_entry(
		
		
		processor,  dst->value.obj.ce,  src->value.obj.ce
		
		
		TSRMLS_CC
	);

	

	
	
	dst->value.obj.ce = (zend_class_entry *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->value.obj.ce);


	}
	else {
		
		
	
	
	assert(src->value.obj.ce == NULL);

	}
	

				
	
	/* STRUCT_P(HashTable,value.obj.properties,HashTable_zval_ptr) */

	if (src->value.obj.properties) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.obj.properties'),SRC(`value.obj.properties'),value.obj.properties,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.obj.properties)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`value.obj.properties')',`HashTable' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(HashTable);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`value.obj.properties')',`HashTable' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->value.obj.properties = (HashTable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->value.obj.properties, (void *) (unsigned long) __LINE__, sizeof(HashTable));
#endif

			
		processor->p += sizeof(HashTable);

		
	
	
	
	
	


	

	xc_store_HashTable_zval_ptr(
		
		
		processor,  dst->value.obj.properties,  src->value.obj.properties
		
		
		TSRMLS_CC
	);

	

	
	
	dst->value.obj.properties = (HashTable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->value.obj.properties);


	}
	else {
		
		
	
	
	assert(src->value.obj.properties == NULL);

	}
	

#endif
				break;

			default:
				assert(0);
		}
		
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(xc_zval_type_t,type) */

	assert(sizeof(xc_zval_type_t) == sizeof(src->type));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uchar,is_ref__gc) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref__gc));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref__gc", sizeof("is_ref__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref__gc", sizeof("is_ref__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref__gc);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_uchar,is_ref) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref", sizeof("is_ref"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref", sizeof("is_ref"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uint,refcount__gc) */

	assert(sizeof(zend_uint) == sizeof(src->refcount__gc));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount__gc", sizeof("refcount__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount__gc", sizeof("refcount__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount__gc);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2)
			
	/* PROCESS(zend_uint,refcount) */

	assert(sizeof(zend_uint) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_ushort,refcount) */

	assert(sizeof(zend_ushort) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zval", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_zval_ptr */
	
 	  	 	static void inline 	xc_store_zval_ptr( 		 		 		xc_processor_t *processor, zval_ptr *dst, const zval_ptr * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zval_ptr));
			do {
		

		
			
		do {
			
				if (processor->reference) {
					zval_ptr *ppzv;
					if (zend_hash_find(&processor->zvalptrs, (char *) &src[0], sizeof(src[0]), (void **) &ppzv) == SUCCESS) {
						
							dst[0] = *ppzv;
							/* *dst is updated */
													
						processor->have_references = 1;
						assert(xc_is_shm(dst[0]));
						
						break;
					}
				}
			
			
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `dst[0]',`zval' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zval);
				if (expect != real) {
					fprintf(stderr, "mismatch `dst[0]',`zval' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst[0] = (zval *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst[0], (void *) (unsigned long) __LINE__, sizeof(zval));
#endif

			
		processor->p += sizeof(zval);

		
	
	
	
	
	

			
				if (processor->reference) {
					
						zval_ptr pzv = dst[0];
						
	pzv = (zval *) processor->shm->handlers->to_readonly(processor->shm, (void *)pzv);

					
					if (zend_hash_add(&processor->zvalptrs, (char *) &src[0], sizeof(src[0]), (void *) &pzv, sizeof(pzv), NULL) == SUCCESS) {
						/* first add, go on */
											}
					else {
						assert(0);
					}
				}
			
			
							
			
			
	
	/* STRUCT_P_EX(zval,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src[0])[0]));
	

	

	xc_store_zval(
		
		
		processor,   dst[0],   src[0]
		
		
		TSRMLS_CC
	);

	

	
	

			
	dst[0] = (zval *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst[0]);

		} while (0);
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_zval_ptr_nullable */
	
 	  	 	static void inline 	xc_store_zval_ptr_nullable( 		 		 		xc_processor_t *processor, zval_ptr_nullable *dst, const zval_ptr_nullable * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr_nullable), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zval_ptr_nullable));
			do {
		

		
			if (src[0]) {
		
		
	
	/* STRUCT_P_EX(zval_ptr,dst,src,,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  src)[0]));
	

	xc_store_zval_ptr(
		
		
		processor,   dst,   src
		
		
		TSRMLS_CC
	);

	
	

		
	}
	else {
		
	
	
	assert(src[0] == NULL);

	}
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr_nullable);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zval_ptr_nullable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_store_zend_arg_info */
	
 	  	 	static void inline 	xc_store_zend_arg_info( 		 		 		xc_processor_t *processor, zend_arg_info *dst, const zend_arg_info * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_arg_info*)NULL)->name) + sizeof(((zend_arg_info*)NULL)->name_len) + sizeof(((zend_arg_info*)NULL)->class_name) + sizeof(((zend_arg_info*)NULL)->class_name_len) + sizeof(((zend_arg_info*)NULL)->type_hint) + sizeof(((zend_arg_info*)NULL)->pass_by_reference) + sizeof(((zend_arg_info*)NULL)->allow_null) + sizeof(((zend_arg_info*)NULL)->is_variadic)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","class_name","class_name_len","type_hint","pass_by_reference","allow_null","is_variadic" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_arg_info));
			do {
		

		
				
	/* PROCESS(zend_uint,name_len) */

	assert(sizeof(zend_uint) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->name, src->name_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(zend_uint,class_name_len) */

	assert(sizeof(zend_uint) == sizeof(src->class_name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name_len", sizeof("class_name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name_len", sizeof("class_name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,class_name,class_name_len) */
 
	
	/* PROC_ZSTRING_N(,class_name,class_name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->class_name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->class_name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->class_name, src->class_name_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->class_name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->class_name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->class_name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->class_name, src->class_name_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->class_name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->class_name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->class_name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->class_name, src->class_name_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->class_name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->class_name));

		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,type_hint) */

	assert(sizeof(zend_uchar) == sizeof(src->type_hint));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type_hint", sizeof("type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type_hint", sizeof("type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type_hint);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2_1)
		
	/* PROCESS(zend_bool,array_type_hint) */

	assert(sizeof(zend_bool) == sizeof(src->array_type_hint));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "array_type_hint", sizeof("array_type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "array_type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "array_type_hint", sizeof("array_type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->array_type_hint);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_uchar,pass_by_reference) */

	assert(sizeof(zend_uchar) == sizeof(src->pass_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,allow_null) */

	assert(sizeof(zend_bool) == sizeof(src->allow_null));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "allow_null", sizeof("allow_null"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "allow_null"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "allow_null", sizeof("allow_null"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->allow_null);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_bool,is_variadic) */

	assert(sizeof(zend_bool) == sizeof(src->is_variadic));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_variadic", sizeof("is_variadic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "is_variadic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_variadic", sizeof("is_variadic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_variadic);
	xc_autocheck_done_count ++;

#endif



	

#else
		
	/* PROCESS(zend_bool,pass_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,return_reference) */

	assert(sizeof(zend_bool) == sizeof(src->return_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,required_num_args) */

	assert(sizeof(int) == sizeof(src->required_num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_arg_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_store_zend_constant */
	
 	  	 	static void inline 	xc_store_zend_constant( 		 		 		xc_processor_t *processor, zend_constant *dst, const zend_constant * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_constant*)NULL)->value) + sizeof(((zend_constant*)NULL)->flags) + sizeof(((zend_constant*)NULL)->name) + sizeof(((zend_constant*)NULL)->name_len) + sizeof(((zend_constant*)NULL)->module_number)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","flags","name","name_len","module_number" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_constant));
			do {
		

		
			
	
	/* STRUCT(zval,value) */

	assert(sizeof(zval) == sizeof(src->value));
	
	
	
	/* STRUCT_P_EX(zval,DST(`value'),SRC(`value'),value,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->value)[0]));
	

	

	xc_store_zval(
		
		
		processor, & dst->value, & src->value
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(int,flags) */

	assert(sizeof(int) == sizeof(src->flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,name_len) */

	assert(sizeof(uint) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	/* PROC_ZSTRING_N(,name,name_len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->name, src->name_len C_RELAYLINE));
		
		
	ZSTR_U(dst->name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_len C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_len C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(int,module_number) */

	assert(sizeof(int) == sizeof(src->module_number));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module_number", sizeof("module_number"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "module_number"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module_number", sizeof("module_number"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module_number);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_constant", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zend_function */
	
		/* export:  	  	 	void 	xc_store_zend_function( 		 		 		xc_processor_t *processor, zend_function *dst, const zend_function * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_zend_function( 		 		 		xc_processor_t *processor, zend_function *dst, const zend_function * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_function), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_function));
			do {
		

		
			
	
	

	switch (src->type) {
	case ZEND_INTERNAL_FUNCTION:
	case ZEND_OVERLOADED_FUNCTION:
		
		break;

	case ZEND_USER_FUNCTION:
	case ZEND_EVAL_CODE:
		
		
	
	/* STRUCT(zend_op_array,op_array) */

	assert(sizeof(zend_op_array) == sizeof(src->op_array));
	
	
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,,&) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof((& src->op_array)[0]));
	

	

	xc_store_zend_op_array(
		
		
		processor, & dst->op_array, & src->op_array
		
		
		TSRMLS_CC
	);

	

	
	

	

		break;

	default:
		assert(0);
	}
	
	
	

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_store_zend_property_info */
	
 	  	 	static void inline 	xc_store_zend_property_info( 		 		 		xc_processor_t *processor, zend_property_info *dst, const zend_property_info * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_property_info*)NULL)->flags) + sizeof(((zend_property_info*)NULL)->name) + sizeof(((zend_property_info*)NULL)->name_length) + sizeof(((zend_property_info*)NULL)->h) + sizeof(((zend_property_info*)NULL)->offset) + sizeof(((zend_property_info*)NULL)->doc_comment) + sizeof(((zend_property_info*)NULL)->doc_comment_len) + sizeof(((zend_property_info*)NULL)->ce)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "flags","name","name_length","h","offset","doc_comment","doc_comment_len","ce" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_property_info));
			do {
		

		
				
	/* PROCESS(zend_uint,flags) */

	assert(sizeof(zend_uint) == sizeof(src->flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,name_length) */

	assert(sizeof(int) == sizeof(src->name_length));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->name, src->name_length + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(int,offset) */

	assert(sizeof(int) == sizeof(src->offset));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "offset", sizeof("offset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "offset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "offset", sizeof("offset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->offset);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->doc_comment) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->doc_comment) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

#endif
	

#endif
	#if defined(ZEND_ENGINE_2_2)
	
	if (src->ce) {
		dst->ce = (zend_class_entry *) xc_get_class_num(processor,src->ce);
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->ce == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif


#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_store_zend_trait_method_reference */
	
 	  	 	static void inline 	xc_store_zend_trait_method_reference( 		 		 		xc_processor_t *processor, zend_trait_method_reference *dst, const zend_trait_method_reference * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_method_reference*)NULL)->method_name) + sizeof(((zend_trait_method_reference*)NULL)->mname_len) + sizeof(((zend_trait_method_reference*)NULL)->ce) + sizeof(((zend_trait_method_reference*)NULL)->class_name) + sizeof(((zend_trait_method_reference*)NULL)->cname_len)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "method_name","mname_len","ce","class_name","cname_len" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_method_reference));
			do {
		

		
				
	/* PROCESS(unsigned int,mname_len) */

	assert(sizeof(unsigned int) == sizeof(src->mname_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "mname_len", sizeof("mname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "mname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "mname_len", sizeof("mname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->mname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(method_name,mname_len) */
 
	/* PROC_STRING_N(method_name,mname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "method_name", sizeof("method_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "method_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "method_name", sizeof("method_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->method_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->method_name == NULL) {
		
		
	}
	else {
		
		
		dst->method_name =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->method_name), src->mname_len + 1 C_RELAYLINE));
		
		
	dst->method_name = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->method_name);

		
	}
	
	
	
	
	
	
	

	
	
	
	
	assert(src->ce == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,cname_len) */

	assert(sizeof(unsigned int) == sizeof(src->cname_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cname_len", sizeof("cname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "cname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cname_len", sizeof("cname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(class_name,cname_len) */
 
	/* PROC_STRING_N(class_name,cname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->class_name == NULL) {
		
		
	}
	else {
		
		
		dst->class_name =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->class_name), src->cname_len + 1 C_RELAYLINE));
		
		
	dst->class_name = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->class_name);

		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_trait_method_reference", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_zend_trait_alias */
	
 	  	 	static void inline 	xc_store_zend_trait_alias( 		 		 		xc_processor_t *processor, zend_trait_alias *dst, const zend_trait_alias * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_alias*)NULL)->trait_method) + sizeof(((zend_trait_alias*)NULL)->alias) + sizeof(((zend_trait_alias*)NULL)->alias_len) + sizeof(((zend_trait_alias*)NULL)->modifiers)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","alias","alias_len","modifiers" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_alias));
			do {
		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`trait_method')',`zend_trait_method_reference' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_trait_method_reference);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`trait_method')',`zend_trait_method_reference' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->trait_method = (zend_trait_method_reference *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->trait_method, (void *) (unsigned long) __LINE__, sizeof(zend_trait_method_reference));
#endif

			
		processor->p += sizeof(zend_trait_method_reference);

		
	
	
	
	
	


	

	xc_store_zend_trait_method_reference(
		
		
		processor,  dst->trait_method,  src->trait_method
		
		
		TSRMLS_CC
	);

	

	
	
	dst->trait_method = (zend_trait_method_reference *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->trait_method);


	}
	else {
		
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,alias_len) */

	assert(sizeof(unsigned int) == sizeof(src->alias_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias_len", sizeof("alias_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias_len", sizeof("alias_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(alias,alias_len) */
 
	/* PROC_STRING_N(alias,alias_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias", sizeof("alias"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias", sizeof("alias"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->alias == NULL) {
		
		
	}
	else {
		
		
		dst->alias =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->alias), src->alias_len + 1 C_RELAYLINE));
		
		
	dst->alias = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->alias);

		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,modifiers) */

	assert(sizeof(zend_uint) == sizeof(src->modifiers));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "modifiers", sizeof("modifiers"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "modifiers"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "modifiers", sizeof("modifiers"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->modifiers);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_trait_alias", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_zend_trait_precedence */
	
 	  	 	static void inline 	xc_store_zend_trait_precedence( 		 		 		xc_processor_t *processor, zend_trait_precedence *dst, const zend_trait_precedence * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_precedence*)NULL)->trait_method) + sizeof(((zend_trait_precedence*)NULL)->exclude_from_classes)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","exclude_from_classes" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_precedence));
			do {
		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`trait_method')',`zend_trait_method_reference' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_trait_method_reference);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`trait_method')',`zend_trait_method_reference' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->trait_method = (zend_trait_method_reference *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->trait_method, (void *) (unsigned long) __LINE__, sizeof(zend_trait_method_reference));
#endif

			
		processor->p += sizeof(zend_trait_method_reference);

		
	
	
	
	
	


	

	xc_store_zend_trait_method_reference(
		
		
		processor,  dst->trait_method,  src->trait_method
		
		
		TSRMLS_CC
	);

	

	
	
	dst->trait_method = (zend_trait_method_reference *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->trait_method);


	}
	else {
		
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		if (src->exclude_from_classes) {
		int LOOPCOUNTER;
		
						
				size_t count = 0;
				while (src->exclude_from_classes[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`exclude_from_classes')',`xc_ztstring',`STRUCT_COUNT',`',`zend_class_entry*' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_ztstring) * count;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`exclude_from_classes')',`xc_ztstring',`STRUCT_COUNT',`',`zend_class_entry*' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->exclude_from_classes = (zend_class_entry* *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->exclude_from_classes, (void *) (unsigned long) __LINE__, sizeof(xc_ztstring) * count);
#endif

			
		processor->p += sizeof(xc_ztstring) * count;

		
	
	
	
	
	

			

			for (LOOPCOUNTER = 0;
					src->exclude_from_classes[LOOPCOUNTER];
					++LOOPCOUNTER) {
				
	
	

					
					
						
	/* PROCESS(xc_ztstring,exclude_from_classes) */

	assert(sizeof(xc_ztstring) == sizeof((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]));
		
	
	/* PROC_STRING(exclude_from_classes) */
 
	
	
	
	
	
	
	
	
	if ((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER] == NULL) {
		
		
	}
	else {
		
		
		dst->exclude_from_classes [LOOPCOUNTER] = (zend_class_entry *) ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]), strlen((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]) + 1 C_RELAYLINE));
		
		
	dst->exclude_from_classes [LOOPCOUNTER] = (zend_class_entry *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->exclude_from_classes [LOOPCOUNTER]);

		
	}
	
	
	
	
	
	
	

	

	

					
					
				
	
	

			}
						dst->exclude_from_classes[LOOPCOUNTER] = NULL;
				
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->exclude_from_classes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif



	}

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_trait_precedence", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_zend_trait_alias_ptr */
	
 	  	 	static void inline 	xc_store_zend_trait_alias_ptr( 		 		 		xc_processor_t *processor, zend_trait_alias_ptr *dst, const zend_trait_alias_ptr * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_alias), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_alias_ptr));
			do {
		

		
			
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `dst[0]',`zend_trait_alias' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_trait_alias);
				if (expect != real) {
					fprintf(stderr, "mismatch `dst[0]',`zend_trait_alias' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst[0] = (zend_trait_alias *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst[0], (void *) (unsigned long) __LINE__, sizeof(zend_trait_alias));
#endif

			
		processor->p += sizeof(zend_trait_alias);

		
	
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_alias,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_alias) == sizeof((  src[0])[0]));
	

	

	xc_store_zend_trait_alias(
		
		
		processor,   dst[0],   src[0]
		
		
		TSRMLS_CC
	);

	

	
	

		
	dst[0] = (zend_trait_alias *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst[0]);

	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_alias);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_trait_alias_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_zend_trait_precedence_ptr */
	
 	  	 	static void inline 	xc_store_zend_trait_precedence_ptr( 		 		 		xc_processor_t *processor, zend_trait_precedence_ptr *dst, const zend_trait_precedence_ptr * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_precedence), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_precedence_ptr));
			do {
		

		
			
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `dst[0]',`zend_trait_precedence' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_trait_precedence);
				if (expect != real) {
					fprintf(stderr, "mismatch `dst[0]',`zend_trait_precedence' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst[0] = (zend_trait_precedence *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst[0], (void *) (unsigned long) __LINE__, sizeof(zend_trait_precedence));
#endif

			
		processor->p += sizeof(zend_trait_precedence);

		
	
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_precedence,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_precedence) == sizeof((  src[0])[0]));
	

	

	xc_store_zend_trait_precedence(
		
		
		processor,   dst[0],   src[0]
		
		
		TSRMLS_CC
	);

	

	
	

		
	dst[0] = (zend_trait_precedence *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst[0]);

	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_precedence);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_trait_precedence_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zend_class_entry */
	
		/* export:  	  	 	void 	xc_store_zend_class_entry( 		 		 		xc_processor_t *processor, zend_class_entry *dst, const zend_class_entry * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_zend_class_entry( 		 		 		xc_processor_t *processor, zend_class_entry *dst, const zend_class_entry * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_class_entry*)NULL)->type) + sizeof(((zend_class_entry*)NULL)->name) + sizeof(((zend_class_entry*)NULL)->name_length) + sizeof(((zend_class_entry*)NULL)->parent) + sizeof(((zend_class_entry*)NULL)->refcount) + sizeof(((zend_class_entry*)NULL)->ce_flags) + sizeof(((zend_class_entry*)NULL)->function_table) + sizeof(((zend_class_entry*)NULL)->properties_info) + sizeof(((zend_class_entry*)NULL)->default_properties_table) + sizeof(((zend_class_entry*)NULL)->default_static_members_table) + sizeof(((zend_class_entry*)NULL)->static_members_table) + sizeof(((zend_class_entry*)NULL)->constants_table) + sizeof(((zend_class_entry*)NULL)->default_properties_count) + sizeof(((zend_class_entry*)NULL)->default_static_members_count) + sizeof(((zend_class_entry*)NULL)->constructor) + sizeof(((zend_class_entry*)NULL)->destructor) + sizeof(((zend_class_entry*)NULL)->clone) + sizeof(((zend_class_entry*)NULL)->__get) + sizeof(((zend_class_entry*)NULL)->__set) + sizeof(((zend_class_entry*)NULL)->__unset) + sizeof(((zend_class_entry*)NULL)->__isset) + sizeof(((zend_class_entry*)NULL)->__call) + sizeof(((zend_class_entry*)NULL)->__callstatic) + sizeof(((zend_class_entry*)NULL)->__tostring) + sizeof(((zend_class_entry*)NULL)->__debugInfo) + sizeof(((zend_class_entry*)NULL)->serialize_func) + sizeof(((zend_class_entry*)NULL)->unserialize_func) + sizeof(((zend_class_entry*)NULL)->iterator_funcs) + sizeof(((zend_class_entry*)NULL)->create_object) + sizeof(((zend_class_entry*)NULL)->get_iterator) + sizeof(((zend_class_entry*)NULL)->interface_gets_implemented) + sizeof(((zend_class_entry*)NULL)->get_static_method) + sizeof(((zend_class_entry*)NULL)->serialize) + sizeof(((zend_class_entry*)NULL)->unserialize) + sizeof(((zend_class_entry*)NULL)->interfaces) + sizeof(((zend_class_entry*)NULL)->num_interfaces) + sizeof(((zend_class_entry*)NULL)->traits) + sizeof(((zend_class_entry*)NULL)->num_traits) + sizeof(((zend_class_entry*)NULL)->trait_aliases) + sizeof(((zend_class_entry*)NULL)->trait_precedences) + sizeof(((zend_class_entry*)NULL)->info)  ), assert_count = 41;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","name","name_length","parent","refcount","ce_flags","function_table","properties_info","default_properties_table","default_static_members_table","static_members_table","constants_table","default_properties_count","default_static_members_count","constructor","destructor","clone","__get","__set","__unset","__isset","__call","__callstatic","__tostring","__debugInfo","serialize_func","unserialize_func","iterator_funcs","create_object","get_iterator","interface_gets_implemented","get_static_method","serialize","unserialize","interfaces","num_interfaces","traits","num_traits","trait_aliases","trait_precedences","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_class_entry));
			do {
		

		
			
		processor->active_class_entry_src = src;
		processor->active_class_entry_dst = dst;
	
		
	/* PROCESS(char,type) */

	assert(sizeof(char) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,name_length) */

	assert(sizeof(zend_uint) == sizeof(src->name_length));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->name, src->name_length + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->name, src->name_length + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->name));

		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	if (src->parent) {
		dst->parent = (zend_class_entry *) xc_get_class_num(processor,src->parent);
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->parent == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif


	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(int,refcount) */

	assert(sizeof(int) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
	
	
	/* STRUCT_P(int,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(int,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(int) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`refcount')',`int' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(int);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`refcount')',`int' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->refcount = (int *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->refcount, (void *) (unsigned long) __LINE__, sizeof(int));
#endif

			
		processor->p += sizeof(int);

		
	
	
	
	
	


	

	xc_store_int(
		
		
		processor,  dst->refcount,  src->refcount
		
		
		TSRMLS_CC
	);

	

	
	
	dst->refcount = (int *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->refcount);


	}
	else {
		
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,constants_updated) */

	assert(sizeof(zend_bool) == sizeof(src->constants_updated));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_updated", sizeof("constants_updated"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_updated"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_updated", sizeof("constants_updated"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_updated);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,ce_flags) */

	assert(sizeof(zend_uint) == sizeof(src->ce_flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce_flags", sizeof("ce_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "ce_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce_flags", sizeof("ce_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce_flags);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,properties_info,HashTable_zend_property_info) */

	assert(sizeof(HashTable) == sizeof(src->properties_info));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`properties_info'),SRC(`properties_info'),properties_info,HashTable_zend_property_info,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->properties_info)[0]));
	

	

	xc_store_HashTable_zend_property_info(
		
		
		processor, & dst->properties_info, & src->properties_info
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "properties_info", sizeof("properties_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "properties_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "properties_info", sizeof("properties_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->properties_info);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2_4
	
	if (src->default_properties_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`default_properties_table')',`zval_ptr_nullable',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zval_ptr_nullable) * src->default_properties_count;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`default_properties_table')',`zval_ptr_nullable',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->default_properties_table = (zval_ptr_nullable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->default_properties_table, (void *) (unsigned long) __LINE__, sizeof(zval_ptr_nullable) * src->default_properties_count);
#endif

			
		processor->p += sizeof(zval_ptr_nullable) * src->default_properties_count;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->default_properties_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_properties_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_properties_table[i]));
	
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_properties_table[LOOPCOUNTER]'),SRC(`default_properties_table[LOOPCOUNTER]'),default_properties_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_properties_table[i])[0]));
	

	

	xc_store_zval_ptr_nullable(
		
		
		processor, & dst->default_properties_table[i], & src->default_properties_table[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->default_properties_table = (zval_ptr_nullable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->default_properties_table);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_properties_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_properties_count) */

	assert(sizeof(int) == sizeof(src->default_properties_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_count", sizeof("default_properties_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_count", sizeof("default_properties_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_count);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->default_static_members_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`default_static_members_table')',`zval_ptr_nullable',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zval_ptr_nullable) * src->default_static_members_count;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`default_static_members_table')',`zval_ptr_nullable',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->default_static_members_table = (zval_ptr_nullable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->default_static_members_table, (void *) (unsigned long) __LINE__, sizeof(zval_ptr_nullable) * src->default_static_members_count);
#endif

			
		processor->p += sizeof(zval_ptr_nullable) * src->default_static_members_count;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->default_static_members_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_static_members_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_static_members_table[i]));
	
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_static_members_table[LOOPCOUNTER]'),SRC(`default_static_members_table[LOOPCOUNTER]'),default_static_members_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_static_members_table[i])[0]));
	

	

	xc_store_zval_ptr_nullable(
		
		
		processor, & dst->default_static_members_table[i], & src->default_static_members_table[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->default_static_members_table = (zval_ptr_nullable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->default_static_members_table);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_static_members_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_static_members_count) */

	assert(sizeof(int) == sizeof(src->default_static_members_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_count", sizeof("default_static_members_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_count", sizeof("default_static_members_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_count);
	xc_autocheck_done_count ++;

#endif



	

	dst->static_members_table = dst->default_static_members_table;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members_table", sizeof("static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members_table", sizeof("static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members_table);
	xc_autocheck_done_count ++;

#endif


#else
	dst->builtin_functions = src->builtin_functions;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "builtin_functions", sizeof("builtin_functions"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "builtin_functions"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "builtin_functions", sizeof("builtin_functions"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->builtin_functions);
	xc_autocheck_done_count ++;

#endif


	
	
	/* STRUCT(HashTable,default_properties,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_properties));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_properties'),SRC(`default_properties'),default_properties,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_properties)[0]));
	

	

	xc_store_HashTable_zval_ptr(
		
		
		processor, & dst->default_properties, & src->default_properties
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties", sizeof("default_properties"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties", sizeof("default_properties"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties);
	xc_autocheck_done_count ++;

#endif



#	ifdef ZEND_ENGINE_2_1
	
	
	/* STRUCT(HashTable,default_static_members,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_static_members));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_static_members'),SRC(`default_static_members'),default_static_members,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_static_members)[0]));
	

	

	xc_store_HashTable_zval_ptr(
		
		
		processor, & dst->default_static_members, & src->default_static_members
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members", sizeof("default_static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members", sizeof("default_static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members);
	xc_autocheck_done_count ++;

#endif



	dst->static_members = &dst->default_static_members;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif


#	elif defined(ZEND_ENGINE_2)
	
	
	/* STRUCT_P(HashTable,static_members,HashTable_zval_ptr) */

	if (src->static_members) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_members'),SRC(`static_members'),static_members,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_members)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`static_members')',`HashTable' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(HashTable);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`static_members')',`HashTable' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->static_members = (HashTable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->static_members, (void *) (unsigned long) __LINE__, sizeof(HashTable));
#endif

			
		processor->p += sizeof(HashTable);

		
	
	
	
	
	


	

	xc_store_HashTable_zval_ptr(
		
		
		processor,  dst->static_members,  src->static_members
		
		
		TSRMLS_CC
	);

	

	
	
	dst->static_members = (HashTable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->static_members);


	}
	else {
		
		
	
	
	assert(src->static_members == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif



#	endif
#endif /* ZEND_ENGINE_2_4 */

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,constants_table,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->constants_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`constants_table'),SRC(`constants_table'),constants_table,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->constants_table)[0]));
	

	

	xc_store_HashTable_zval_ptr(
		
		
		processor, & dst->constants_table, & src->constants_table
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_table", sizeof("constants_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_table", sizeof("constants_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_table);
	xc_autocheck_done_count ++;

#endif




#ifdef ZEND_ENGINE_2_2
		
	
	
	
	assert(src->interfaces == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_interfaces == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif




#	ifdef ZEND_ENGINE_2_4
		
	
	
	
	assert(src->traits == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "traits", sizeof("traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "traits", sizeof("traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->traits);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_traits == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_traits", sizeof("num_traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_traits", sizeof("num_traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_traits);
	xc_autocheck_done_count ++;

#endif



	
	if (src->trait_aliases) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_aliases[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`trait_aliases')',`zend_trait_alias_ptr',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_trait_alias_ptr) * count;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`trait_aliases')',`zend_trait_alias_ptr',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->trait_aliases = (zend_trait_alias_ptr *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->trait_aliases, (void *) (unsigned long) __LINE__, sizeof(zend_trait_alias_ptr) * count);
#endif

			
		processor->p += sizeof(zend_trait_alias_ptr) * count;

		
	
	
	
	
	

			

			for (i = 0;
					src->trait_aliases[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_alias_ptr,trait_aliases[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_alias_ptr) == sizeof(src->trait_aliases[i]));
	
	
	
	/* STRUCT_P_EX(zend_trait_alias_ptr,DST(`trait_aliases[LOOPCOUNTER]'),SRC(`trait_aliases[LOOPCOUNTER]'),trait_aliases[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_alias_ptr) == sizeof((& src->trait_aliases[i])[0]));
	

	

	xc_store_zend_trait_alias_ptr(
		
		
		processor, & dst->trait_aliases[i], & src->trait_aliases[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						dst->trait_aliases[i] = NULL;
				
	dst->trait_aliases = (zend_trait_alias_ptr *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->trait_aliases);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_alias_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_aliases == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif



	}

	
	if (src->trait_precedences) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_precedences[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`trait_precedences')',`zend_trait_precedence_ptr',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_trait_precedence_ptr) * count;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`trait_precedences')',`zend_trait_precedence_ptr',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->trait_precedences = (zend_trait_precedence_ptr *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->trait_precedences, (void *) (unsigned long) __LINE__, sizeof(zend_trait_precedence_ptr) * count);
#endif

			
		processor->p += sizeof(zend_trait_precedence_ptr) * count;

		
	
	
	
	
	

			

			for (i = 0;
					src->trait_precedences[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_precedence_ptr,trait_precedences[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_precedence_ptr) == sizeof(src->trait_precedences[i]));
	
	
	
	/* STRUCT_P_EX(zend_trait_precedence_ptr,DST(`trait_precedences[LOOPCOUNTER]'),SRC(`trait_precedences[LOOPCOUNTER]'),trait_precedences[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_precedence_ptr) == sizeof((& src->trait_precedences[i])[0]));
	

	

	xc_store_zend_trait_precedence_ptr(
		
		
		processor, & dst->trait_precedences[i], & src->trait_precedences[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						dst->trait_precedences[i] = NULL;
				
	dst->trait_precedences = (zend_trait_precedence_ptr *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->trait_precedences);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_trait_precedence_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_precedences == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif



	}

#	endif
#else
	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif


	
		
	/* PROCESS(zend_uint,num_interfaces) */

	assert(sizeof(zend_uint) == sizeof(src->num_interfaces));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif



	

#endif

#	ifdef ZEND_ENGINE_2_4
	
	
	

	
	/* PROC_STRING(info.user.filename) */
 
	
	
	
	
	
	
	
	
	if (src->info.user.filename == NULL) {
		
		
	}
	else {
		
		
		dst->info.user.filename =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->info.user.filename), strlen(src->info.user.filename) + 1 C_RELAYLINE));
		
		
	dst->info.user.filename = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->info.user.filename);

		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,info.user.line_start) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_start));
		
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.line_end) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_end));
		
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.doc_comment_len));
		
	
	
	

	

	
	/* PROC_ZSTRING_L(,info.user.doc_comment,info.user.doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,info.user.doc_comment,info.user.doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->info.user.doc_comment) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->info.user.doc_comment, src->info.user.doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->info.user.doc_comment) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->info.user.doc_comment));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->info.user.doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->info.user.doc_comment, src->info.user.doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->info.user.doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->info.user.doc_comment));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->info.user.doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->info.user.doc_comment, src->info.user.doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->info.user.doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->info.user.doc_comment));

		
	}
	
	
	
	
	
	
	

#endif
	

	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif


#	else
	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
	}
	else {
		
		
		dst->filename =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->filename), strlen(src->filename) + 1 C_RELAYLINE));
		
		
	dst->filename = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->filename);

		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->doc_comment) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->doc_comment) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

#endif
	

#	endif

	/* # NOT DONE */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize_func", sizeof("serialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize_func", sizeof("serialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize_func);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize_func", sizeof("unserialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize_func", sizeof("unserialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize_func);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "iterator_funcs", sizeof("iterator_funcs"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "iterator_funcs"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "iterator_funcs", sizeof("iterator_funcs"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->iterator_funcs);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "create_object", sizeof("create_object"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "create_object"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "create_object", sizeof("create_object"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->create_object);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_iterator", sizeof("get_iterator"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_iterator"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_iterator", sizeof("get_iterator"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_iterator);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interface_gets_implemented", sizeof("interface_gets_implemented"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interface_gets_implemented"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interface_gets_implemented", sizeof("interface_gets_implemented"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interface_gets_implemented);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_ENGINE_2_3
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_static_method", sizeof("get_static_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_static_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_static_method", sizeof("get_static_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_static_method);
	xc_autocheck_done_count ++;

#endif


#	endif
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize", sizeof("serialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize", sizeof("serialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize", sizeof("unserialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize", sizeof("unserialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize);
	xc_autocheck_done_count ++;

#endif


#	endif
	/* deal with it inside xc_fix_method */
	dst->constructor = NULL;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constructor", sizeof("constructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constructor", sizeof("constructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "destructor", sizeof("destructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "destructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "destructor", sizeof("destructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->destructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "clone", sizeof("clone"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "clone"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "clone", sizeof("clone"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->clone);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__get", sizeof("__get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__get", sizeof("__get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__set", sizeof("__set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__set", sizeof("__set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__set);
	xc_autocheck_done_count ++;

#endif


/* should be >5.1 */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__unset", sizeof("__unset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__unset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__unset", sizeof("__unset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__unset);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__isset", sizeof("__isset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__isset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__isset", sizeof("__isset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__isset);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__call", sizeof("__call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__call", sizeof("__call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__call);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_CALLSTATIC_FUNC_NAME
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__callstatic", sizeof("__callstatic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__callstatic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__callstatic", sizeof("__callstatic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__callstatic);
	xc_autocheck_done_count ++;

#endif


#	endif
# if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__tostring", sizeof("__tostring"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__tostring"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__tostring", sizeof("__tostring"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__tostring);
	xc_autocheck_done_count ++;

#endif


# endif
# if defined(ZEND_ENGINE_2_6)
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__debugInfo", sizeof("__debugInfo"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__debugInfo"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__debugInfo", sizeof("__debugInfo"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__debugInfo);
	xc_autocheck_done_count ++;

#endif


# endif
#	ifndef ZEND_ENGINE_2_4
	/* # NOT DONE */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module", sizeof("module"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "module"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module", sizeof("module"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module);
	xc_autocheck_done_count ++;

#endif


#	endif
#else /* ZEND_ENGINE_2 */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_function_call", sizeof("handle_function_call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_function_call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_function_call", sizeof("handle_function_call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_function_call);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_get", sizeof("handle_property_get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_get", sizeof("handle_property_get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_set", sizeof("handle_property_set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_set", sizeof("handle_property_set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_set);
	xc_autocheck_done_count ++;

#endif


#endif
		
	
	/* STRUCT(HashTable,function_table,HashTable_zend_function) */

	assert(sizeof(HashTable) == sizeof(src->function_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`function_table'),SRC(`function_table'),function_table,HashTable_zend_function,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->function_table)[0]));
	

	

	xc_store_HashTable_zend_function(
		
		
		processor, & dst->function_table, & src->function_table
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_table", sizeof("function_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "function_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_table", sizeof("function_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_table);
	xc_autocheck_done_count ++;

#endif



	
	
		processor->active_class_entry_src = NULL;
		processor->active_class_entry_dst = NULL;
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_class_entry", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4


#else

	
	

/* {{{ xc_store_znode */
	
 	  	 	static void inline 	xc_store_znode( 		 		 		xc_processor_t *processor, znode *dst, const znode * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((znode*)NULL)->op_type) + sizeof(((znode*)NULL)->u) + sizeof(((znode*)NULL)->EA)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "op_type","u","EA" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(znode));
			do {
		

		
				
	/* PROCESS(xc_op_type,op_type) */

	assert(sizeof(xc_op_type) == sizeof(src->op_type));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_type", sizeof("op_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_znode : %s\n"
				, __FILE__, __LINE__
				, "op_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_type", sizeof("op_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_type);
	xc_autocheck_done_count ++;

#endif




	


#ifdef IS_CV
#	define XCACHE_IS_CV IS_CV
#else
/* compatible with zend optimizer */
#	define XCACHE_IS_CV 16
#endif
	assert(src->op_type == IS_CONST ||
		src->op_type == IS_VAR ||
		src->op_type == XCACHE_IS_CV ||
		src->op_type == IS_TMP_VAR ||
		src->op_type == IS_UNUSED);
		
	
	

	switch (src->op_type) {
		case IS_CONST:
			
	
	/* STRUCT(zval,u.constant) */

	assert(sizeof(zval) == sizeof(src->u.constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`u.constant'),SRC(`u.constant'),u.constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->u.constant)[0]));
	

	

	xc_store_zval(
		
		
		processor, & dst->u.constant, & src->u.constant
		
		
		TSRMLS_CC
	);

	

	
	

	

			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_znode : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


#if 0
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "EA", sizeof("EA"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_znode : %s\n"
				, __FILE__, __LINE__
				, "EA"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "EA", sizeof("EA"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->EA);
	xc_autocheck_done_count ++;

#endif


#endif
#undef XCACHE_IS_CV

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_znode", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zend_op */
	
		/* export:  	  	 	void 	xc_store_zend_op( 		 		 		xc_processor_t *processor, zend_op *dst, const zend_op * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_zend_op( 		 		 		xc_processor_t *processor, zend_op *dst, const zend_op * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op*)NULL)->handler) + sizeof(((zend_op*)NULL)->op1) + sizeof(((zend_op*)NULL)->op2) + sizeof(((zend_op*)NULL)->result) + sizeof(((zend_op*)NULL)->extended_value) + sizeof(((zend_op*)NULL)->lineno) + sizeof(((zend_op*)NULL)->opcode) + sizeof(((zend_op*)NULL)->op1_type) + sizeof(((zend_op*)NULL)->op2_type) + sizeof(((zend_op*)NULL)->result_type)  ), assert_count = 10;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "handler","op1","op2","result","extended_value","lineno","opcode","op1_type","op2_type","result_type" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_op));
			do {
		

		
				
	/* PROCESS(xc_opcode,opcode) */

	assert(sizeof(xc_opcode) == sizeof(src->opcode));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcode", sizeof("opcode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcode", sizeof("opcode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcode);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_4
	
	switch (src->opcode) {
	case ZEND_BIND_TRAITS:
		((zend_op *) src)->op2_type = IS_UNUSED;
		break;
	}
	
	#ifndef NDEBUG
	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
		case IS_CONST:
			
					
	/* PROCESS(zend_uint,result.constant) */

	assert(sizeof(zend_uint) == sizeof(src->result.constant));
		
	
	
	

	

			
			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op1_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op1_type )) {
		case IS_CONST:
			
				
					
						dst->op1 = src->op1;
					
				
			
			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op2_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op2_type )) {
		case IS_CONST:
			
				
					
						dst->op2 = src->op2;
					
				
			
			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(znode,result) */

	assert(sizeof(znode) == sizeof(src->result));
	
	
	
	/* STRUCT_P_EX(znode,DST(`result'),SRC(`result'),result,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->result)[0]));
	

	

	xc_store_znode(
		
		
		processor, & dst->result, & src->result
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op1) */

	assert(sizeof(znode) == sizeof(src->op1));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op1'),SRC(`op1'),op1,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op1)[0]));
	

	

	xc_store_znode(
		
		
		processor, & dst->op1, & src->op1
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op2) */

	assert(sizeof(znode) == sizeof(src->op2));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op2'),SRC(`op2'),op2,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op2)[0]));
	

	

	xc_store_znode(
		
		
		processor, & dst->op2, & src->op2
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#endif
		
	/* PROCESS(ulong,extended_value) */

	assert(sizeof(ulong) == sizeof(src->extended_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "extended_value", sizeof("extended_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "extended_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "extended_value", sizeof("extended_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->extended_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,op1_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op1_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1_type", sizeof("op1_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1_type", sizeof("op1_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,op2_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op2_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2_type", sizeof("op2_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2_type", sizeof("op2_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,result_type) */

	assert(sizeof(zend_uchar) == sizeof(src->result_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result_type", sizeof("result_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result_type", sizeof("result_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		assert(processor->active_op_array_src);
		assert(processor->active_op_array_dst);
#ifdef ZEND_ENGINE_2_4
		
		
			if (src->op1_type == IS_CONST) {
				dst->op1.constant = src->op1.literal - processor->active_op_array_src->literals;
				dst->op1.literal = &processor->active_op_array_dst->literals[dst->op1.constant];
			}
		
		
			if (src->op2_type == IS_CONST) {
				dst->op2.constant = src->op2.literal - processor->active_op_array_src->literals;
				dst->op2.literal = &processor->active_op_array_dst->literals[dst->op2.constant];
			}
		
#endif
		
#ifdef ZEND_ENGINE_2
		switch (src->opcode) {
#	ifdef ZEND_GOTO
			case ZEND_GOTO:
#	endif
			case ZEND_JMP:
#	ifdef ZEND_FAST_CALL
			case ZEND_FAST_CALL:
#	endif
				assert(Z_OP(src->op1).jmp_addr >= processor->active_op_array_src->opcodes);
				assert(Z_OP(src->op1).jmp_addr - processor->active_op_array_src->opcodes < processor->active_op_array_src->last);
				Z_OP(dst->op1).jmp_addr = processor->active_op_array_dst->opcodes + (Z_OP(src->op1).jmp_addr - processor->active_op_array_src->opcodes);
				assert(Z_OP(dst->op1).jmp_addr >= processor->active_op_array_dst->opcodes);
				assert(Z_OP(dst->op1).jmp_addr - processor->active_op_array_dst->opcodes < processor->active_op_array_dst->last);
				
	Z_OP(dst->op1).jmp_addr = (zend_op *) processor->shm->handlers->to_readonly(processor->shm, (void *)Z_OP(dst->op1).jmp_addr);

				break;

			case ZEND_JMPZ:
			case ZEND_JMPNZ:
			case ZEND_JMPZ_EX:
			case ZEND_JMPNZ_EX:
#	ifdef ZEND_JMP_SET
			case ZEND_JMP_SET:
#	endif
#	ifdef ZEND_JMP_SET_VAR
			case ZEND_JMP_SET_VAR:
#	endif
				assert(Z_OP(src->op2).jmp_addr >= processor->active_op_array_src->opcodes);
				assert(Z_OP(src->op2).jmp_addr - processor->active_op_array_src->opcodes < processor->active_op_array_src->last);
				Z_OP(dst->op2).jmp_addr = processor->active_op_array_dst->opcodes + (Z_OP(src->op2).jmp_addr - processor->active_op_array_src->opcodes);
				assert(Z_OP(dst->op2).jmp_addr >= processor->active_op_array_dst->opcodes);
				assert(Z_OP(dst->op2).jmp_addr - processor->active_op_array_dst->opcodes < processor->active_op_array_dst->last);
				
	Z_OP(dst->op2).jmp_addr = (zend_op *) processor->shm->handlers->to_readonly(processor->shm, (void *)Z_OP(dst->op2).jmp_addr);

				break;

			default:
				break;
		}
#	endif
	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(opcode_handler_t,handler) */

	assert(sizeof(opcode_handler_t) == sizeof(src->handler));
	/* is copying enough? */
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handler", sizeof("handler"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "handler"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handler", sizeof("handler"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handler);
	xc_autocheck_done_count ++;

#endif


	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_op", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_store_zend_literal */
	
 	  	 	static void inline 	xc_store_zend_literal( 		 		 		xc_processor_t *processor, zend_literal *dst, const zend_literal * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_literal*)NULL)->constant) + sizeof(((zend_literal*)NULL)->hash_value) + sizeof(((zend_literal*)NULL)->cache_slot)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "constant","hash_value","cache_slot" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_literal));
			do {
		

		
			
	
	/* STRUCT(zval,constant) */

	assert(sizeof(zval) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->constant)[0]));
	

	

	xc_store_zval(
		
		
		processor, & dst->constant, & src->constant
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(zend_ulong,hash_value) */

	assert(sizeof(zend_ulong) == sizeof(src->hash_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,cache_slot) */

	assert(sizeof(zend_uint) == sizeof(src->cache_slot));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cache_slot", sizeof("cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cache_slot", sizeof("cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cache_slot);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_literal", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_store_zend_op_array */
	
		/* export:  	  	 	void 	xc_store_zend_op_array( 		 		 		xc_processor_t *processor, zend_op_array *dst, const zend_op_array * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_zend_op_array( 		 		 		xc_processor_t *processor, zend_op_array *dst, const zend_op_array * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op_array*)NULL)->type) + sizeof(((zend_op_array*)NULL)->function_name) + sizeof(((zend_op_array*)NULL)->scope) + sizeof(((zend_op_array*)NULL)->fn_flags) + sizeof(((zend_op_array*)NULL)->prototype) + sizeof(((zend_op_array*)NULL)->num_args) + sizeof(((zend_op_array*)NULL)->required_num_args) + sizeof(((zend_op_array*)NULL)->arg_info) + sizeof(((zend_op_array*)NULL)->refcount) + sizeof(((zend_op_array*)NULL)->opcodes) + sizeof(((zend_op_array*)NULL)->last) + sizeof(((zend_op_array*)NULL)->vars) + sizeof(((zend_op_array*)NULL)->last_var) + sizeof(((zend_op_array*)NULL)->T) + sizeof(((zend_op_array*)NULL)->nested_calls) + sizeof(((zend_op_array*)NULL)->used_stack) + sizeof(((zend_op_array*)NULL)->brk_cont_array) + sizeof(((zend_op_array*)NULL)->last_brk_cont) + sizeof(((zend_op_array*)NULL)->try_catch_array) + sizeof(((zend_op_array*)NULL)->last_try_catch) + sizeof(((zend_op_array*)NULL)->has_finally_block) + sizeof(((zend_op_array*)NULL)->static_variables) + sizeof(((zend_op_array*)NULL)->this_var) + sizeof(((zend_op_array*)NULL)->filename) + sizeof(((zend_op_array*)NULL)->line_start) + sizeof(((zend_op_array*)NULL)->line_end) + sizeof(((zend_op_array*)NULL)->doc_comment) + sizeof(((zend_op_array*)NULL)->doc_comment_len) + sizeof(((zend_op_array*)NULL)->early_binding) + sizeof(((zend_op_array*)NULL)->literals) + sizeof(((zend_op_array*)NULL)->last_literal) + sizeof(((zend_op_array*)NULL)->run_time_cache) + sizeof(((zend_op_array*)NULL)->last_cache_slot) + sizeof(((zend_op_array*)NULL)->reserved)  ), assert_count = 34;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","function_name","scope","fn_flags","prototype","num_args","required_num_args","arg_info","refcount","opcodes","last","vars","last_var","T","nested_calls","used_stack","brk_cont_array","last_brk_cont","try_catch_array","last_try_catch","has_finally_block","static_variables","this_var","filename","line_start","line_end","doc_comment","doc_comment_len","early_binding","literals","last_literal","run_time_cache","last_cache_slot","reserved" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_op_array));
			do {
		

		
			
		processor->active_op_array_dst = dst;
		processor->active_op_array_src = src;
	
	
	{
	
	do {
	
	/* Common elements */
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING(,function_name) */
 
	
	/* PROC_ZSTRING_N(,function_name,,strlen) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->function_name) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->function_name, xc_zstrlen_uchar (src->function_name) + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->function_name) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->function_name));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->function_name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->function_name, xc_zstrlen_char (src->function_name) + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->function_name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->function_name));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->function_name) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->function_name, xc_zstrlen_char (src->function_name) + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->function_name) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->function_name));

		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,fn_flags) */

	assert(sizeof(zend_uint) == sizeof(src->fn_flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "fn_flags", sizeof("fn_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "fn_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "fn_flags", sizeof("fn_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->fn_flags);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->arg_info) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`arg_info')',`zend_arg_info',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_arg_info) * src->num_args;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`arg_info')',`zend_arg_info',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->arg_info = (zend_arg_info *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->arg_info, (void *) (unsigned long) __LINE__, sizeof(zend_arg_info) * src->num_args);
#endif

			
		processor->p += sizeof(zend_arg_info) * src->num_args;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->num_args;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_arg_info,arg_info[LOOPCOUNTER],) */

	assert(sizeof(zend_arg_info) == sizeof(src->arg_info[i]));
	
	
	
	/* STRUCT_P_EX(zend_arg_info,DST(`arg_info[LOOPCOUNTER]'),SRC(`arg_info[LOOPCOUNTER]'),arg_info[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_arg_info) == sizeof((& src->arg_info[i])[0]));
	

	

	xc_store_zend_arg_info(
		
		
		processor, & dst->arg_info[i], & src->arg_info[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->arg_info = (zend_arg_info *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->arg_info);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->arg_info == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,num_args) */

	assert(sizeof(zend_uint) == sizeof(src->num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_args", sizeof("num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_args", sizeof("num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_args);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,required_num_args) */

	assert(sizeof(zend_uint) == sizeof(src->required_num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,pass_rest_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_rest_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_rest_by_reference", sizeof("pass_rest_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "pass_rest_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_rest_by_reference", sizeof("pass_rest_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_rest_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
	if (src->arg_types) {
		
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`arg_types')',`zend_uchar',`src->arg_types[0] + 1' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_uchar) * src->arg_types[0] + 1;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`arg_types')',`zend_uchar',`src->arg_types[0] + 1' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->arg_types = (zend_uchar *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->arg_types, (void *) (unsigned long) __LINE__, sizeof(zend_uchar) * src->arg_types[0] + 1);
#endif

			
		processor->p += sizeof(zend_uchar) * src->arg_types[0] + 1;

		
	
	
	
	
	

		memcpy(dst->arg_types, src->arg_types, sizeof(src->arg_types[0]) * (src->arg_types[0]+1));
		
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->arg_types == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif



	}
#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(unsigned char,return_reference) */

	assert(sizeof(unsigned char) == sizeof(src->return_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* END of common elements */
#ifdef IS_UNICODE
	#endif

	
	
	/* STRUCT_P(zend_uint,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(zend_uint,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(zend_uint) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`refcount')',`zend_uint' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_uint);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`refcount')',`zend_uint' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->refcount = (zend_uint *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->refcount, (void *) (unsigned long) __LINE__, sizeof(zend_uint));
#endif

			
		processor->p += sizeof(zend_uint);

		
	
	
	
	
	


	

	xc_store_zend_uint(
		
		
		processor,  dst->refcount,  src->refcount
		
		
		TSRMLS_CC
	);

	

	
	
	dst->refcount = (zend_uint *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->refcount);


	}
	else {
		
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	
		
	dst->refcount = (zend_uint *) processor->shm->handlers->to_readwrite(processor->shm, (void *)dst->refcount);

		dst->refcount[0] = 1;
		
	dst->refcount = (zend_uint *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->refcount);

	

#ifdef ZEND_ENGINE_2_4
		
	if (src->literals) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`literals')',`zend_literal',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_literal) * src->last_literal;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`literals')',`zend_literal',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->literals = (zend_literal *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->literals, (void *) (unsigned long) __LINE__, sizeof(zend_literal) * src->last_literal);
#endif

			
		processor->p += sizeof(zend_literal) * src->last_literal;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->last_literal;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_literal,literals[LOOPCOUNTER],) */

	assert(sizeof(zend_literal) == sizeof(src->literals[i]));
	
	
	
	/* STRUCT_P_EX(zend_literal,DST(`literals[LOOPCOUNTER]'),SRC(`literals[LOOPCOUNTER]'),literals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_literal) == sizeof((& src->literals[i])[0]));
	

	

	xc_store_zend_literal(
		
		
		processor, & dst->literals[i], & src->literals[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->literals = (zend_literal *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->literals);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_literal) */

	assert(sizeof(int) == sizeof(src->last_literal));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_literal", sizeof("last_literal"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_literal"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_literal", sizeof("last_literal"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_literal);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
	if (src->opcodes) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`opcodes')',`zend_op',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_op) * src->last;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`opcodes')',`zend_op',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->opcodes = (zend_op *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->opcodes, (void *) (unsigned long) __LINE__, sizeof(zend_op) * src->last);
#endif

			
		processor->p += sizeof(zend_op) * src->last;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->last;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_op,opcodes[LOOPCOUNTER],) */

	assert(sizeof(zend_op) == sizeof(src->opcodes[i]));
	
	
	
	/* STRUCT_P_EX(zend_op,DST(`opcodes[LOOPCOUNTER]'),SRC(`opcodes[LOOPCOUNTER]'),opcodes[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_op) == sizeof((& src->opcodes[i])[0]));
	

	

	xc_store_zend_op(
		
		
		processor, & dst->opcodes[i], & src->opcodes[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->opcodes = (zend_op *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->opcodes);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->opcodes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,last) */

	assert(sizeof(zend_uint) == sizeof(src->last));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last", sizeof("last"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last", sizeof("last"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_4
	dst->size = src->last;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif


#endif

#ifdef IS_CV
	
	if (src->vars) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`vars')',`zend_compiled_variable',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_compiled_variable) * src->last_var;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`vars')',`zend_compiled_variable',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->vars = (zend_compiled_variable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->vars, (void *) (unsigned long) __LINE__, sizeof(zend_compiled_variable) * src->last_var);
#endif

			
		processor->p += sizeof(zend_compiled_variable) * src->last_var;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->last_var;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_compiled_variable,vars[LOOPCOUNTER],) */

	assert(sizeof(zend_compiled_variable) == sizeof(src->vars[i]));
	
	
	
	/* STRUCT_P_EX(zend_compiled_variable,DST(`vars[LOOPCOUNTER]'),SRC(`vars[LOOPCOUNTER]'),vars[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_compiled_variable) == sizeof((& src->vars[i])[0]));
	

	

	xc_store_zend_compiled_variable(
		
		
		processor, & dst->vars[i], & src->vars[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->vars = (zend_compiled_variable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->vars);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->vars == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_var) */

	assert(sizeof(int) == sizeof(src->last_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_var", sizeof("last_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_var", sizeof("last_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_var);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
	dst->size_var = src->last_var;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size_var", sizeof("size_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size_var", sizeof("size_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size_var);
	xc_autocheck_done_count ++;

#endif


#	endif
#else
		
#endif

		
	/* PROCESS(zend_uint,T) */

	assert(sizeof(zend_uint) == sizeof(src->T));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "T", sizeof("T"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "T"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "T", sizeof("T"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->T);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,nested_calls) */

	assert(sizeof(zend_uint) == sizeof(src->nested_calls));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nested_calls", sizeof("nested_calls"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "nested_calls"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nested_calls", sizeof("nested_calls"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nested_calls);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,used_stack) */

	assert(sizeof(zend_uint) == sizeof(src->used_stack));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "used_stack", sizeof("used_stack"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "used_stack"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "used_stack", sizeof("used_stack"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->used_stack);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	if (src->brk_cont_array) {
		last_brk_cont_t i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`brk_cont_array')',`zend_brk_cont_element',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_brk_cont_element) * src->last_brk_cont;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`brk_cont_array')',`zend_brk_cont_element',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->brk_cont_array = (zend_brk_cont_element *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->brk_cont_array, (void *) (unsigned long) __LINE__, sizeof(zend_brk_cont_element) * src->last_brk_cont);
#endif

			
		processor->p += sizeof(zend_brk_cont_element) * src->last_brk_cont;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->last_brk_cont;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_brk_cont_element,brk_cont_array[LOOPCOUNTER],) */

	assert(sizeof(zend_brk_cont_element) == sizeof(src->brk_cont_array[i]));
	
	
	
	/* STRUCT_P_EX(zend_brk_cont_element,DST(`brk_cont_array[LOOPCOUNTER]'),SRC(`brk_cont_array[LOOPCOUNTER]'),brk_cont_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_brk_cont_element) == sizeof((& src->brk_cont_array[i])[0]));
	

	

	xc_store_zend_brk_cont_element(
		
		
		processor, & dst->brk_cont_array[i], & src->brk_cont_array[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->brk_cont_array = (zend_brk_cont_element *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->brk_cont_array);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->brk_cont_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(last_brk_cont_t,last_brk_cont) */

	assert(sizeof(last_brk_cont_t) == sizeof(src->last_brk_cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_brk_cont", sizeof("last_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_brk_cont", sizeof("last_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_brk_cont);
	xc_autocheck_done_count ++;

#endif




	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,current_brk_cont) */

	assert(sizeof(zend_uint) == sizeof(src->current_brk_cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "current_brk_cont", sizeof("current_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "current_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "current_brk_cont", sizeof("current_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->current_brk_cont);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifndef ZEND_ENGINE_2
		
	/* PROCESS(zend_bool,uses_globals) */

	assert(sizeof(zend_bool) == sizeof(src->uses_globals));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_globals", sizeof("uses_globals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_globals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_globals", sizeof("uses_globals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_globals);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	if (src->try_catch_array) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`try_catch_array')',`zend_try_catch_element',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_try_catch_element) * src->last_try_catch;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`try_catch_array')',`zend_try_catch_element',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->try_catch_array = (zend_try_catch_element *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->try_catch_array, (void *) (unsigned long) __LINE__, sizeof(zend_try_catch_element) * src->last_try_catch);
#endif

			
		processor->p += sizeof(zend_try_catch_element) * src->last_try_catch;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->last_try_catch;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_try_catch_element,try_catch_array[LOOPCOUNTER],) */

	assert(sizeof(zend_try_catch_element) == sizeof(src->try_catch_array[i]));
	
	
	
	/* STRUCT_P_EX(zend_try_catch_element,DST(`try_catch_array[LOOPCOUNTER]'),SRC(`try_catch_array[LOOPCOUNTER]'),try_catch_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_try_catch_element) == sizeof((& src->try_catch_array[i])[0]));
	

	

	xc_store_zend_try_catch_element(
		
		
		processor, & dst->try_catch_array[i], & src->try_catch_array[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->try_catch_array = (zend_try_catch_element *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->try_catch_array);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->try_catch_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_try_catch) */

	assert(sizeof(int) == sizeof(src->last_try_catch));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_try_catch", sizeof("last_try_catch"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_try_catch"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_try_catch", sizeof("last_try_catch"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_try_catch);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_bool,has_finally_block) */

	assert(sizeof(zend_bool) == sizeof(src->has_finally_block));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "has_finally_block", sizeof("has_finally_block"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "has_finally_block"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "has_finally_block", sizeof("has_finally_block"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->has_finally_block);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	
	/* STRUCT_P(HashTable,static_variables,HashTable_zval_ptr) */

	if (src->static_variables) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_variables'),SRC(`static_variables'),static_variables,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_variables)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`static_variables')',`HashTable' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(HashTable);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`static_variables')',`HashTable' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->static_variables = (HashTable *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->static_variables, (void *) (unsigned long) __LINE__, sizeof(HashTable));
#endif

			
		processor->p += sizeof(HashTable);

		
	
	
	
	
	


	

	xc_store_HashTable_zval_ptr(
		
		
		processor,  dst->static_variables,  src->static_variables
		
		
		TSRMLS_CC
	);

	

	
	
	dst->static_variables = (HashTable *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->static_variables);


	}
	else {
		
		
	
	
	assert(src->static_variables == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_variables", sizeof("static_variables"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "static_variables"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_variables", sizeof("static_variables"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_variables);
	xc_autocheck_done_count ++;

#endif




#ifndef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start_op", sizeof("start_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "start_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start_op", sizeof("start_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start_op);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,backpatch_count) */

	assert(sizeof(int) == sizeof(src->backpatch_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "backpatch_count", sizeof("backpatch_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "backpatch_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "backpatch_count", sizeof("backpatch_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->backpatch_count);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_3
		
	/* PROCESS(zend_uint,this_var) */

	assert(sizeof(zend_uint) == sizeof(src->this_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "this_var", sizeof("this_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "this_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "this_var", sizeof("this_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->this_var);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,done_pass_two) */

	assert(sizeof(zend_bool) == sizeof(src->done_pass_two));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "done_pass_two", sizeof("done_pass_two"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "done_pass_two"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "done_pass_two", sizeof("done_pass_two"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->done_pass_two);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* 5.0 <= ver < 5.3 */
#if defined(ZEND_ENGINE_2) && !defined(ZEND_ENGINE_2_3)
		
	/* PROCESS(zend_bool,uses_this) */

	assert(sizeof(zend_bool) == sizeof(src->uses_this));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_this", sizeof("uses_this"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_this"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_this", sizeof("uses_this"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_this);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
	}
	else {
		
		
		dst->filename =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->filename), strlen(src->filename) + 1 C_RELAYLINE));
		
		
	dst->filename = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->filename);

		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
	
		
	/* PROC_STRING(script_encoding) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "script_encoding", sizeof("script_encoding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "script_encoding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "script_encoding", sizeof("script_encoding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->script_encoding);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->script_encoding == NULL) {
		
		
	}
	else {
		
		
		dst->script_encoding =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->script_encoding), strlen(src->script_encoding) + 1 C_RELAYLINE));
		
		
	dst->script_encoding = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->script_encoding);

		
	}
	
	
	
	
	
	
	

	
#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->doc_comment) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->doc_comment) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->doc_comment) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->doc_comment, src->doc_comment_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->doc_comment) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->doc_comment));

		
	}
	
	
	
	
	
	
	

#endif
	

#endif
#ifdef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_uint,early_binding) */

	assert(sizeof(zend_uint) == sizeof(src->early_binding));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "early_binding", sizeof("early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "early_binding", sizeof("early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->early_binding);
	xc_autocheck_done_count ++;

#endif



	
;
#endif

	/* reserved */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "reserved", sizeof("reserved"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "reserved"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "reserved", sizeof("reserved"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->reserved);
	xc_autocheck_done_count ++;

#endif


#if defined(HARDENING_PATCH) && HARDENING_PATCH
		
	/* PROCESS(zend_bool,created_by_eval) */

	assert(sizeof(zend_bool) == sizeof(src->created_by_eval));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "created_by_eval", sizeof("created_by_eval"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "created_by_eval"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "created_by_eval", sizeof("created_by_eval"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->created_by_eval);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_4
	dst->run_time_cache = NULL;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "run_time_cache", sizeof("run_time_cache"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "run_time_cache"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "run_time_cache", sizeof("run_time_cache"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->run_time_cache);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,last_cache_slot) */

	assert(sizeof(int) == sizeof(src->last_cache_slot));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_cache_slot", sizeof("last_cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_cache_slot", sizeof("last_cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_cache_slot);
	xc_autocheck_done_count ++;

#endif



	

#endif
	} while (0);
	

#ifdef ZEND_ENGINE_2
		dst->prototype = (processor->active_class_entry_src && src->prototype) ? (zend_function *) -1 : NULL;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "prototype", sizeof("prototype"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "prototype"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "prototype", sizeof("prototype"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->prototype);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2
	
	if (src->scope) {
		dst->scope = (zend_class_entry *) xc_get_class_num(processor,src->scope);
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->scope == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "scope", sizeof("scope"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "scope"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "scope", sizeof("scope"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->scope);
	xc_autocheck_done_count ++;

#endif


	
		if (src->scope) {
			xc_fix_method(processor, dst TSRMLS_CC);
		}
	
#endif

	
	}
	
		processor->active_op_array_dst = NULL;
		processor->active_op_array_src = NULL;
	
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_zend_op_array", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_store_xc_constinfo_t */
	
 	  	 	static void inline 	xc_store_xc_constinfo_t( 		 		 		xc_processor_t *processor, xc_constinfo_t *dst, const xc_constinfo_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_constinfo_t*)NULL)->key) + sizeof(((xc_constinfo_t*)NULL)->key_size) + sizeof(((xc_constinfo_t*)NULL)->h) + sizeof(((xc_constinfo_t*)NULL)->constant)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","constant" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_constinfo_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->key) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_U(dst->key) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->key));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
	
	/* STRUCT(zend_constant,constant) */

	assert(sizeof(zend_constant) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zend_constant,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zend_constant) == sizeof((& src->constant)[0]));
	

	

	xc_store_zend_constant(
		
		
		processor, & dst->constant, & src->constant
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_constinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_store_xc_op_array_info_detail_t */
	
 	  	 	static void inline 	xc_store_xc_op_array_info_detail_t( 		 		 		xc_processor_t *processor, xc_op_array_info_detail_t *dst, const xc_op_array_info_detail_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_detail_t*)NULL)->index) + sizeof(((xc_op_array_info_detail_t*)NULL)->info)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "index","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_op_array_info_detail_t));
			do {
		

		
				
	/* PROCESS(zend_uint,index) */

	assert(sizeof(zend_uint) == sizeof(src->index));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "index", sizeof("index"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "index"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "index", sizeof("index"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->index);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,info) */

	assert(sizeof(zend_uint) == sizeof(src->info));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_op_array_info_detail_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_xc_op_array_info_t */
	
 	  	 	static void inline 	xc_store_xc_op_array_info_t( 		 		 		xc_processor_t *processor, xc_op_array_info_t *dst, const xc_op_array_info_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_t*)NULL)->literalinfo_cnt) + sizeof(((xc_op_array_info_t*)NULL)->literalinfos)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "literalinfo_cnt","literalinfos" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_op_array_info_t));
			do {
		

		
		#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,literalinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->literalinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfo_cnt", sizeof("literalinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfo_cnt", sizeof("literalinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->literalinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`literalinfos')',`xc_op_array_info_detail_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_op_array_info_detail_t) * src->literalinfo_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`literalinfos')',`xc_op_array_info_detail_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->literalinfos = (xc_op_array_info_detail_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->literalinfos, (void *) (unsigned long) __LINE__, sizeof(xc_op_array_info_detail_t) * src->literalinfo_cnt);
#endif

			
		processor->p += sizeof(xc_op_array_info_detail_t) * src->literalinfo_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->literalinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_detail_t,literalinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_detail_t) == sizeof(src->literalinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_detail_t,DST(`literalinfos[LOOPCOUNTER]'),SRC(`literalinfos[LOOPCOUNTER]'),literalinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_detail_t) == sizeof((& src->literalinfos[i])[0]));
	

	

	xc_store_xc_op_array_info_detail_t(
		
		
		processor, & dst->literalinfos[i], & src->literalinfos[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->literalinfos = (xc_op_array_info_detail_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->literalinfos);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literalinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif



	}

#else
		
	/* PROCESS(zend_uint,oplineinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->oplineinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfo_cnt", sizeof("oplineinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfo_cnt", sizeof("oplineinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->oplineinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`oplineinfos')',`xc_op_array_info_detail_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_op_array_info_detail_t) * src->oplineinfo_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`oplineinfos')',`xc_op_array_info_detail_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->oplineinfos = (xc_op_array_info_detail_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->oplineinfos, (void *) (unsigned long) __LINE__, sizeof(xc_op_array_info_detail_t) * src->oplineinfo_cnt);
#endif

			
		processor->p += sizeof(xc_op_array_info_detail_t) * src->oplineinfo_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->oplineinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_detail_t,oplineinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_detail_t) == sizeof(src->oplineinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_detail_t,DST(`oplineinfos[LOOPCOUNTER]'),SRC(`oplineinfos[LOOPCOUNTER]'),oplineinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_detail_t) == sizeof((& src->oplineinfos[i])[0]));
	

	

	xc_store_xc_op_array_info_detail_t(
		
		
		processor, & dst->oplineinfos[i], & src->oplineinfos[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->oplineinfos = (xc_op_array_info_detail_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->oplineinfos);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->oplineinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_op_array_info_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	

/* {{{ xc_store_xc_funcinfo_t */
	
		/* export:  	  	 	void 	xc_store_xc_funcinfo_t( 		 		 		xc_processor_t *processor, xc_funcinfo_t *dst, const xc_funcinfo_t * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_xc_funcinfo_t( 		 		 		xc_processor_t *processor, xc_funcinfo_t *dst, const xc_funcinfo_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_funcinfo_t*)NULL)->key) + sizeof(((xc_funcinfo_t*)NULL)->key_size) + sizeof(((xc_funcinfo_t*)NULL)->h) + sizeof(((xc_funcinfo_t*)NULL)->op_array_info) + sizeof(((xc_funcinfo_t*)NULL)->func)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","op_array_info","func" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_funcinfo_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->key) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_U(dst->key) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->key));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	

	xc_store_xc_op_array_info_t(
		
		
		processor, & dst->op_array_info, & src->op_array_info
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT(zend_function,func) */

	assert(sizeof(zend_function) == sizeof(src->func));
	
	
	
	/* STRUCT_P_EX(zend_function,DST(`func'),SRC(`func'),func,,&) */

	
	

	
	assert(sizeof(zend_function) == sizeof((& src->func)[0]));
	

	

	xc_store_zend_function(
		
		
		processor, & dst->func, & src->func
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "func", sizeof("func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "func", sizeof("func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->func);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_funcinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_xc_classinfo_t */
	
		/* export:  	  	 	void 	xc_store_xc_classinfo_t( 		 		 		xc_processor_t *processor, xc_classinfo_t *dst, const xc_classinfo_t * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_xc_classinfo_t( 		 		 		xc_processor_t *processor, xc_classinfo_t *dst, const xc_classinfo_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_classinfo_t*)NULL)->key) + sizeof(((xc_classinfo_t*)NULL)->key_size) + sizeof(((xc_classinfo_t*)NULL)->h) + sizeof(((xc_classinfo_t*)NULL)->methodinfo_cnt) + sizeof(((xc_classinfo_t*)NULL)->methodinfos) + sizeof(((xc_classinfo_t*)NULL)->cest)  ), assert_count = 6;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","methodinfo_cnt","methodinfos","cest" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_classinfo_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->key) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_U(dst->key) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->key));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_size C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,methodinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->methodinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfo_cnt", sizeof("methodinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfo_cnt", sizeof("methodinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->methodinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`methodinfos')',`xc_op_array_info_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_op_array_info_t) * src->methodinfo_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`methodinfos')',`xc_op_array_info_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->methodinfos = (xc_op_array_info_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->methodinfos, (void *) (unsigned long) __LINE__, sizeof(xc_op_array_info_t) * src->methodinfo_cnt);
#endif

			
		processor->p += sizeof(xc_op_array_info_t) * src->methodinfo_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->methodinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_t,methodinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->methodinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`methodinfos[LOOPCOUNTER]'),SRC(`methodinfos[LOOPCOUNTER]'),methodinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->methodinfos[i])[0]));
	

	

	xc_store_xc_op_array_info_t(
		
		
		processor, & dst->methodinfos[i], & src->methodinfos[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->methodinfos = (xc_op_array_info_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->methodinfos);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->methodinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif



	}

	
	
#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT_P(zend_class_entry,cest) */

	if (src->cest) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->cest)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`cest')',`zend_class_entry' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_class_entry);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`cest')',`zend_class_entry' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->cest = (zend_class_entry *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->cest, (void *) (unsigned long) __LINE__, sizeof(zend_class_entry));
#endif

			
		processor->p += sizeof(zend_class_entry);

		
	
	
	
	
	


	

	xc_store_zend_class_entry(
		
		
		processor,  dst->cest,  src->cest
		
		
		TSRMLS_CC
	);

	

	
	
	dst->cest = (zend_class_entry *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->cest);


	}
	else {
		
		
	
	
	assert(src->cest == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(zend_class_entry,cest) */

	assert(sizeof(zend_class_entry) == sizeof(src->cest));
	
	
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,,&) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof((& src->cest)[0]));
	

	

	xc_store_zend_class_entry(
		
		
		processor, & dst->cest, & src->cest
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(int,oplineno) */

	assert(sizeof(int) == sizeof(src->oplineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineno", sizeof("oplineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "oplineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineno", sizeof("oplineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineno);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_classinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2_1

	
	

/* {{{ xc_store_xc_autoglobal_t */
	
 	  	 	static void inline 	xc_store_xc_autoglobal_t( 		 		 		xc_processor_t *processor, xc_autoglobal_t *dst, const xc_autoglobal_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_autoglobal_t*)NULL)->key) + sizeof(((xc_autoglobal_t*)NULL)->key_len) + sizeof(((xc_autoglobal_t*)NULL)->h)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_len","h" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_autoglobal_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_len) */

	assert(sizeof(zend_uint) == sizeof(src->key_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_len", sizeof("key_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_len", sizeof("key_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_len);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	/* PROC_ZSTRING_L(type,key,key_len) */
 
	
	/* PROC_ZSTRING_N(type,key,key_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->key) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->key, src->key_len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->key) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->key));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->key) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->key, src->key_len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->key) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->key));

		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_autoglobal_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


#ifdef XCACHE_ERROR_CACHING

	
	

/* {{{ xc_store_xc_compilererror_t */
	
 	  	 	static void inline 	xc_store_xc_compilererror_t( 		 		 		xc_processor_t *processor, xc_compilererror_t *dst, const xc_compilererror_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_compilererror_t*)NULL)->type) + sizeof(((xc_compilererror_t*)NULL)->lineno) + sizeof(((xc_compilererror_t*)NULL)->error_len) + sizeof(((xc_compilererror_t*)NULL)->error)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","lineno","error_len","error" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_compilererror_t));
			do {
		

		
				
	/* PROCESS(int,type) */

	assert(sizeof(int) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,error_len) */

	assert(sizeof(int) == sizeof(src->error_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error_len", sizeof("error_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error_len", sizeof("error_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(error,error_len) */
 
	/* PROC_STRING_N(error,error_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error", sizeof("error"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error", sizeof("error"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->error == NULL) {
		
		
	}
	else {
		
		
		dst->error =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->error), src->error_len + 1 C_RELAYLINE));
		
		
	dst->error = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->error);

		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_compilererror_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_store_xc_entry_data_php_t */
	
		/* export:  	  	 	void 	xc_store_xc_entry_data_php_t( 		 		 		xc_processor_t *processor, xc_entry_data_php_t *dst, const xc_entry_data_php_t * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_xc_entry_data_php_t( 		 		 		xc_processor_t *processor, xc_entry_data_php_t *dst, const xc_entry_data_php_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_data_php_t*)NULL)->next) + sizeof(((xc_entry_data_php_t*)NULL)->hvalue) + sizeof(((xc_entry_data_php_t*)NULL)->md5) + sizeof(((xc_entry_data_php_t*)NULL)->refcount) + sizeof(((xc_entry_data_php_t*)NULL)->hits) + sizeof(((xc_entry_data_php_t*)NULL)->size) + sizeof(((xc_entry_data_php_t*)NULL)->op_array_info) + sizeof(((xc_entry_data_php_t*)NULL)->op_array) + sizeof(((xc_entry_data_php_t*)NULL)->constinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->constinfos) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfos) + sizeof(((xc_entry_data_php_t*)NULL)->classinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->classinfos) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobal_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobals) + sizeof(((xc_entry_data_php_t*)NULL)->compilererror_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->compilererrors) + sizeof(((xc_entry_data_php_t*)NULL)->have_references)  ), assert_count = 19;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","hvalue","md5","refcount","hits","size","op_array_info","op_array","constinfo_cnt","constinfos","funcinfo_cnt","funcinfos","classinfo_cnt","classinfos","autoglobal_cnt","autoglobals","compilererror_cnt","compilererrors","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_data_php_t));
			do {
		

		
			
		processor->php_dst = dst;
		processor->php_src = src;
	

	/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(xc_hash_value_t,hvalue) */

	assert(sizeof(xc_hash_value_t) == sizeof(src->hvalue));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hvalue", sizeof("hvalue"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hvalue"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hvalue", sizeof("hvalue"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hvalue);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(xc_md5sum_t,md5) */

	assert(sizeof(xc_md5sum_t) == sizeof(src->md5));
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "md5", sizeof("md5"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "md5"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "md5", sizeof("md5"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->md5);
	xc_autocheck_done_count ++;

#endif


	

		
	/* PROCESS(zend_ulong,refcount) */

	assert(sizeof(zend_ulong) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	

	xc_store_xc_op_array_info_t(
		
		
		processor, & dst->op_array_info, & src->op_array_info
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT_P(zend_op_array,op_array) */

	if (src->op_array) {
		
		
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof(( src->op_array)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`op_array')',`zend_op_array' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(zend_op_array);
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`op_array')',`zend_op_array' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->op_array = (zend_op_array *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->op_array, (void *) (unsigned long) __LINE__, sizeof(zend_op_array));
#endif

			
		processor->p += sizeof(zend_op_array);

		
	
	
	
	
	


	

	xc_store_zend_op_array(
		
		
		processor,  dst->op_array,  src->op_array
		
		
		TSRMLS_CC
	);

	

	
	
	dst->op_array = (zend_op_array *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->op_array);


	}
	else {
		
		
	
	
	assert(src->op_array == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array", sizeof("op_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array", sizeof("op_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array);
	xc_autocheck_done_count ++;

#endif




#ifdef HAVE_XCACHE_CONSTANT
		
	/* PROCESS(zend_uint,constinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->constinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfo_cnt", sizeof("constinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfo_cnt", sizeof("constinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->constinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`constinfos')',`xc_constinfo_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_constinfo_t) * src->constinfo_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`constinfos')',`xc_constinfo_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->constinfos = (xc_constinfo_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->constinfos, (void *) (unsigned long) __LINE__, sizeof(xc_constinfo_t) * src->constinfo_cnt);
#endif

			
		processor->p += sizeof(xc_constinfo_t) * src->constinfo_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->constinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_constinfo_t,constinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_constinfo_t) == sizeof(src->constinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_constinfo_t,DST(`constinfos[LOOPCOUNTER]'),SRC(`constinfos[LOOPCOUNTER]'),constinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_constinfo_t) == sizeof((& src->constinfos[i])[0]));
	

	

	xc_store_xc_constinfo_t(
		
		
		processor, & dst->constinfos[i], & src->constinfos[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->constinfos = (xc_constinfo_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->constinfos);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->constinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
	/* PROCESS(zend_uint,funcinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->funcinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfo_cnt", sizeof("funcinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfo_cnt", sizeof("funcinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->funcinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`funcinfos')',`xc_funcinfo_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_funcinfo_t) * src->funcinfo_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`funcinfos')',`xc_funcinfo_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->funcinfos = (xc_funcinfo_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->funcinfos, (void *) (unsigned long) __LINE__, sizeof(xc_funcinfo_t) * src->funcinfo_cnt);
#endif

			
		processor->p += sizeof(xc_funcinfo_t) * src->funcinfo_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->funcinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_funcinfo_t,funcinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_funcinfo_t) == sizeof(src->funcinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_funcinfo_t,DST(`funcinfos[LOOPCOUNTER]'),SRC(`funcinfos[LOOPCOUNTER]'),funcinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_funcinfo_t) == sizeof((& src->funcinfos[i])[0]));
	

	

	xc_store_xc_funcinfo_t(
		
		
		processor, & dst->funcinfos[i], & src->funcinfos[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->funcinfos = (xc_funcinfo_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->funcinfos);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->funcinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif



	}


		
	/* PROCESS(zend_uint,classinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->classinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfo_cnt", sizeof("classinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfo_cnt", sizeof("classinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->classinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`classinfos')',`xc_classinfo_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_classinfo_t) * src->classinfo_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`classinfos')',`xc_classinfo_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->classinfos = (xc_classinfo_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->classinfos, (void *) (unsigned long) __LINE__, sizeof(xc_classinfo_t) * src->classinfo_cnt);
#endif

			
		processor->p += sizeof(xc_classinfo_t) * src->classinfo_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->classinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_classinfo_t,classinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_classinfo_t) == sizeof(src->classinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_classinfo_t,DST(`classinfos[LOOPCOUNTER]'),SRC(`classinfos[LOOPCOUNTER]'),classinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_classinfo_t) == sizeof((& src->classinfos[i])[0]));
	

	

	xc_store_xc_classinfo_t(
		
		
		processor, & dst->classinfos[i], & src->classinfos[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->classinfos = (xc_classinfo_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->classinfos);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->classinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif



	}

#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(zend_uint,autoglobal_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->autoglobal_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobal_cnt", sizeof("autoglobal_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobal_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobal_cnt", sizeof("autoglobal_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobal_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->autoglobals) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`autoglobals')',`xc_autoglobal_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_autoglobal_t) * src->autoglobal_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`autoglobals')',`xc_autoglobal_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->autoglobals = (xc_autoglobal_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->autoglobals, (void *) (unsigned long) __LINE__, sizeof(xc_autoglobal_t) * src->autoglobal_cnt);
#endif

			
		processor->p += sizeof(xc_autoglobal_t) * src->autoglobal_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->autoglobal_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_autoglobal_t,autoglobals[LOOPCOUNTER],) */

	assert(sizeof(xc_autoglobal_t) == sizeof(src->autoglobals[i]));
	
	
	
	/* STRUCT_P_EX(xc_autoglobal_t,DST(`autoglobals[LOOPCOUNTER]'),SRC(`autoglobals[LOOPCOUNTER]'),autoglobals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_autoglobal_t) == sizeof((& src->autoglobals[i])[0]));
	

	

	xc_store_xc_autoglobal_t(
		
		
		processor, & dst->autoglobals[i], & src->autoglobals[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->autoglobals = (xc_autoglobal_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->autoglobals);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->autoglobals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifdef XCACHE_ERROR_CACHING
		
	/* PROCESS(zend_uint,compilererror_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->compilererror_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererror_cnt", sizeof("compilererror_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererror_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererror_cnt", sizeof("compilererror_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererror_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->compilererrors) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
		
#ifndef NDEBUG
		{
			if (!xc_stack_count(&processor->allocsizes)) {
				fprintf(stderr, "mismatch `DST(`compilererrors')',`xc_compilererror_t',`ARRAY_ELEMENT_COUNT' at line %d\n", __LINE__);
			}
			else {
				unsigned long expect = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long atline = (unsigned long) xc_stack_pop(&processor->allocsizes);
				unsigned long real = sizeof(xc_compilererror_t) * src->compilererror_cnt;
				if (expect != real) {
					fprintf(stderr, "mismatch `DST(`compilererrors')',`xc_compilererror_t',`ARRAY_ELEMENT_COUNT' at line %d(was %lu): real %lu - expect %lu = %lu\n", __LINE__, atline, real, expect, real - expect);
				}
			}
		}
#endif

		
		dst->compilererrors = (xc_compilererror_t *) (processor->p = (char *) ALIGN(processor->p));
		
				
#ifndef NDEBUG
		memsetptr(dst->compilererrors, (void *) (unsigned long) __LINE__, sizeof(xc_compilererror_t) * src->compilererror_cnt);
#endif

			
		processor->p += sizeof(xc_compilererror_t) * src->compilererror_cnt;

		
	
	
	
	
	

			

			for (i = 0;
					i < src->compilererror_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_compilererror_t,compilererrors[LOOPCOUNTER],) */

	assert(sizeof(xc_compilererror_t) == sizeof(src->compilererrors[i]));
	
	
	
	/* STRUCT_P_EX(xc_compilererror_t,DST(`compilererrors[LOOPCOUNTER]'),SRC(`compilererrors[LOOPCOUNTER]'),compilererrors[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_compilererror_t) == sizeof((& src->compilererrors[i])[0]));
	

	

	xc_store_xc_compilererror_t(
		
		
		processor, & dst->compilererrors[i], & src->compilererrors[i]
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
	dst->compilererrors = (xc_compilererror_t *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->compilererrors);

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->compilererrors == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_bool,have_early_binding) */

	assert(sizeof(zend_bool) == sizeof(src->have_early_binding));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_early_binding", sizeof("have_early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_early_binding", sizeof("have_early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_early_binding);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_entry_data_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_xc_entry_t */
	
 	  	 	static void inline 	xc_store_xc_entry_t( 		 		 		xc_processor_t *processor, xc_entry_t *dst, const xc_entry_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_t*)NULL)->next) + sizeof(((xc_entry_t*)NULL)->size) + sizeof(((xc_entry_t*)NULL)->ctime) + sizeof(((xc_entry_t*)NULL)->atime) + sizeof(((xc_entry_t*)NULL)->dtime) + sizeof(((xc_entry_t*)NULL)->hits) + sizeof(((xc_entry_t*)NULL)->ttl) + sizeof(((xc_entry_t*)NULL)->name)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","size","ctime","atime","dtime","hits","ttl","name" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_t));
			do {
		

		
			/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(time_t,ctime) */

	assert(sizeof(time_t) == sizeof(src->ctime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ctime", sizeof("ctime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ctime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ctime", sizeof("ctime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ctime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,atime) */

	assert(sizeof(time_t) == sizeof(src->atime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "atime", sizeof("atime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "atime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "atime", sizeof("atime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->atime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,dtime) */

	assert(sizeof(time_t) == sizeof(src->dtime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dtime", sizeof("dtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "dtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dtime", sizeof("dtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(long,ttl) */

	assert(sizeof(long) == sizeof(src->ttl));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ttl", sizeof("ttl"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ttl"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ttl", sizeof("ttl"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ttl);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif

 
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_entry_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_xc_entry_php_t */
	
		/* export:  	  	 	void 	xc_store_xc_entry_php_t( 		 		 		xc_processor_t *processor, xc_entry_php_t *dst, const xc_entry_php_t * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_xc_entry_php_t( 		 		 		xc_processor_t *processor, xc_entry_php_t *dst, const xc_entry_php_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_php_t*)NULL)->entry) + sizeof(((xc_entry_php_t*)NULL)->php) + sizeof(((xc_entry_php_t*)NULL)->refcount) + sizeof(((xc_entry_php_t*)NULL)->file_mtime) + sizeof(((xc_entry_php_t*)NULL)->file_size) + sizeof(((xc_entry_php_t*)NULL)->file_device) + sizeof(((xc_entry_php_t*)NULL)->file_inode) + sizeof(((xc_entry_php_t*)NULL)->filepath_len) + sizeof(((xc_entry_php_t*)NULL)->filepath) + sizeof(((xc_entry_php_t*)NULL)->dirpath_len) + sizeof(((xc_entry_php_t*)NULL)->dirpath)  ), assert_count = 11;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","php","refcount","file_mtime","file_size","file_device","file_inode","filepath_len","filepath","dirpath_len","dirpath" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_php_t));
			do {
		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_store_xc_entry_t(
		
		
		processor, & dst->entry, & src->entry
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif



	
	
	

			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

		
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
	}
	else {
		
		
		dst->entry.name.str.val =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->entry.name.str.val), src->entry.name.str.len + 1 C_RELAYLINE));
		
		
	dst->entry.name.str.val = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->entry.name.str.val);

		
	}
	
	
	
	
	
	
	

		
	
	
	


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "php", sizeof("php"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "php"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "php", sizeof("php"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->php);
	xc_autocheck_done_count ++;

#endif



	dst->refcount = 0; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(time_t,file_mtime) */

	assert(sizeof(time_t) == sizeof(src->file_mtime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_mtime", sizeof("file_mtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_mtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_mtime", sizeof("file_mtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_mtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_size) */

	assert(sizeof(size_t) == sizeof(src->file_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_size", sizeof("file_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_size", sizeof("file_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_size);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_device) */

	assert(sizeof(size_t) == sizeof(src->file_device));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_device", sizeof("file_device"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_device"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_device", sizeof("file_device"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_device);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_inode) */

	assert(sizeof(size_t) == sizeof(src->file_inode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_inode", sizeof("file_inode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_inode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_inode", sizeof("file_inode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_inode);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(size_t,filepath_len) */

	assert(sizeof(size_t) == sizeof(src->filepath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath_len", sizeof("filepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath_len", sizeof("filepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(filepath,filepath_len) */
 
	/* PROC_STRING_N(filepath,filepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath", sizeof("filepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath", sizeof("filepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filepath == NULL) {
		
		
	}
	else {
		
		
		dst->filepath =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->filepath), src->filepath_len + 1 C_RELAYLINE));
		
		
	dst->filepath = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->filepath);

		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(size_t,dirpath_len) */

	assert(sizeof(size_t) == sizeof(src->dirpath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath_len", sizeof("dirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath_len", sizeof("dirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(dirpath,dirpath_len) */
 
	/* PROC_STRING_N(dirpath,dirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath", sizeof("dirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath", sizeof("dirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->dirpath == NULL) {
		
		
	}
	else {
		
		
		dst->dirpath =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->dirpath), src->dirpath_len + 1 C_RELAYLINE));
		
		
	dst->dirpath = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->dirpath);

		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
		
	/* PROCESS(int,ufilepath_len) */

	assert(sizeof(int) == sizeof(src->ufilepath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath_len", sizeof("ufilepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath_len", sizeof("ufilepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(ufilepath,ufilepath_len) */
 
	/* PROC_USTRING_N(ufilepath,ufilepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath", sizeof("ufilepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath", sizeof("ufilepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->ufilepath == NULL) {
		
		
	}
	else {
		
		
		dst->ufilepath =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, ZSTR(src->ufilepath), src->ufilepath_len + 1 C_RELAYLINE));
		
		
	dst->ufilepath = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->ufilepath);

		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(int,udirpath_len) */

	assert(sizeof(int) == sizeof(src->udirpath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath_len", sizeof("udirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath_len", sizeof("udirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(udirpath,udirpath_len) */
 
	/* PROC_USTRING_N(udirpath,udirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath", sizeof("udirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath", sizeof("udirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->udirpath == NULL) {
		
		
	}
	else {
		
		
		dst->udirpath =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, ZSTR(src->udirpath), src->udirpath_len + 1 C_RELAYLINE));
		
		
	dst->udirpath = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->udirpath);

		
	}
	
	
	
	
	
	
	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_entry_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_store_xc_entry_var_t */
	
		/* export:  	  	 	void 	xc_store_xc_entry_var_t( 		 		 		xc_processor_t *processor, xc_entry_var_t *dst, const xc_entry_var_t * const src 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_store_xc_entry_var_t( 		 		 		xc_processor_t *processor, xc_entry_var_t *dst, const xc_entry_var_t * const src 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_var_t*)NULL)->entry) + sizeof(((xc_entry_var_t*)NULL)->value) + sizeof(((xc_entry_var_t*)NULL)->have_references)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","value","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			assert(!xc_is_shm(src));
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_var_t));
			do {
		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_store_xc_entry_t(
		
		
		processor, & dst->entry, & src->entry
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif




#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,name_type) */

	assert(sizeof(zend_uchar) == sizeof(src->name_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_type", sizeof("name_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "name_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_type", sizeof("name_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	
	

#ifdef IS_UNICODE
		if (src->name_type == IS_UNICODE) {
				
	/* PROCESS(int32_t,entry.name.ustr.len) */

	assert(sizeof(int32_t) == sizeof(src->entry.name.ustr.len));
		
	
	
	

	

		}
		else {
				
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

		}
#else
			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

#endif
		
#ifdef IS_UNICODE
			
	/* PROC_ZSTRING_L(name_type,entry.name.uni.val,entry.name.uni.len) */
 
	
	/* PROC_ZSTRING_N(name_type,entry.name.uni.val,entry.name.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
		if (src->name_type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_U(dst->entry.name.uni.val) =  ZSTR_U(xc_store_string_n(processor, IS_UNICODE, src->entry.name.uni.val, src->entry.name.uni.len + 1 C_RELAYLINE));
		
		
	ZSTR_U(dst->entry.name.uni.val) = (UChar *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_U(dst->entry.name.uni.val));

		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->entry.name.uni.val) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->entry.name.uni.val, src->entry.name.uni.len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->entry.name.uni.val) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->entry.name.uni.val));

		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		
		
		ZSTR_S(dst->entry.name.uni.val) =  ZSTR_S(xc_store_string_n(processor, IS_STRING, src->entry.name.uni.val, src->entry.name.uni.len + 1 C_RELAYLINE));
		
		
	ZSTR_S(dst->entry.name.uni.val) = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)ZSTR_S(dst->entry.name.uni.val));

		
	}
	
	
	
	
	
	
	

#endif
	

#else
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
	}
	else {
		
		
		dst->entry.name.str.val =  ZSTR_S(xc_store_string_n(processor, IS_STRING, ZSTR(src->entry.name.str.val), src->entry.name.str.len + 1 C_RELAYLINE));
		
		
	dst->entry.name.str.val = (char *) processor->shm->handlers->to_readonly(processor->shm, (void *)dst->entry.name.str.val);

		
	}
	
	
	
	
	
	
	

#endif
		
	
	
	

	
	
	
	
	/* STRUCT_P_EX(zval_ptr,dst->value,src->value,value,,&) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((& src->value)[0]));
	

	

	xc_store_zval_ptr(
		
		
		processor, & dst->value, & src->value
		
		
		TSRMLS_CC
	);

	

	
	

		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_store_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_store_xc_entry_var_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_store_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_store_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	




  /* {{{ Pre-declare */
 	  	 	void 	xc_restore_zval( 		 		 		 		xc_processor_t *processor, zval *dst, const zval * const src 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_restore_zval_ptr( 		 		 		 		xc_processor_t *processor, zval_ptr *dst, const zval_ptr * const src 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_restore_zval_ptr_nullable( 		 		 		 		xc_processor_t *processor, zval_ptr_nullable *dst, const zval_ptr_nullable * const src 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_restore_zend_op_array( 		 		 		 		xc_processor_t *processor, zend_op_array *dst, const zend_op_array * const src 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_restore_zend_class_entry( 		 		 		 		xc_processor_t *processor, zend_class_entry *dst, const zend_class_entry * const src 		 		TSRMLS_DC 	); 	
#ifdef HAVE_XCACHE_CONSTANT
 	  	 	static void inline 	xc_restore_zend_constant( 		 		 		 		xc_processor_t *processor, zend_constant *dst, const zend_constant * const src 		 		TSRMLS_DC 	); 	
#endif
 	  	 	void 	xc_restore_zend_function( 		 		 		 		xc_processor_t *processor, zend_function *dst, const zend_function * const src 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_restore_xc_entry_var_t( 		 		 		 		xc_processor_t *processor, xc_entry_var_t *dst, const xc_entry_var_t * const src 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_restore_xc_entry_php_t( 		 		 		 		xc_processor_t *processor, xc_entry_php_t *dst, const xc_entry_php_t * const src 		 		TSRMLS_DC 	); 	
#ifdef ZEND_ENGINE_2
 	  	 	static void inline 	xc_restore_zend_property_info( 		 		 		 		xc_processor_t *processor, zend_property_info *dst, const zend_property_info * const src 		 		TSRMLS_DC 	); 	
#endif
/* }}} */
#ifdef IS_CV

	
	

/* {{{ xc_restore_zend_compiled_variable */
	
 	  	 	static void inline 	xc_restore_zend_compiled_variable( 		 		 		 		xc_processor_t *processor, zend_compiled_variable *dst, const zend_compiled_variable * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_compiled_variable*)NULL)->name) + sizeof(((zend_compiled_variable*)NULL)->name_len) + sizeof(((zend_compiled_variable*)NULL)->hash_value)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","hash_value" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_compiled_variable));
			do {
		

		
				
	/* PROCESS(int,name_len) */

	assert(sizeof(int) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->name) =  eustrndup (ZSTR_U(src->name), (src->name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,hash_value) */

	assert(sizeof(ulong) == sizeof(src->hash_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_compiled_variable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zend_uint */
	
 	  	 	static void inline 	xc_restore_zend_uint( 		 		 		 		xc_processor_t *processor, zend_uint *dst, const zend_uint * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_uint), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_uint));
			do {
		

		
			dst[0] = src[0];
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_uint", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifndef ZEND_ENGINE_2

	
	

/* {{{ xc_restore_int */
	
 	  	 	static void inline 	xc_restore_int( 		 		 		 		xc_processor_t *processor, int *dst, const int * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(int), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(int));
			do {
		

		
			*dst = *src;
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_int", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_restore_zend_try_catch_element */
	
 	  	 	static void inline 	xc_restore_zend_try_catch_element( 		 		 		 		xc_processor_t *processor, zend_try_catch_element *dst, const zend_try_catch_element * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_try_catch_element*)NULL)->try_op) + sizeof(((zend_try_catch_element*)NULL)->catch_op) + sizeof(((zend_try_catch_element*)NULL)->finally_op) + sizeof(((zend_try_catch_element*)NULL)->finally_end)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "try_op","catch_op","finally_op","finally_end" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_try_catch_element));
			do {
		

		
				
	/* PROCESS(zend_uint,try_op) */

	assert(sizeof(zend_uint) == sizeof(src->try_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_op", sizeof("try_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_op", sizeof("try_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,catch_op) */

	assert(sizeof(zend_uint) == sizeof(src->catch_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "catch_op", sizeof("catch_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "catch_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "catch_op", sizeof("catch_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->catch_op);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,finally_op) */

	assert(sizeof(zend_uint) == sizeof(src->finally_op));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_op", sizeof("finally_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_op", sizeof("finally_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,finally_end) */

	assert(sizeof(zend_uint) == sizeof(src->finally_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_end", sizeof("finally_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_end", sizeof("finally_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_end);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_try_catch_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zend_brk_cont_element */
	
 	  	 	static void inline 	xc_restore_zend_brk_cont_element( 		 		 		 		xc_processor_t *processor, zend_brk_cont_element *dst, const zend_brk_cont_element * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_brk_cont_element*)NULL)->start) + sizeof(((zend_brk_cont_element*)NULL)->cont) + sizeof(((zend_brk_cont_element*)NULL)->brk) + sizeof(((zend_brk_cont_element*)NULL)->parent)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "start","cont","brk","parent" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_brk_cont_element));
			do {
		

		
		#ifdef ZEND_ENGINE_2_2
		
	/* PROCESS(int,start) */

	assert(sizeof(int) == sizeof(src->start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start", sizeof("start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start", sizeof("start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(int,cont) */

	assert(sizeof(int) == sizeof(src->cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cont", sizeof("cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cont", sizeof("cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cont);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,brk) */

	assert(sizeof(int) == sizeof(src->brk));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk", sizeof("brk"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk", sizeof("brk"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,parent) */

	assert(sizeof(int) == sizeof(src->parent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_brk_cont_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	
	

/* {{{ xc_restore_HashTable_zval_ptr */
	
 	  	 	static void inline 	xc_restore_HashTable_zval_ptr( 		 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(HashTable));
			do {
		

		
		
		
	

				
				Bucket *srcBucket;
		Bucket *pnew = NULL, *prev = NULL;
		zend_bool first = 1;
				uint n;
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		dst->canary = zend_hash_canary; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif


#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		dst->pInternalPointer = NULL;	/* Used for element traversal */ 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		dst->pListHead = NULL; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
	
			dst->arBuckets = (Bucket* *) ecalloc(src->nTableSize, sizeof(Bucket*));
		
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
	
	
			pnew = (Bucket *) emalloc(sizeof(char) * bucketsize);
			
#ifndef NDEBUG
		memsetptr(pnew, (void *) __LINE__, sizeof(char) * bucketsize);
#endif

		
	
	
	
	

			
#ifdef ZEND_ENGINE_2_4
				memcpy(pnew, srcBucket, BUCKET_HEAD_SIZE(Bucket));
				if (BUCKET_KEY_SIZE(srcBucket)) {
					memcpy((char *) (pnew + 1), srcBucket->arKey, BUCKET_KEY_SIZE(srcBucket));
					pnew->arKey = (const char *) (pnew + 1);
				}
				else {
					pnew->arKey = NULL;
				}
#else
				memcpy(pnew, srcBucket, bucketsize);
#endif
				n = srcBucket->h & src->nTableMask;
				/* pnew into hash node chain */
				pnew->pLast = NULL;
				pnew->pNext = dst->arBuckets[n];
				if (pnew->pNext) {
					pnew->pNext->pLast = pnew;
				}
				dst->arBuckets[n] = pnew;
			
			
			if (sizeof(void *) == sizeof(zval_ptr)) {
				pnew->pData = &pnew->pDataPtr;
								
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  ((zval_ptr*)srcBucket->pData))[0]));
	

	

	xc_restore_zval_ptr(
		
		
		
		processor,   pnew->pData,   ((zval_ptr*)srcBucket->pData)
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof(( ((zval_ptr*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			pnew->pData = (zval_ptr *) emalloc(sizeof(zval_ptr));
			
#ifndef NDEBUG
		memsetptr(pnew->pData, (void *) __LINE__, sizeof(zval_ptr));
#endif

		
	
	
	
	


	

	xc_restore_zval_ptr(
		
		
		
		processor,  pnew->pData,  ((zval_ptr*)srcBucket->pData)
		
		TSRMLS_CC
	);

	

	
	

				pnew->pDataPtr = NULL;
			}

			if (first) {
				dst->pListHead = pnew;
				first = 0;
			}

			
				/* flat link */
				pnew->pListLast = prev;
				pnew->pListNext = NULL;
				if (prev) {
					prev->pListNext = pnew;
				}
				prev = pnew;
			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		dst->pListTail = pnew; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		dst->pDestructor = src->pDestructor; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_HashTable_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	
	

/* {{{ xc_restore_HashTable_zend_function */
	
		/* export:  	  	 	void 	xc_restore_HashTable_zend_function( 		 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_HashTable_zend_function( 		 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(HashTable));
			do {
		

		
		
		
	

				
				Bucket *srcBucket;
		Bucket *pnew = NULL, *prev = NULL;
		zend_bool first = 1;
				uint n;
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		dst->canary = zend_hash_canary; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif


#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		dst->pInternalPointer = NULL;	/* Used for element traversal */ 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		dst->pListHead = NULL; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
	
			dst->arBuckets = (Bucket* *) ecalloc(src->nTableSize, sizeof(Bucket*));
		
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
	
	
			pnew = (Bucket *) emalloc(sizeof(char) * bucketsize);
			
#ifndef NDEBUG
		memsetptr(pnew, (void *) __LINE__, sizeof(char) * bucketsize);
#endif

		
	
	
	
	

			
#ifdef ZEND_ENGINE_2_4
				memcpy(pnew, srcBucket, BUCKET_HEAD_SIZE(Bucket));
				if (BUCKET_KEY_SIZE(srcBucket)) {
					memcpy((char *) (pnew + 1), srcBucket->arKey, BUCKET_KEY_SIZE(srcBucket));
					pnew->arKey = (const char *) (pnew + 1);
				}
				else {
					pnew->arKey = NULL;
				}
#else
				memcpy(pnew, srcBucket, bucketsize);
#endif
				n = srcBucket->h & src->nTableMask;
				/* pnew into hash node chain */
				pnew->pLast = NULL;
				pnew->pNext = dst->arBuckets[n];
				if (pnew->pNext) {
					pnew->pNext->pLast = pnew;
				}
				dst->arBuckets[n] = pnew;
			
			
			if (sizeof(void *) == sizeof(zend_function)) {
				pnew->pData = &pnew->pDataPtr;
								
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_function) == sizeof((  ((zend_function*)srcBucket->pData))[0]));
	

	

	xc_restore_zend_function(
		
		
		
		processor,   pnew->pData,   ((zend_function*)srcBucket->pData)
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_function) == sizeof(( ((zend_function*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			pnew->pData = (zend_function *) emalloc(sizeof(zend_function));
			
#ifndef NDEBUG
		memsetptr(pnew->pData, (void *) __LINE__, sizeof(zend_function));
#endif

		
	
	
	
	


	

	xc_restore_zend_function(
		
		
		
		processor,  pnew->pData,  ((zend_function*)srcBucket->pData)
		
		TSRMLS_CC
	);

	

	
	

				pnew->pDataPtr = NULL;
			}

			if (first) {
				dst->pListHead = pnew;
				first = 0;
			}

			
				/* flat link */
				pnew->pListLast = prev;
				pnew->pListNext = NULL;
				if (prev) {
					prev->pListNext = pnew;
				}
				prev = pnew;
			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		dst->pListTail = pnew; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		dst->pDestructor = src->pDestructor; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_function : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_HashTable_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2

	
	
	

/* {{{ xc_restore_HashTable_zend_property_info */
	
 	  	 	static void inline 	xc_restore_HashTable_zend_property_info( 		 		 		 		xc_processor_t *processor, HashTable *dst, const HashTable * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(HashTable));
			do {
		

		
		
		
	

				
				Bucket *srcBucket;
		Bucket *pnew = NULL, *prev = NULL;
		zend_bool first = 1;
				uint n;
		size_t bucketsize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		dst->canary = zend_hash_canary; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif


#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		dst->pInternalPointer = NULL;	/* Used for element traversal */ 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		dst->pListHead = NULL; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
	
			dst->arBuckets = (Bucket* *) ecalloc(src->nTableSize, sizeof(Bucket*));
		
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			bucketsize = BUCKET_SIZE(srcBucket);
			
	
	
		
	
	
	/* allocate */
	
	
	
			pnew = (Bucket *) emalloc(sizeof(char) * bucketsize);
			
#ifndef NDEBUG
		memsetptr(pnew, (void *) __LINE__, sizeof(char) * bucketsize);
#endif

		
	
	
	
	

			
#ifdef ZEND_ENGINE_2_4
				memcpy(pnew, srcBucket, BUCKET_HEAD_SIZE(Bucket));
				if (BUCKET_KEY_SIZE(srcBucket)) {
					memcpy((char *) (pnew + 1), srcBucket->arKey, BUCKET_KEY_SIZE(srcBucket));
					pnew->arKey = (const char *) (pnew + 1);
				}
				else {
					pnew->arKey = NULL;
				}
#else
				memcpy(pnew, srcBucket, bucketsize);
#endif
				n = srcBucket->h & src->nTableMask;
				/* pnew into hash node chain */
				pnew->pLast = NULL;
				pnew->pNext = dst->arBuckets[n];
				if (pnew->pNext) {
					pnew->pNext->pLast = pnew;
				}
				dst->arBuckets[n] = pnew;
			
			
			if (sizeof(void *) == sizeof(zend_property_info)) {
				pnew->pData = &pnew->pDataPtr;
								
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof((  ((zend_property_info*)srcBucket->pData))[0]));
	

	

	xc_restore_zend_property_info(
		
		
		
		processor,   pnew->pData,   ((zend_property_info*)srcBucket->pData)
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof(( ((zend_property_info*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			pnew->pData = (zend_property_info *) emalloc(sizeof(zend_property_info));
			
#ifndef NDEBUG
		memsetptr(pnew->pData, (void *) __LINE__, sizeof(zend_property_info));
#endif

		
	
	
	
	


	

	xc_restore_zend_property_info(
		
		
		
		processor,  pnew->pData,  ((zend_property_info*)srcBucket->pData)
		
		TSRMLS_CC
	);

	

	
	

				pnew->pDataPtr = NULL;
			}

			if (first) {
				dst->pListHead = pnew;
				first = 0;
			}

			
				/* flat link */
				pnew->pListLast = prev;
				pnew->pListNext = NULL;
				if (prev) {
					prev->pListNext = pnew;
				}
				prev = pnew;
			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		dst->pListTail = pnew; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		dst->pDestructor = src->pDestructor; 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_HashTable_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif
#ifdef IS_CONSTANT_AST


	
	

/* {{{ xc_restore_zend_ast */
	
		/* export:  	  	 	void 	xc_restore_zend_ast( 		 		 		 		xc_processor_t *processor, zend_ast *dst, const zend_ast * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_zend_ast( 		 		 		 		xc_processor_t *processor, zend_ast *dst, const zend_ast * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_ast*)NULL)->kind) + sizeof(((zend_ast*)NULL)->children) + sizeof(((zend_ast*)NULL)->u)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "kind","children","u" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_ast));
			do {
		

		
				zend_ushort i;
			
	/* PROCESS(zend_ushort,kind) */

	assert(sizeof(zend_ushort) == sizeof(src->kind));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "kind", sizeof("kind"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "kind"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "kind", sizeof("kind"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->kind);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_ushort,children) */

	assert(sizeof(zend_ushort) == sizeof(src->children));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "children", sizeof("children"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "children"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "children", sizeof("children"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->children);
	xc_autocheck_done_count ++;

#endif



	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


		
	
	

			if (src->kind == ZEND_CONST) {
				assert(src->u.val);
				
					dst->u.val = (zval *) (dst + 1);
					memcpy(dst->u.val, src->u.val, sizeof(zval));
				
				
	
	/* STRUCT_P_EX(zval,dst->u.val,src->u.val,[],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src->u.val)[0]));
	

	

	xc_restore_zval(
		
		
		
		processor,   dst->u.val,   src->u.val
		
		TSRMLS_CC
	);

	

	
	

				
			}
			else {
				for (i = 0; i < src->children; ++i) {
					zend_ast *src_ast = (&src->u.child)[i];
					if (src_ast) {
						{
	
		size_t zend_ast_size = (src_ast->kind == ZEND_CONST)
		 ? sizeof(zend_ast) + sizeof(zval)
		 : sizeof(zend_ast) + sizeof(zend_ast *) * (src_ast->children - 1);
	

	
	
							
	
	
		
	
	
	/* allocate */
	
	
	
			(&dst->u.child)[i] = (zend_ast *) emalloc(zend_ast_size);
			
#ifndef NDEBUG
		memsetptr((&dst->u.child)[i], (void *) __LINE__, zend_ast_size);
#endif

		
	
	
	
	

							
	
	/* STRUCT_P_EX(zend_ast,(&dst->u.child)[i],src_ast,[],, ) */

	
	

	
	assert(sizeof(zend_ast) == sizeof((  src_ast)[0]));
	

	

	xc_restore_zend_ast(
		
		
		
		processor,   (&dst->u.child)[i],   src_ast
		
		TSRMLS_CC
	);

	

	
	

						
	
}

						
					}
					else {
						(&dst->u.child)[i] = NULL;
					}
				}
			}
		
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_ast", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zval */
	
		/* export:  	  	 	void 	xc_restore_zval( 		 		 		 		xc_processor_t *processor, zval *dst, const zval * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_zval( 		 		 		 		xc_processor_t *processor, zval *dst, const zval * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zval*)NULL)->value) + sizeof(((zval*)NULL)->refcount__gc) + sizeof(((zval*)NULL)->type) + sizeof(((zval*)NULL)->is_ref__gc)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","refcount__gc","type","is_ref__gc" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zval));
			do {
		

		
			
				/* Variable information */
		
	
	

		switch ((Z_TYPE_P(src) & IS_CONSTANT_TYPE_MASK)) {
			case IS_LONG:
			case IS_RESOURCE:
			case IS_BOOL:
					
	/* PROCESS(long,value.lval) */

	assert(sizeof(long) == sizeof(src->value.lval));
		
	
	
	

	

				break;
			case IS_DOUBLE:
					
	/* PROCESS(double,value.dval) */

	assert(sizeof(double) == sizeof(src->value.dval));
		
	
	
	

	

				break;
			case IS_NULL:
				
				break;

			case IS_CONSTANT:
#ifdef IS_UNICODE
				if (UG(unicode)) {
					goto proc_unicode;
				}
#endif
			case IS_STRING:
#ifdef FLAG_IS_BC
			case FLAG_IS_BC:
#endif
					
	/* PROCESS(int,value.str.len) */

	assert(sizeof(int) == sizeof(src->value.str.len));
		
	
	
	

	

				
	/* PROC_STRING_L(value.str.val,value.str.len) */
 
	/* PROC_STRING_N(value.str.val,value.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->value.str.val == NULL) {
		
		
	}
	else {
		
		
		
		
			dst->value.str.val =  estrndup (src->value.str.val, (src->value.str.len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

				break;
#ifdef IS_UNICODE
			case IS_UNICODE:
proc_unicode:
					
	/* PROCESS(int32_t,value.uni.len) */

	assert(sizeof(int32_t) == sizeof(src->value.uni.len));
		
	
	
	

	

				
	/* PROC_ZSTRING_L(1,value.uni.val,value.uni.len) */
 
	
	/* PROC_ZSTRING_N(1,value.uni.val,value.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->value.uni.val) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->value.uni.val) =  eustrndup (ZSTR_U(src->value.uni.val), (src->value.uni.len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->value.uni.val) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->value.uni.val) =  estrndup (ZSTR_S(src->value.uni.val), (src->value.uni.len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

				break;
#endif

			case IS_ARRAY:
#ifdef IS_CONSTANT_ARRAY
			case IS_CONSTANT_ARRAY:
#endif
				assert(src->value.ht);
				
	
	/* STRUCT_P(HashTable,value.ht,HashTable_zval_ptr) */

	if (src->value.ht) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.ht'),SRC(`value.ht'),value.ht,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.ht)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			ALLOC_HASHTABLE(dst->value.ht);
			
#ifndef NDEBUG
		memsetptr(dst->value.ht, (void *) __LINE__, sizeof(HashTable));
#endif

		
	
	
	
	


	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor,  dst->value.ht,  src->value.ht
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.ht == NULL);

	}
	

				break;

#ifdef IS_CONSTANT_AST
			case IS_CONSTANT_AST:
				assert(src->value.ast);
				{
	
		size_t zend_ast_size = (src->value.ast->kind == ZEND_CONST)
		 ? sizeof(zend_ast) + sizeof(zval)
		 : sizeof(zend_ast) + sizeof(zend_ast *) * (src->value.ast->children - 1);
	

	
	
	
	/* STRUCT_P(zend_ast,value.ast) */

	if (src->value.ast) {
		
		
	
	/* STRUCT_P_EX(zend_ast,DST(`value.ast'),SRC(`value.ast'),value.ast,) */

	
	

	
	assert(sizeof(zend_ast) == sizeof(( src->value.ast)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->value.ast = (zend_ast *) emalloc(zend_ast_size);
			
#ifndef NDEBUG
		memsetptr(dst->value.ast, (void *) __LINE__, zend_ast_size);
#endif

		
	
	
	
	


	

	xc_restore_zend_ast(
		
		
		
		processor,  dst->value.ast,  src->value.ast
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.ast == NULL);

	}
	

	
}

				break;
#endif

			case IS_OBJECT:
				
				#ifndef ZEND_ENGINE_2
				
	
	/* STRUCT_P(zend_class_entry,value.obj.ce) */

	if (src->value.obj.ce) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`value.obj.ce'),SRC(`value.obj.ce'),value.obj.ce,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->value.obj.ce)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->value.obj.ce = (zend_class_entry *) emalloc(sizeof(zend_class_entry));
			
#ifndef NDEBUG
		memsetptr(dst->value.obj.ce, (void *) __LINE__, sizeof(zend_class_entry));
#endif

		
	
	
	
	


	

	xc_restore_zend_class_entry(
		
		
		
		processor,  dst->value.obj.ce,  src->value.obj.ce
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.obj.ce == NULL);

	}
	

				
	
	/* STRUCT_P(HashTable,value.obj.properties,HashTable_zval_ptr) */

	if (src->value.obj.properties) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.obj.properties'),SRC(`value.obj.properties'),value.obj.properties,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.obj.properties)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			ALLOC_HASHTABLE(dst->value.obj.properties);
			
#ifndef NDEBUG
		memsetptr(dst->value.obj.properties, (void *) __LINE__, sizeof(HashTable));
#endif

		
	
	
	
	


	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor,  dst->value.obj.properties,  src->value.obj.properties
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->value.obj.properties == NULL);

	}
	

#endif
				break;

			default:
				assert(0);
		}
		
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(xc_zval_type_t,type) */

	assert(sizeof(xc_zval_type_t) == sizeof(src->type));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uchar,is_ref__gc) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref__gc));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref__gc", sizeof("is_ref__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref__gc", sizeof("is_ref__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref__gc);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_uchar,is_ref) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref", sizeof("is_ref"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref", sizeof("is_ref"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uint,refcount__gc) */

	assert(sizeof(zend_uint) == sizeof(src->refcount__gc));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount__gc", sizeof("refcount__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount__gc", sizeof("refcount__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount__gc);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2)
			
	/* PROCESS(zend_uint,refcount) */

	assert(sizeof(zend_uint) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_ushort,refcount) */

	assert(sizeof(zend_ushort) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zval", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_zval_ptr */
	
 	  	 	static void inline 	xc_restore_zval_ptr( 		 		 		 		xc_processor_t *processor, zval_ptr *dst, const zval_ptr * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zval_ptr));
			do {
		

		
			
		do {
			
				if (processor->reference) {
					zval_ptr *ppzv;
					if (zend_hash_find(&processor->zvalptrs, (char *) &src[0], sizeof(src[0]), (void **) &ppzv) == SUCCESS) {
						
							dst[0] = *ppzv;
							/* *dst is updated */
													
						
						
						assert(!xc_is_shm(dst[0]));
						break;
					}
				}
			
			
			
	
	
		
	
	
	/* allocate */
	
	
	
			ALLOC_ZVAL(dst[0]);
			
#ifndef NDEBUG
		memsetptr(dst[0], (void *) __LINE__, sizeof(zval));
#endif

		
	
	
	
	

			
				if (processor->reference) {
					
						zval_ptr pzv = dst[0];
						
					
					if (zend_hash_add(&processor->zvalptrs, (char *) &src[0], sizeof(src[0]), (void *) &pzv, sizeof(pzv), NULL) == SUCCESS) {
						/* first add, go on */
											}
					else {
						assert(0);
					}
				}
			
			
							
			
			
	
	/* STRUCT_P_EX(zval,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src[0])[0]));
	

	

	xc_restore_zval(
		
		
		
		processor,   dst[0],   src[0]
		
		TSRMLS_CC
	);

	

	
	

			
		} while (0);
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_zval_ptr_nullable */
	
 	  	 	static void inline 	xc_restore_zval_ptr_nullable( 		 		 		 		xc_processor_t *processor, zval_ptr_nullable *dst, const zval_ptr_nullable * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr_nullable), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zval_ptr_nullable));
			do {
		

		
			if (src[0]) {
		
		
	
	/* STRUCT_P_EX(zval_ptr,dst,src,,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  src)[0]));
	

	xc_restore_zval_ptr(
		
		
		
		processor,   dst,   src
		
		TSRMLS_CC
	);

	
	

		
	}
	else {
		
	
	
	assert(src[0] == NULL);

	}
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr_nullable);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zval_ptr_nullable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_restore_zend_arg_info */
	
 	  	 	static void inline 	xc_restore_zend_arg_info( 		 		 		 		xc_processor_t *processor, zend_arg_info *dst, const zend_arg_info * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_arg_info*)NULL)->name) + sizeof(((zend_arg_info*)NULL)->name_len) + sizeof(((zend_arg_info*)NULL)->class_name) + sizeof(((zend_arg_info*)NULL)->class_name_len) + sizeof(((zend_arg_info*)NULL)->type_hint) + sizeof(((zend_arg_info*)NULL)->pass_by_reference) + sizeof(((zend_arg_info*)NULL)->allow_null) + sizeof(((zend_arg_info*)NULL)->is_variadic)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","class_name","class_name_len","type_hint","pass_by_reference","allow_null","is_variadic" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_arg_info));
			do {
		

		
				
	/* PROCESS(zend_uint,name_len) */

	assert(sizeof(zend_uint) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->name) =  eustrndup (ZSTR_U(src->name), (src->name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(zend_uint,class_name_len) */

	assert(sizeof(zend_uint) == sizeof(src->class_name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name_len", sizeof("class_name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name_len", sizeof("class_name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,class_name,class_name_len) */
 
	
	/* PROC_ZSTRING_N(,class_name,class_name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->class_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->class_name) =  eustrndup (ZSTR_U(src->class_name), (src->class_name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->class_name) =  estrndup (ZSTR_S(src->class_name), (src->class_name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->class_name) =  estrndup (ZSTR_S(src->class_name), (src->class_name_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,type_hint) */

	assert(sizeof(zend_uchar) == sizeof(src->type_hint));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type_hint", sizeof("type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type_hint", sizeof("type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type_hint);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2_1)
		
	/* PROCESS(zend_bool,array_type_hint) */

	assert(sizeof(zend_bool) == sizeof(src->array_type_hint));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "array_type_hint", sizeof("array_type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "array_type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "array_type_hint", sizeof("array_type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->array_type_hint);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_uchar,pass_by_reference) */

	assert(sizeof(zend_uchar) == sizeof(src->pass_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,allow_null) */

	assert(sizeof(zend_bool) == sizeof(src->allow_null));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "allow_null", sizeof("allow_null"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "allow_null"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "allow_null", sizeof("allow_null"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->allow_null);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_bool,is_variadic) */

	assert(sizeof(zend_bool) == sizeof(src->is_variadic));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_variadic", sizeof("is_variadic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "is_variadic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_variadic", sizeof("is_variadic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_variadic);
	xc_autocheck_done_count ++;

#endif



	

#else
		
	/* PROCESS(zend_bool,pass_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,return_reference) */

	assert(sizeof(zend_bool) == sizeof(src->return_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,required_num_args) */

	assert(sizeof(int) == sizeof(src->required_num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_arg_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_restore_zend_constant */
	
 	  	 	static void inline 	xc_restore_zend_constant( 		 		 		 		xc_processor_t *processor, zend_constant *dst, const zend_constant * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_constant*)NULL)->value) + sizeof(((zend_constant*)NULL)->flags) + sizeof(((zend_constant*)NULL)->name) + sizeof(((zend_constant*)NULL)->name_len) + sizeof(((zend_constant*)NULL)->module_number)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","flags","name","name_len","module_number" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_constant));
			do {
		

		
			
	
	/* STRUCT(zval,value) */

	assert(sizeof(zval) == sizeof(src->value));
	
	
	
	/* STRUCT_P_EX(zval,DST(`value'),SRC(`value'),value,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->value)[0]));
	

	

	xc_restore_zval(
		
		
		
		processor, & dst->value, & src->value
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(int,flags) */

	assert(sizeof(int) == sizeof(src->flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,name_len) */

	assert(sizeof(uint) == sizeof(src->name_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	/* PROC_ZSTRING_N(,name,name_len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->name) =  eustrndup (ZSTR_U(src->name), (src->name_len) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  zend_strndup (ZSTR_S(src->name), (src->name_len) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  zend_strndup (ZSTR_S(src->name), (src->name_len) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(int,module_number) */

	assert(sizeof(int) == sizeof(src->module_number));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module_number", sizeof("module_number"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "module_number"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module_number", sizeof("module_number"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module_number);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_constant", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zend_function */
	
		/* export:  	  	 	void 	xc_restore_zend_function( 		 		 		 		xc_processor_t *processor, zend_function *dst, const zend_function * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_zend_function( 		 		 		 		xc_processor_t *processor, zend_function *dst, const zend_function * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_function), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_function));
			do {
		

		
			
	
	

	switch (src->type) {
	case ZEND_INTERNAL_FUNCTION:
	case ZEND_OVERLOADED_FUNCTION:
		
		break;

	case ZEND_USER_FUNCTION:
	case ZEND_EVAL_CODE:
		
		
	
	/* STRUCT(zend_op_array,op_array) */

	assert(sizeof(zend_op_array) == sizeof(src->op_array));
	
	
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,,&) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof((& src->op_array)[0]));
	

	

	xc_restore_zend_op_array(
		
		
		
		processor, & dst->op_array, & src->op_array
		
		TSRMLS_CC
	);

	

	
	

	

		break;

	default:
		assert(0);
	}
	
	
	

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_restore_zend_property_info */
	
 	  	 	static void inline 	xc_restore_zend_property_info( 		 		 		 		xc_processor_t *processor, zend_property_info *dst, const zend_property_info * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_property_info*)NULL)->flags) + sizeof(((zend_property_info*)NULL)->name) + sizeof(((zend_property_info*)NULL)->name_length) + sizeof(((zend_property_info*)NULL)->h) + sizeof(((zend_property_info*)NULL)->offset) + sizeof(((zend_property_info*)NULL)->doc_comment) + sizeof(((zend_property_info*)NULL)->doc_comment_len) + sizeof(((zend_property_info*)NULL)->ce)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "flags","name","name_length","h","offset","doc_comment","doc_comment_len","ce" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_property_info));
			do {
		

		
				
	/* PROCESS(zend_uint,flags) */

	assert(sizeof(zend_uint) == sizeof(src->flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,name_length) */

	assert(sizeof(int) == sizeof(src->name_length));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->name) =  eustrndup (ZSTR_U(src->name), (src->name_length + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_length + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_length + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(int,offset) */

	assert(sizeof(int) == sizeof(src->offset));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "offset", sizeof("offset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "offset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "offset", sizeof("offset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->offset);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->doc_comment) =  eustrndup (ZSTR_U(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->doc_comment) =  estrndup (ZSTR_S(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->doc_comment) =  estrndup (ZSTR_S(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
	#if defined(ZEND_ENGINE_2_2)
	
	if (src->ce) {
		
		dst->ce = xc_get_class(processor,(zend_ulong) src->ce);
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->ce == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif


#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_restore_zend_trait_method_reference */
	
 	  	 	static void inline 	xc_restore_zend_trait_method_reference( 		 		 		 		xc_processor_t *processor, zend_trait_method_reference *dst, const zend_trait_method_reference * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_method_reference*)NULL)->method_name) + sizeof(((zend_trait_method_reference*)NULL)->mname_len) + sizeof(((zend_trait_method_reference*)NULL)->ce) + sizeof(((zend_trait_method_reference*)NULL)->class_name) + sizeof(((zend_trait_method_reference*)NULL)->cname_len)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "method_name","mname_len","ce","class_name","cname_len" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_method_reference));
			do {
		

		
				
	/* PROCESS(unsigned int,mname_len) */

	assert(sizeof(unsigned int) == sizeof(src->mname_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "mname_len", sizeof("mname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "mname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "mname_len", sizeof("mname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->mname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(method_name,mname_len) */
 
	/* PROC_STRING_N(method_name,mname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "method_name", sizeof("method_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "method_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "method_name", sizeof("method_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->method_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->method_name == NULL) {
		
		
	}
	else {
		
		
		
		
			dst->method_name =  estrndup (src->method_name, (src->mname_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

	
	
	
	
	assert(src->ce == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,cname_len) */

	assert(sizeof(unsigned int) == sizeof(src->cname_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cname_len", sizeof("cname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "cname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cname_len", sizeof("cname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(class_name,cname_len) */
 
	/* PROC_STRING_N(class_name,cname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->class_name == NULL) {
		
		
	}
	else {
		
		
		
		
			dst->class_name =  estrndup (src->class_name, (src->cname_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_trait_method_reference", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_zend_trait_alias */
	
 	  	 	static void inline 	xc_restore_zend_trait_alias( 		 		 		 		xc_processor_t *processor, zend_trait_alias *dst, const zend_trait_alias * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_alias*)NULL)->trait_method) + sizeof(((zend_trait_alias*)NULL)->alias) + sizeof(((zend_trait_alias*)NULL)->alias_len) + sizeof(((zend_trait_alias*)NULL)->modifiers)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","alias","alias_len","modifiers" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_alias));
			do {
		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->trait_method = (zend_trait_method_reference *) emalloc(sizeof(zend_trait_method_reference));
			
#ifndef NDEBUG
		memsetptr(dst->trait_method, (void *) __LINE__, sizeof(zend_trait_method_reference));
#endif

		
	
	
	
	


	

	xc_restore_zend_trait_method_reference(
		
		
		
		processor,  dst->trait_method,  src->trait_method
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,alias_len) */

	assert(sizeof(unsigned int) == sizeof(src->alias_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias_len", sizeof("alias_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias_len", sizeof("alias_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(alias,alias_len) */
 
	/* PROC_STRING_N(alias,alias_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias", sizeof("alias"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias", sizeof("alias"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->alias == NULL) {
		
		
	}
	else {
		
		
		
		
			dst->alias =  estrndup (src->alias, (src->alias_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,modifiers) */

	assert(sizeof(zend_uint) == sizeof(src->modifiers));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "modifiers", sizeof("modifiers"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "modifiers"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "modifiers", sizeof("modifiers"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->modifiers);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_trait_alias", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_zend_trait_precedence */
	
 	  	 	static void inline 	xc_restore_zend_trait_precedence( 		 		 		 		xc_processor_t *processor, zend_trait_precedence *dst, const zend_trait_precedence * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_precedence*)NULL)->trait_method) + sizeof(((zend_trait_precedence*)NULL)->exclude_from_classes)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","exclude_from_classes" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_precedence));
			do {
		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->trait_method = (zend_trait_method_reference *) emalloc(sizeof(zend_trait_method_reference));
			
#ifndef NDEBUG
		memsetptr(dst->trait_method, (void *) __LINE__, sizeof(zend_trait_method_reference));
#endif

		
	
	
	
	


	

	xc_restore_zend_trait_method_reference(
		
		
		
		processor,  dst->trait_method,  src->trait_method
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		if (src->exclude_from_classes) {
		int LOOPCOUNTER;
		
						
				size_t count = 0;
				while (src->exclude_from_classes[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->exclude_from_classes = (zend_class_entry* *) emalloc(sizeof(xc_ztstring) * count);
			
#ifndef NDEBUG
		memsetptr(dst->exclude_from_classes, (void *) __LINE__, sizeof(xc_ztstring) * count);
#endif

		
	
	
	
	

			

			for (LOOPCOUNTER = 0;
					src->exclude_from_classes[LOOPCOUNTER];
					++LOOPCOUNTER) {
				
	
	

					
					
						
	/* PROCESS(xc_ztstring,exclude_from_classes) */

	assert(sizeof(xc_ztstring) == sizeof((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]));
		
	
	/* PROC_STRING(exclude_from_classes) */
 
	
	
	
	
	
	
	
	
	if ((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER] == NULL) {
		
		
	}
	else {
		
		
		
		
			dst->exclude_from_classes [LOOPCOUNTER] = (zend_class_entry *) estrndup ((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER], (strlen((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

	

	

					
					
				
	
	

			}
						dst->exclude_from_classes[LOOPCOUNTER] = NULL;
				
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->exclude_from_classes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif



	}

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_trait_precedence", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_zend_trait_alias_ptr */
	
 	  	 	static void inline 	xc_restore_zend_trait_alias_ptr( 		 		 		 		xc_processor_t *processor, zend_trait_alias_ptr *dst, const zend_trait_alias_ptr * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_alias), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_alias_ptr));
			do {
		

		
			
		
	
	
		
	
	
	/* allocate */
	
	
	
			dst[0] = (zend_trait_alias *) emalloc(sizeof(zend_trait_alias));
			
#ifndef NDEBUG
		memsetptr(dst[0], (void *) __LINE__, sizeof(zend_trait_alias));
#endif

		
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_alias,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_alias) == sizeof((  src[0])[0]));
	

	

	xc_restore_zend_trait_alias(
		
		
		
		processor,   dst[0],   src[0]
		
		TSRMLS_CC
	);

	

	
	

		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_alias);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_trait_alias_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_zend_trait_precedence_ptr */
	
 	  	 	static void inline 	xc_restore_zend_trait_precedence_ptr( 		 		 		 		xc_processor_t *processor, zend_trait_precedence_ptr *dst, const zend_trait_precedence_ptr * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_precedence), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_trait_precedence_ptr));
			do {
		

		
			
		
	
	
		
	
	
	/* allocate */
	
	
	
			dst[0] = (zend_trait_precedence *) emalloc(sizeof(zend_trait_precedence));
			
#ifndef NDEBUG
		memsetptr(dst[0], (void *) __LINE__, sizeof(zend_trait_precedence));
#endif

		
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_precedence,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_precedence) == sizeof((  src[0])[0]));
	

	

	xc_restore_zend_trait_precedence(
		
		
		
		processor,   dst[0],   src[0]
		
		TSRMLS_CC
	);

	

	
	

		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_precedence);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_trait_precedence_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zend_class_entry */
	
		/* export:  	  	 	void 	xc_restore_zend_class_entry( 		 		 		 		xc_processor_t *processor, zend_class_entry *dst, const zend_class_entry * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_zend_class_entry( 		 		 		 		xc_processor_t *processor, zend_class_entry *dst, const zend_class_entry * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_class_entry*)NULL)->type) + sizeof(((zend_class_entry*)NULL)->name) + sizeof(((zend_class_entry*)NULL)->name_length) + sizeof(((zend_class_entry*)NULL)->parent) + sizeof(((zend_class_entry*)NULL)->refcount) + sizeof(((zend_class_entry*)NULL)->ce_flags) + sizeof(((zend_class_entry*)NULL)->function_table) + sizeof(((zend_class_entry*)NULL)->properties_info) + sizeof(((zend_class_entry*)NULL)->default_properties_table) + sizeof(((zend_class_entry*)NULL)->default_static_members_table) + sizeof(((zend_class_entry*)NULL)->static_members_table) + sizeof(((zend_class_entry*)NULL)->constants_table) + sizeof(((zend_class_entry*)NULL)->default_properties_count) + sizeof(((zend_class_entry*)NULL)->default_static_members_count) + sizeof(((zend_class_entry*)NULL)->constructor) + sizeof(((zend_class_entry*)NULL)->destructor) + sizeof(((zend_class_entry*)NULL)->clone) + sizeof(((zend_class_entry*)NULL)->__get) + sizeof(((zend_class_entry*)NULL)->__set) + sizeof(((zend_class_entry*)NULL)->__unset) + sizeof(((zend_class_entry*)NULL)->__isset) + sizeof(((zend_class_entry*)NULL)->__call) + sizeof(((zend_class_entry*)NULL)->__callstatic) + sizeof(((zend_class_entry*)NULL)->__tostring) + sizeof(((zend_class_entry*)NULL)->__debugInfo) + sizeof(((zend_class_entry*)NULL)->serialize_func) + sizeof(((zend_class_entry*)NULL)->unserialize_func) + sizeof(((zend_class_entry*)NULL)->iterator_funcs) + sizeof(((zend_class_entry*)NULL)->create_object) + sizeof(((zend_class_entry*)NULL)->get_iterator) + sizeof(((zend_class_entry*)NULL)->interface_gets_implemented) + sizeof(((zend_class_entry*)NULL)->get_static_method) + sizeof(((zend_class_entry*)NULL)->serialize) + sizeof(((zend_class_entry*)NULL)->unserialize) + sizeof(((zend_class_entry*)NULL)->interfaces) + sizeof(((zend_class_entry*)NULL)->num_interfaces) + sizeof(((zend_class_entry*)NULL)->traits) + sizeof(((zend_class_entry*)NULL)->num_traits) + sizeof(((zend_class_entry*)NULL)->trait_aliases) + sizeof(((zend_class_entry*)NULL)->trait_precedences) + sizeof(((zend_class_entry*)NULL)->info)  ), assert_count = 41;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","name","name_length","parent","refcount","ce_flags","function_table","properties_info","default_properties_table","default_static_members_table","static_members_table","constants_table","default_properties_count","default_static_members_count","constructor","destructor","clone","__get","__set","__unset","__isset","__call","__callstatic","__tostring","__debugInfo","serialize_func","unserialize_func","iterator_funcs","create_object","get_iterator","interface_gets_implemented","get_static_method","serialize","unserialize","interfaces","num_interfaces","traits","num_traits","trait_aliases","trait_precedences","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_class_entry));
			do {
		

		
			
		processor->active_class_entry_src = src;
		processor->active_class_entry_dst = dst;
	
		
	/* PROCESS(char,type) */

	assert(sizeof(char) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,name_length) */

	assert(sizeof(zend_uint) == sizeof(src->name_length));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->name) =  eustrndup (ZSTR_U(src->name), (src->name_length + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_length + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->name) =  estrndup (ZSTR_S(src->name), (src->name_length + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
#ifndef ZEND_ENGINE_2
		/* just copy parent and resolve on install_class */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif


#else
		
	if (src->parent) {
		
		dst->parent = xc_get_class(processor,(zend_ulong) src->parent);
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->parent == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif


#endif
	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(int,refcount) */

	assert(sizeof(int) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
	
	
	/* STRUCT_P(int,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(int,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(int) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->refcount = (int *) emalloc(sizeof(int));
			
#ifndef NDEBUG
		memsetptr(dst->refcount, (void *) __LINE__, sizeof(int));
#endif

		
	
	
	
	


	

	xc_restore_int(
		
		
		
		processor,  dst->refcount,  src->refcount
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,constants_updated) */

	assert(sizeof(zend_bool) == sizeof(src->constants_updated));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_updated", sizeof("constants_updated"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_updated"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_updated", sizeof("constants_updated"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_updated);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,ce_flags) */

	assert(sizeof(zend_uint) == sizeof(src->ce_flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce_flags", sizeof("ce_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "ce_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce_flags", sizeof("ce_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce_flags);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,properties_info,HashTable_zend_property_info) */

	assert(sizeof(HashTable) == sizeof(src->properties_info));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`properties_info'),SRC(`properties_info'),properties_info,HashTable_zend_property_info,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->properties_info)[0]));
	

	

	xc_restore_HashTable_zend_property_info(
		
		
		
		processor, & dst->properties_info, & src->properties_info
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "properties_info", sizeof("properties_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "properties_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "properties_info", sizeof("properties_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->properties_info);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2_4
	
	if (src->default_properties_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->default_properties_table = (zval_ptr_nullable *) emalloc(sizeof(zval_ptr_nullable) * src->default_properties_count);
			
#ifndef NDEBUG
		memsetptr(dst->default_properties_table, (void *) __LINE__, sizeof(zval_ptr_nullable) * src->default_properties_count);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->default_properties_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_properties_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_properties_table[i]));
	
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_properties_table[LOOPCOUNTER]'),SRC(`default_properties_table[LOOPCOUNTER]'),default_properties_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_properties_table[i])[0]));
	

	

	xc_restore_zval_ptr_nullable(
		
		
		
		processor, & dst->default_properties_table[i], & src->default_properties_table[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_properties_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_properties_count) */

	assert(sizeof(int) == sizeof(src->default_properties_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_count", sizeof("default_properties_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_count", sizeof("default_properties_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_count);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->default_static_members_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->default_static_members_table = (zval_ptr_nullable *) emalloc(sizeof(zval_ptr_nullable) * src->default_static_members_count);
			
#ifndef NDEBUG
		memsetptr(dst->default_static_members_table, (void *) __LINE__, sizeof(zval_ptr_nullable) * src->default_static_members_count);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->default_static_members_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_static_members_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_static_members_table[i]));
	
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_static_members_table[LOOPCOUNTER]'),SRC(`default_static_members_table[LOOPCOUNTER]'),default_static_members_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_static_members_table[i])[0]));
	

	

	xc_restore_zval_ptr_nullable(
		
		
		
		processor, & dst->default_static_members_table[i], & src->default_static_members_table[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_static_members_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_static_members_count) */

	assert(sizeof(int) == sizeof(src->default_static_members_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_count", sizeof("default_static_members_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_count", sizeof("default_static_members_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_count);
	xc_autocheck_done_count ++;

#endif



	

	dst->static_members_table = dst->default_static_members_table;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members_table", sizeof("static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members_table", sizeof("static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members_table);
	xc_autocheck_done_count ++;

#endif


#else
	dst->builtin_functions = src->builtin_functions;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "builtin_functions", sizeof("builtin_functions"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "builtin_functions"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "builtin_functions", sizeof("builtin_functions"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->builtin_functions);
	xc_autocheck_done_count ++;

#endif


	
	
	/* STRUCT(HashTable,default_properties,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_properties));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_properties'),SRC(`default_properties'),default_properties,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_properties)[0]));
	

	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor, & dst->default_properties, & src->default_properties
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties", sizeof("default_properties"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties", sizeof("default_properties"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties);
	xc_autocheck_done_count ++;

#endif



#	ifdef ZEND_ENGINE_2_1
	
	
	/* STRUCT(HashTable,default_static_members,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_static_members));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_static_members'),SRC(`default_static_members'),default_static_members,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_static_members)[0]));
	

	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor, & dst->default_static_members, & src->default_static_members
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members", sizeof("default_static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members", sizeof("default_static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members);
	xc_autocheck_done_count ++;

#endif



	dst->static_members = &dst->default_static_members;
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif


#	elif defined(ZEND_ENGINE_2)
	
	
	/* STRUCT_P(HashTable,static_members,HashTable_zval_ptr) */

	if (src->static_members) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_members'),SRC(`static_members'),static_members,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_members)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			ALLOC_HASHTABLE(dst->static_members);
			
#ifndef NDEBUG
		memsetptr(dst->static_members, (void *) __LINE__, sizeof(HashTable));
#endif

		
	
	
	
	


	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor,  dst->static_members,  src->static_members
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->static_members == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif



#	endif
#endif /* ZEND_ENGINE_2_4 */

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,constants_table,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->constants_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`constants_table'),SRC(`constants_table'),constants_table,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->constants_table)[0]));
	

	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor, & dst->constants_table, & src->constants_table
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_table", sizeof("constants_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_table", sizeof("constants_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_table);
	xc_autocheck_done_count ++;

#endif




#ifdef ZEND_ENGINE_2_2
		
	
	
	
	assert(src->interfaces == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_interfaces == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif




#	ifdef ZEND_ENGINE_2_4
		
	
	
	
	assert(src->traits == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "traits", sizeof("traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "traits", sizeof("traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->traits);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_traits == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_traits", sizeof("num_traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_traits", sizeof("num_traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_traits);
	xc_autocheck_done_count ++;

#endif



	
	if (src->trait_aliases) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_aliases[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->trait_aliases = (zend_trait_alias_ptr *) emalloc(sizeof(zend_trait_alias_ptr) * count);
			
#ifndef NDEBUG
		memsetptr(dst->trait_aliases, (void *) __LINE__, sizeof(zend_trait_alias_ptr) * count);
#endif

		
	
	
	
	

			

			for (i = 0;
					src->trait_aliases[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_alias_ptr,trait_aliases[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_alias_ptr) == sizeof(src->trait_aliases[i]));
	
	
	
	/* STRUCT_P_EX(zend_trait_alias_ptr,DST(`trait_aliases[LOOPCOUNTER]'),SRC(`trait_aliases[LOOPCOUNTER]'),trait_aliases[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_alias_ptr) == sizeof((& src->trait_aliases[i])[0]));
	

	

	xc_restore_zend_trait_alias_ptr(
		
		
		
		processor, & dst->trait_aliases[i], & src->trait_aliases[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						dst->trait_aliases[i] = NULL;
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_alias_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_aliases == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif



	}

	
	if (src->trait_precedences) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_precedences[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->trait_precedences = (zend_trait_precedence_ptr *) emalloc(sizeof(zend_trait_precedence_ptr) * count);
			
#ifndef NDEBUG
		memsetptr(dst->trait_precedences, (void *) __LINE__, sizeof(zend_trait_precedence_ptr) * count);
#endif

		
	
	
	
	

			

			for (i = 0;
					src->trait_precedences[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_precedence_ptr,trait_precedences[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_precedence_ptr) == sizeof(src->trait_precedences[i]));
	
	
	
	/* STRUCT_P_EX(zend_trait_precedence_ptr,DST(`trait_precedences[LOOPCOUNTER]'),SRC(`trait_precedences[LOOPCOUNTER]'),trait_precedences[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_precedence_ptr) == sizeof((& src->trait_precedences[i])[0]));
	

	

	xc_restore_zend_trait_precedence_ptr(
		
		
		
		processor, & dst->trait_precedences[i], & src->trait_precedences[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						dst->trait_precedences[i] = NULL;
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_trait_precedence_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_precedences == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif



	}

#	endif
#else
	
		if (src->num_interfaces) {
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->interfaces = (zend_class_entry* *) ecalloc(src->num_interfaces, sizeof(zend_class_entry*));
		
	
	
	
	

			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif


		}
		else {
			
	
	
	
	assert(src->interfaces == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif



		}
	
		
	/* PROCESS(zend_uint,num_interfaces) */

	assert(sizeof(zend_uint) == sizeof(src->num_interfaces));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif



	

#endif

#	ifdef ZEND_ENGINE_2_4
	
	
	

	dst->info.user.filename = processor->entry_php_src->filepath;
		
	/* PROCESS(zend_uint,info.user.line_start) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_start));
		
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.line_end) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_end));
		
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.doc_comment_len));
		
	
	
	

	

	
	/* PROC_ZSTRING_L(,info.user.doc_comment,info.user.doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,info.user.doc_comment,info.user.doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->info.user.doc_comment) =  eustrndup (ZSTR_U(src->info.user.doc_comment), (src->info.user.doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->info.user.doc_comment) =  estrndup (ZSTR_S(src->info.user.doc_comment), (src->info.user.doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->info.user.doc_comment) =  estrndup (ZSTR_S(src->info.user.doc_comment), (src->info.user.doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif


#	else
	dst->filename = processor->entry_php_src->filepath;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->doc_comment) =  eustrndup (ZSTR_U(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->doc_comment) =  estrndup (ZSTR_S(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->doc_comment) =  estrndup (ZSTR_S(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#	endif

	/* # NOT DONE */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize_func", sizeof("serialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize_func", sizeof("serialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize_func);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize_func", sizeof("unserialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize_func", sizeof("unserialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize_func);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "iterator_funcs", sizeof("iterator_funcs"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "iterator_funcs"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "iterator_funcs", sizeof("iterator_funcs"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->iterator_funcs);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "create_object", sizeof("create_object"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "create_object"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "create_object", sizeof("create_object"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->create_object);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_iterator", sizeof("get_iterator"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_iterator"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_iterator", sizeof("get_iterator"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_iterator);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interface_gets_implemented", sizeof("interface_gets_implemented"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interface_gets_implemented"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interface_gets_implemented", sizeof("interface_gets_implemented"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interface_gets_implemented);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_ENGINE_2_3
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_static_method", sizeof("get_static_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_static_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_static_method", sizeof("get_static_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_static_method);
	xc_autocheck_done_count ++;

#endif


#	endif
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize", sizeof("serialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize", sizeof("serialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize", sizeof("unserialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize", sizeof("unserialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize);
	xc_autocheck_done_count ++;

#endif


#	endif
	/* deal with it inside xc_fix_method */
	dst->constructor = NULL;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constructor", sizeof("constructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constructor", sizeof("constructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "destructor", sizeof("destructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "destructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "destructor", sizeof("destructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->destructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "clone", sizeof("clone"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "clone"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "clone", sizeof("clone"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->clone);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__get", sizeof("__get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__get", sizeof("__get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__set", sizeof("__set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__set", sizeof("__set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__set);
	xc_autocheck_done_count ++;

#endif


/* should be >5.1 */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__unset", sizeof("__unset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__unset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__unset", sizeof("__unset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__unset);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__isset", sizeof("__isset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__isset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__isset", sizeof("__isset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__isset);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__call", sizeof("__call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__call", sizeof("__call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__call);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_CALLSTATIC_FUNC_NAME
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__callstatic", sizeof("__callstatic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__callstatic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__callstatic", sizeof("__callstatic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__callstatic);
	xc_autocheck_done_count ++;

#endif


#	endif
# if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__tostring", sizeof("__tostring"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__tostring"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__tostring", sizeof("__tostring"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__tostring);
	xc_autocheck_done_count ++;

#endif


# endif
# if defined(ZEND_ENGINE_2_6)
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__debugInfo", sizeof("__debugInfo"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__debugInfo"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__debugInfo", sizeof("__debugInfo"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__debugInfo);
	xc_autocheck_done_count ++;

#endif


# endif
#	ifndef ZEND_ENGINE_2_4
	/* # NOT DONE */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module", sizeof("module"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "module"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module", sizeof("module"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module);
	xc_autocheck_done_count ++;

#endif


#	endif
#else /* ZEND_ENGINE_2 */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_function_call", sizeof("handle_function_call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_function_call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_function_call", sizeof("handle_function_call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_function_call);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_get", sizeof("handle_property_get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_get", sizeof("handle_property_get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_set", sizeof("handle_property_set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_set", sizeof("handle_property_set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_set);
	xc_autocheck_done_count ++;

#endif


#endif
		
	
	/* STRUCT(HashTable,function_table,HashTable_zend_function) */

	assert(sizeof(HashTable) == sizeof(src->function_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`function_table'),SRC(`function_table'),function_table,HashTable_zend_function,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->function_table)[0]));
	

	

	xc_restore_HashTable_zend_function(
		
		
		
		processor, & dst->function_table, & src->function_table
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_table", sizeof("function_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "function_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_table", sizeof("function_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_table);
	xc_autocheck_done_count ++;

#endif



	dst->function_table.pDestructor = ZEND_FUNCTION_DTOR;
	
		processor->active_class_entry_src = NULL;
		processor->active_class_entry_dst = NULL;
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_class_entry", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4


#else

	
	

/* {{{ xc_restore_znode */
	
 	  	 	static void inline 	xc_restore_znode( 		 		 		 		xc_processor_t *processor, znode *dst, const znode * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((znode*)NULL)->op_type) + sizeof(((znode*)NULL)->u) + sizeof(((znode*)NULL)->EA)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "op_type","u","EA" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(znode));
			do {
		

		
				
	/* PROCESS(xc_op_type,op_type) */

	assert(sizeof(xc_op_type) == sizeof(src->op_type));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_type", sizeof("op_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_znode : %s\n"
				, __FILE__, __LINE__
				, "op_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_type", sizeof("op_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_type);
	xc_autocheck_done_count ++;

#endif




	


#ifdef IS_CV
#	define XCACHE_IS_CV IS_CV
#else
/* compatible with zend optimizer */
#	define XCACHE_IS_CV 16
#endif
	assert(src->op_type == IS_CONST ||
		src->op_type == IS_VAR ||
		src->op_type == XCACHE_IS_CV ||
		src->op_type == IS_TMP_VAR ||
		src->op_type == IS_UNUSED);
		
	
	

	switch (src->op_type) {
		case IS_CONST:
			
	
	/* STRUCT(zval,u.constant) */

	assert(sizeof(zval) == sizeof(src->u.constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`u.constant'),SRC(`u.constant'),u.constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->u.constant)[0]));
	

	

	xc_restore_zval(
		
		
		
		processor, & dst->u.constant, & src->u.constant
		
		TSRMLS_CC
	);

	

	
	

	

			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_znode : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


#if 0
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "EA", sizeof("EA"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_znode : %s\n"
				, __FILE__, __LINE__
				, "EA"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "EA", sizeof("EA"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->EA);
	xc_autocheck_done_count ++;

#endif


#endif
#undef XCACHE_IS_CV

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_znode", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zend_op */
	
		/* export:  	  	 	void 	xc_restore_zend_op( 		 		 		 		xc_processor_t *processor, zend_op *dst, const zend_op * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_zend_op( 		 		 		 		xc_processor_t *processor, zend_op *dst, const zend_op * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op*)NULL)->handler) + sizeof(((zend_op*)NULL)->op1) + sizeof(((zend_op*)NULL)->op2) + sizeof(((zend_op*)NULL)->result) + sizeof(((zend_op*)NULL)->extended_value) + sizeof(((zend_op*)NULL)->lineno) + sizeof(((zend_op*)NULL)->opcode) + sizeof(((zend_op*)NULL)->op1_type) + sizeof(((zend_op*)NULL)->op2_type) + sizeof(((zend_op*)NULL)->result_type)  ), assert_count = 10;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "handler","op1","op2","result","extended_value","lineno","opcode","op1_type","op2_type","result_type" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_op));
			do {
		

		
				
	/* PROCESS(xc_opcode,opcode) */

	assert(sizeof(xc_opcode) == sizeof(src->opcode));
			
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcode", sizeof("opcode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcode", sizeof("opcode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcode);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_4
	
	#ifndef NDEBUG
	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
		case IS_CONST:
			
					
	/* PROCESS(zend_uint,result.constant) */

	assert(sizeof(zend_uint) == sizeof(src->result.constant));
		
	
	
	

	

			
			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op1_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op1_type )) {
		case IS_CONST:
			
				
					
						dst->op1 = src->op1;
					
				
			
			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op2_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op2_type )) {
		case IS_CONST:
			
				
					
						dst->op2 = src->op2;
					
				
			
			break;
		
			
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(znode,result) */

	assert(sizeof(znode) == sizeof(src->result));
	
	
	
	/* STRUCT_P_EX(znode,DST(`result'),SRC(`result'),result,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->result)[0]));
	

	

	xc_restore_znode(
		
		
		
		processor, & dst->result, & src->result
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op1) */

	assert(sizeof(znode) == sizeof(src->op1));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op1'),SRC(`op1'),op1,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op1)[0]));
	

	

	xc_restore_znode(
		
		
		
		processor, & dst->op1, & src->op1
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op2) */

	assert(sizeof(znode) == sizeof(src->op2));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op2'),SRC(`op2'),op2,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op2)[0]));
	

	

	xc_restore_znode(
		
		
		
		processor, & dst->op2, & src->op2
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#endif
		
	/* PROCESS(ulong,extended_value) */

	assert(sizeof(ulong) == sizeof(src->extended_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "extended_value", sizeof("extended_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "extended_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "extended_value", sizeof("extended_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->extended_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,op1_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op1_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1_type", sizeof("op1_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1_type", sizeof("op1_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,op2_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op2_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2_type", sizeof("op2_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2_type", sizeof("op2_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,result_type) */

	assert(sizeof(zend_uchar) == sizeof(src->result_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result_type", sizeof("result_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result_type", sizeof("result_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		assert(processor->active_op_array_src);
		assert(processor->active_op_array_dst);
#ifdef ZEND_ENGINE_2_4
		
		
			if (src->op1_type == IS_CONST) {
				dst->op1.constant = src->op1.literal - processor->active_op_array_src->literals;
				dst->op1.literal = &processor->active_op_array_dst->literals[dst->op1.constant];
			}
		
		
			if (src->op2_type == IS_CONST) {
				dst->op2.constant = src->op2.literal - processor->active_op_array_src->literals;
				dst->op2.literal = &processor->active_op_array_dst->literals[dst->op2.constant];
			}
		
#endif
		
#ifdef ZEND_ENGINE_2
		switch (src->opcode) {
#	ifdef ZEND_GOTO
			case ZEND_GOTO:
#	endif
			case ZEND_JMP:
#	ifdef ZEND_FAST_CALL
			case ZEND_FAST_CALL:
#	endif
				assert(Z_OP(src->op1).jmp_addr >= processor->active_op_array_src->opcodes);
				assert(Z_OP(src->op1).jmp_addr - processor->active_op_array_src->opcodes < processor->active_op_array_src->last);
				Z_OP(dst->op1).jmp_addr = processor->active_op_array_dst->opcodes + (Z_OP(src->op1).jmp_addr - processor->active_op_array_src->opcodes);
				assert(Z_OP(dst->op1).jmp_addr >= processor->active_op_array_dst->opcodes);
				assert(Z_OP(dst->op1).jmp_addr - processor->active_op_array_dst->opcodes < processor->active_op_array_dst->last);
				
				break;

			case ZEND_JMPZ:
			case ZEND_JMPNZ:
			case ZEND_JMPZ_EX:
			case ZEND_JMPNZ_EX:
#	ifdef ZEND_JMP_SET
			case ZEND_JMP_SET:
#	endif
#	ifdef ZEND_JMP_SET_VAR
			case ZEND_JMP_SET_VAR:
#	endif
				assert(Z_OP(src->op2).jmp_addr >= processor->active_op_array_src->opcodes);
				assert(Z_OP(src->op2).jmp_addr - processor->active_op_array_src->opcodes < processor->active_op_array_src->last);
				Z_OP(dst->op2).jmp_addr = processor->active_op_array_dst->opcodes + (Z_OP(src->op2).jmp_addr - processor->active_op_array_src->opcodes);
				assert(Z_OP(dst->op2).jmp_addr >= processor->active_op_array_dst->opcodes);
				assert(Z_OP(dst->op2).jmp_addr - processor->active_op_array_dst->opcodes < processor->active_op_array_dst->last);
				
				break;

			default:
				break;
		}
#	endif
	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(opcode_handler_t,handler) */

	assert(sizeof(opcode_handler_t) == sizeof(src->handler));
	/* is copying enough? */
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handler", sizeof("handler"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "handler"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handler", sizeof("handler"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handler);
	xc_autocheck_done_count ++;

#endif


	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_op", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_restore_zend_literal */
	
 	  	 	static void inline 	xc_restore_zend_literal( 		 		 		 		xc_processor_t *processor, zend_literal *dst, const zend_literal * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_literal*)NULL)->constant) + sizeof(((zend_literal*)NULL)->hash_value) + sizeof(((zend_literal*)NULL)->cache_slot)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "constant","hash_value","cache_slot" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_literal));
			do {
		

		
			
	
	/* STRUCT(zval,constant) */

	assert(sizeof(zval) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->constant)[0]));
	

	

	xc_restore_zval(
		
		
		
		processor, & dst->constant, & src->constant
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(zend_ulong,hash_value) */

	assert(sizeof(zend_ulong) == sizeof(src->hash_value));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,cache_slot) */

	assert(sizeof(zend_uint) == sizeof(src->cache_slot));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cache_slot", sizeof("cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cache_slot", sizeof("cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cache_slot);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_literal", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_restore_zend_op_array */
	
		/* export:  	  	 	void 	xc_restore_zend_op_array( 		 		 		 		xc_processor_t *processor, zend_op_array *dst, const zend_op_array * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_zend_op_array( 		 		 		 		xc_processor_t *processor, zend_op_array *dst, const zend_op_array * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op_array*)NULL)->type) + sizeof(((zend_op_array*)NULL)->function_name) + sizeof(((zend_op_array*)NULL)->scope) + sizeof(((zend_op_array*)NULL)->fn_flags) + sizeof(((zend_op_array*)NULL)->prototype) + sizeof(((zend_op_array*)NULL)->num_args) + sizeof(((zend_op_array*)NULL)->required_num_args) + sizeof(((zend_op_array*)NULL)->arg_info) + sizeof(((zend_op_array*)NULL)->refcount) + sizeof(((zend_op_array*)NULL)->opcodes) + sizeof(((zend_op_array*)NULL)->last) + sizeof(((zend_op_array*)NULL)->vars) + sizeof(((zend_op_array*)NULL)->last_var) + sizeof(((zend_op_array*)NULL)->T) + sizeof(((zend_op_array*)NULL)->nested_calls) + sizeof(((zend_op_array*)NULL)->used_stack) + sizeof(((zend_op_array*)NULL)->brk_cont_array) + sizeof(((zend_op_array*)NULL)->last_brk_cont) + sizeof(((zend_op_array*)NULL)->try_catch_array) + sizeof(((zend_op_array*)NULL)->last_try_catch) + sizeof(((zend_op_array*)NULL)->has_finally_block) + sizeof(((zend_op_array*)NULL)->static_variables) + sizeof(((zend_op_array*)NULL)->this_var) + sizeof(((zend_op_array*)NULL)->filename) + sizeof(((zend_op_array*)NULL)->line_start) + sizeof(((zend_op_array*)NULL)->line_end) + sizeof(((zend_op_array*)NULL)->doc_comment) + sizeof(((zend_op_array*)NULL)->doc_comment_len) + sizeof(((zend_op_array*)NULL)->early_binding) + sizeof(((zend_op_array*)NULL)->literals) + sizeof(((zend_op_array*)NULL)->last_literal) + sizeof(((zend_op_array*)NULL)->run_time_cache) + sizeof(((zend_op_array*)NULL)->last_cache_slot) + sizeof(((zend_op_array*)NULL)->reserved)  ), assert_count = 34;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","function_name","scope","fn_flags","prototype","num_args","required_num_args","arg_info","refcount","opcodes","last","vars","last_var","T","nested_calls","used_stack","brk_cont_array","last_brk_cont","try_catch_array","last_try_catch","has_finally_block","static_variables","this_var","filename","line_start","line_end","doc_comment","doc_comment_len","early_binding","literals","last_literal","run_time_cache","last_cache_slot","reserved" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(zend_op_array));
			do {
		

		
			
		processor->active_op_array_dst = dst;
		processor->active_op_array_src = src;
	
	
	{
	
	const xc_op_array_info_t *op_array_info = &processor->active_op_array_infos_src[processor->active_op_array_index++];
			#ifdef ZEND_COMPILE_DELAYED_BINDING
	zend_bool need_early_binding = 0;
#else
	zend_bool need_early_binding = processor->php_src->have_early_binding;
#endif
	zend_bool shallow_copy = !processor->readonly_protection && !(src == processor->php_src->op_array && need_early_binding);
	if (shallow_copy) {
		zend_bool gc_arg_info = 0;
		zend_bool gc_opcodes  = 0;
#ifdef ZEND_ENGINE_2_4
		zend_bool gc_literals = 0;
#endif
		/* really fast shallow copy */
		memcpy(dst, src, sizeof(src[0]));
		dst->refcount = &XG(op_array_dummy_refcount_holder);
		XG(op_array_dummy_refcount_holder) = ((zend_uint) -1) / 2;
#ifdef ZEND_ACC_ALIAS
		if ((processor->active_class_entry_src && (processor->active_class_entry_src->ce_flags & ZEND_ACC_TRAIT))) {
			
	/* PROC_ZSTRING(,function_name) */
 
	
	/* PROC_ZSTRING_N(,function_name,,strlen) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->function_name) =  eustrndup (ZSTR_U(src->function_name), (xc_zstrlen_uchar (src->function_name) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->function_name) =  estrndup (ZSTR_S(src->function_name), (xc_zstrlen_char (src->function_name) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->function_name) =  estrndup (ZSTR_S(src->function_name), (xc_zstrlen_char (src->function_name) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		}
#endif
		/* deep */
		
	
	/* STRUCT_P(HashTable,static_variables,HashTable_zval_ptr) */

	if (src->static_variables) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_variables'),SRC(`static_variables'),static_variables,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_variables)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			ALLOC_HASHTABLE(dst->static_variables);
			
#ifndef NDEBUG
		memsetptr(dst->static_variables, (void *) __LINE__, sizeof(HashTable));
#endif

		
	
	
	
	


	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor,  dst->static_variables,  src->static_variables
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->static_variables == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_variables", sizeof("static_variables"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "static_variables"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_variables", sizeof("static_variables"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_variables);
	xc_autocheck_done_count ++;

#endif



#ifdef ZEND_ENGINE_2
		if (src->arg_info) {
			gc_arg_info = 1;
			
	if (src->arg_info) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->arg_info = (zend_arg_info *) emalloc(sizeof(zend_arg_info) * src->num_args);
			
#ifndef NDEBUG
		memsetptr(dst->arg_info, (void *) __LINE__, sizeof(zend_arg_info) * src->num_args);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->num_args;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_arg_info,arg_info[LOOPCOUNTER],) */

	assert(sizeof(zend_arg_info) == sizeof(src->arg_info[i]));
	
	
	
	/* STRUCT_P_EX(zend_arg_info,DST(`arg_info[LOOPCOUNTER]'),SRC(`arg_info[LOOPCOUNTER]'),arg_info[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_arg_info) == sizeof((& src->arg_info[i])[0]));
	

	

	xc_restore_zend_arg_info(
		
		
		
		processor, & dst->arg_info[i], & src->arg_info[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->arg_info == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif



	}

		}
#endif
		dst->filename = processor->entry_php_src->filepath;

#ifdef ZEND_ENGINE_2_4
		if (src->literals && op_array_info->literalinfo_cnt) {
			gc_opcodes = 1;
			gc_literals = 1;
		}
#else
		if (op_array_info->oplineinfo_cnt) {
			gc_opcodes = 1;
		}
#endif

#ifdef ZEND_ENGINE_2_4
		if (gc_literals) {
						
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->literals = (zend_literal *) emalloc(sizeof(zend_literal) * src->last_literal);
			
#ifndef NDEBUG
		memsetptr(dst->literals, (void *) __LINE__, sizeof(zend_literal) * src->last_literal);
#endif

		
	
	
	
	

	
		memcpy(dst->literals, src->literals, sizeof(dst->literals[0]) * src->last_literal);
		

		}
#endif
		if (gc_opcodes) {
			zend_op *opline, *end;
			
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->opcodes = (zend_op *) emalloc(sizeof(zend_op) * src->last);
			
#ifndef NDEBUG
		memsetptr(dst->opcodes, (void *) __LINE__, sizeof(zend_op) * src->last);
#endif

		
	
	
	
	

	
		memcpy(dst->opcodes, src->opcodes, sizeof(dst->opcodes[0]) * src->last);
		


			for (opline = dst->opcodes, end = opline + src->last; opline < end; ++opline) {
#ifdef ZEND_ENGINE_2_4
				
				
					if (opline->op1_type == IS_CONST) {
						opline->op1.literal = &dst->literals[opline->op1.literal - src->literals];
					}
				
				
					if (opline->op2_type == IS_CONST) {
						opline->op2.literal = &dst->literals[opline->op2.literal - src->literals];
					}
				
				
#endif

				switch (opline->opcode) {
#ifdef ZEND_GOTO
					case ZEND_GOTO:
#endif
					case ZEND_JMP:
#ifdef ZEND_FAST_CALL
					case ZEND_FAST_CALL:
#endif
#ifdef ZEND_ENGINE_2
						Z_OP(opline->op1).jmp_addr = &dst->opcodes[Z_OP(opline->op1).jmp_addr - src->opcodes];
#endif
						break;

					case ZEND_JMPZ:
					case ZEND_JMPNZ:
					case ZEND_JMPZ_EX:
					case ZEND_JMPNZ_EX:
#ifdef ZEND_JMP_SET
					case ZEND_JMP_SET:
#endif
#ifdef ZEND_JMP_SET_VAR
			case ZEND_JMP_SET_VAR:
#endif
#ifdef ZEND_ENGINE_2
						Z_OP(opline->op2).jmp_addr = &dst->opcodes[Z_OP(opline->op2).jmp_addr - src->opcodes];
#endif
						break;

					default:
						break;
				}
			}
		}
		if (gc_arg_info || gc_opcodes
#ifdef ZEND_ENGINE_2_4
		 || gc_literals
#endif
		) {
			xc_gc_op_array_t gc_op_array;
#ifdef ZEND_ENGINE_2
			gc_op_array.num_args = gc_arg_info ? dst->num_args : 0;
			gc_op_array.arg_info = gc_arg_info ? dst->arg_info : NULL;
#endif
			gc_op_array.opcodes  = gc_opcodes ? dst->opcodes : NULL;
#ifdef ZEND_ENGINE_2_4
			gc_op_array.literals = gc_literals ? dst->literals : NULL;
#endif
			xc_gc_add_op_array(&gc_op_array TSRMLS_CC);
		}
		
#ifndef NDEBUG
		xc_autocheck_skip = 1;
#endif

	}
	else
	
	do {
	
	/* Common elements */
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING(,function_name) */
 
	
	/* PROC_ZSTRING_N(,function_name,,strlen) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->function_name) =  eustrndup (ZSTR_U(src->function_name), (xc_zstrlen_uchar (src->function_name) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->function_name) =  estrndup (ZSTR_S(src->function_name), (xc_zstrlen_char (src->function_name) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->function_name) =  estrndup (ZSTR_S(src->function_name), (xc_zstrlen_char (src->function_name) + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,fn_flags) */

	assert(sizeof(zend_uint) == sizeof(src->fn_flags));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "fn_flags", sizeof("fn_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "fn_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "fn_flags", sizeof("fn_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->fn_flags);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->arg_info) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->arg_info = (zend_arg_info *) emalloc(sizeof(zend_arg_info) * src->num_args);
			
#ifndef NDEBUG
		memsetptr(dst->arg_info, (void *) __LINE__, sizeof(zend_arg_info) * src->num_args);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->num_args;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_arg_info,arg_info[LOOPCOUNTER],) */

	assert(sizeof(zend_arg_info) == sizeof(src->arg_info[i]));
	
	
	
	/* STRUCT_P_EX(zend_arg_info,DST(`arg_info[LOOPCOUNTER]'),SRC(`arg_info[LOOPCOUNTER]'),arg_info[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_arg_info) == sizeof((& src->arg_info[i])[0]));
	

	

	xc_restore_zend_arg_info(
		
		
		
		processor, & dst->arg_info[i], & src->arg_info[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->arg_info == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,num_args) */

	assert(sizeof(zend_uint) == sizeof(src->num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_args", sizeof("num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_args", sizeof("num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_args);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,required_num_args) */

	assert(sizeof(zend_uint) == sizeof(src->required_num_args));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,pass_rest_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_rest_by_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_rest_by_reference", sizeof("pass_rest_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "pass_rest_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_rest_by_reference", sizeof("pass_rest_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_rest_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
	if (src->arg_types) {
		
	
	
		
	
	
	/* allocate */
	
	
	
			dst->arg_types = (zend_uchar *) emalloc(sizeof(zend_uchar) * src->arg_types[0] + 1);
			
#ifndef NDEBUG
		memsetptr(dst->arg_types, (void *) __LINE__, sizeof(zend_uchar) * src->arg_types[0] + 1);
#endif

		
	
	
	
	

		memcpy(dst->arg_types, src->arg_types, sizeof(src->arg_types[0]) * (src->arg_types[0]+1));
		
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->arg_types == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif



	}
#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(unsigned char,return_reference) */

	assert(sizeof(unsigned char) == sizeof(src->return_reference));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* END of common elements */
#ifdef IS_UNICODE
	#endif

	
	
	/* STRUCT_P(zend_uint,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(zend_uint,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(zend_uint) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->refcount = (zend_uint *) emalloc(sizeof(zend_uint));
			
#ifndef NDEBUG
		memsetptr(dst->refcount, (void *) __LINE__, sizeof(zend_uint));
#endif

		
	
	
	
	


	

	xc_restore_zend_uint(
		
		
		
		processor,  dst->refcount,  src->refcount
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	if (src->literals) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->literals = (zend_literal *) emalloc(sizeof(zend_literal) * src->last_literal);
			
#ifndef NDEBUG
		memsetptr(dst->literals, (void *) __LINE__, sizeof(zend_literal) * src->last_literal);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->last_literal;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_literal,literals[LOOPCOUNTER],) */

	assert(sizeof(zend_literal) == sizeof(src->literals[i]));
	
	
	
	/* STRUCT_P_EX(zend_literal,DST(`literals[LOOPCOUNTER]'),SRC(`literals[LOOPCOUNTER]'),literals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_literal) == sizeof((& src->literals[i])[0]));
	

	

	xc_restore_zend_literal(
		
		
		
		processor, & dst->literals[i], & src->literals[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_literal) */

	assert(sizeof(int) == sizeof(src->last_literal));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_literal", sizeof("last_literal"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_literal"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_literal", sizeof("last_literal"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_literal);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
	if (src->opcodes) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->opcodes = (zend_op *) emalloc(sizeof(zend_op) * src->last);
			
#ifndef NDEBUG
		memsetptr(dst->opcodes, (void *) __LINE__, sizeof(zend_op) * src->last);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->last;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_op,opcodes[LOOPCOUNTER],) */

	assert(sizeof(zend_op) == sizeof(src->opcodes[i]));
	
	
	
	/* STRUCT_P_EX(zend_op,DST(`opcodes[LOOPCOUNTER]'),SRC(`opcodes[LOOPCOUNTER]'),opcodes[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_op) == sizeof((& src->opcodes[i])[0]));
	

	

	xc_restore_zend_op(
		
		
		
		processor, & dst->opcodes[i], & src->opcodes[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->opcodes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,last) */

	assert(sizeof(zend_uint) == sizeof(src->last));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last", sizeof("last"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last", sizeof("last"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_4
	dst->size = src->last;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif


#endif

#ifdef IS_CV
	
	if (src->vars) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->vars = (zend_compiled_variable *) emalloc(sizeof(zend_compiled_variable) * src->last_var);
			
#ifndef NDEBUG
		memsetptr(dst->vars, (void *) __LINE__, sizeof(zend_compiled_variable) * src->last_var);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->last_var;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_compiled_variable,vars[LOOPCOUNTER],) */

	assert(sizeof(zend_compiled_variable) == sizeof(src->vars[i]));
	
	
	
	/* STRUCT_P_EX(zend_compiled_variable,DST(`vars[LOOPCOUNTER]'),SRC(`vars[LOOPCOUNTER]'),vars[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_compiled_variable) == sizeof((& src->vars[i])[0]));
	

	

	xc_restore_zend_compiled_variable(
		
		
		
		processor, & dst->vars[i], & src->vars[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->vars == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_var) */

	assert(sizeof(int) == sizeof(src->last_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_var", sizeof("last_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_var", sizeof("last_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_var);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
	dst->size_var = src->last_var;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size_var", sizeof("size_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size_var", sizeof("size_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size_var);
	xc_autocheck_done_count ++;

#endif


#	endif
#else
		
#endif

		
	/* PROCESS(zend_uint,T) */

	assert(sizeof(zend_uint) == sizeof(src->T));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "T", sizeof("T"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "T"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "T", sizeof("T"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->T);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,nested_calls) */

	assert(sizeof(zend_uint) == sizeof(src->nested_calls));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nested_calls", sizeof("nested_calls"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "nested_calls"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nested_calls", sizeof("nested_calls"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nested_calls);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,used_stack) */

	assert(sizeof(zend_uint) == sizeof(src->used_stack));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "used_stack", sizeof("used_stack"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "used_stack"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "used_stack", sizeof("used_stack"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->used_stack);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	if (src->brk_cont_array) {
		last_brk_cont_t i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->brk_cont_array = (zend_brk_cont_element *) emalloc(sizeof(zend_brk_cont_element) * src->last_brk_cont);
			
#ifndef NDEBUG
		memsetptr(dst->brk_cont_array, (void *) __LINE__, sizeof(zend_brk_cont_element) * src->last_brk_cont);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->last_brk_cont;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_brk_cont_element,brk_cont_array[LOOPCOUNTER],) */

	assert(sizeof(zend_brk_cont_element) == sizeof(src->brk_cont_array[i]));
	
	
	
	/* STRUCT_P_EX(zend_brk_cont_element,DST(`brk_cont_array[LOOPCOUNTER]'),SRC(`brk_cont_array[LOOPCOUNTER]'),brk_cont_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_brk_cont_element) == sizeof((& src->brk_cont_array[i])[0]));
	

	

	xc_restore_zend_brk_cont_element(
		
		
		
		processor, & dst->brk_cont_array[i], & src->brk_cont_array[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->brk_cont_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(last_brk_cont_t,last_brk_cont) */

	assert(sizeof(last_brk_cont_t) == sizeof(src->last_brk_cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_brk_cont", sizeof("last_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_brk_cont", sizeof("last_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_brk_cont);
	xc_autocheck_done_count ++;

#endif




	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,current_brk_cont) */

	assert(sizeof(zend_uint) == sizeof(src->current_brk_cont));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "current_brk_cont", sizeof("current_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "current_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "current_brk_cont", sizeof("current_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->current_brk_cont);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifndef ZEND_ENGINE_2
		
	/* PROCESS(zend_bool,uses_globals) */

	assert(sizeof(zend_bool) == sizeof(src->uses_globals));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_globals", sizeof("uses_globals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_globals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_globals", sizeof("uses_globals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_globals);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	if (src->try_catch_array) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->try_catch_array = (zend_try_catch_element *) emalloc(sizeof(zend_try_catch_element) * src->last_try_catch);
			
#ifndef NDEBUG
		memsetptr(dst->try_catch_array, (void *) __LINE__, sizeof(zend_try_catch_element) * src->last_try_catch);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->last_try_catch;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_try_catch_element,try_catch_array[LOOPCOUNTER],) */

	assert(sizeof(zend_try_catch_element) == sizeof(src->try_catch_array[i]));
	
	
	
	/* STRUCT_P_EX(zend_try_catch_element,DST(`try_catch_array[LOOPCOUNTER]'),SRC(`try_catch_array[LOOPCOUNTER]'),try_catch_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_try_catch_element) == sizeof((& src->try_catch_array[i])[0]));
	

	

	xc_restore_zend_try_catch_element(
		
		
		
		processor, & dst->try_catch_array[i], & src->try_catch_array[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->try_catch_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_try_catch) */

	assert(sizeof(int) == sizeof(src->last_try_catch));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_try_catch", sizeof("last_try_catch"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_try_catch"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_try_catch", sizeof("last_try_catch"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_try_catch);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_bool,has_finally_block) */

	assert(sizeof(zend_bool) == sizeof(src->has_finally_block));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "has_finally_block", sizeof("has_finally_block"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "has_finally_block"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "has_finally_block", sizeof("has_finally_block"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->has_finally_block);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	
	/* STRUCT_P(HashTable,static_variables,HashTable_zval_ptr) */

	if (src->static_variables) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_variables'),SRC(`static_variables'),static_variables,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_variables)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			ALLOC_HASHTABLE(dst->static_variables);
			
#ifndef NDEBUG
		memsetptr(dst->static_variables, (void *) __LINE__, sizeof(HashTable));
#endif

		
	
	
	
	


	

	xc_restore_HashTable_zval_ptr(
		
		
		
		processor,  dst->static_variables,  src->static_variables
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->static_variables == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_variables", sizeof("static_variables"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "static_variables"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_variables", sizeof("static_variables"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_variables);
	xc_autocheck_done_count ++;

#endif




#ifndef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start_op", sizeof("start_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "start_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start_op", sizeof("start_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start_op);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,backpatch_count) */

	assert(sizeof(int) == sizeof(src->backpatch_count));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "backpatch_count", sizeof("backpatch_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "backpatch_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "backpatch_count", sizeof("backpatch_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->backpatch_count);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_3
		
	/* PROCESS(zend_uint,this_var) */

	assert(sizeof(zend_uint) == sizeof(src->this_var));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "this_var", sizeof("this_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "this_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "this_var", sizeof("this_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->this_var);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,done_pass_two) */

	assert(sizeof(zend_bool) == sizeof(src->done_pass_two));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "done_pass_two", sizeof("done_pass_two"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "done_pass_two"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "done_pass_two", sizeof("done_pass_two"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->done_pass_two);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* 5.0 <= ver < 5.3 */
#if defined(ZEND_ENGINE_2) && !defined(ZEND_ENGINE_2_3)
		
	/* PROCESS(zend_bool,uses_this) */

	assert(sizeof(zend_bool) == sizeof(src->uses_this));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_this", sizeof("uses_this"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_this"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_this", sizeof("uses_this"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_this);
	xc_autocheck_done_count ++;

#endif



	

#endif

	dst->filename = processor->entry_php_src->filepath;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


#ifdef IS_UNICODE
	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "script_encoding", sizeof("script_encoding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "script_encoding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "script_encoding", sizeof("script_encoding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->script_encoding);
	xc_autocheck_done_count ++;

#endif


	
#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_U(dst->doc_comment) =  eustrndup (ZSTR_U(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->doc_comment) =  estrndup (ZSTR_S(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		
		
		
		
			ZSTR_S(dst->doc_comment) =  estrndup (ZSTR_S(src->doc_comment), (src->doc_comment_len + 1) - 1);
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
#ifdef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_uint,early_binding) */

	assert(sizeof(zend_uint) == sizeof(src->early_binding));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "early_binding", sizeof("early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "early_binding", sizeof("early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->early_binding);
	xc_autocheck_done_count ++;

#endif



	
;
#endif

	/* reserved */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "reserved", sizeof("reserved"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "reserved"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "reserved", sizeof("reserved"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->reserved);
	xc_autocheck_done_count ++;

#endif


#if defined(HARDENING_PATCH) && HARDENING_PATCH
		
	/* PROCESS(zend_bool,created_by_eval) */

	assert(sizeof(zend_bool) == sizeof(src->created_by_eval));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "created_by_eval", sizeof("created_by_eval"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "created_by_eval"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "created_by_eval", sizeof("created_by_eval"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->created_by_eval);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_4
	dst->run_time_cache = NULL;
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "run_time_cache", sizeof("run_time_cache"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "run_time_cache"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "run_time_cache", sizeof("run_time_cache"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->run_time_cache);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,last_cache_slot) */

	assert(sizeof(int) == sizeof(src->last_cache_slot));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_cache_slot", sizeof("last_cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_cache_slot", sizeof("last_cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_cache_slot);
	xc_autocheck_done_count ++;

#endif



	

#endif
	} while (0);
	xc_fix_op_array_info(processor->entry_php_src, processor->php_src, dst, shallow_copy, op_array_info TSRMLS_CC);

#ifdef ZEND_ENGINE_2
		
		do {
			zend_function *parent;
			if (src->prototype != NULL
			 && zend_u_hash_find(&(processor->active_class_entry_dst->parent->function_table),
					UG(unicode) ? IS_UNICODE : IS_STRING,
					src->function_name, xc_zstrlen(UG(unicode) ? IS_UNICODE : IS_STRING, src->function_name) + 1,
					(void **) &parent) == SUCCESS) {
				/* see do_inherit_method_check() */
				if ((parent->common.fn_flags & ZEND_ACC_ABSTRACT)) {
					dst->prototype = parent;
				} else if (!(parent->common.fn_flags & ZEND_ACC_CTOR) || (parent->common.prototype && (parent->common.prototype->common.scope->ce_flags & ZEND_ACC_INTERFACE))) {
					/* ctors only have a prototype if it comes from an interface */
					dst->prototype = parent->common.prototype ? parent->common.prototype : parent;
				}
				else {
					dst->prototype = NULL;
				}
			}
			else {
				dst->prototype = NULL;
			}
		} while (0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "prototype", sizeof("prototype"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "prototype"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "prototype", sizeof("prototype"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->prototype);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2
	
	if (src->scope) {
		
		dst->scope = xc_get_class(processor,(zend_ulong) src->scope);
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->scope == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "scope", sizeof("scope"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "scope"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "scope", sizeof("scope"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->scope);
	xc_autocheck_done_count ++;

#endif


	
		if (src->scope) {
			xc_fix_method(processor, dst TSRMLS_CC);
		}
	
#endif

	
		if (xc_have_op_array_ctor) {
			zend_llist_apply_with_argument(&zend_extensions, (llist_apply_with_arg_func_t) xc_zend_extension_op_array_ctor_handler, dst TSRMLS_CC);
		}
	
	}
	
		processor->active_op_array_dst = NULL;
		processor->active_op_array_src = NULL;
	
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_zend_op_array", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_restore_xc_constinfo_t */
	
 	  	 	static void inline 	xc_restore_xc_constinfo_t( 		 		 		 		xc_processor_t *processor, xc_constinfo_t *dst, const xc_constinfo_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_constinfo_t*)NULL)->key) + sizeof(((xc_constinfo_t*)NULL)->key_size) + sizeof(((xc_constinfo_t*)NULL)->h) + sizeof(((xc_constinfo_t*)NULL)->constant)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","constant" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_constinfo_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
	
	/* STRUCT(zend_constant,constant) */

	assert(sizeof(zend_constant) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zend_constant,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zend_constant) == sizeof((& src->constant)[0]));
	

	

	xc_restore_zend_constant(
		
		
		
		processor, & dst->constant, & src->constant
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_constinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_restore_xc_funcinfo_t */
	
		/* export:  	  	 	void 	xc_restore_xc_funcinfo_t( 		 		 		 		xc_processor_t *processor, xc_funcinfo_t *dst, const xc_funcinfo_t * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_xc_funcinfo_t( 		 		 		 		xc_processor_t *processor, xc_funcinfo_t *dst, const xc_funcinfo_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_funcinfo_t*)NULL)->key) + sizeof(((xc_funcinfo_t*)NULL)->key_size) + sizeof(((xc_funcinfo_t*)NULL)->h) + sizeof(((xc_funcinfo_t*)NULL)->op_array_info) + sizeof(((xc_funcinfo_t*)NULL)->func)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","op_array_info","func" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_funcinfo_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif


	
		processor->active_op_array_infos_src = &src->op_array_info;
		processor->active_op_array_index = 0;
	
	
	
	/* STRUCT(zend_function,func) */

	assert(sizeof(zend_function) == sizeof(src->func));
	
	
	
	/* STRUCT_P_EX(zend_function,DST(`func'),SRC(`func'),func,,&) */

	
	

	
	assert(sizeof(zend_function) == sizeof((& src->func)[0]));
	

	

	xc_restore_zend_function(
		
		
		
		processor, & dst->func, & src->func
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "func", sizeof("func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "func", sizeof("func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->func);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_funcinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_xc_classinfo_t */
	
		/* export:  	  	 	void 	xc_restore_xc_classinfo_t( 		 		 		 		xc_processor_t *processor, xc_classinfo_t *dst, const xc_classinfo_t * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_xc_classinfo_t( 		 		 		 		xc_processor_t *processor, xc_classinfo_t *dst, const xc_classinfo_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_classinfo_t*)NULL)->key) + sizeof(((xc_classinfo_t*)NULL)->key_size) + sizeof(((xc_classinfo_t*)NULL)->h) + sizeof(((xc_classinfo_t*)NULL)->methodinfo_cnt) + sizeof(((xc_classinfo_t*)NULL)->methodinfos) + sizeof(((xc_classinfo_t*)NULL)->cest)  ), assert_count = 6;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","methodinfo_cnt","methodinfos","cest" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_classinfo_t));
			do {
		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,methodinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->methodinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfo_cnt", sizeof("methodinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfo_cnt", sizeof("methodinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif


	
		processor->active_op_array_infos_src = src->methodinfos;
		processor->active_op_array_index = 0;
	
#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT_P(zend_class_entry,cest) */

	if (src->cest) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->cest)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->cest = (zend_class_entry *) emalloc(sizeof(zend_class_entry));
			
#ifndef NDEBUG
		memsetptr(dst->cest, (void *) __LINE__, sizeof(zend_class_entry));
#endif

		
	
	
	
	


	

	xc_restore_zend_class_entry(
		
		
		
		processor,  dst->cest,  src->cest
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->cest == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(zend_class_entry,cest) */

	assert(sizeof(zend_class_entry) == sizeof(src->cest));
	
	
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,,&) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof((& src->cest)[0]));
	

	

	xc_restore_zend_class_entry(
		
		
		
		processor, & dst->cest, & src->cest
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(int,oplineno) */

	assert(sizeof(int) == sizeof(src->oplineno));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineno", sizeof("oplineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "oplineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineno", sizeof("oplineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineno);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_classinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	




	
	

/* {{{ xc_restore_xc_entry_data_php_t */
	
		/* export:  	  	 	void 	xc_restore_xc_entry_data_php_t( 		 		 		 		xc_processor_t *processor, xc_entry_data_php_t *dst, const xc_entry_data_php_t * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_xc_entry_data_php_t( 		 		 		 		xc_processor_t *processor, xc_entry_data_php_t *dst, const xc_entry_data_php_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_data_php_t*)NULL)->next) + sizeof(((xc_entry_data_php_t*)NULL)->hvalue) + sizeof(((xc_entry_data_php_t*)NULL)->md5) + sizeof(((xc_entry_data_php_t*)NULL)->refcount) + sizeof(((xc_entry_data_php_t*)NULL)->hits) + sizeof(((xc_entry_data_php_t*)NULL)->size) + sizeof(((xc_entry_data_php_t*)NULL)->op_array_info) + sizeof(((xc_entry_data_php_t*)NULL)->op_array) + sizeof(((xc_entry_data_php_t*)NULL)->constinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->constinfos) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfos) + sizeof(((xc_entry_data_php_t*)NULL)->classinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->classinfos) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobal_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobals) + sizeof(((xc_entry_data_php_t*)NULL)->compilererror_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->compilererrors) + sizeof(((xc_entry_data_php_t*)NULL)->have_references)  ), assert_count = 19;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","hvalue","md5","refcount","hits","size","op_array_info","op_array","constinfo_cnt","constinfos","funcinfo_cnt","funcinfos","classinfo_cnt","classinfos","autoglobal_cnt","autoglobals","compilererror_cnt","compilererrors","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_data_php_t));
			do {
		

		
			
		processor->php_dst = dst;
		processor->php_src = src;
	

	/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(xc_hash_value_t,hvalue) */

	assert(sizeof(xc_hash_value_t) == sizeof(src->hvalue));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hvalue", sizeof("hvalue"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hvalue"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hvalue", sizeof("hvalue"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hvalue);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(xc_md5sum_t,md5) */

	assert(sizeof(xc_md5sum_t) == sizeof(src->md5));
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "md5", sizeof("md5"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "md5"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "md5", sizeof("md5"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->md5);
	xc_autocheck_done_count ++;

#endif


	

		
	/* PROCESS(zend_ulong,refcount) */

	assert(sizeof(zend_ulong) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif


	
		processor->active_op_array_infos_src = &dst->op_array_info;
		processor->active_op_array_index = 0;
	
	
	
	/* STRUCT_P(zend_op_array,op_array) */

	if (src->op_array) {
		
		
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof(( src->op_array)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
			dst->op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
			
#ifndef NDEBUG
		memsetptr(dst->op_array, (void *) __LINE__, sizeof(zend_op_array));
#endif

		
	
	
	
	


	

	xc_restore_zend_op_array(
		
		
		
		processor,  dst->op_array,  src->op_array
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		
		
	
	
	assert(src->op_array == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array", sizeof("op_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array", sizeof("op_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array);
	xc_autocheck_done_count ++;

#endif




#ifdef HAVE_XCACHE_CONSTANT
		
	/* PROCESS(zend_uint,constinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->constinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfo_cnt", sizeof("constinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfo_cnt", sizeof("constinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->constinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->constinfos = (xc_constinfo_t *) emalloc(sizeof(xc_constinfo_t) * src->constinfo_cnt);
			
#ifndef NDEBUG
		memsetptr(dst->constinfos, (void *) __LINE__, sizeof(xc_constinfo_t) * src->constinfo_cnt);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->constinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_constinfo_t,constinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_constinfo_t) == sizeof(src->constinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_constinfo_t,DST(`constinfos[LOOPCOUNTER]'),SRC(`constinfos[LOOPCOUNTER]'),constinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_constinfo_t) == sizeof((& src->constinfos[i])[0]));
	

	

	xc_restore_xc_constinfo_t(
		
		
		
		processor, & dst->constinfos[i], & src->constinfos[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->constinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
	/* PROCESS(zend_uint,funcinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->funcinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfo_cnt", sizeof("funcinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfo_cnt", sizeof("funcinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->funcinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->funcinfos = (xc_funcinfo_t *) emalloc(sizeof(xc_funcinfo_t) * src->funcinfo_cnt);
			
#ifndef NDEBUG
		memsetptr(dst->funcinfos, (void *) __LINE__, sizeof(xc_funcinfo_t) * src->funcinfo_cnt);
#endif

		
	
	
	
	

			

			for (i = 0;
					i < src->funcinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_funcinfo_t,funcinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_funcinfo_t) == sizeof(src->funcinfos[i]));
	
	
	
	/* STRUCT_P_EX(xc_funcinfo_t,DST(`funcinfos[LOOPCOUNTER]'),SRC(`funcinfos[LOOPCOUNTER]'),funcinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_funcinfo_t) == sizeof((& src->funcinfos[i])[0]));
	

	

	xc_restore_xc_funcinfo_t(
		
		
		
		processor, & dst->funcinfos[i], & src->funcinfos[i]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->funcinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif



	}


		
	/* PROCESS(zend_uint,classinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->classinfo_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfo_cnt", sizeof("classinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfo_cnt", sizeof("classinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->classinfos) {
		
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
			dst->classinfos = (xc_classinfo_t *) emalloc(sizeof(xc_classinfo_t) * src->classinfo_cnt);
			
#ifndef NDEBUG
		memsetptr(dst->classinfos, (void *) __LINE__, sizeof(xc_classinfo_t) * src->classinfo_cnt);
#endif

		
	
	
	
	

			

			for (processor->active_class_index = 0;
					processor->active_class_index < src->classinfo_cnt;
					++processor->active_class_index) {
				
	
	

					
	
	/* STRUCT(xc_classinfo_t,classinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_classinfo_t) == sizeof(src->classinfos[processor->active_class_index]));
	
	
	
	/* STRUCT_P_EX(xc_classinfo_t,DST(`classinfos[LOOPCOUNTER]'),SRC(`classinfos[LOOPCOUNTER]'),classinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_classinfo_t) == sizeof((& src->classinfos[processor->active_class_index])[0]));
	

	

	xc_restore_xc_classinfo_t(
		
		
		
		processor, & dst->classinfos[processor->active_class_index], & src->classinfos[processor->active_class_index]
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->classinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif



	}

#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(zend_uint,autoglobal_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->autoglobal_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobal_cnt", sizeof("autoglobal_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobal_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobal_cnt", sizeof("autoglobal_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobal_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif


	
#endif
#ifdef XCACHE_ERROR_CACHING
		
	/* PROCESS(zend_uint,compilererror_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->compilererror_cnt));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererror_cnt", sizeof("compilererror_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererror_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererror_cnt", sizeof("compilererror_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererror_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif


	
#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_bool,have_early_binding) */

	assert(sizeof(zend_bool) == sizeof(src->have_early_binding));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_early_binding", sizeof("have_early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_early_binding", sizeof("have_early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_early_binding);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_entry_data_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_xc_entry_t */
	
 	  	 	static void inline 	xc_restore_xc_entry_t( 		 		 		 		xc_processor_t *processor, xc_entry_t *dst, const xc_entry_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_t*)NULL)->next) + sizeof(((xc_entry_t*)NULL)->size) + sizeof(((xc_entry_t*)NULL)->ctime) + sizeof(((xc_entry_t*)NULL)->atime) + sizeof(((xc_entry_t*)NULL)->dtime) + sizeof(((xc_entry_t*)NULL)->hits) + sizeof(((xc_entry_t*)NULL)->ttl) + sizeof(((xc_entry_t*)NULL)->name)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","size","ctime","atime","dtime","hits","ttl","name" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_t));
			do {
		

		
			/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(time_t,ctime) */

	assert(sizeof(time_t) == sizeof(src->ctime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ctime", sizeof("ctime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ctime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ctime", sizeof("ctime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ctime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,atime) */

	assert(sizeof(time_t) == sizeof(src->atime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "atime", sizeof("atime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "atime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "atime", sizeof("atime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->atime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,dtime) */

	assert(sizeof(time_t) == sizeof(src->dtime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dtime", sizeof("dtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "dtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dtime", sizeof("dtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(long,ttl) */

	assert(sizeof(long) == sizeof(src->ttl));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ttl", sizeof("ttl"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ttl"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ttl", sizeof("ttl"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ttl);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif

 
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_entry_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_xc_entry_php_t */
	
		/* export:  	  	 	void 	xc_restore_xc_entry_php_t( 		 		 		 		xc_processor_t *processor, xc_entry_php_t *dst, const xc_entry_php_t * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_xc_entry_php_t( 		 		 		 		xc_processor_t *processor, xc_entry_php_t *dst, const xc_entry_php_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_php_t*)NULL)->entry) + sizeof(((xc_entry_php_t*)NULL)->php) + sizeof(((xc_entry_php_t*)NULL)->refcount) + sizeof(((xc_entry_php_t*)NULL)->file_mtime) + sizeof(((xc_entry_php_t*)NULL)->file_size) + sizeof(((xc_entry_php_t*)NULL)->file_device) + sizeof(((xc_entry_php_t*)NULL)->file_inode) + sizeof(((xc_entry_php_t*)NULL)->filepath_len) + sizeof(((xc_entry_php_t*)NULL)->filepath) + sizeof(((xc_entry_php_t*)NULL)->dirpath_len) + sizeof(((xc_entry_php_t*)NULL)->dirpath)  ), assert_count = 11;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","php","refcount","file_mtime","file_size","file_device","file_inode","filepath_len","filepath","dirpath_len","dirpath" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_php_t));
			do {
		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_restore_xc_entry_t(
		
		
		
		processor, & dst->entry, & src->entry
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif



	
	
	

			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

		
	
	
	


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "php", sizeof("php"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "php"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "php", sizeof("php"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->php);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(long,refcount) */

	assert(sizeof(long) == sizeof(src->refcount));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,file_mtime) */

	assert(sizeof(time_t) == sizeof(src->file_mtime));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_mtime", sizeof("file_mtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_mtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_mtime", sizeof("file_mtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_mtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_size) */

	assert(sizeof(size_t) == sizeof(src->file_size));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_size", sizeof("file_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_size", sizeof("file_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_size);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_device) */

	assert(sizeof(size_t) == sizeof(src->file_device));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_device", sizeof("file_device"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_device"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_device", sizeof("file_device"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_device);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_inode) */

	assert(sizeof(size_t) == sizeof(src->file_inode));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_inode", sizeof("file_inode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_inode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_inode", sizeof("file_inode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_inode);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(size_t,filepath_len) */

	assert(sizeof(size_t) == sizeof(src->filepath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath_len", sizeof("filepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath_len", sizeof("filepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath", sizeof("filepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath", sizeof("filepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(size_t,dirpath_len) */

	assert(sizeof(size_t) == sizeof(src->dirpath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath_len", sizeof("dirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath_len", sizeof("dirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath", sizeof("dirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath", sizeof("dirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath);
	xc_autocheck_done_count ++;

#endif


#ifdef IS_UNICODE
		
	/* PROCESS(int,ufilepath_len) */

	assert(sizeof(int) == sizeof(src->ufilepath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath_len", sizeof("ufilepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath_len", sizeof("ufilepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath", sizeof("ufilepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath", sizeof("ufilepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,udirpath_len) */

	assert(sizeof(int) == sizeof(src->udirpath_len));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath_len", sizeof("udirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath_len", sizeof("udirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath", sizeof("udirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath", sizeof("udirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath);
	xc_autocheck_done_count ++;

#endif


#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_entry_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_restore_xc_entry_var_t */
	
		/* export:  	  	 	void 	xc_restore_xc_entry_var_t( 		 		 		 		xc_processor_t *processor, xc_entry_var_t *dst, const xc_entry_var_t * const src 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_restore_xc_entry_var_t( 		 		 		 		xc_processor_t *processor, xc_entry_var_t *dst, const xc_entry_var_t * const src 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_var_t*)NULL)->entry) + sizeof(((xc_entry_var_t*)NULL)->value) + sizeof(((xc_entry_var_t*)NULL)->have_references)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","value","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			assert(xc_is_shm(src));
			
			do {
		
#endif

		

		
			memcpy(dst, src, sizeof(xc_entry_var_t));
			do {
		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_restore_xc_entry_t(
		
		
		
		processor, & dst->entry, & src->entry
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif




#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,name_type) */

	assert(sizeof(zend_uchar) == sizeof(src->name_type));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_type", sizeof("name_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "name_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_type", sizeof("name_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	
	

#ifdef IS_UNICODE
		if (src->name_type == IS_UNICODE) {
				
	/* PROCESS(int32_t,entry.name.ustr.len) */

	assert(sizeof(int32_t) == sizeof(src->entry.name.ustr.len));
		
	
	
	

	

		}
		else {
				
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

		}
#else
			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
	

	

#endif
		
	
	
	

	
	
	
	
	/* STRUCT_P_EX(zval_ptr,dst->value,src->value,value,,&) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((& src->value)[0]));
	

	

	xc_restore_zval_ptr(
		
		
		
		processor, & dst->value, & src->value
		
		TSRMLS_CC
	);

	

	
	

		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_restore_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_restore_xc_entry_var_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_restore_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_restore_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
			} while (0);
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	




 
#ifdef HAVE_XCACHE_DPRINT
  /* {{{ Pre-declare */
 	  	 	void 	xc_dprint_zval( 		const zval * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_dprint_zval_ptr( 		const zval_ptr * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_dprint_zval_ptr_nullable( 		const zval_ptr_nullable * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dprint_zend_op_array( 		const zend_op_array * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dprint_zend_class_entry( 		const zend_class_entry * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
#ifdef HAVE_XCACHE_CONSTANT
 	  	 	static void inline 	xc_dprint_zend_constant( 		const zend_constant * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
#endif
 	  	 	void 	xc_dprint_zend_function( 		const zend_function * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dprint_xc_entry_var_t( 		const xc_entry_var_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dprint_xc_entry_php_t( 		const xc_entry_php_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
#ifdef ZEND_ENGINE_2
 	  	 	static void inline 	xc_dprint_zend_property_info( 		const zend_property_info * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	
#endif
/* }}} */
#ifdef IS_CV

	
	

/* {{{ xc_dprint_zend_compiled_variable */
	
 	  	 	static void inline 	xc_dprint_zend_compiled_variable( 		const zend_compiled_variable * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_compiled_variable*)NULL)->name) + sizeof(((zend_compiled_variable*)NULL)->name_len) + sizeof(((zend_compiled_variable*)NULL)->hash_value)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","hash_value" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(int,name_len) */

	assert(sizeof(int) == sizeof(src->name_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:name_len:\t%d\n", src->name_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->name), src->name_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,hash_value) */

	assert(sizeof(ulong) == sizeof(src->hash_value));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:hash_value:\t%lu\n", src->hash_value);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_compiled_variable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zend_uint */
	
 	  	 	static void inline 	xc_dprint_zend_uint( 		const zend_uint * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_uint), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
		xc_dprint_indent(indent);
		fprintf(stderr, "%u\n", src[0]);
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_uint", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifndef ZEND_ENGINE_2

	
	

/* {{{ xc_dprint_int */
	
 	  	 	static void inline 	xc_dprint_int( 		const int * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(int), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
		xc_dprint_indent(indent);
		fprintf(stderr, "%d\n", src[0]);
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_int", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_dprint_zend_try_catch_element */
	
 	  	 	static void inline 	xc_dprint_zend_try_catch_element( 		const zend_try_catch_element * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_try_catch_element*)NULL)->try_op) + sizeof(((zend_try_catch_element*)NULL)->catch_op) + sizeof(((zend_try_catch_element*)NULL)->finally_op) + sizeof(((zend_try_catch_element*)NULL)->finally_end)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "try_op","catch_op","finally_op","finally_end" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,try_op) */

	assert(sizeof(zend_uint) == sizeof(src->try_op));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:try_op:\t%u\n", src->try_op);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_op", sizeof("try_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_op", sizeof("try_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,catch_op) */

	assert(sizeof(zend_uint) == sizeof(src->catch_op));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:catch_op:\t%u\n", src->catch_op);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "catch_op", sizeof("catch_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "catch_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "catch_op", sizeof("catch_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->catch_op);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,finally_op) */

	assert(sizeof(zend_uint) == sizeof(src->finally_op));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:finally_op:\t%u\n", src->finally_op);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_op", sizeof("finally_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_op", sizeof("finally_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,finally_end) */

	assert(sizeof(zend_uint) == sizeof(src->finally_end));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:finally_end:\t%u\n", src->finally_end);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_end", sizeof("finally_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_end", sizeof("finally_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_end);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_try_catch_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zend_brk_cont_element */
	
 	  	 	static void inline 	xc_dprint_zend_brk_cont_element( 		const zend_brk_cont_element * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_brk_cont_element*)NULL)->start) + sizeof(((zend_brk_cont_element*)NULL)->cont) + sizeof(((zend_brk_cont_element*)NULL)->brk) + sizeof(((zend_brk_cont_element*)NULL)->parent)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "start","cont","brk","parent" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
		#ifdef ZEND_ENGINE_2_2
		
	/* PROCESS(int,start) */

	assert(sizeof(int) == sizeof(src->start));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:start:\t%d\n", src->start);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start", sizeof("start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start", sizeof("start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(int,cont) */

	assert(sizeof(int) == sizeof(src->cont));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:cont:\t%d\n", src->cont);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cont", sizeof("cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cont", sizeof("cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cont);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,brk) */

	assert(sizeof(int) == sizeof(src->brk));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:brk:\t%d\n", src->brk);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk", sizeof("brk"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk", sizeof("brk"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,parent) */

	assert(sizeof(int) == sizeof(src->parent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:parent:\t%d\n", src->parent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_brk_cont_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	
	

/* {{{ xc_dprint_HashTable_zval_ptr */
	
 	  	 	static void inline 	xc_dprint_HashTable_zval_ptr( 		const HashTable * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
		
		
	

				
				Bucket *srcBucket;
		
		zend_bool first = 1;
				
		

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned int:canary:\t%u\n", src->canary);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nTableSize:\t%u\n", src->nTableSize);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nTableMask:\t%u\n", src->nTableMask);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nNumOfElements:\t%u\n", src->nNumOfElements);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:nNextFreeElement:\t%lu\n", src->nNextFreeElement);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			
			
				xc_dprint_indent(indent);
				fprintf(stderr, "zval_ptr:\"");
				xc_dprint_str_len(BUCKET_KEY_S(srcBucket), BUCKET_KEY_SIZE(srcBucket));
				fprintf(stderr, "\" %d:h=%lu ", BUCKET_KEY_SIZE(srcBucket), srcBucket->h);
			
			if (sizeof(void *) == sizeof(zval_ptr)) {
				
								
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  ((zval_ptr*)srcBucket->pData))[0]));
	

	

	xc_dprint_zval_ptr(
		             ((zval_ptr*)srcBucket->pData), indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zval_ptr,pnew->pData,((zval_ptr*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof(( ((zval_ptr*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zval_ptr(
		            ((zval_ptr*)srcBucket->pData), indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}

			if (first) {
				
				first = 0;
			}

			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:persistent:\t%u\n", src->persistent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:unicode:\t%u\n", src->unicode);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned char:nApplyCount:\t%u\n", src->nApplyCount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:bApplyProtection:\t%u\n", src->bApplyProtection);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:inconsistent:\t%d\n", src->inconsistent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_HashTable_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	
	

/* {{{ xc_dprint_HashTable_zend_function */
	
		/* export:  	  	 	void 	xc_dprint_HashTable_zend_function( 		const HashTable * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_HashTable_zend_function( 		const HashTable * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
		
		
	

				
				Bucket *srcBucket;
		
		zend_bool first = 1;
				
		

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned int:canary:\t%u\n", src->canary);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nTableSize:\t%u\n", src->nTableSize);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nTableMask:\t%u\n", src->nTableMask);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nNumOfElements:\t%u\n", src->nNumOfElements);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:nNextFreeElement:\t%lu\n", src->nNextFreeElement);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			
			
				xc_dprint_indent(indent);
				fprintf(stderr, "zend_function:\"");
				xc_dprint_str_len(BUCKET_KEY_S(srcBucket), BUCKET_KEY_SIZE(srcBucket));
				fprintf(stderr, "\" %d:h=%lu ", BUCKET_KEY_SIZE(srcBucket), srcBucket->h);
			
			if (sizeof(void *) == sizeof(zend_function)) {
				
								
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_function) == sizeof((  ((zend_function*)srcBucket->pData))[0]));
	

	

	xc_dprint_zend_function(
		             ((zend_function*)srcBucket->pData), indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_function,pnew->pData,((zend_function*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_function) == sizeof(( ((zend_function*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_function(
		            ((zend_function*)srcBucket->pData), indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}

			if (first) {
				
				first = 0;
			}

			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:persistent:\t%u\n", src->persistent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:unicode:\t%u\n", src->unicode);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned char:nApplyCount:\t%u\n", src->nApplyCount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:bApplyProtection:\t%u\n", src->bApplyProtection);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:inconsistent:\t%d\n", src->inconsistent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_function : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_HashTable_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2

	
	
	

/* {{{ xc_dprint_HashTable_zend_property_info */
	
 	  	 	static void inline 	xc_dprint_HashTable_zend_property_info( 		const HashTable * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
		
		
	

				
				Bucket *srcBucket;
		
		zend_bool first = 1;
				
		

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
		
							
	/* PROCESS(unsigned int,canary) */

	assert(sizeof(unsigned int) == sizeof(src->canary));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned int:canary:\t%u\n", src->canary);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif



	

		
#endif
			
	/* PROCESS(uint,nTableSize) */

	assert(sizeof(uint) == sizeof(src->nTableSize));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nTableSize:\t%u\n", src->nTableSize);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nTableMask) */

	assert(sizeof(uint) == sizeof(src->nTableMask));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nTableMask:\t%u\n", src->nTableMask);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(uint,nNumOfElements) */

	assert(sizeof(uint) == sizeof(src->nNumOfElements));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:nNumOfElements:\t%u\n", src->nNumOfElements);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(ulong,nNextFreeElement) */

	assert(sizeof(ulong) == sizeof(src->nNextFreeElement));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:nNextFreeElement:\t%lu\n", src->nNextFreeElement);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif



	

		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_4
	if (src->nTableMask) {
#endif
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


		
	
	

		for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
			

			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			
			
				xc_dprint_indent(indent);
				fprintf(stderr, "zend_property_info:\"");
				xc_dprint_str_len(BUCKET_KEY_S(srcBucket), BUCKET_KEY_SIZE(srcBucket));
				fprintf(stderr, "\" %d:h=%lu ", BUCKET_KEY_SIZE(srcBucket), srcBucket->h);
			
			if (sizeof(void *) == sizeof(zend_property_info)) {
				
								
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,, ) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof((  ((zend_property_info*)srcBucket->pData))[0]));
	

	

	xc_dprint_zend_property_info(
		             ((zend_property_info*)srcBucket->pData), indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

			}
			else {
				
	
	/* STRUCT_P_EX(zend_property_info,pnew->pData,((zend_property_info*)srcBucket->pData),,) */

	
	

	
	assert(sizeof(zend_property_info) == sizeof(( ((zend_property_info*)srcBucket->pData))[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_property_info(
		            ((zend_property_info*)srcBucket->pData), indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}

			if (first) {
				
				first = 0;
			}

			
		}
		
	
	

				
#ifdef ZEND_ENGINE_2_4
	}
	else { /* if (src->nTableMask) */
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


	}
#endif
		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


		 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(zend_bool,persistent) */

	assert(sizeof(zend_bool) == sizeof(src->persistent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:persistent:\t%u\n", src->persistent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
			
	/* PROCESS(zend_bool,unicode) */

	assert(sizeof(zend_bool) == sizeof(src->unicode));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:unicode:\t%u\n", src->unicode);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif



	

#endif
			
	/* PROCESS(unsigned char,nApplyCount) */

	assert(sizeof(unsigned char) == sizeof(src->nApplyCount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned char:nApplyCount:\t%u\n", src->nApplyCount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_bool,bApplyProtection) */

	assert(sizeof(zend_bool) == sizeof(src->bApplyProtection));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:bApplyProtection:\t%u\n", src->bApplyProtection);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif



	

#if ZEND_DEBUG
			
	/* PROCESS(int,inconsistent) */

	assert(sizeof(int) == sizeof(src->inconsistent));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:inconsistent:\t%d\n", src->inconsistent);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif



	

#endif
				
	
		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_HashTable_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif
#ifdef IS_CONSTANT_AST


	
	

/* {{{ xc_dprint_zend_ast */
	
		/* export:  	  	 	void 	xc_dprint_zend_ast( 		const zend_ast * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_zend_ast( 		const zend_ast * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_ast*)NULL)->kind) + sizeof(((zend_ast*)NULL)->children) + sizeof(((zend_ast*)NULL)->u)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "kind","children","u" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				zend_ushort i;
			
	/* PROCESS(zend_ushort,kind) */

	assert(sizeof(zend_ushort) == sizeof(src->kind));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ushort:kind:\t%hu\n", src->kind);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "kind", sizeof("kind"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "kind"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "kind", sizeof("kind"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->kind);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_ushort,children) */

	assert(sizeof(zend_ushort) == sizeof(src->children));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ushort:children:\t%hu\n", src->children);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "children", sizeof("children"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "children"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "children", sizeof("children"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->children);
	xc_autocheck_done_count ++;

#endif



	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


		
	
	

			if (src->kind == ZEND_CONST) {
				assert(src->u.val);
				
				
	
	/* STRUCT_P_EX(zval,dst->u.val,src->u.val,[],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src->u.val)[0]));
	

	

	xc_dprint_zval(
		             src->u.val, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

				
			}
			else {
				for (i = 0; i < src->children; ++i) {
					zend_ast *src_ast = (&src->u.child)[i];
					if (src_ast) {
						{
	

	
	
							
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

							
	
	/* STRUCT_P_EX(zend_ast,(&dst->u.child)[i],src_ast,[],, ) */

	
	

	
	assert(sizeof(zend_ast) == sizeof((  src_ast)[0]));
	

	

	xc_dprint_zend_ast(
		             src_ast, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

						
	
}

						
					}
					else {
						
					}
				}
			}
		
	
	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_ast", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zval */
	
		/* export:  	  	 	void 	xc_dprint_zval( 		const zval * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_zval( 		const zval * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zval*)NULL)->value) + sizeof(((zval*)NULL)->refcount__gc) + sizeof(((zval*)NULL)->type) + sizeof(((zval*)NULL)->is_ref__gc)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","refcount__gc","type","is_ref__gc" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
				/* Variable information */
		
	
	

		switch ((Z_TYPE_P(src) & IS_CONSTANT_TYPE_MASK)) {
			case IS_LONG:
			case IS_RESOURCE:
			case IS_BOOL:
					
	/* PROCESS(long,value.lval) */

	assert(sizeof(long) == sizeof(src->value.lval));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "long:value.lval:\t%ld\n", src->value.lval);
	
	
	

	

				break;
			case IS_DOUBLE:
					
	/* PROCESS(double,value.dval) */

	assert(sizeof(double) == sizeof(src->value.dval));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "double:value.dval:\t%f\n", src->value.dval);
	
	
	

	

				break;
			case IS_NULL:
				xc_dprint_indent(indent);fprintf(stderr, "\tNULL\n");
				break;

			case IS_CONSTANT:
#ifdef IS_UNICODE
				if (UG(unicode)) {
					goto proc_unicode;
				}
#endif
			case IS_STRING:
#ifdef FLAG_IS_BC
			case FLAG_IS_BC:
#endif
					
	/* PROCESS(int,value.str.len) */

	assert(sizeof(int) == sizeof(src->value.str.len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:value.str.len:\t%d\n", src->value.str.len);
	
	
	

	

				
	/* PROC_STRING_L(value.str.val,value.str.len) */
 
	/* PROC_STRING_N(value.str.val,value.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->value.str.val == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->value.str.val");
			xc_dprint_str_len(src->value.str.val, src->value.str.len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->value.str.len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

				break;
#ifdef IS_UNICODE
			case IS_UNICODE:
proc_unicode:
					
	/* PROCESS(int32_t,value.uni.len) */

	assert(sizeof(int32_t) == sizeof(src->value.uni.len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int32_t:value.uni.len:\t%d\n", src->value.uni.len);
	
	
	

	

				
	/* PROC_ZSTRING_L(1,value.uni.val,value.uni.len) */
 
	
	/* PROC_ZSTRING_N(1,value.uni.val,value.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->value.uni.val) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->value.uni.val), src->value.uni.len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->value.uni.val");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->value.uni.len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->value.uni.val) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->value.uni.val");
			xc_dprint_str_len(ZSTR_S(src->value.uni.val), src->value.uni.len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->value.uni.len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

				break;
#endif

			case IS_ARRAY:
#ifdef IS_CONSTANT_ARRAY
			case IS_CONSTANT_ARRAY:
#endif
				assert(src->value.ht);
				
	
	/* STRUCT_P(HashTable,value.ht,HashTable_zval_ptr) */

	if (src->value.ht) {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:value.ht ");
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.ht'),SRC(`value.ht'),value.ht,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.ht)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_HashTable_zval_ptr(
		            src->value.ht, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:value.ht:\tNULL\n");
		
	
	
	assert(src->value.ht == NULL);

	}
	

				break;

#ifdef IS_CONSTANT_AST
			case IS_CONSTANT_AST:
				assert(src->value.ast);
				{
	

	
	
	
	/* STRUCT_P(zend_ast,value.ast) */

	if (src->value.ast) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_ast:value.ast ");
		
	
	/* STRUCT_P_EX(zend_ast,DST(`value.ast'),SRC(`value.ast'),value.ast,) */

	
	

	
	assert(sizeof(zend_ast) == sizeof(( src->value.ast)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_ast(
		            src->value.ast, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_ast:value.ast:\tNULL\n");
		
	
	
	assert(src->value.ast == NULL);

	}
	

	
}

				break;
#endif

			case IS_OBJECT:
				
				#ifndef ZEND_ENGINE_2
				
	
	/* STRUCT_P(zend_class_entry,value.obj.ce) */

	if (src->value.obj.ce) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_class_entry:value.obj.ce ");
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`value.obj.ce'),SRC(`value.obj.ce'),value.obj.ce,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->value.obj.ce)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_class_entry(
		            src->value.obj.ce, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_class_entry:value.obj.ce:\tNULL\n");
		
	
	
	assert(src->value.obj.ce == NULL);

	}
	

				
	
	/* STRUCT_P(HashTable,value.obj.properties,HashTable_zval_ptr) */

	if (src->value.obj.properties) {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:value.obj.properties ");
		
	
	/* STRUCT_P_EX(HashTable,DST(`value.obj.properties'),SRC(`value.obj.properties'),value.obj.properties,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->value.obj.properties)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_HashTable_zval_ptr(
		            src->value.obj.properties, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:value.obj.properties:\tNULL\n");
		
	
	
	assert(src->value.obj.properties == NULL);

	}
	

#endif
				break;

			default:
				assert(0);
		}
		
	
	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif


			
	/* PROCESS(xc_zval_type_t,type) */

	assert(sizeof(xc_zval_type_t) == sizeof(src->type));
		
		xc_dprint_indent(indent);
		fprintf(stderr, ":type:\t%d %s\n", src->type, xc_get_data_type(src->type));
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif


	

	

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uchar,is_ref__gc) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref__gc));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:is_ref__gc:\t%u\n", src->is_ref__gc);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref__gc", sizeof("is_ref__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref__gc", sizeof("is_ref__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref__gc);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_uchar,is_ref) */

	assert(sizeof(zend_uchar) == sizeof(src->is_ref));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:is_ref:\t%u\n", src->is_ref);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref", sizeof("is_ref"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref", sizeof("is_ref"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2_3
			
	/* PROCESS(zend_uint,refcount__gc) */

	assert(sizeof(zend_uint) == sizeof(src->refcount__gc));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:refcount__gc:\t%u\n", src->refcount__gc);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount__gc", sizeof("refcount__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount__gc", sizeof("refcount__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount__gc);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2)
			
	/* PROCESS(zend_uint,refcount) */

	assert(sizeof(zend_uint) == sizeof(src->refcount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:refcount:\t%u\n", src->refcount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
			
	/* PROCESS(zend_ushort,refcount) */

	assert(sizeof(zend_ushort) == sizeof(src->refcount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ushort:refcount:\t%hu\n", src->refcount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zval", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_zval_ptr */
	
 	  	 	static void inline 	xc_dprint_zval_ptr( 		const zval_ptr * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
		do {
			
			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			
			
			xc_dprint_indent(indent);fprintf(stderr, "[%p] ", (void *) src[0]);
			
	
	/* STRUCT_P_EX(zval,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src[0])[0]));
	

	

	xc_dprint_zval(
		             src[0], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

			
		} while (0);
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_zval_ptr_nullable */
	
 	  	 	static void inline 	xc_dprint_zval_ptr_nullable( 		const zval_ptr_nullable * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr_nullable), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			if (src[0]) {
		
		
	
	/* STRUCT_P_EX(zval_ptr,dst,src,,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  src)[0]));
	

	xc_dprint_zval_ptr(
		             src, indent
		
		
		
		
		TSRMLS_CC
	);

	
	

		
	}
	else {
		
	}
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr_nullable);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zval_ptr_nullable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_dprint_zend_arg_info */
	
 	  	 	static void inline 	xc_dprint_zend_arg_info( 		const zend_arg_info * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_arg_info*)NULL)->name) + sizeof(((zend_arg_info*)NULL)->name_len) + sizeof(((zend_arg_info*)NULL)->class_name) + sizeof(((zend_arg_info*)NULL)->class_name_len) + sizeof(((zend_arg_info*)NULL)->type_hint) + sizeof(((zend_arg_info*)NULL)->pass_by_reference) + sizeof(((zend_arg_info*)NULL)->allow_null) + sizeof(((zend_arg_info*)NULL)->is_variadic)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","class_name","class_name_len","type_hint","pass_by_reference","allow_null","is_variadic" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,name_len) */

	assert(sizeof(zend_uint) == sizeof(src->name_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:name_len:\t%u\n", src->name_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->name), src->name_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(zend_uint,class_name_len) */

	assert(sizeof(zend_uint) == sizeof(src->class_name_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:class_name_len:\t%u\n", src->class_name_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name_len", sizeof("class_name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name_len", sizeof("class_name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,class_name,class_name_len) */
 
	
	/* PROC_ZSTRING_N(,class_name,class_name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->class_name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->class_name), src->class_name_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->class_name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->class_name_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->class_name");
			xc_dprint_str_len(ZSTR_S(src->class_name), src->class_name_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->class_name_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->class_name");
			xc_dprint_str_len(ZSTR_S(src->class_name), src->class_name_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->class_name_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,type_hint) */

	assert(sizeof(zend_uchar) == sizeof(src->type_hint));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:type_hint:\t%u\n", src->type_hint);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type_hint", sizeof("type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type_hint", sizeof("type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type_hint);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2_1)
		
	/* PROCESS(zend_bool,array_type_hint) */

	assert(sizeof(zend_bool) == sizeof(src->array_type_hint));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:array_type_hint:\t%u\n", src->array_type_hint);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "array_type_hint", sizeof("array_type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "array_type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "array_type_hint", sizeof("array_type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->array_type_hint);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_uchar,pass_by_reference) */

	assert(sizeof(zend_uchar) == sizeof(src->pass_by_reference));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:pass_by_reference:\t%u\n", src->pass_by_reference);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,allow_null) */

	assert(sizeof(zend_bool) == sizeof(src->allow_null));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:allow_null:\t%u\n", src->allow_null);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "allow_null", sizeof("allow_null"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "allow_null"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "allow_null", sizeof("allow_null"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->allow_null);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_bool,is_variadic) */

	assert(sizeof(zend_bool) == sizeof(src->is_variadic));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:is_variadic:\t%u\n", src->is_variadic);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_variadic", sizeof("is_variadic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "is_variadic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_variadic", sizeof("is_variadic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_variadic);
	xc_autocheck_done_count ++;

#endif



	

#else
		
	/* PROCESS(zend_bool,pass_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_by_reference));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:pass_by_reference:\t%u\n", src->pass_by_reference);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,return_reference) */

	assert(sizeof(zend_bool) == sizeof(src->return_reference));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:return_reference:\t%u\n", src->return_reference);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,required_num_args) */

	assert(sizeof(int) == sizeof(src->required_num_args));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:required_num_args:\t%d\n", src->required_num_args);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_arg_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_dprint_zend_constant */
	
 	  	 	static void inline 	xc_dprint_zend_constant( 		const zend_constant * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_constant*)NULL)->value) + sizeof(((zend_constant*)NULL)->flags) + sizeof(((zend_constant*)NULL)->name) + sizeof(((zend_constant*)NULL)->name_len) + sizeof(((zend_constant*)NULL)->module_number)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","flags","name","name_len","module_number" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	/* STRUCT(zval,value) */

	assert(sizeof(zval) == sizeof(src->value));
	xc_dprint_indent(indent);fprintf(stderr, "zval:value ");
	
	
	/* STRUCT_P_EX(zval,DST(`value'),SRC(`value'),value,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->value)[0]));
	

	

	xc_dprint_zval(
		           & src->value, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(int,flags) */

	assert(sizeof(int) == sizeof(src->flags));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:flags:\t%d\n", src->flags);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,name_len) */

	assert(sizeof(uint) == sizeof(src->name_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:name_len:\t%u\n", src->name_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	/* PROC_ZSTRING_N(,name,name_len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->name), src->name_len - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_len - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_len - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_len - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(int,module_number) */

	assert(sizeof(int) == sizeof(src->module_number));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:module_number:\t%d\n", src->module_number);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module_number", sizeof("module_number"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "module_number"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module_number", sizeof("module_number"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module_number);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_constant", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zend_function */
	
		/* export:  	  	 	void 	xc_dprint_zend_function( 		const zend_function * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_zend_function( 		const zend_function * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_function), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	

	switch (src->type) {
	case ZEND_INTERNAL_FUNCTION:
	case ZEND_OVERLOADED_FUNCTION:
		
		break;

	case ZEND_USER_FUNCTION:
	case ZEND_EVAL_CODE:
		
		
	
	/* STRUCT(zend_op_array,op_array) */

	assert(sizeof(zend_op_array) == sizeof(src->op_array));
	xc_dprint_indent(indent);fprintf(stderr, "zend_op_array:op_array ");
	
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,,&) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof((& src->op_array)[0]));
	

	

	xc_dprint_zend_op_array(
		           & src->op_array, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

		break;

	default:
		assert(0);
	}
	
	
	

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_dprint_zend_property_info */
	
 	  	 	static void inline 	xc_dprint_zend_property_info( 		const zend_property_info * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_property_info*)NULL)->flags) + sizeof(((zend_property_info*)NULL)->name) + sizeof(((zend_property_info*)NULL)->name_length) + sizeof(((zend_property_info*)NULL)->h) + sizeof(((zend_property_info*)NULL)->offset) + sizeof(((zend_property_info*)NULL)->doc_comment) + sizeof(((zend_property_info*)NULL)->doc_comment_len) + sizeof(((zend_property_info*)NULL)->ce)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "flags","name","name_length","h","offset","doc_comment","doc_comment_len","ce" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,flags) */

	assert(sizeof(zend_uint) == sizeof(src->flags));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:flags:\t%u\n", src->flags);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,name_length) */

	assert(sizeof(int) == sizeof(src->name_length));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:name_length:\t%d\n", src->name_length);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->name), src->name_length + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_length + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_length + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_length + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_length + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_length + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:h:\t%lu\n", src->h);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(int,offset) */

	assert(sizeof(int) == sizeof(src->offset));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:offset:\t%d\n", src->offset);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "offset", sizeof("offset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "offset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "offset", sizeof("offset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->offset);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:doc_comment_len:\t%d\n", src->doc_comment_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->doc_comment), src->doc_comment_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
			xc_dprint_str_len(ZSTR_S(src->doc_comment), src->doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
			xc_dprint_str_len(ZSTR_S(src->doc_comment), src->doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
	#if defined(ZEND_ENGINE_2_2)
	
	if (src->ce) {
		
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->ce == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif


#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_dprint_zend_trait_method_reference */
	
 	  	 	static void inline 	xc_dprint_zend_trait_method_reference( 		const zend_trait_method_reference * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_method_reference*)NULL)->method_name) + sizeof(((zend_trait_method_reference*)NULL)->mname_len) + sizeof(((zend_trait_method_reference*)NULL)->ce) + sizeof(((zend_trait_method_reference*)NULL)->class_name) + sizeof(((zend_trait_method_reference*)NULL)->cname_len)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "method_name","mname_len","ce","class_name","cname_len" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(unsigned int,mname_len) */

	assert(sizeof(unsigned int) == sizeof(src->mname_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned int:mname_len:\t%u\n", src->mname_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "mname_len", sizeof("mname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "mname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "mname_len", sizeof("mname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->mname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(method_name,mname_len) */
 
	/* PROC_STRING_N(method_name,mname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "method_name", sizeof("method_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "method_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "method_name", sizeof("method_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->method_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->method_name == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->method_name");
			xc_dprint_str_len(src->method_name, src->mname_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->mname_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

	
	
	
	
	assert(src->ce == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,cname_len) */

	assert(sizeof(unsigned int) == sizeof(src->cname_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned int:cname_len:\t%u\n", src->cname_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cname_len", sizeof("cname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "cname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cname_len", sizeof("cname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(class_name,cname_len) */
 
	/* PROC_STRING_N(class_name,cname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->class_name == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->class_name");
			xc_dprint_str_len(src->class_name, src->cname_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->cname_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_trait_method_reference", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_zend_trait_alias */
	
 	  	 	static void inline 	xc_dprint_zend_trait_alias( 		const zend_trait_alias * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_alias*)NULL)->trait_method) + sizeof(((zend_trait_alias*)NULL)->alias) + sizeof(((zend_trait_alias*)NULL)->alias_len) + sizeof(((zend_trait_alias*)NULL)->modifiers)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","alias","alias_len","modifiers" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_trait_method_reference:trait_method ");
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_trait_method_reference(
		            src->trait_method, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_trait_method_reference:trait_method:\tNULL\n");
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,alias_len) */

	assert(sizeof(unsigned int) == sizeof(src->alias_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned int:alias_len:\t%u\n", src->alias_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias_len", sizeof("alias_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias_len", sizeof("alias_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(alias,alias_len) */
 
	/* PROC_STRING_N(alias,alias_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias", sizeof("alias"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias", sizeof("alias"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->alias == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->alias");
			xc_dprint_str_len(src->alias, src->alias_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->alias_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,modifiers) */

	assert(sizeof(zend_uint) == sizeof(src->modifiers));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:modifiers:\t%u\n", src->modifiers);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "modifiers", sizeof("modifiers"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "modifiers"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "modifiers", sizeof("modifiers"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->modifiers);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_trait_alias", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_zend_trait_precedence */
	
 	  	 	static void inline 	xc_dprint_zend_trait_precedence( 		const zend_trait_precedence * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_precedence*)NULL)->trait_method) + sizeof(((zend_trait_precedence*)NULL)->exclude_from_classes)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","exclude_from_classes" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_trait_method_reference:trait_method ");
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_trait_method_reference(
		            src->trait_method, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_trait_method_reference:trait_method:\tNULL\n");
		
	
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		if (src->exclude_from_classes) {
		int LOOPCOUNTER;
		
						
				size_t count = 0;
				while (src->exclude_from_classes[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (LOOPCOUNTER = 0;
					src->exclude_from_classes[LOOPCOUNTER];
					++LOOPCOUNTER) {
				
	
	

					
					
						
	/* PROCESS(xc_ztstring,exclude_from_classes) */

	assert(sizeof(xc_ztstring) == sizeof((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]));
		
	
	/* PROC_STRING(exclude_from_classes) */
 
	
	
	
	
	
	
	
	
	if ((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER] == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->exclude_from_classes [LOOPCOUNTER]");
			xc_dprint_str_len((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER], strlen((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) strlen((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

	

	

					
					
				
	
	

			}
						
				
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->exclude_from_classes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif



	}

#ifndef ZEND_ENGINE_2_5
	
	
	
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_trait_precedence", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_zend_trait_alias_ptr */
	
 	  	 	static void inline 	xc_dprint_zend_trait_alias_ptr( 		const zend_trait_alias_ptr * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_alias), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_alias,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_alias) == sizeof((  src[0])[0]));
	

	

	xc_dprint_zend_trait_alias(
		             src[0], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_alias);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_trait_alias_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_zend_trait_precedence_ptr */
	
 	  	 	static void inline 	xc_dprint_zend_trait_precedence_ptr( 		const zend_trait_precedence_ptr * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_precedence), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
	
	/* STRUCT_P_EX(zend_trait_precedence,dst[0],src[0],[0],, ) */

	
	

	
	assert(sizeof(zend_trait_precedence) == sizeof((  src[0])[0]));
	

	

	xc_dprint_zend_trait_precedence(
		             src[0], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_precedence);
	xc_autocheck_done_count ++;

#endif


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_trait_precedence_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zend_class_entry */
	
		/* export:  	  	 	void 	xc_dprint_zend_class_entry( 		const zend_class_entry * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_zend_class_entry( 		const zend_class_entry * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_class_entry*)NULL)->type) + sizeof(((zend_class_entry*)NULL)->name) + sizeof(((zend_class_entry*)NULL)->name_length) + sizeof(((zend_class_entry*)NULL)->parent) + sizeof(((zend_class_entry*)NULL)->refcount) + sizeof(((zend_class_entry*)NULL)->ce_flags) + sizeof(((zend_class_entry*)NULL)->function_table) + sizeof(((zend_class_entry*)NULL)->properties_info) + sizeof(((zend_class_entry*)NULL)->default_properties_table) + sizeof(((zend_class_entry*)NULL)->default_static_members_table) + sizeof(((zend_class_entry*)NULL)->static_members_table) + sizeof(((zend_class_entry*)NULL)->constants_table) + sizeof(((zend_class_entry*)NULL)->default_properties_count) + sizeof(((zend_class_entry*)NULL)->default_static_members_count) + sizeof(((zend_class_entry*)NULL)->constructor) + sizeof(((zend_class_entry*)NULL)->destructor) + sizeof(((zend_class_entry*)NULL)->clone) + sizeof(((zend_class_entry*)NULL)->__get) + sizeof(((zend_class_entry*)NULL)->__set) + sizeof(((zend_class_entry*)NULL)->__unset) + sizeof(((zend_class_entry*)NULL)->__isset) + sizeof(((zend_class_entry*)NULL)->__call) + sizeof(((zend_class_entry*)NULL)->__callstatic) + sizeof(((zend_class_entry*)NULL)->__tostring) + sizeof(((zend_class_entry*)NULL)->__debugInfo) + sizeof(((zend_class_entry*)NULL)->serialize_func) + sizeof(((zend_class_entry*)NULL)->unserialize_func) + sizeof(((zend_class_entry*)NULL)->iterator_funcs) + sizeof(((zend_class_entry*)NULL)->create_object) + sizeof(((zend_class_entry*)NULL)->get_iterator) + sizeof(((zend_class_entry*)NULL)->interface_gets_implemented) + sizeof(((zend_class_entry*)NULL)->get_static_method) + sizeof(((zend_class_entry*)NULL)->serialize) + sizeof(((zend_class_entry*)NULL)->unserialize) + sizeof(((zend_class_entry*)NULL)->interfaces) + sizeof(((zend_class_entry*)NULL)->num_interfaces) + sizeof(((zend_class_entry*)NULL)->traits) + sizeof(((zend_class_entry*)NULL)->num_traits) + sizeof(((zend_class_entry*)NULL)->trait_aliases) + sizeof(((zend_class_entry*)NULL)->trait_precedences) + sizeof(((zend_class_entry*)NULL)->info)  ), assert_count = 41;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","name","name_length","parent","refcount","ce_flags","function_table","properties_info","default_properties_table","default_static_members_table","static_members_table","constants_table","default_properties_count","default_static_members_count","constructor","destructor","clone","__get","__set","__unset","__isset","__call","__callstatic","__tostring","__debugInfo","serialize_func","unserialize_func","iterator_funcs","create_object","get_iterator","interface_gets_implemented","get_static_method","serialize","unserialize","interfaces","num_interfaces","traits","num_traits","trait_aliases","trait_precedences","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
		
	/* PROCESS(char,type) */

	assert(sizeof(char) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "char:type:\t%d\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,name_length) */

	assert(sizeof(zend_uint) == sizeof(src->name_length));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:name_length:\t%u\n", src->name_length);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->name), src->name_length + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_length + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_length + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_length + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->name");
			xc_dprint_str_len(ZSTR_S(src->name), src->name_length + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->name_length + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	if (src->parent) {
		
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->parent == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif


	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(int,refcount) */

	assert(sizeof(int) == sizeof(src->refcount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:refcount:\t%d\n", src->refcount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
	
	
	/* STRUCT_P(int,refcount) */

	if (src->refcount) {
		xc_dprint_indent(indent);fprintf(stderr, "int:refcount ");
		
	
	/* STRUCT_P_EX(int,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(int) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_int(
		            src->refcount, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "int:refcount:\tNULL\n");
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,constants_updated) */

	assert(sizeof(zend_bool) == sizeof(src->constants_updated));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:constants_updated:\t%u\n", src->constants_updated);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_updated", sizeof("constants_updated"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_updated"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_updated", sizeof("constants_updated"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_updated);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,ce_flags) */

	assert(sizeof(zend_uint) == sizeof(src->ce_flags));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:ce_flags:\t%u\n", src->ce_flags);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce_flags", sizeof("ce_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "ce_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce_flags", sizeof("ce_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce_flags);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,properties_info,HashTable_zend_property_info) */

	assert(sizeof(HashTable) == sizeof(src->properties_info));
	xc_dprint_indent(indent);fprintf(stderr, "HashTable:properties_info ");
	
	
	/* STRUCT_P_EX(HashTable,DST(`properties_info'),SRC(`properties_info'),properties_info,HashTable_zend_property_info,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->properties_info)[0]));
	

	

	xc_dprint_HashTable_zend_property_info(
		           & src->properties_info, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "properties_info", sizeof("properties_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "properties_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "properties_info", sizeof("properties_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->properties_info);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2_4
	
	if (src->default_properties_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->default_properties_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_properties_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_properties_table[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zval_ptr_nullable:default_properties_table[i] ");
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_properties_table[LOOPCOUNTER]'),SRC(`default_properties_table[LOOPCOUNTER]'),default_properties_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_properties_table[i])[0]));
	

	

	xc_dprint_zval_ptr_nullable(
		           & src->default_properties_table[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_properties_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_properties_count) */

	assert(sizeof(int) == sizeof(src->default_properties_count));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:default_properties_count:\t%d\n", src->default_properties_count);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_count", sizeof("default_properties_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_count", sizeof("default_properties_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_count);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->default_static_members_table) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->default_static_members_count;
					++i) {
				
	
	

					
	
	/* STRUCT(zval_ptr_nullable,default_static_members_table[LOOPCOUNTER],) */

	assert(sizeof(zval_ptr_nullable) == sizeof(src->default_static_members_table[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zval_ptr_nullable:default_static_members_table[i] ");
	
	
	/* STRUCT_P_EX(zval_ptr_nullable,DST(`default_static_members_table[LOOPCOUNTER]'),SRC(`default_static_members_table[LOOPCOUNTER]'),default_static_members_table[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zval_ptr_nullable) == sizeof((& src->default_static_members_table[i])[0]));
	

	

	xc_dprint_zval_ptr_nullable(
		           & src->default_static_members_table[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->default_static_members_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_static_members_count) */

	assert(sizeof(int) == sizeof(src->default_static_members_count));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:default_static_members_count:\t%d\n", src->default_static_members_count);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_count", sizeof("default_static_members_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_count", sizeof("default_static_members_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_count);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members_table", sizeof("static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members_table", sizeof("static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members_table);
	xc_autocheck_done_count ++;

#endif


#else
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "builtin_functions", sizeof("builtin_functions"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "builtin_functions"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "builtin_functions", sizeof("builtin_functions"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->builtin_functions);
	xc_autocheck_done_count ++;

#endif


	
	
	/* STRUCT(HashTable,default_properties,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_properties));
	xc_dprint_indent(indent);fprintf(stderr, "HashTable:default_properties ");
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_properties'),SRC(`default_properties'),default_properties,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_properties)[0]));
	

	

	xc_dprint_HashTable_zval_ptr(
		           & src->default_properties, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties", sizeof("default_properties"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties", sizeof("default_properties"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties);
	xc_autocheck_done_count ++;

#endif



#	ifdef ZEND_ENGINE_2_1
	
	
	/* STRUCT(HashTable,default_static_members,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_static_members));
	xc_dprint_indent(indent);fprintf(stderr, "HashTable:default_static_members ");
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_static_members'),SRC(`default_static_members'),default_static_members,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_static_members)[0]));
	

	

	xc_dprint_HashTable_zval_ptr(
		           & src->default_static_members, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members", sizeof("default_static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members", sizeof("default_static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif


#	elif defined(ZEND_ENGINE_2)
	
	
	/* STRUCT_P(HashTable,static_members,HashTable_zval_ptr) */

	if (src->static_members) {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:static_members ");
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_members'),SRC(`static_members'),static_members,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_members)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_HashTable_zval_ptr(
		            src->static_members, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:static_members:\tNULL\n");
		
	
	
	assert(src->static_members == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif



#	endif
#endif /* ZEND_ENGINE_2_4 */

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,constants_table,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->constants_table));
	xc_dprint_indent(indent);fprintf(stderr, "HashTable:constants_table ");
	
	
	/* STRUCT_P_EX(HashTable,DST(`constants_table'),SRC(`constants_table'),constants_table,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->constants_table)[0]));
	

	

	xc_dprint_HashTable_zval_ptr(
		           & src->constants_table, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_table", sizeof("constants_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_table", sizeof("constants_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_table);
	xc_autocheck_done_count ++;

#endif




#ifdef ZEND_ENGINE_2_2
		
	
	
	
	assert(src->interfaces == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_interfaces == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif




#	ifdef ZEND_ENGINE_2_4
		
	
	
	
	assert(src->traits == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "traits", sizeof("traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "traits", sizeof("traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->traits);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	assert(src->num_traits == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_traits", sizeof("num_traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_traits", sizeof("num_traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_traits);
	xc_autocheck_done_count ++;

#endif



	
	if (src->trait_aliases) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_aliases[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					src->trait_aliases[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_alias_ptr,trait_aliases[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_alias_ptr) == sizeof(src->trait_aliases[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_trait_alias_ptr:trait_aliases[i] ");
	
	
	/* STRUCT_P_EX(zend_trait_alias_ptr,DST(`trait_aliases[LOOPCOUNTER]'),SRC(`trait_aliases[LOOPCOUNTER]'),trait_aliases[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_alias_ptr) == sizeof((& src->trait_aliases[i])[0]));
	

	

	xc_dprint_zend_trait_alias_ptr(
		           & src->trait_aliases[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_alias_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_aliases == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif



	}

	
	if (src->trait_precedences) {
		size_t i; 
		
	

		
						
				size_t count = 0;
				while (src->trait_precedences[count]) {
					++count;
				}
				++count;
				
			
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					src->trait_precedences[i];
					++i) {
				
	
	

					
	
	/* STRUCT(zend_trait_precedence_ptr,trait_precedences[LOOPCOUNTER],) */

	assert(sizeof(zend_trait_precedence_ptr) == sizeof(src->trait_precedences[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_trait_precedence_ptr:trait_precedences[i] ");
	
	
	/* STRUCT_P_EX(zend_trait_precedence_ptr,DST(`trait_precedences[LOOPCOUNTER]'),SRC(`trait_precedences[LOOPCOUNTER]'),trait_precedences[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_trait_precedence_ptr) == sizeof((& src->trait_precedences[i])[0]));
	

	

	xc_dprint_zend_trait_precedence_ptr(
		           & src->trait_precedences[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_trait_precedence_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->trait_precedences == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif



	}

#	endif
#else
	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif


	
		
	/* PROCESS(zend_uint,num_interfaces) */

	assert(sizeof(zend_uint) == sizeof(src->num_interfaces));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:num_interfaces:\t%u\n", src->num_interfaces);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif



	

#endif

#	ifdef ZEND_ENGINE_2_4
	
	
	

	
	/* PROC_STRING(info.user.filename) */
 
	
	
	
	
	
	
	
	
	if (src->info.user.filename == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->info.user.filename");
			xc_dprint_str_len(src->info.user.filename, strlen(src->info.user.filename) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) strlen(src->info.user.filename) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,info.user.line_start) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_start));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:info.user.line_start:\t%u\n", src->info.user.line_start);
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.line_end) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_end));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:info.user.line_end:\t%u\n", src->info.user.line_end);
	
	
	

	

		
	/* PROCESS(zend_uint,info.user.doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.doc_comment_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:info.user.doc_comment_len:\t%u\n", src->info.user.doc_comment_len);
	
	
	

	

	
	/* PROC_ZSTRING_L(,info.user.doc_comment,info.user.doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,info.user.doc_comment,info.user.doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->info.user.doc_comment), src->info.user.doc_comment_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->info.user.doc_comment");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->info.user.doc_comment_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->info.user.doc_comment");
			xc_dprint_str_len(ZSTR_S(src->info.user.doc_comment), src->info.user.doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->info.user.doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->info.user.doc_comment");
			xc_dprint_str_len(ZSTR_S(src->info.user.doc_comment), src->info.user.doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->info.user.doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif


#	else
	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->filename");
			xc_dprint_str_len(src->filename, strlen(src->filename) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) strlen(src->filename) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:line_start:\t%u\n", src->line_start);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:line_end:\t%u\n", src->line_end);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->doc_comment_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:doc_comment_len:\t%u\n", src->doc_comment_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->doc_comment), src->doc_comment_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
			xc_dprint_str_len(ZSTR_S(src->doc_comment), src->doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
			xc_dprint_str_len(ZSTR_S(src->doc_comment), src->doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#	endif

	/* # NOT DONE */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize_func", sizeof("serialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize_func", sizeof("serialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize_func);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize_func", sizeof("unserialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize_func", sizeof("unserialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize_func);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "iterator_funcs", sizeof("iterator_funcs"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "iterator_funcs"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "iterator_funcs", sizeof("iterator_funcs"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->iterator_funcs);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "create_object", sizeof("create_object"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "create_object"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "create_object", sizeof("create_object"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->create_object);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_iterator", sizeof("get_iterator"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_iterator"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_iterator", sizeof("get_iterator"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_iterator);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interface_gets_implemented", sizeof("interface_gets_implemented"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interface_gets_implemented"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interface_gets_implemented", sizeof("interface_gets_implemented"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interface_gets_implemented);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_ENGINE_2_3
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_static_method", sizeof("get_static_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_static_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_static_method", sizeof("get_static_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_static_method);
	xc_autocheck_done_count ++;

#endif


#	endif
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize", sizeof("serialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize", sizeof("serialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize", sizeof("unserialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize", sizeof("unserialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize);
	xc_autocheck_done_count ++;

#endif


#	endif
	/* deal with it inside xc_fix_method */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constructor", sizeof("constructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constructor", sizeof("constructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "destructor", sizeof("destructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "destructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "destructor", sizeof("destructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->destructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "clone", sizeof("clone"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "clone"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "clone", sizeof("clone"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->clone);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__get", sizeof("__get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__get", sizeof("__get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__set", sizeof("__set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__set", sizeof("__set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__set);
	xc_autocheck_done_count ++;

#endif


/* should be >5.1 */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__unset", sizeof("__unset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__unset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__unset", sizeof("__unset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__unset);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__isset", sizeof("__isset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__isset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__isset", sizeof("__isset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__isset);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__call", sizeof("__call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__call", sizeof("__call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__call);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_CALLSTATIC_FUNC_NAME
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__callstatic", sizeof("__callstatic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__callstatic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__callstatic", sizeof("__callstatic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__callstatic);
	xc_autocheck_done_count ++;

#endif


#	endif
# if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__tostring", sizeof("__tostring"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__tostring"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__tostring", sizeof("__tostring"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__tostring);
	xc_autocheck_done_count ++;

#endif


# endif
# if defined(ZEND_ENGINE_2_6)
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__debugInfo", sizeof("__debugInfo"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__debugInfo"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__debugInfo", sizeof("__debugInfo"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__debugInfo);
	xc_autocheck_done_count ++;

#endif


# endif
#	ifndef ZEND_ENGINE_2_4
	/* # NOT DONE */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module", sizeof("module"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "module"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module", sizeof("module"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module);
	xc_autocheck_done_count ++;

#endif


#	endif
#else /* ZEND_ENGINE_2 */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_function_call", sizeof("handle_function_call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_function_call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_function_call", sizeof("handle_function_call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_function_call);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_get", sizeof("handle_property_get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_get", sizeof("handle_property_get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_set", sizeof("handle_property_set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_set", sizeof("handle_property_set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_set);
	xc_autocheck_done_count ++;

#endif


#endif
		
	
	/* STRUCT(HashTable,function_table,HashTable_zend_function) */

	assert(sizeof(HashTable) == sizeof(src->function_table));
	xc_dprint_indent(indent);fprintf(stderr, "HashTable:function_table ");
	
	
	/* STRUCT_P_EX(HashTable,DST(`function_table'),SRC(`function_table'),function_table,HashTable_zend_function,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->function_table)[0]));
	

	

	xc_dprint_HashTable_zend_function(
		           & src->function_table, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_table", sizeof("function_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "function_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_table", sizeof("function_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_table);
	xc_autocheck_done_count ++;

#endif



	
	

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_class_entry", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4


#else

	
	

/* {{{ xc_dprint_znode */
	
 	  	 	static void inline 	xc_dprint_znode( 		const znode * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((znode*)NULL)->op_type) + sizeof(((znode*)NULL)->u) + sizeof(((znode*)NULL)->EA)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "op_type","u","EA" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(xc_op_type,op_type) */

	assert(sizeof(xc_op_type) == sizeof(src->op_type));
		
		xc_dprint_indent(indent);
		fprintf(stderr, ":op_type:\t%d %s\n", src->op_type, xc_get_op_type(src->op_type));
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_type", sizeof("op_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_znode : %s\n"
				, __FILE__, __LINE__
				, "op_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_type", sizeof("op_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_type);
	xc_autocheck_done_count ++;

#endif


	

	


#ifdef IS_CV
#	define XCACHE_IS_CV IS_CV
#else
/* compatible with zend optimizer */
#	define XCACHE_IS_CV 16
#endif
	assert(src->op_type == IS_CONST ||
		src->op_type == IS_VAR ||
		src->op_type == XCACHE_IS_CV ||
		src->op_type == IS_TMP_VAR ||
		src->op_type == IS_UNUSED);
		
	
	

	switch (src->op_type) {
		case IS_CONST:
			
	
	/* STRUCT(zval,u.constant) */

	assert(sizeof(zval) == sizeof(src->u.constant));
	xc_dprint_indent(indent);fprintf(stderr, "zval:u.constant ");
	
	
	/* STRUCT_P_EX(zval,DST(`u.constant'),SRC(`u.constant'),u.constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->u.constant)[0]));
	

	

	xc_dprint_zval(
		           & src->u.constant, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case XCACHE_IS_CV:
				
	/* PROCESS(zend_uint,u.var) */

	assert(sizeof(zend_uint) == sizeof(src->u.var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:u.var:\t%u\n", src->u.var);
	
	
	

	

				
	/* PROCESS(zend_uint,u.EA.type) */

	assert(sizeof(zend_uint) == sizeof(src->u.EA.type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:u.EA.type:\t%u\n", src->u.EA.type);
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,u.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->u.opline_num));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:u.opline_num:\t%u\n", src->u.opline_num);
	
	
	

	

#ifndef ZEND_ENGINE_2
				
	/* PROCESS(zend_uint,u.fetch_type) */

	assert(sizeof(zend_uint) == sizeof(src->u.fetch_type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:u.fetch_type:\t%u\n", src->u.fetch_type);
	
	
	

	

#endif
				
	/* PROCESS(zend_uint,u.EA.type) */

	assert(sizeof(zend_uint) == sizeof(src->u.EA.type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:u.EA.type:\t%u\n", src->u.EA.type);
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_znode : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


#if 0
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "EA", sizeof("EA"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_znode : %s\n"
				, __FILE__, __LINE__
				, "EA"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "EA", sizeof("EA"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->EA);
	xc_autocheck_done_count ++;

#endif


#endif
#undef XCACHE_IS_CV

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_znode", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zend_op */
	
		/* export:  	  	 	void 	xc_dprint_zend_op( 		const zend_op * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_zend_op( 		const zend_op * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op*)NULL)->handler) + sizeof(((zend_op*)NULL)->op1) + sizeof(((zend_op*)NULL)->op2) + sizeof(((zend_op*)NULL)->result) + sizeof(((zend_op*)NULL)->extended_value) + sizeof(((zend_op*)NULL)->lineno) + sizeof(((zend_op*)NULL)->opcode) + sizeof(((zend_op*)NULL)->op1_type) + sizeof(((zend_op*)NULL)->op2_type) + sizeof(((zend_op*)NULL)->result_type)  ), assert_count = 10;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "handler","op1","op2","result","extended_value","lineno","opcode","op1_type","op2_type","result_type" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(xc_opcode,opcode) */

	assert(sizeof(xc_opcode) == sizeof(src->opcode));
		
		xc_dprint_indent(indent);
		fprintf(stderr, ":opcode:\t%u %s\n", src->opcode, xc_get_opcode(src->opcode));
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcode", sizeof("opcode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcode", sizeof("opcode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcode);
	xc_autocheck_done_count ++;

#endif


	

	

#ifdef ZEND_ENGINE_2_4
	
	switch (src->opcode) {
	case ZEND_BIND_TRAITS:
		((zend_op *) src)->op2_type = IS_UNUSED;
		break;
	}
	
	#ifndef NDEBUG
	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
		case IS_CONST:
			
					
	/* PROCESS(zend_uint,result.constant) */

	assert(sizeof(zend_uint) == sizeof(src->result.constant));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:result.constant:\t%u\n", src->result.constant);
	
	
	

	

			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,result.var) */

	assert(sizeof(zend_uint) == sizeof(src->result.var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:result.var:\t%u\n", src->result.var);
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,result.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->result.opline_num));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:result.opline_num:\t%u\n", src->result.opline_num);
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op1_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op1_type )) {
		case IS_CONST:
			
				
					
							
	/* PROCESS(zend_uint,op1.constant) */

	assert(sizeof(zend_uint) == sizeof(src->op1.constant));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:op1.constant:\t%u\n", src->op1.constant);
	
	
	

	

					
				
			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,op1.var) */

	assert(sizeof(zend_uint) == sizeof(src->op1.var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:op1.var:\t%u\n", src->op1.var);
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,op1.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->op1.opline_num));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:op1.opline_num:\t%u\n", src->op1.opline_num);
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op2_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op2_type )) {
		case IS_CONST:
			
				
					
							
	/* PROCESS(zend_uint,op2.constant) */

	assert(sizeof(zend_uint) == sizeof(src->op2.constant));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:op2.constant:\t%u\n", src->op2.constant);
	
	
	

	

					
				
			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,op2.var) */

	assert(sizeof(zend_uint) == sizeof(src->op2.var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:op2.var:\t%u\n", src->op2.var);
	
	
	

	

			break;
		case IS_UNUSED:
			
				
	/* PROCESS(zend_uint,op2.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->op2.opline_num));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:op2.opline_num:\t%u\n", src->op2.opline_num);
	
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(znode,result) */

	assert(sizeof(znode) == sizeof(src->result));
	xc_dprint_indent(indent);fprintf(stderr, "znode:result ");
	
	
	/* STRUCT_P_EX(znode,DST(`result'),SRC(`result'),result,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->result)[0]));
	

	

	xc_dprint_znode(
		           & src->result, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op1) */

	assert(sizeof(znode) == sizeof(src->op1));
	xc_dprint_indent(indent);fprintf(stderr, "znode:op1 ");
	
	
	/* STRUCT_P_EX(znode,DST(`op1'),SRC(`op1'),op1,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op1)[0]));
	

	

	xc_dprint_znode(
		           & src->op1, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op2) */

	assert(sizeof(znode) == sizeof(src->op2));
	xc_dprint_indent(indent);fprintf(stderr, "znode:op2 ");
	
	
	/* STRUCT_P_EX(znode,DST(`op2'),SRC(`op2'),op2,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op2)[0]));
	

	

	xc_dprint_znode(
		           & src->op2, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#endif
		
	/* PROCESS(ulong,extended_value) */

	assert(sizeof(ulong) == sizeof(src->extended_value));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:extended_value:\t%lu\n", src->extended_value);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "extended_value", sizeof("extended_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "extended_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "extended_value", sizeof("extended_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->extended_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:lineno:\t%u\n", src->lineno);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,op1_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op1_type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:op1_type:\t%u\n", src->op1_type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1_type", sizeof("op1_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1_type", sizeof("op1_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,op2_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op2_type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:op2_type:\t%u\n", src->op2_type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2_type", sizeof("op2_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2_type", sizeof("op2_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,result_type) */

	assert(sizeof(zend_uchar) == sizeof(src->result_type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:result_type:\t%u\n", src->result_type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result_type", sizeof("result_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result_type", sizeof("result_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(opcode_handler_t,handler) */

	assert(sizeof(opcode_handler_t) == sizeof(src->handler));
	/* is copying enough? */
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handler", sizeof("handler"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "handler"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handler", sizeof("handler"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handler);
	xc_autocheck_done_count ++;

#endif


	

#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_op", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_dprint_zend_literal */
	
 	  	 	static void inline 	xc_dprint_zend_literal( 		const zend_literal * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_literal*)NULL)->constant) + sizeof(((zend_literal*)NULL)->hash_value) + sizeof(((zend_literal*)NULL)->cache_slot)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "constant","hash_value","cache_slot" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	/* STRUCT(zval,constant) */

	assert(sizeof(zval) == sizeof(src->constant));
	xc_dprint_indent(indent);fprintf(stderr, "zval:constant ");
	
	
	/* STRUCT_P_EX(zval,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->constant)[0]));
	

	

	xc_dprint_zval(
		           & src->constant, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(zend_ulong,hash_value) */

	assert(sizeof(zend_ulong) == sizeof(src->hash_value));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ulong:hash_value:\t%lu\n", src->hash_value);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,cache_slot) */

	assert(sizeof(zend_uint) == sizeof(src->cache_slot));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:cache_slot:\t%u\n", src->cache_slot);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cache_slot", sizeof("cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cache_slot", sizeof("cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cache_slot);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_literal", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dprint_zend_op_array */
	
		/* export:  	  	 	void 	xc_dprint_zend_op_array( 		const zend_op_array * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_zend_op_array( 		const zend_op_array * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op_array*)NULL)->type) + sizeof(((zend_op_array*)NULL)->function_name) + sizeof(((zend_op_array*)NULL)->scope) + sizeof(((zend_op_array*)NULL)->fn_flags) + sizeof(((zend_op_array*)NULL)->prototype) + sizeof(((zend_op_array*)NULL)->num_args) + sizeof(((zend_op_array*)NULL)->required_num_args) + sizeof(((zend_op_array*)NULL)->arg_info) + sizeof(((zend_op_array*)NULL)->refcount) + sizeof(((zend_op_array*)NULL)->opcodes) + sizeof(((zend_op_array*)NULL)->last) + sizeof(((zend_op_array*)NULL)->vars) + sizeof(((zend_op_array*)NULL)->last_var) + sizeof(((zend_op_array*)NULL)->T) + sizeof(((zend_op_array*)NULL)->nested_calls) + sizeof(((zend_op_array*)NULL)->used_stack) + sizeof(((zend_op_array*)NULL)->brk_cont_array) + sizeof(((zend_op_array*)NULL)->last_brk_cont) + sizeof(((zend_op_array*)NULL)->try_catch_array) + sizeof(((zend_op_array*)NULL)->last_try_catch) + sizeof(((zend_op_array*)NULL)->has_finally_block) + sizeof(((zend_op_array*)NULL)->static_variables) + sizeof(((zend_op_array*)NULL)->this_var) + sizeof(((zend_op_array*)NULL)->filename) + sizeof(((zend_op_array*)NULL)->line_start) + sizeof(((zend_op_array*)NULL)->line_end) + sizeof(((zend_op_array*)NULL)->doc_comment) + sizeof(((zend_op_array*)NULL)->doc_comment_len) + sizeof(((zend_op_array*)NULL)->early_binding) + sizeof(((zend_op_array*)NULL)->literals) + sizeof(((zend_op_array*)NULL)->last_literal) + sizeof(((zend_op_array*)NULL)->run_time_cache) + sizeof(((zend_op_array*)NULL)->last_cache_slot) + sizeof(((zend_op_array*)NULL)->reserved)  ), assert_count = 34;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","function_name","scope","fn_flags","prototype","num_args","required_num_args","arg_info","refcount","opcodes","last","vars","last_var","T","nested_calls","used_stack","brk_cont_array","last_brk_cont","try_catch_array","last_try_catch","has_finally_block","static_variables","this_var","filename","line_start","line_end","doc_comment","doc_comment_len","early_binding","literals","last_literal","run_time_cache","last_cache_slot","reserved" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	{
	
	do {
	
	/* Common elements */
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:type:\t%u\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING(,function_name) */
 
	
	/* PROC_ZSTRING_N(,function_name,,strlen) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->function_name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->function_name), xc_zstrlen_uchar (src->function_name) + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->function_name");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) xc_zstrlen_uchar (src->function_name) + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->function_name");
			xc_dprint_str_len(ZSTR_S(src->function_name), xc_zstrlen_char (src->function_name) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) xc_zstrlen_char (src->function_name) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->function_name");
			xc_dprint_str_len(ZSTR_S(src->function_name), xc_zstrlen_char (src->function_name) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) xc_zstrlen_char (src->function_name) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,fn_flags) */

	assert(sizeof(zend_uint) == sizeof(src->fn_flags));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:fn_flags:\t%u\n", src->fn_flags);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "fn_flags", sizeof("fn_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "fn_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "fn_flags", sizeof("fn_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->fn_flags);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->arg_info) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->num_args;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_arg_info,arg_info[LOOPCOUNTER],) */

	assert(sizeof(zend_arg_info) == sizeof(src->arg_info[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_arg_info:arg_info[i] ");
	
	
	/* STRUCT_P_EX(zend_arg_info,DST(`arg_info[LOOPCOUNTER]'),SRC(`arg_info[LOOPCOUNTER]'),arg_info[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_arg_info) == sizeof((& src->arg_info[i])[0]));
	

	

	xc_dprint_zend_arg_info(
		           & src->arg_info[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->arg_info == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,num_args) */

	assert(sizeof(zend_uint) == sizeof(src->num_args));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:num_args:\t%u\n", src->num_args);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_args", sizeof("num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_args", sizeof("num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_args);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,required_num_args) */

	assert(sizeof(zend_uint) == sizeof(src->required_num_args));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:required_num_args:\t%u\n", src->required_num_args);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,pass_rest_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_rest_by_reference));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:pass_rest_by_reference:\t%u\n", src->pass_rest_by_reference);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_rest_by_reference", sizeof("pass_rest_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "pass_rest_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_rest_by_reference", sizeof("pass_rest_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_rest_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
	if (src->arg_types) {
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
		
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	
	
	assert(src->arg_types == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif



	}
#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(unsigned char,return_reference) */

	assert(sizeof(unsigned char) == sizeof(src->return_reference));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "unsigned char:return_reference:\t%u\n", src->return_reference);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* END of common elements */
#ifdef IS_UNICODE
	#endif

	
	
	/* STRUCT_P(zend_uint,refcount) */

	if (src->refcount) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_uint:refcount ");
		
	
	/* STRUCT_P_EX(zend_uint,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(zend_uint) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_uint(
		            src->refcount, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_uint:refcount:\tNULL\n");
		
	
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	if (src->literals) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_literal;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_literal,literals[LOOPCOUNTER],) */

	assert(sizeof(zend_literal) == sizeof(src->literals[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_literal:literals[i] ");
	
	
	/* STRUCT_P_EX(zend_literal,DST(`literals[LOOPCOUNTER]'),SRC(`literals[LOOPCOUNTER]'),literals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_literal) == sizeof((& src->literals[i])[0]));
	

	

	xc_dprint_zend_literal(
		           & src->literals[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_literal) */

	assert(sizeof(int) == sizeof(src->last_literal));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:last_literal:\t%d\n", src->last_literal);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_literal", sizeof("last_literal"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_literal"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_literal", sizeof("last_literal"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_literal);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
	if (src->opcodes) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_op,opcodes[LOOPCOUNTER],) */

	assert(sizeof(zend_op) == sizeof(src->opcodes[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_op:opcodes[i] ");
	
	
	/* STRUCT_P_EX(zend_op,DST(`opcodes[LOOPCOUNTER]'),SRC(`opcodes[LOOPCOUNTER]'),opcodes[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_op) == sizeof((& src->opcodes[i])[0]));
	

	

	xc_dprint_zend_op(
		           & src->opcodes[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->opcodes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,last) */

	assert(sizeof(zend_uint) == sizeof(src->last));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:last:\t%u\n", src->last);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last", sizeof("last"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last", sizeof("last"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,size) */

	assert(sizeof(zend_uint) == sizeof(src->size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:size:\t%u\n", src->size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef IS_CV
	
	if (src->vars) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_var;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_compiled_variable,vars[LOOPCOUNTER],) */

	assert(sizeof(zend_compiled_variable) == sizeof(src->vars[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_compiled_variable:vars[i] ");
	
	
	/* STRUCT_P_EX(zend_compiled_variable,DST(`vars[LOOPCOUNTER]'),SRC(`vars[LOOPCOUNTER]'),vars[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_compiled_variable) == sizeof((& src->vars[i])[0]));
	

	

	xc_dprint_zend_compiled_variable(
		           & src->vars[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->vars == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_var) */

	assert(sizeof(int) == sizeof(src->last_var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:last_var:\t%d\n", src->last_var);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_var", sizeof("last_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_var", sizeof("last_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_var);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,size_var) */

	assert(sizeof(zend_uint) == sizeof(src->size_var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:size_var:\t%u\n", src->size_var);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size_var", sizeof("size_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size_var", sizeof("size_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size_var);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
		
#endif

		
	/* PROCESS(zend_uint,T) */

	assert(sizeof(zend_uint) == sizeof(src->T));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:T:\t%u\n", src->T);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "T", sizeof("T"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "T"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "T", sizeof("T"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->T);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,nested_calls) */

	assert(sizeof(zend_uint) == sizeof(src->nested_calls));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:nested_calls:\t%u\n", src->nested_calls);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nested_calls", sizeof("nested_calls"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "nested_calls"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nested_calls", sizeof("nested_calls"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nested_calls);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,used_stack) */

	assert(sizeof(zend_uint) == sizeof(src->used_stack));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:used_stack:\t%u\n", src->used_stack);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "used_stack", sizeof("used_stack"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "used_stack"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "used_stack", sizeof("used_stack"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->used_stack);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	if (src->brk_cont_array) {
		last_brk_cont_t i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_brk_cont;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_brk_cont_element,brk_cont_array[LOOPCOUNTER],) */

	assert(sizeof(zend_brk_cont_element) == sizeof(src->brk_cont_array[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_brk_cont_element:brk_cont_array[i] ");
	
	
	/* STRUCT_P_EX(zend_brk_cont_element,DST(`brk_cont_array[LOOPCOUNTER]'),SRC(`brk_cont_array[LOOPCOUNTER]'),brk_cont_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_brk_cont_element) == sizeof((& src->brk_cont_array[i])[0]));
	

	

	xc_dprint_zend_brk_cont_element(
		           & src->brk_cont_array[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->brk_cont_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(last_brk_cont_t,last_brk_cont) */

	assert(sizeof(last_brk_cont_t) == sizeof(src->last_brk_cont));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "last_brk_cont_t:last_brk_cont:\t%d\n", src->last_brk_cont);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_brk_cont", sizeof("last_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_brk_cont", sizeof("last_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_brk_cont);
	xc_autocheck_done_count ++;

#endif




	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,current_brk_cont) */

	assert(sizeof(zend_uint) == sizeof(src->current_brk_cont));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:current_brk_cont:\t%u\n", src->current_brk_cont);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "current_brk_cont", sizeof("current_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "current_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "current_brk_cont", sizeof("current_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->current_brk_cont);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifndef ZEND_ENGINE_2
		
	/* PROCESS(zend_bool,uses_globals) */

	assert(sizeof(zend_bool) == sizeof(src->uses_globals));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:uses_globals:\t%u\n", src->uses_globals);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_globals", sizeof("uses_globals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_globals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_globals", sizeof("uses_globals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_globals);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	if (src->try_catch_array) {
		int i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->last_try_catch;
					++i) {
				
	
	

					
	
	/* STRUCT(zend_try_catch_element,try_catch_array[LOOPCOUNTER],) */

	assert(sizeof(zend_try_catch_element) == sizeof(src->try_catch_array[i]));
	xc_dprint_indent(indent);fprintf(stderr, "zend_try_catch_element:try_catch_array[i] ");
	
	
	/* STRUCT_P_EX(zend_try_catch_element,DST(`try_catch_array[LOOPCOUNTER]'),SRC(`try_catch_array[LOOPCOUNTER]'),try_catch_array[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(zend_try_catch_element) == sizeof((& src->try_catch_array[i])[0]));
	

	

	xc_dprint_zend_try_catch_element(
		           & src->try_catch_array[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->try_catch_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_try_catch) */

	assert(sizeof(int) == sizeof(src->last_try_catch));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:last_try_catch:\t%d\n", src->last_try_catch);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_try_catch", sizeof("last_try_catch"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_try_catch"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_try_catch", sizeof("last_try_catch"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_try_catch);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_bool,has_finally_block) */

	assert(sizeof(zend_bool) == sizeof(src->has_finally_block));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:has_finally_block:\t%u\n", src->has_finally_block);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "has_finally_block", sizeof("has_finally_block"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "has_finally_block"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "has_finally_block", sizeof("has_finally_block"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->has_finally_block);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	
	/* STRUCT_P(HashTable,static_variables,HashTable_zval_ptr) */

	if (src->static_variables) {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:static_variables ");
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_variables'),SRC(`static_variables'),static_variables,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_variables)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_HashTable_zval_ptr(
		            src->static_variables, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "HashTable:static_variables:\tNULL\n");
		
	
	
	assert(src->static_variables == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_variables", sizeof("static_variables"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "static_variables"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_variables", sizeof("static_variables"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_variables);
	xc_autocheck_done_count ++;

#endif




#ifndef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start_op", sizeof("start_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "start_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start_op", sizeof("start_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start_op);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,backpatch_count) */

	assert(sizeof(int) == sizeof(src->backpatch_count));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:backpatch_count:\t%d\n", src->backpatch_count);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "backpatch_count", sizeof("backpatch_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "backpatch_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "backpatch_count", sizeof("backpatch_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->backpatch_count);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_3
		
	/* PROCESS(zend_uint,this_var) */

	assert(sizeof(zend_uint) == sizeof(src->this_var));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:this_var:\t%u\n", src->this_var);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "this_var", sizeof("this_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "this_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "this_var", sizeof("this_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->this_var);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,done_pass_two) */

	assert(sizeof(zend_bool) == sizeof(src->done_pass_two));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:done_pass_two:\t%u\n", src->done_pass_two);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "done_pass_two", sizeof("done_pass_two"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "done_pass_two"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "done_pass_two", sizeof("done_pass_two"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->done_pass_two);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* 5.0 <= ver < 5.3 */
#if defined(ZEND_ENGINE_2) && !defined(ZEND_ENGINE_2_3)
		
	/* PROCESS(zend_bool,uses_this) */

	assert(sizeof(zend_bool) == sizeof(src->uses_this));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:uses_this:\t%u\n", src->uses_this);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_this", sizeof("uses_this"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_this"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_this", sizeof("uses_this"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_this);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->filename");
			xc_dprint_str_len(src->filename, strlen(src->filename) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) strlen(src->filename) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
	
		
	/* PROC_STRING(script_encoding) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "script_encoding", sizeof("script_encoding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "script_encoding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "script_encoding", sizeof("script_encoding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->script_encoding);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->script_encoding == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->script_encoding");
			xc_dprint_str_len(src->script_encoding, strlen(src->script_encoding) + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) strlen(src->script_encoding) + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

	
#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:line_start:\t%u\n", src->line_start);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:line_end:\t%u\n", src->line_end);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:doc_comment_len:\t%d\n", src->doc_comment_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->doc_comment), src->doc_comment_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
			xc_dprint_str_len(ZSTR_S(src->doc_comment), src->doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->doc_comment");
			xc_dprint_str_len(ZSTR_S(src->doc_comment), src->doc_comment_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->doc_comment_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
#ifdef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_uint,early_binding) */

	assert(sizeof(zend_uint) == sizeof(src->early_binding));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:early_binding:\t%u\n", src->early_binding);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "early_binding", sizeof("early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "early_binding", sizeof("early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->early_binding);
	xc_autocheck_done_count ++;

#endif



	
;
#endif

	/* reserved */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "reserved", sizeof("reserved"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "reserved"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "reserved", sizeof("reserved"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->reserved);
	xc_autocheck_done_count ++;

#endif


#if defined(HARDENING_PATCH) && HARDENING_PATCH
		
	/* PROCESS(zend_bool,created_by_eval) */

	assert(sizeof(zend_bool) == sizeof(src->created_by_eval));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:created_by_eval:\t%u\n", src->created_by_eval);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "created_by_eval", sizeof("created_by_eval"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "created_by_eval"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "created_by_eval", sizeof("created_by_eval"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->created_by_eval);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "run_time_cache", sizeof("run_time_cache"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "run_time_cache"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "run_time_cache", sizeof("run_time_cache"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->run_time_cache);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,last_cache_slot) */

	assert(sizeof(int) == sizeof(src->last_cache_slot));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:last_cache_slot:\t%d\n", src->last_cache_slot);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_cache_slot", sizeof("last_cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_cache_slot", sizeof("last_cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_cache_slot);
	xc_autocheck_done_count ++;

#endif



	

#endif
	} while (0);
	

#ifdef ZEND_ENGINE_2
		
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "prototype", sizeof("prototype"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "prototype"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "prototype", sizeof("prototype"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->prototype);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2
	
	if (src->scope) {
		
		
#ifdef IS_UNICODE
		
#else
		
#endif
	}
	else {
		
	
	
	assert(src->scope == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "scope", sizeof("scope"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "scope"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "scope", sizeof("scope"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->scope);
	xc_autocheck_done_count ++;

#endif


	
#endif

	
	}
	
	

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_zend_op_array", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_dprint_xc_constinfo_t */
	
 	  	 	static void inline 	xc_dprint_xc_constinfo_t( 		const xc_constinfo_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_constinfo_t*)NULL)->key) + sizeof(((xc_constinfo_t*)NULL)->key_size) + sizeof(((xc_constinfo_t*)NULL)->h) + sizeof(((xc_constinfo_t*)NULL)->constant)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","constant" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:key_size:\t%u\n", src->key_size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:type:\t%u\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->key), src->key_size - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->key");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_size - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_size - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:h:\t%lu\n", src->h);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
	
	/* STRUCT(zend_constant,constant) */

	assert(sizeof(zend_constant) == sizeof(src->constant));
	xc_dprint_indent(indent);fprintf(stderr, "zend_constant:constant ");
	
	
	/* STRUCT_P_EX(zend_constant,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zend_constant) == sizeof((& src->constant)[0]));
	

	

	xc_dprint_zend_constant(
		           & src->constant, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif




		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_constinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_dprint_xc_op_array_info_detail_t */
	
 	  	 	static void inline 	xc_dprint_xc_op_array_info_detail_t( 		const xc_op_array_info_detail_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_detail_t*)NULL)->index) + sizeof(((xc_op_array_info_detail_t*)NULL)->info)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "index","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,index) */

	assert(sizeof(zend_uint) == sizeof(src->index));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:index:\t%u\n", src->index);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "index", sizeof("index"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "index"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "index", sizeof("index"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->index);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,info) */

	assert(sizeof(zend_uint) == sizeof(src->info));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:info:\t%u\n", src->info);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_op_array_info_detail_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_xc_op_array_info_t */
	
 	  	 	static void inline 	xc_dprint_xc_op_array_info_t( 		const xc_op_array_info_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_t*)NULL)->literalinfo_cnt) + sizeof(((xc_op_array_info_t*)NULL)->literalinfos)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "literalinfo_cnt","literalinfos" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
		#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,literalinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->literalinfo_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:literalinfo_cnt:\t%u\n", src->literalinfo_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfo_cnt", sizeof("literalinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfo_cnt", sizeof("literalinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->literalinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->literalinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_detail_t,literalinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_detail_t) == sizeof(src->literalinfos[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_op_array_info_detail_t:literalinfos[i] ");
	
	
	/* STRUCT_P_EX(xc_op_array_info_detail_t,DST(`literalinfos[LOOPCOUNTER]'),SRC(`literalinfos[LOOPCOUNTER]'),literalinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_detail_t) == sizeof((& src->literalinfos[i])[0]));
	

	

	xc_dprint_xc_op_array_info_detail_t(
		           & src->literalinfos[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->literalinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif



	}

#else
		
	/* PROCESS(zend_uint,oplineinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->oplineinfo_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:oplineinfo_cnt:\t%u\n", src->oplineinfo_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfo_cnt", sizeof("oplineinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfo_cnt", sizeof("oplineinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->oplineinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->oplineinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_detail_t,oplineinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_detail_t) == sizeof(src->oplineinfos[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_op_array_info_detail_t:oplineinfos[i] ");
	
	
	/* STRUCT_P_EX(xc_op_array_info_detail_t,DST(`oplineinfos[LOOPCOUNTER]'),SRC(`oplineinfos[LOOPCOUNTER]'),oplineinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_detail_t) == sizeof((& src->oplineinfos[i])[0]));
	

	

	xc_dprint_xc_op_array_info_detail_t(
		           & src->oplineinfos[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->oplineinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_op_array_info_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	

/* {{{ xc_dprint_xc_funcinfo_t */
	
		/* export:  	  	 	void 	xc_dprint_xc_funcinfo_t( 		const xc_funcinfo_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_xc_funcinfo_t( 		const xc_funcinfo_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_funcinfo_t*)NULL)->key) + sizeof(((xc_funcinfo_t*)NULL)->key_size) + sizeof(((xc_funcinfo_t*)NULL)->h) + sizeof(((xc_funcinfo_t*)NULL)->op_array_info) + sizeof(((xc_funcinfo_t*)NULL)->func)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","op_array_info","func" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:key_size:\t%u\n", src->key_size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:type:\t%u\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->key), src->key_size - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->key");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_size - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_size - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:h:\t%lu\n", src->h);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	xc_dprint_indent(indent);fprintf(stderr, "xc_op_array_info_t:op_array_info ");
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	

	xc_dprint_xc_op_array_info_t(
		           & src->op_array_info, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT(zend_function,func) */

	assert(sizeof(zend_function) == sizeof(src->func));
	xc_dprint_indent(indent);fprintf(stderr, "zend_function:func ");
	
	
	/* STRUCT_P_EX(zend_function,DST(`func'),SRC(`func'),func,,&) */

	
	

	
	assert(sizeof(zend_function) == sizeof((& src->func)[0]));
	

	

	xc_dprint_zend_function(
		           & src->func, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "func", sizeof("func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "func", sizeof("func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->func);
	xc_autocheck_done_count ++;

#endif




		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_funcinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_xc_classinfo_t */
	
		/* export:  	  	 	void 	xc_dprint_xc_classinfo_t( 		const xc_classinfo_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_xc_classinfo_t( 		const xc_classinfo_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_classinfo_t*)NULL)->key) + sizeof(((xc_classinfo_t*)NULL)->key_size) + sizeof(((xc_classinfo_t*)NULL)->h) + sizeof(((xc_classinfo_t*)NULL)->methodinfo_cnt) + sizeof(((xc_classinfo_t*)NULL)->methodinfos) + sizeof(((xc_classinfo_t*)NULL)->cest)  ), assert_count = 6;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","methodinfo_cnt","methodinfos","cest" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:key_size:\t%u\n", src->key_size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:type:\t%u\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->key), src->key_size - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->key");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_size - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_size - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_size - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:h:\t%lu\n", src->h);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,methodinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->methodinfo_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:methodinfo_cnt:\t%u\n", src->methodinfo_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfo_cnt", sizeof("methodinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfo_cnt", sizeof("methodinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->methodinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->methodinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_op_array_info_t,methodinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->methodinfos[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_op_array_info_t:methodinfos[i] ");
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`methodinfos[LOOPCOUNTER]'),SRC(`methodinfos[LOOPCOUNTER]'),methodinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->methodinfos[i])[0]));
	

	

	xc_dprint_xc_op_array_info_t(
		           & src->methodinfos[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->methodinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif



	}

	
	
#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT_P(zend_class_entry,cest) */

	if (src->cest) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_class_entry:cest ");
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->cest)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_class_entry(
		            src->cest, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_class_entry:cest:\tNULL\n");
		
	
	
	assert(src->cest == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(zend_class_entry,cest) */

	assert(sizeof(zend_class_entry) == sizeof(src->cest));
	xc_dprint_indent(indent);fprintf(stderr, "zend_class_entry:cest ");
	
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,,&) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof((& src->cest)[0]));
	

	

	xc_dprint_zend_class_entry(
		           & src->cest, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(int,oplineno) */

	assert(sizeof(int) == sizeof(src->oplineno));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:oplineno:\t%d\n", src->oplineno);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineno", sizeof("oplineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "oplineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineno", sizeof("oplineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineno);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_classinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2_1

	
	

/* {{{ xc_dprint_xc_autoglobal_t */
	
 	  	 	static void inline 	xc_dprint_xc_autoglobal_t( 		const xc_autoglobal_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_autoglobal_t*)NULL)->key) + sizeof(((xc_autoglobal_t*)NULL)->key_len) + sizeof(((xc_autoglobal_t*)NULL)->h)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_len","h" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(zend_uint,key_len) */

	assert(sizeof(zend_uint) == sizeof(src->key_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:key_len:\t%u\n", src->key_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_len", sizeof("key_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_len", sizeof("key_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_len);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:type:\t%u\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	/* PROC_ZSTRING_L(type,key,key_len) */
 
	
	/* PROC_ZSTRING_N(type,key,key_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->key), src->key_len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->key");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->key");
			xc_dprint_str_len(ZSTR_S(src->key), src->key_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->key_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "ulong:h:\t%lu\n", src->h);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_autoglobal_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


#ifdef XCACHE_ERROR_CACHING

	
	

/* {{{ xc_dprint_xc_compilererror_t */
	
 	  	 	static void inline 	xc_dprint_xc_compilererror_t( 		const xc_compilererror_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_compilererror_t*)NULL)->type) + sizeof(((xc_compilererror_t*)NULL)->lineno) + sizeof(((xc_compilererror_t*)NULL)->error_len) + sizeof(((xc_compilererror_t*)NULL)->error)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","lineno","error_len","error" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
				
	/* PROCESS(int,type) */

	assert(sizeof(int) == sizeof(src->type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:type:\t%d\n", src->type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "uint:lineno:\t%u\n", src->lineno);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,error_len) */

	assert(sizeof(int) == sizeof(src->error_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:error_len:\t%d\n", src->error_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error_len", sizeof("error_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error_len", sizeof("error_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(error,error_len) */
 
	/* PROC_STRING_N(error,error_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error", sizeof("error"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error", sizeof("error"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->error == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->error");
			xc_dprint_str_len(src->error, src->error_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->error_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_compilererror_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_dprint_xc_entry_data_php_t */
	
		/* export:  	  	 	void 	xc_dprint_xc_entry_data_php_t( 		const xc_entry_data_php_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_xc_entry_data_php_t( 		const xc_entry_data_php_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_data_php_t*)NULL)->next) + sizeof(((xc_entry_data_php_t*)NULL)->hvalue) + sizeof(((xc_entry_data_php_t*)NULL)->md5) + sizeof(((xc_entry_data_php_t*)NULL)->refcount) + sizeof(((xc_entry_data_php_t*)NULL)->hits) + sizeof(((xc_entry_data_php_t*)NULL)->size) + sizeof(((xc_entry_data_php_t*)NULL)->op_array_info) + sizeof(((xc_entry_data_php_t*)NULL)->op_array) + sizeof(((xc_entry_data_php_t*)NULL)->constinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->constinfos) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfos) + sizeof(((xc_entry_data_php_t*)NULL)->classinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->classinfos) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobal_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobals) + sizeof(((xc_entry_data_php_t*)NULL)->compilererror_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->compilererrors) + sizeof(((xc_entry_data_php_t*)NULL)->have_references)  ), assert_count = 19;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","hvalue","md5","refcount","hits","size","op_array_info","op_array","constinfo_cnt","constinfos","funcinfo_cnt","funcinfos","classinfo_cnt","classinfos","autoglobal_cnt","autoglobals","compilererror_cnt","compilererrors","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			

	/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(xc_hash_value_t,hvalue) */

	assert(sizeof(xc_hash_value_t) == sizeof(src->hvalue));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "xc_hash_value_t:hvalue:\t%lu\n", src->hvalue);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hvalue", sizeof("hvalue"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hvalue"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hvalue", sizeof("hvalue"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hvalue);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(xc_md5sum_t,md5) */

	assert(sizeof(xc_md5sum_t) == sizeof(src->md5));
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "md5", sizeof("md5"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "md5"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "md5", sizeof("md5"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->md5);
	xc_autocheck_done_count ++;

#endif


	

		
	/* PROCESS(zend_ulong,refcount) */

	assert(sizeof(zend_ulong) == sizeof(src->refcount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ulong:refcount:\t%lu\n", src->refcount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ulong:hits:\t%lu\n", src->hits);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:size:\t%lu\n", src->size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	xc_dprint_indent(indent);fprintf(stderr, "xc_op_array_info_t:op_array_info ");
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	

	xc_dprint_xc_op_array_info_t(
		           & src->op_array_info, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT_P(zend_op_array,op_array) */

	if (src->op_array) {
		xc_dprint_indent(indent);fprintf(stderr, "zend_op_array:op_array ");
		
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof(( src->op_array)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_zend_op_array(
		            src->op_array, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "zend_op_array:op_array:\tNULL\n");
		
	
	
	assert(src->op_array == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array", sizeof("op_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array", sizeof("op_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array);
	xc_autocheck_done_count ++;

#endif




#ifdef HAVE_XCACHE_CONSTANT
		
	/* PROCESS(zend_uint,constinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->constinfo_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:constinfo_cnt:\t%u\n", src->constinfo_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfo_cnt", sizeof("constinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfo_cnt", sizeof("constinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->constinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->constinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_constinfo_t,constinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_constinfo_t) == sizeof(src->constinfos[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_constinfo_t:constinfos[i] ");
	
	
	/* STRUCT_P_EX(xc_constinfo_t,DST(`constinfos[LOOPCOUNTER]'),SRC(`constinfos[LOOPCOUNTER]'),constinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_constinfo_t) == sizeof((& src->constinfos[i])[0]));
	

	

	xc_dprint_xc_constinfo_t(
		           & src->constinfos[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->constinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
	/* PROCESS(zend_uint,funcinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->funcinfo_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:funcinfo_cnt:\t%u\n", src->funcinfo_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfo_cnt", sizeof("funcinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfo_cnt", sizeof("funcinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->funcinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->funcinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_funcinfo_t,funcinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_funcinfo_t) == sizeof(src->funcinfos[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_funcinfo_t:funcinfos[i] ");
	
	
	/* STRUCT_P_EX(xc_funcinfo_t,DST(`funcinfos[LOOPCOUNTER]'),SRC(`funcinfos[LOOPCOUNTER]'),funcinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_funcinfo_t) == sizeof((& src->funcinfos[i])[0]));
	

	

	xc_dprint_xc_funcinfo_t(
		           & src->funcinfos[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->funcinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif



	}


		
	/* PROCESS(zend_uint,classinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->classinfo_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:classinfo_cnt:\t%u\n", src->classinfo_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfo_cnt", sizeof("classinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfo_cnt", sizeof("classinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->classinfos) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->classinfo_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_classinfo_t,classinfos[LOOPCOUNTER],) */

	assert(sizeof(xc_classinfo_t) == sizeof(src->classinfos[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_classinfo_t:classinfos[i] ");
	
	
	/* STRUCT_P_EX(xc_classinfo_t,DST(`classinfos[LOOPCOUNTER]'),SRC(`classinfos[LOOPCOUNTER]'),classinfos[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_classinfo_t) == sizeof((& src->classinfos[i])[0]));
	

	

	xc_dprint_xc_classinfo_t(
		           & src->classinfos[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->classinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif



	}

#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(zend_uint,autoglobal_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->autoglobal_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:autoglobal_cnt:\t%u\n", src->autoglobal_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobal_cnt", sizeof("autoglobal_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobal_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobal_cnt", sizeof("autoglobal_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobal_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->autoglobals) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->autoglobal_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_autoglobal_t,autoglobals[LOOPCOUNTER],) */

	assert(sizeof(xc_autoglobal_t) == sizeof(src->autoglobals[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_autoglobal_t:autoglobals[i] ");
	
	
	/* STRUCT_P_EX(xc_autoglobal_t,DST(`autoglobals[LOOPCOUNTER]'),SRC(`autoglobals[LOOPCOUNTER]'),autoglobals[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_autoglobal_t) == sizeof((& src->autoglobals[i])[0]));
	

	

	xc_dprint_xc_autoglobal_t(
		           & src->autoglobals[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->autoglobals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifdef XCACHE_ERROR_CACHING
		
	/* PROCESS(zend_uint,compilererror_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->compilererror_cnt));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uint:compilererror_cnt:\t%u\n", src->compilererror_cnt);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererror_cnt", sizeof("compilererror_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererror_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererror_cnt", sizeof("compilererror_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererror_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->compilererrors) {
		zend_uint i; 
		
	

		
						
			
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

			

			for (i = 0;
					i < src->compilererror_cnt;
					++i) {
				
	
	

					
	
	/* STRUCT(xc_compilererror_t,compilererrors[LOOPCOUNTER],) */

	assert(sizeof(xc_compilererror_t) == sizeof(src->compilererrors[i]));
	xc_dprint_indent(indent);fprintf(stderr, "xc_compilererror_t:compilererrors[i] ");
	
	
	/* STRUCT_P_EX(xc_compilererror_t,DST(`compilererrors[LOOPCOUNTER]'),SRC(`compilererrors[LOOPCOUNTER]'),compilererrors[LOOPCOUNTER],,&) */

	
	

	
	assert(sizeof(xc_compilererror_t) == sizeof((& src->compilererrors[i])[0]));
	

	

	xc_dprint_xc_compilererror_t(
		           & src->compilererrors[i], indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	

				
	
	

			}
						
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	
	
	assert(src->compilererrors == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_bool,have_early_binding) */

	assert(sizeof(zend_bool) == sizeof(src->have_early_binding));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:have_early_binding:\t%u\n", src->have_early_binding);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_early_binding", sizeof("have_early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_early_binding", sizeof("have_early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_early_binding);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:have_references:\t%u\n", src->have_references);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	


		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_entry_data_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_xc_entry_t */
	
 	  	 	static void inline 	xc_dprint_xc_entry_t( 		const xc_entry_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_t*)NULL)->next) + sizeof(((xc_entry_t*)NULL)->size) + sizeof(((xc_entry_t*)NULL)->ctime) + sizeof(((xc_entry_t*)NULL)->atime) + sizeof(((xc_entry_t*)NULL)->dtime) + sizeof(((xc_entry_t*)NULL)->hits) + sizeof(((xc_entry_t*)NULL)->ttl) + sizeof(((xc_entry_t*)NULL)->name)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","size","ctime","atime","dtime","hits","ttl","name" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:size:\t%lu\n", src->size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(time_t,ctime) */

	assert(sizeof(time_t) == sizeof(src->ctime));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "time_t:ctime:\t%ld\n", src->ctime);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ctime", sizeof("ctime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ctime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ctime", sizeof("ctime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ctime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,atime) */

	assert(sizeof(time_t) == sizeof(src->atime));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "time_t:atime:\t%ld\n", src->atime);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "atime", sizeof("atime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "atime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "atime", sizeof("atime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->atime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,dtime) */

	assert(sizeof(time_t) == sizeof(src->dtime));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "time_t:dtime:\t%ld\n", src->dtime);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dtime", sizeof("dtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "dtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dtime", sizeof("dtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(long,ttl) */

	assert(sizeof(long) == sizeof(src->ttl));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "long:ttl:\t%ld\n", src->ttl);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ttl", sizeof("ttl"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ttl"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ttl", sizeof("ttl"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ttl);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_ulong:hits:\t%lu\n", src->hits);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif

 
		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_entry_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_xc_entry_php_t */
	
		/* export:  	  	 	void 	xc_dprint_xc_entry_php_t( 		const xc_entry_php_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_xc_entry_php_t( 		const xc_entry_php_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_php_t*)NULL)->entry) + sizeof(((xc_entry_php_t*)NULL)->php) + sizeof(((xc_entry_php_t*)NULL)->refcount) + sizeof(((xc_entry_php_t*)NULL)->file_mtime) + sizeof(((xc_entry_php_t*)NULL)->file_size) + sizeof(((xc_entry_php_t*)NULL)->file_device) + sizeof(((xc_entry_php_t*)NULL)->file_inode) + sizeof(((xc_entry_php_t*)NULL)->filepath_len) + sizeof(((xc_entry_php_t*)NULL)->filepath) + sizeof(((xc_entry_php_t*)NULL)->dirpath_len) + sizeof(((xc_entry_php_t*)NULL)->dirpath)  ), assert_count = 11;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","php","refcount","file_mtime","file_size","file_device","file_inode","filepath_len","filepath","dirpath_len","dirpath" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	xc_dprint_indent(indent);fprintf(stderr, "xc_entry_t:entry ");
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_dprint_xc_entry_t(
		           & src->entry, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif



	
	
	

			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:entry.name.str.len:\t%d\n", src->entry.name.str.len);
	
	
	

	

		
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->entry.name.str.val");
			xc_dprint_str_len(src->entry.name.str.val, src->entry.name.str.len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->entry.name.str.len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		
	
	
	


	
	
	/* STRUCT_P(xc_entry_data_php_t,php) */

	if (src->php) {
		xc_dprint_indent(indent);fprintf(stderr, "xc_entry_data_php_t:php ");
		
	
	/* STRUCT_P_EX(xc_entry_data_php_t,DST(`php'),SRC(`php'),php,) */

	
	

	
	assert(sizeof(xc_entry_data_php_t) == sizeof(( src->php)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	

	xc_dprint_xc_entry_data_php_t(
		            src->php, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	}
	else {
		xc_dprint_indent(indent);fprintf(stderr, "xc_entry_data_php_t:php:\tNULL\n");
		
	
	
	assert(src->php == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "php", sizeof("php"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "php"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "php", sizeof("php"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->php);
	xc_autocheck_done_count ++;

#endif




		
	/* PROCESS(long,refcount) */

	assert(sizeof(long) == sizeof(src->refcount));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "long:refcount:\t%ld\n", src->refcount);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,file_mtime) */

	assert(sizeof(time_t) == sizeof(src->file_mtime));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "time_t:file_mtime:\t%ld\n", src->file_mtime);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_mtime", sizeof("file_mtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_mtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_mtime", sizeof("file_mtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_mtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_size) */

	assert(sizeof(size_t) == sizeof(src->file_size));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:file_size:\t%lu\n", src->file_size);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_size", sizeof("file_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_size", sizeof("file_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_size);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_device) */

	assert(sizeof(size_t) == sizeof(src->file_device));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:file_device:\t%lu\n", src->file_device);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_device", sizeof("file_device"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_device"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_device", sizeof("file_device"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_device);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_inode) */

	assert(sizeof(size_t) == sizeof(src->file_inode));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:file_inode:\t%lu\n", src->file_inode);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_inode", sizeof("file_inode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_inode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_inode", sizeof("file_inode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_inode);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(size_t,filepath_len) */

	assert(sizeof(size_t) == sizeof(src->filepath_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:filepath_len:\t%lu\n", src->filepath_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath_len", sizeof("filepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath_len", sizeof("filepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(filepath,filepath_len) */
 
	/* PROC_STRING_N(filepath,filepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath", sizeof("filepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath", sizeof("filepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filepath == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->filepath");
			xc_dprint_str_len(src->filepath, src->filepath_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->filepath_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(size_t,dirpath_len) */

	assert(sizeof(size_t) == sizeof(src->dirpath_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "size_t:dirpath_len:\t%lu\n", src->dirpath_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath_len", sizeof("dirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath_len", sizeof("dirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(dirpath,dirpath_len) */
 
	/* PROC_STRING_N(dirpath,dirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath", sizeof("dirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath", sizeof("dirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->dirpath == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->dirpath");
			xc_dprint_str_len(src->dirpath, src->dirpath_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->dirpath_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
		
	/* PROCESS(int,ufilepath_len) */

	assert(sizeof(int) == sizeof(src->ufilepath_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:ufilepath_len:\t%d\n", src->ufilepath_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath_len", sizeof("ufilepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath_len", sizeof("ufilepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(ufilepath,ufilepath_len) */
 
	/* PROC_USTRING_N(ufilepath,ufilepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath", sizeof("ufilepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath", sizeof("ufilepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->ufilepath == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->ufilepath");
			xc_dprint_str_len(src->ufilepath, src->ufilepath_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->ufilepath_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(int,udirpath_len) */

	assert(sizeof(int) == sizeof(src->udirpath_len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:udirpath_len:\t%d\n", src->udirpath_len);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath_len", sizeof("udirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath_len", sizeof("udirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(udirpath,udirpath_len) */
 
	/* PROC_USTRING_N(udirpath,udirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath", sizeof("udirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath", sizeof("udirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->udirpath == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->udirpath");
			xc_dprint_str_len(src->udirpath, src->udirpath_len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->udirpath_len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif

		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_entry_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dprint_xc_entry_var_t */
	
		/* export:  	  	 	void 	xc_dprint_xc_entry_var_t( 		const xc_entry_var_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dprint_xc_entry_var_t( 		const xc_entry_var_t * const src, int indent 		 		 		 		 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_var_t*)NULL)->entry) + sizeof(((xc_entry_var_t*)NULL)->value) + sizeof(((xc_entry_var_t*)NULL)->have_references)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","value","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			fprintf(stderr, "%s", "{\n");
			indent ++;
			{
		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	xc_dprint_indent(indent);fprintf(stderr, "xc_entry_t:entry ");
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	

	xc_dprint_xc_entry_t(
		           & src->entry, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif




#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,name_type) */

	assert(sizeof(zend_uchar) == sizeof(src->name_type));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_uchar:name_type:\t%u\n", src->name_type);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_type", sizeof("name_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "name_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_type", sizeof("name_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	
	

#ifdef IS_UNICODE
		if (src->name_type == IS_UNICODE) {
				
	/* PROCESS(int32_t,entry.name.ustr.len) */

	assert(sizeof(int32_t) == sizeof(src->entry.name.ustr.len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int32_t:entry.name.ustr.len:\t%d\n", src->entry.name.ustr.len);
	
	
	

	

		}
		else {
				
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:entry.name.str.len:\t%d\n", src->entry.name.str.len);
	
	
	

	

		}
#else
			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "int:entry.name.str.len:\t%d\n", src->entry.name.str.len);
	
	
	

	

#endif
		
#ifdef IS_UNICODE
			
	/* PROC_ZSTRING_L(name_type,entry.name.uni.val,entry.name.uni.len) */
 
	
	/* PROC_ZSTRING_N(name_type,entry.name.uni.val,entry.name.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
		if (src->name_type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
#ifdef IS_UNICODE
			do {
				zval zv;
				zval reszv;
				int usecopy;

				INIT_ZVAL(zv);
				ZVAL_UNICODEL(&zv, ZSTR_U(src->entry.name.uni.val), src->entry.name.uni.len + 1 - 1, 1);
				zend_make_printable_zval(&zv, &reszv, &usecopy);
				fprintf(stderr, "string:%s:\t\"", "dst->entry.name.uni.val");
				xc_dprint_str_len(Z_STRVAL(reszv), Z_STRLEN(reszv));
				fprintf(stderr, "\" len=%lu\n", (unsigned long) src->entry.name.uni.len + 1 - 1);
				if (usecopy) {
					zval_dtor(&reszv);
				}
				zval_dtor(&zv);
			} while (0);
#endif
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->entry.name.uni.val");
			xc_dprint_str_len(ZSTR_S(src->entry.name.uni.val), src->entry.name.uni.len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->entry.name.uni.len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->entry.name.uni.val");
			xc_dprint_str_len(ZSTR_S(src->entry.name.uni.val), src->entry.name.uni.len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->entry.name.uni.len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
	

#else
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
	}
	else {
		xc_dprint_indent(indent);
			
			fprintf(stderr, "string:%s:\t\"", "dst->entry.name.str.val");
			xc_dprint_str_len(src->entry.name.str.val, src->entry.name.str.len + 1 - 1);
			fprintf(stderr, "\" len=%lu\n", (unsigned long) src->entry.name.str.len + 1 - 1);
			
		
		
		
		
		
		
	}
	
	
	
	
	
	
	

#endif
		
	
	
	

	
	xc_dprint_indent(indent);fprintf(stderr, "zval:value");
	
	
	/* STRUCT_P_EX(zval_ptr,dst->value,src->value,value,,&) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((& src->value)[0]));
	

	

	xc_dprint_zval_ptr(
		           & src->value, indent
		
		
		
		
		TSRMLS_CC
	);

	

	
	

		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
		xc_dprint_indent(indent);
		fprintf(stderr, "zend_bool:have_references:\t%u\n", src->have_references);
	
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dprint_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
			}
			indent --;
			xc_dprint_indent(indent);fprintf(stderr, "}\n");
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dprint_xc_entry_var_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dprint_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dprint_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif /* HAVE_XCACHE_DPRINT */
#ifdef HAVE_XCACHE_DISASSEMBLER
  /* {{{ Pre-declare */
 	  	 	void 	xc_dasm_zval( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval * const src 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_dasm_zval_ptr( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval_ptr * const src 		TSRMLS_DC 	); 	
 	  	 	static void inline 	xc_dasm_zval_ptr_nullable( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval_ptr_nullable * const src 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dasm_zend_op_array( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_op_array * const src 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dasm_zend_class_entry( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_class_entry * const src 		TSRMLS_DC 	); 	
#ifdef HAVE_XCACHE_CONSTANT
 	  	 	static void inline 	xc_dasm_zend_constant( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_constant * const src 		TSRMLS_DC 	); 	
#endif
 	  	 	void 	xc_dasm_zend_function( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_function * const src 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dasm_xc_entry_var_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_var_t * const src 		TSRMLS_DC 	); 	
 	  	 	void 	xc_dasm_xc_entry_php_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_php_t * const src 		TSRMLS_DC 	); 	
#ifdef ZEND_ENGINE_2
 	  	 	static void inline 	xc_dasm_zend_property_info( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_property_info * const src 		TSRMLS_DC 	); 	
#endif
/* }}} */
#ifdef IS_CV

	
	

/* {{{ xc_dasm_zend_compiled_variable */
	
 	  	 	static void inline 	xc_dasm_zend_compiled_variable( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_compiled_variable * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_compiled_variable*)NULL)->name) + sizeof(((zend_compiled_variable*)NULL)->name_len) + sizeof(((zend_compiled_variable*)NULL)->hash_value)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","hash_value" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(int,name_len) */

	assert(sizeof(int) == sizeof(src->name_len));
		
	
	
		add_assoc_long_ex(dst, ("name_len"), (sizeof("name_len")), src->name_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("name"), (sizeof("name")), ZSTR_U(src->name), src->name_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,hash_value) */

	assert(sizeof(ulong) == sizeof(src->hash_value));
		
	
	
		add_assoc_long_ex(dst, ("hash_value"), (sizeof("hash_value")), src->hash_value);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_compiled_variable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_compiled_variable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zend_uint */
	
 	  	 	static void inline 	xc_dasm_zend_uint( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_uint * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_uint), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_uint", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_uint : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifndef ZEND_ENGINE_2

	
	

/* {{{ xc_dasm_int */
	
 	  	 	static void inline 	xc_dasm_int( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const int * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(int), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_int", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_int : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_dasm_zend_try_catch_element */
	
 	  	 	static void inline 	xc_dasm_zend_try_catch_element( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_try_catch_element * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_try_catch_element*)NULL)->try_op) + sizeof(((zend_try_catch_element*)NULL)->catch_op) + sizeof(((zend_try_catch_element*)NULL)->finally_op) + sizeof(((zend_try_catch_element*)NULL)->finally_end)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "try_op","catch_op","finally_op","finally_end" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,try_op) */

	assert(sizeof(zend_uint) == sizeof(src->try_op));
		
	
	
		add_assoc_long_ex(dst, ("try_op"), (sizeof("try_op")), src->try_op);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_op", sizeof("try_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_op", sizeof("try_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,catch_op) */

	assert(sizeof(zend_uint) == sizeof(src->catch_op));
		
	
	
		add_assoc_long_ex(dst, ("catch_op"), (sizeof("catch_op")), src->catch_op);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "catch_op", sizeof("catch_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "catch_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "catch_op", sizeof("catch_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->catch_op);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,finally_op) */

	assert(sizeof(zend_uint) == sizeof(src->finally_op));
		
	
	
		add_assoc_long_ex(dst, ("finally_op"), (sizeof("finally_op")), src->finally_op);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_op", sizeof("finally_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_op", sizeof("finally_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_op);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,finally_end) */

	assert(sizeof(zend_uint) == sizeof(src->finally_end));
		
	
	
		add_assoc_long_ex(dst, ("finally_end"), (sizeof("finally_end")), src->finally_end);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "finally_end", sizeof("finally_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "finally_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "finally_end", sizeof("finally_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->finally_end);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_try_catch_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_try_catch_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zend_brk_cont_element */
	
 	  	 	static void inline 	xc_dasm_zend_brk_cont_element( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_brk_cont_element * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_brk_cont_element*)NULL)->start) + sizeof(((zend_brk_cont_element*)NULL)->cont) + sizeof(((zend_brk_cont_element*)NULL)->brk) + sizeof(((zend_brk_cont_element*)NULL)->parent)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "start","cont","brk","parent" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
		#ifdef ZEND_ENGINE_2_2
		
	/* PROCESS(int,start) */

	assert(sizeof(int) == sizeof(src->start));
		
	
	
		add_assoc_long_ex(dst, ("start"), (sizeof("start")), src->start);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start", sizeof("start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start", sizeof("start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(int,cont) */

	assert(sizeof(int) == sizeof(src->cont));
		
	
	
		add_assoc_long_ex(dst, ("cont"), (sizeof("cont")), src->cont);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cont", sizeof("cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cont", sizeof("cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cont);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,brk) */

	assert(sizeof(int) == sizeof(src->brk));
		
	
	
		add_assoc_long_ex(dst, ("brk"), (sizeof("brk")), src->brk);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk", sizeof("brk"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk", sizeof("brk"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,parent) */

	assert(sizeof(int) == sizeof(src->parent));
		
	
	
		add_assoc_long_ex(dst, ("parent"), (sizeof("parent")), src->parent);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_brk_cont_element", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_brk_cont_element : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	
	

/* {{{ xc_dasm_HashTable_zval_ptr */
	
 	  	 	static void inline 	xc_dasm_HashTable_zval_ptr( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const HashTable * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
		
		
	

				
			const Bucket *srcBucket;
			zval *zv;
			int bufsize = 2;
			char *buf = emalloc(bufsize);
			int keysize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif


#endif
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif


#if ZEND_DEBUG
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif


#endif
#ifdef IS_UNICODE
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif


#endif

			
	
	

			for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zval_ptr (dasm, zv, ((zval_ptr*)srcBucket->pData) TSRMLS_CC);
				keysize = BUCKET_KEY_SIZE(srcBucket) + 2;
				if (keysize > bufsize) {
					do {
						bufsize *= 2;
					} while (keysize > bufsize);
					buf = erealloc(buf, bufsize);
				}
				memcpy(buf, BUCKET_KEY_S(srcBucket), keysize);
				buf[keysize - 2] = buf[keysize - 1] = ""[0];
				keysize = srcBucket->nKeyLength;
#ifdef IS_UNICODE
				if (BUCKET_KEY_TYPE(srcBucket) == IS_UNICODE) {
					if (buf[0] == ""[0] && buf[1] == ""[0]) {
						keysize ++;
					}
				} else
#endif
				{
					if (buf[0] == ""[0]) {
						keysize ++;
					}
				}
				add_u_assoc_zval_ex(dst, BUCKET_KEY_TYPE(srcBucket), ZSTR(buf), keysize, zv);
			}
			
	
	


			efree(buf);
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_HashTable_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_HashTable_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	
	

/* {{{ xc_dasm_HashTable_zend_function */
	
		/* export:  	  	 	void 	xc_dasm_HashTable_zend_function( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const HashTable * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_HashTable_zend_function( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const HashTable * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
		
		
	

				
			const Bucket *srcBucket;
			zval *zv;
			int bufsize = 2;
			char *buf = emalloc(bufsize);
			int keysize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif


#endif
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif


#if ZEND_DEBUG
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif


#endif
#ifdef IS_UNICODE
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_function : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif


#endif

			
	
	

			for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_function (dasm, zv, ((zend_function*)srcBucket->pData) TSRMLS_CC);
				keysize = BUCKET_KEY_SIZE(srcBucket) + 2;
				if (keysize > bufsize) {
					do {
						bufsize *= 2;
					} while (keysize > bufsize);
					buf = erealloc(buf, bufsize);
				}
				memcpy(buf, BUCKET_KEY_S(srcBucket), keysize);
				buf[keysize - 2] = buf[keysize - 1] = ""[0];
				keysize = srcBucket->nKeyLength;
#ifdef IS_UNICODE
				if (BUCKET_KEY_TYPE(srcBucket) == IS_UNICODE) {
					if (buf[0] == ""[0] && buf[1] == ""[0]) {
						keysize ++;
					}
				} else
#endif
				{
					if (buf[0] == ""[0]) {
						keysize ++;
					}
				}
				add_u_assoc_zval_ex(dst, BUCKET_KEY_TYPE(srcBucket), ZSTR(buf), keysize, zv);
			}
			
	
	


			efree(buf);
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_HashTable_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_HashTable_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2

	
	
	

/* {{{ xc_dasm_HashTable_zend_property_info */
	
 	  	 	static void inline 	xc_dasm_HashTable_zend_property_info( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const HashTable * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((HashTable*)NULL)->nTableSize) + sizeof(((HashTable*)NULL)->nTableMask) + sizeof(((HashTable*)NULL)->nNumOfElements) + sizeof(((HashTable*)NULL)->nNextFreeElement) + sizeof(((HashTable*)NULL)->pInternalPointer) + sizeof(((HashTable*)NULL)->pListHead) + sizeof(((HashTable*)NULL)->pListTail) + sizeof(((HashTable*)NULL)->arBuckets) + sizeof(((HashTable*)NULL)->pDestructor) + sizeof(((HashTable*)NULL)->persistent) + sizeof(((HashTable*)NULL)->nApplyCount) + sizeof(((HashTable*)NULL)->bApplyProtection)  ), assert_count = 12;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "nTableSize","nTableMask","nNumOfElements","nNextFreeElement","pInternalPointer","pListHead","pListTail","arBuckets","pDestructor","persistent","nApplyCount","bApplyProtection" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
		
		
	

				
			const Bucket *srcBucket;
			zval *zv;
			int bufsize = 2;
			char *buf = emalloc(bufsize);
			int keysize;

#if defined(HARDENING_PATCH_HASH_PROTECT) && HARDENING_PATCH_HASH_PROTECT
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "canary", sizeof("canary"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "canary"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "canary", sizeof("canary"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->canary);
	xc_autocheck_done_count ++;

#endif


#endif
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableSize", sizeof("nTableSize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableSize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableSize", sizeof("nTableSize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableSize);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nTableMask", sizeof("nTableMask"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nTableMask"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nTableMask", sizeof("nTableMask"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nTableMask);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNumOfElements", sizeof("nNumOfElements"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNumOfElements"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNumOfElements", sizeof("nNumOfElements"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNumOfElements);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nNextFreeElement", sizeof("nNextFreeElement"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nNextFreeElement"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nNextFreeElement", sizeof("nNextFreeElement"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nNextFreeElement);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pInternalPointer", sizeof("pInternalPointer"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pInternalPointer"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pInternalPointer", sizeof("pInternalPointer"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pInternalPointer);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListHead", sizeof("pListHead"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListHead"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListHead", sizeof("pListHead"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListHead);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pListTail", sizeof("pListTail"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pListTail"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pListTail", sizeof("pListTail"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pListTail);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arBuckets", sizeof("arBuckets"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "arBuckets"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arBuckets", sizeof("arBuckets"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arBuckets);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pDestructor", sizeof("pDestructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "pDestructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pDestructor", sizeof("pDestructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pDestructor);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "persistent", sizeof("persistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "persistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "persistent", sizeof("persistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->persistent);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nApplyCount", sizeof("nApplyCount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "nApplyCount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nApplyCount", sizeof("nApplyCount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nApplyCount);
	xc_autocheck_done_count ++;

#endif


			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "bApplyProtection", sizeof("bApplyProtection"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "bApplyProtection"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "bApplyProtection", sizeof("bApplyProtection"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->bApplyProtection);
	xc_autocheck_done_count ++;

#endif


#if ZEND_DEBUG
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "inconsistent", sizeof("inconsistent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "inconsistent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "inconsistent", sizeof("inconsistent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->inconsistent);
	xc_autocheck_done_count ++;

#endif


#endif
#ifdef IS_UNICODE
			
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unicode", sizeof("unicode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "unicode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unicode", sizeof("unicode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unicode);
	xc_autocheck_done_count ++;

#endif


#endif

			
	
	

			for (srcBucket = src->pListHead; srcBucket != NULL; srcBucket = srcBucket->pListNext) {
				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_property_info (dasm, zv, ((zend_property_info*)srcBucket->pData) TSRMLS_CC);
				keysize = BUCKET_KEY_SIZE(srcBucket) + 2;
				if (keysize > bufsize) {
					do {
						bufsize *= 2;
					} while (keysize > bufsize);
					buf = erealloc(buf, bufsize);
				}
				memcpy(buf, BUCKET_KEY_S(srcBucket), keysize);
				buf[keysize - 2] = buf[keysize - 1] = ""[0];
				keysize = srcBucket->nKeyLength;
#ifdef IS_UNICODE
				if (BUCKET_KEY_TYPE(srcBucket) == IS_UNICODE) {
					if (buf[0] == ""[0] && buf[1] == ""[0]) {
						keysize ++;
					}
				} else
#endif
				{
					if (buf[0] == ""[0]) {
						keysize ++;
					}
				}
				add_u_assoc_zval_ex(dst, BUCKET_KEY_TYPE(srcBucket), ZSTR(buf), keysize, zv);
			}
			
	
	


			efree(buf);
				
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_HashTable_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_HashTable_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif
#ifdef IS_CONSTANT_AST


	
	

/* {{{ xc_dasm_zend_ast */
	
		/* export:  	  	 	void 	xc_dasm_zend_ast( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_ast * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_zend_ast( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_ast * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_ast*)NULL)->kind) + sizeof(((zend_ast*)NULL)->children) + sizeof(((zend_ast*)NULL)->u)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "kind","children","u" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				zend_ushort i;
			
	/* PROCESS(zend_ushort,kind) */

	assert(sizeof(zend_ushort) == sizeof(src->kind));
		
	
	
		add_assoc_long_ex(dst, ("kind"), (sizeof("kind")), src->kind);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "kind", sizeof("kind"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "kind"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "kind", sizeof("kind"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->kind);
	xc_autocheck_done_count ++;

#endif



	

			
	/* PROCESS(zend_ushort,children) */

	assert(sizeof(zend_ushort) == sizeof(src->children));
		
	
	
		add_assoc_long_ex(dst, ("children"), (sizeof("children")), src->children);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "children", sizeof("children"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "children"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "children", sizeof("children"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->children);
	xc_autocheck_done_count ++;

#endif



	

		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_ast : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


		
	
	

			if (src->kind == ZEND_CONST) {
				assert(src->u.val);
				
				
	
	/* STRUCT_P_EX(zval,dst->u.val,src->u.val,[],, ) */

	
	

	
	assert(sizeof(zval) == sizeof((  src->u.val)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zval(
		
		
		
		
		dasm, zv,   src->u.val
		TSRMLS_CC
	);

	
		
			add_next_index_zval(dst, zv);
		
	} while (0);
	

	
	

				
			}
			else {
				for (i = 0; i < src->children; ++i) {
					zend_ast *src_ast = (&src->u.child)[i];
					if (src_ast) {
						{
	

	
	
							
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

							
	
	/* STRUCT_P_EX(zend_ast,(&dst->u.child)[i],src_ast,[],, ) */

	
	

	
	assert(sizeof(zend_ast) == sizeof((  src_ast)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_ast(
		
		
		
		
		dasm, zv,   src_ast
		TSRMLS_CC
	);

	
		
			add_next_index_zval(dst, zv);
		
	} while (0);
	

	
	

						
	
}

						
					}
					else {
						
					}
				}
			}
		
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_ast", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_ast : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zval */
	
		/* export:  	  	 	void 	xc_dasm_zval( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_zval( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zval*)NULL)->value) + sizeof(((zval*)NULL)->refcount__gc) + sizeof(((zval*)NULL)->type) + sizeof(((zval*)NULL)->is_ref__gc)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","refcount__gc","type","is_ref__gc" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			do {
		zval_dtor(dst);
		*dst = *src;
		zval_copy_ctor(dst);
		Z_SET_REFCOUNT(*dst, 1);
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif


		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif


#ifdef ZEND_ENGINE_2_3
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref__gc", sizeof("is_ref__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref__gc", sizeof("is_ref__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref__gc);
	xc_autocheck_done_count ++;

#endif


		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount__gc", sizeof("refcount__gc"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount__gc"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount__gc", sizeof("refcount__gc"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount__gc);
	xc_autocheck_done_count ++;

#endif


#else
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_ref", sizeof("is_ref"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval : %s\n"
				, __FILE__, __LINE__
				, "is_ref"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_ref", sizeof("is_ref"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_ref);
	xc_autocheck_done_count ++;

#endif


		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif


#endif
	} while(0);
	
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zval", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zval : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_zval_ptr */
	
 	  	 	static void inline 	xc_dasm_zval_ptr( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval_ptr * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
		
	

		xc_dasm_zval (dasm, dst, src[0] TSRMLS_CC);
		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zval_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zval_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_zval_ptr_nullable */
	
 	  	 	static void inline 	xc_dasm_zval_ptr_nullable( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zval_ptr_nullable * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zval_ptr_nullable), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			if (src[0]) {
		
		
	
	/* STRUCT_P_EX(zval_ptr,dst,src,,, ) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((  src)[0]));
	

	xc_dasm_zval_ptr(
		
		
		
		
		dasm, dst,   src
		TSRMLS_CC
	);

	
	

		
	}
	else {
		
	}
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zval_ptr_nullable);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zval_ptr_nullable", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zval_ptr_nullable : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_dasm_zend_arg_info */
	
 	  	 	static void inline 	xc_dasm_zend_arg_info( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_arg_info * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_arg_info*)NULL)->name) + sizeof(((zend_arg_info*)NULL)->name_len) + sizeof(((zend_arg_info*)NULL)->class_name) + sizeof(((zend_arg_info*)NULL)->class_name_len) + sizeof(((zend_arg_info*)NULL)->type_hint) + sizeof(((zend_arg_info*)NULL)->pass_by_reference) + sizeof(((zend_arg_info*)NULL)->allow_null) + sizeof(((zend_arg_info*)NULL)->is_variadic)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "name","name_len","class_name","class_name_len","type_hint","pass_by_reference","allow_null","is_variadic" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,name_len) */

	assert(sizeof(zend_uint) == sizeof(src->name_len));
		
	
	
		add_assoc_long_ex(dst, ("name_len"), (sizeof("name_len")), src->name_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_len) */
 
	
	/* PROC_ZSTRING_N(,name,name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("name"), (sizeof("name")), ZSTR_U(src->name), src->name_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(zend_uint,class_name_len) */

	assert(sizeof(zend_uint) == sizeof(src->class_name_len));
		
	
	
		add_assoc_long_ex(dst, ("class_name_len"), (sizeof("class_name_len")), src->class_name_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name_len", sizeof("class_name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name_len", sizeof("class_name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,class_name,class_name_len) */
 
	
	/* PROC_ZSTRING_N(,class_name,class_name_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->class_name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("class_name"), (sizeof("class_name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("class_name"), (sizeof("class_name")), ZSTR_U(src->class_name), src->class_name_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("class_name"), (sizeof("class_name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("class_name"), (sizeof("class_name")), (char *) ZSTR_S(src->class_name), src->class_name_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->class_name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("class_name"), (sizeof("class_name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("class_name"), (sizeof("class_name")), (char *) ZSTR_S(src->class_name), src->class_name_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,type_hint) */

	assert(sizeof(zend_uchar) == sizeof(src->type_hint));
		
	
	
		add_assoc_long_ex(dst, ("type_hint"), (sizeof("type_hint")), src->type_hint);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type_hint", sizeof("type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type_hint", sizeof("type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type_hint);
	xc_autocheck_done_count ++;

#endif



	

#elif defined(ZEND_ENGINE_2_1)
		
	/* PROCESS(zend_bool,array_type_hint) */

	assert(sizeof(zend_bool) == sizeof(src->array_type_hint));
		
	
	
		add_assoc_bool_ex(dst, ("array_type_hint"), (sizeof("array_type_hint")), src->array_type_hint ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "array_type_hint", sizeof("array_type_hint"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "array_type_hint"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "array_type_hint", sizeof("array_type_hint"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->array_type_hint);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_uchar,pass_by_reference) */

	assert(sizeof(zend_uchar) == sizeof(src->pass_by_reference));
		
	
	
		add_assoc_long_ex(dst, ("pass_by_reference"), (sizeof("pass_by_reference")), src->pass_by_reference);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,allow_null) */

	assert(sizeof(zend_bool) == sizeof(src->allow_null));
		
	
	
		add_assoc_bool_ex(dst, ("allow_null"), (sizeof("allow_null")), src->allow_null ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "allow_null", sizeof("allow_null"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "allow_null"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "allow_null", sizeof("allow_null"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->allow_null);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_6
		
	/* PROCESS(zend_bool,is_variadic) */

	assert(sizeof(zend_bool) == sizeof(src->is_variadic));
		
	
	
		add_assoc_bool_ex(dst, ("is_variadic"), (sizeof("is_variadic")), src->is_variadic ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "is_variadic", sizeof("is_variadic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "is_variadic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "is_variadic", sizeof("is_variadic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->is_variadic);
	xc_autocheck_done_count ++;

#endif



	

#else
		
	/* PROCESS(zend_bool,pass_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_by_reference));
		
	
	
		add_assoc_bool_ex(dst, ("pass_by_reference"), (sizeof("pass_by_reference")), src->pass_by_reference ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_by_reference", sizeof("pass_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "pass_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_by_reference", sizeof("pass_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,return_reference) */

	assert(sizeof(zend_bool) == sizeof(src->return_reference));
		
	
	
		add_assoc_bool_ex(dst, ("return_reference"), (sizeof("return_reference")), src->return_reference ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,required_num_args) */

	assert(sizeof(int) == sizeof(src->required_num_args));
		
	
	
		add_assoc_long_ex(dst, ("required_num_args"), (sizeof("required_num_args")), src->required_num_args);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_arg_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_arg_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_dasm_zend_constant */
	
 	  	 	static void inline 	xc_dasm_zend_constant( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_constant * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_constant*)NULL)->value) + sizeof(((zend_constant*)NULL)->flags) + sizeof(((zend_constant*)NULL)->name) + sizeof(((zend_constant*)NULL)->name_len) + sizeof(((zend_constant*)NULL)->module_number)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "value","flags","name","name_len","module_number" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(zval,value) */

	assert(sizeof(zval) == sizeof(src->value));
	
	
	
	/* STRUCT_P_EX(zval,DST(`value'),SRC(`value'),value,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->value)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zval(
		
		
		
		
		dasm, zv, & src->value
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("value"), (sizeof("value")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(int,flags) */

	assert(sizeof(int) == sizeof(src->flags));
		
	
	
		add_assoc_long_ex(dst, ("flags"), (sizeof("flags")), src->flags);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,name_len) */

	assert(sizeof(uint) == sizeof(src->name_len));
		
	
	
		add_assoc_long_ex(dst, ("name_len"), (sizeof("name_len")), src->name_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_len", sizeof("name_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_len", sizeof("name_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_len);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	/* PROC_ZSTRING_N(,name,name_len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("name"), (sizeof("name")), ZSTR_U(src->name), src->name_len-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_len-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_len-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(int,module_number) */

	assert(sizeof(int) == sizeof(src->module_number));
		
	
	
		add_assoc_long_ex(dst, ("module_number"), (sizeof("module_number")), src->module_number);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module_number", sizeof("module_number"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_constant : %s\n"
				, __FILE__, __LINE__
				, "module_number"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module_number", sizeof("module_number"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module_number);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_constant", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_constant : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zend_function */
	
		/* export:  	  	 	void 	xc_dasm_zend_function( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_function * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_zend_function( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_function * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_function), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	

	switch (src->type) {
	case ZEND_INTERNAL_FUNCTION:
	case ZEND_OVERLOADED_FUNCTION:
		
		break;

	case ZEND_USER_FUNCTION:
	case ZEND_EVAL_CODE:
		
		
	
	/* STRUCT(zend_op_array,op_array) */

	assert(sizeof(zend_op_array) == sizeof(src->op_array));
	
	
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,,&) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof((& src->op_array)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_op_array(
		
		
		
		
		dasm, zv, & src->op_array
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("op_array"), (sizeof("op_array")), zv);
		
	} while (0);
	

	
	

	

		break;

	default:
		assert(0);
	}
	
	
	

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src[0]);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_function", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_function : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2

	
	

/* {{{ xc_dasm_zend_property_info */
	
 	  	 	static void inline 	xc_dasm_zend_property_info( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_property_info * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_property_info*)NULL)->flags) + sizeof(((zend_property_info*)NULL)->name) + sizeof(((zend_property_info*)NULL)->name_length) + sizeof(((zend_property_info*)NULL)->h) + sizeof(((zend_property_info*)NULL)->offset) + sizeof(((zend_property_info*)NULL)->doc_comment) + sizeof(((zend_property_info*)NULL)->doc_comment_len) + sizeof(((zend_property_info*)NULL)->ce)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "flags","name","name_length","h","offset","doc_comment","doc_comment_len","ce" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,flags) */

	assert(sizeof(zend_uint) == sizeof(src->flags));
		
	
	
		add_assoc_long_ex(dst, ("flags"), (sizeof("flags")), src->flags);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "flags", sizeof("flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "flags", sizeof("flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->flags);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,name_length) */

	assert(sizeof(int) == sizeof(src->name_length));
		
	
	
		add_assoc_long_ex(dst, ("name_length"), (sizeof("name_length")), src->name_length);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("name"), (sizeof("name")), ZSTR_U(src->name), src->name_length + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_length + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_length + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
		add_assoc_long_ex(dst, ("h"), (sizeof("h")), src->h);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(int,offset) */

	assert(sizeof(int) == sizeof(src->offset));
		
	
	
		add_assoc_long_ex(dst, ("offset"), (sizeof("offset")), src->offset);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "offset", sizeof("offset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "offset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "offset", sizeof("offset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->offset);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
		add_assoc_long_ex(dst, ("doc_comment_len"), (sizeof("doc_comment_len")), src->doc_comment_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("doc_comment"), (sizeof("doc_comment")), ZSTR_U(src->doc_comment), src->doc_comment_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("doc_comment"), (sizeof("doc_comment")), (char *) ZSTR_S(src->doc_comment), src->doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("doc_comment"), (sizeof("doc_comment")), (char *) ZSTR_S(src->doc_comment), src->doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
	#if defined(ZEND_ENGINE_2_2)
	
	if (src->ce) {
		
		
#ifdef IS_UNICODE
		add_assoc_unicodel_ex(dst, ("ce"), (sizeof("ce")), ZSTR_U(src->ce->name), src->ce->name_length, 1);
#else
		add_assoc_stringl_ex(dst, ("ce"), (sizeof("ce")), (char *) src->ce->name, src->ce->name_length, 1);
#endif
	}
	else {
		
	add_assoc_null_ex(dst, ("ce"), (sizeof("ce")));
	
	assert(src->ce == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_property_info : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif


#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_property_info", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_property_info : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif
#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_dasm_zend_trait_method_reference */
	
 	  	 	static void inline 	xc_dasm_zend_trait_method_reference( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_trait_method_reference * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_method_reference*)NULL)->method_name) + sizeof(((zend_trait_method_reference*)NULL)->mname_len) + sizeof(((zend_trait_method_reference*)NULL)->ce) + sizeof(((zend_trait_method_reference*)NULL)->class_name) + sizeof(((zend_trait_method_reference*)NULL)->cname_len)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "method_name","mname_len","ce","class_name","cname_len" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(unsigned int,mname_len) */

	assert(sizeof(unsigned int) == sizeof(src->mname_len));
		
	
	
		add_assoc_long_ex(dst, ("mname_len"), (sizeof("mname_len")), src->mname_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "mname_len", sizeof("mname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "mname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "mname_len", sizeof("mname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->mname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(method_name,mname_len) */
 
	/* PROC_STRING_N(method_name,mname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "method_name", sizeof("method_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "method_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "method_name", sizeof("method_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->method_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->method_name == NULL) {
		
		
			add_assoc_null_ex(dst, ("method_name"), (sizeof("method_name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("method_name"), (sizeof("method_name")), (char *) src->method_name, src->mname_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

	
	
	add_assoc_null_ex(dst, ("ce"), (sizeof("ce")));
	
	assert(src->ce == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce", sizeof("ce"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "ce"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce", sizeof("ce"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,cname_len) */

	assert(sizeof(unsigned int) == sizeof(src->cname_len));
		
	
	
		add_assoc_long_ex(dst, ("cname_len"), (sizeof("cname_len")), src->cname_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cname_len", sizeof("cname_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "cname_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cname_len", sizeof("cname_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cname_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(class_name,cname_len) */
 
	/* PROC_STRING_N(class_name,cname_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "class_name", sizeof("class_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_method_reference : %s\n"
				, __FILE__, __LINE__
				, "class_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "class_name", sizeof("class_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->class_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->class_name == NULL) {
		
		
			add_assoc_null_ex(dst, ("class_name"), (sizeof("class_name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("class_name"), (sizeof("class_name")), (char *) src->class_name, src->cname_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_trait_method_reference", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_trait_method_reference : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_zend_trait_alias */
	
 	  	 	static void inline 	xc_dasm_zend_trait_alias( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_trait_alias * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_alias*)NULL)->trait_method) + sizeof(((zend_trait_alias*)NULL)->alias) + sizeof(((zend_trait_alias*)NULL)->alias_len) + sizeof(((zend_trait_alias*)NULL)->modifiers)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","alias","alias_len","modifiers" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_trait_method_reference(
		
		
		
		
		dasm, zv,  src->trait_method
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("trait_method"), (sizeof("trait_method")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("trait_method"), (sizeof("trait_method")));
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(unsigned int,alias_len) */

	assert(sizeof(unsigned int) == sizeof(src->alias_len));
		
	
	
		add_assoc_long_ex(dst, ("alias_len"), (sizeof("alias_len")), src->alias_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias_len", sizeof("alias_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias_len", sizeof("alias_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(alias,alias_len) */
 
	/* PROC_STRING_N(alias,alias_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "alias", sizeof("alias"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "alias"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "alias", sizeof("alias"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->alias);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->alias == NULL) {
		
		
			add_assoc_null_ex(dst, ("alias"), (sizeof("alias")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("alias"), (sizeof("alias")), (char *) src->alias, src->alias_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,modifiers) */

	assert(sizeof(zend_uint) == sizeof(src->modifiers));
		
	
	
		add_assoc_long_ex(dst, ("modifiers"), (sizeof("modifiers")), src->modifiers);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "modifiers", sizeof("modifiers"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "modifiers"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "modifiers", sizeof("modifiers"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->modifiers);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_5
	
	
	add_assoc_null_ex(dst, ("function"), (sizeof("function")));
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_alias : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_trait_alias", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_trait_alias : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_zend_trait_precedence */
	
 	  	 	static void inline 	xc_dasm_zend_trait_precedence( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_trait_precedence * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_trait_precedence*)NULL)->trait_method) + sizeof(((zend_trait_precedence*)NULL)->exclude_from_classes)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "trait_method","exclude_from_classes" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	/* STRUCT_P(zend_trait_method_reference,trait_method) */

	if (src->trait_method) {
		
		
	
	/* STRUCT_P_EX(zend_trait_method_reference,DST(`trait_method'),SRC(`trait_method'),trait_method,) */

	
	

	
	assert(sizeof(zend_trait_method_reference) == sizeof(( src->trait_method)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_trait_method_reference(
		
		
		
		
		dasm, zv,  src->trait_method
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("trait_method"), (sizeof("trait_method")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("trait_method"), (sizeof("trait_method")));
	
	assert(src->trait_method == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_method", sizeof("trait_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "trait_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_method", sizeof("trait_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_method);
	xc_autocheck_done_count ++;

#endif



		if (src->exclude_from_classes) {
		int LOOPCOUNTER;
		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (LOOPCOUNTER = 0;
					src->exclude_from_classes[LOOPCOUNTER];
					++LOOPCOUNTER) {
				
				
				
				
				
				
				
	
	

						
	/* PROCESS(xc_ztstring,exclude_from_classes) */

	assert(sizeof(xc_ztstring) == sizeof((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]));
		
	
	/* PROC_STRING(exclude_from_classes) */
 
	
	
	
	
	
	
	
	
	if ((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER] == NULL) {
		
		
			add_assoc_null_ex(arr, ("exclude_from_classes"), (sizeof("exclude_from_classes")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(arr, ("exclude_from_classes"), (sizeof("exclude_from_classes")), (char *) (xc_ztstring) src->exclude_from_classes [LOOPCOUNTER], strlen((xc_ztstring) src->exclude_from_classes [LOOPCOUNTER]) + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

	

	

				
	
	

				
				
				
				
				
				
			}
			add_assoc_zval_ex(dst, ("exclude_from_classes"), (sizeof("exclude_from_classes")), arr);
				
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	add_assoc_null_ex(dst, ("exclude_from_classes"), (sizeof("exclude_from_classes")));
	
	assert(src->exclude_from_classes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "exclude_from_classes", sizeof("exclude_from_classes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "exclude_from_classes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "exclude_from_classes", sizeof("exclude_from_classes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->exclude_from_classes);
	xc_autocheck_done_count ++;

#endif



	}

#ifndef ZEND_ENGINE_2_5
	
	
	add_assoc_null_ex(dst, ("function"), (sizeof("function")));
	
	assert(src->function == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function", sizeof("function"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_precedence : %s\n"
				, __FILE__, __LINE__
				, "function"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function", sizeof("function"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function);
	xc_autocheck_done_count ++;

#endif



#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_trait_precedence", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_trait_precedence : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_zend_trait_alias_ptr */
	
 	  	 	static void inline 	xc_dasm_zend_trait_alias_ptr( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_trait_alias_ptr * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_alias), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
		
	

		xc_dasm_zend_trait_alias (dasm, dst, src[0] TSRMLS_CC);
		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_alias);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_trait_alias_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_trait_alias_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_zend_trait_precedence_ptr */
	
 	  	 	static void inline 	xc_dasm_zend_trait_precedence_ptr( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_trait_precedence_ptr * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = sizeof(zend_trait_precedence), assert_count = 1;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char **xc_autocheck_assert_names = NULL;
				size_t xc_autocheck_assert_names_count = 0;
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
		
	

		xc_dasm_zend_trait_precedence (dasm, dst, src[0] TSRMLS_CC);
		
	
	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(zend_trait_precedence);
	xc_autocheck_done_count ++;

#endif


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_trait_precedence_ptr", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_trait_precedence_ptr : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zend_class_entry */
	
		/* export:  	  	 	void 	xc_dasm_zend_class_entry( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_class_entry * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_zend_class_entry( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_class_entry * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_class_entry*)NULL)->type) + sizeof(((zend_class_entry*)NULL)->name) + sizeof(((zend_class_entry*)NULL)->name_length) + sizeof(((zend_class_entry*)NULL)->parent) + sizeof(((zend_class_entry*)NULL)->refcount) + sizeof(((zend_class_entry*)NULL)->ce_flags) + sizeof(((zend_class_entry*)NULL)->function_table) + sizeof(((zend_class_entry*)NULL)->properties_info) + sizeof(((zend_class_entry*)NULL)->default_properties_table) + sizeof(((zend_class_entry*)NULL)->default_static_members_table) + sizeof(((zend_class_entry*)NULL)->static_members_table) + sizeof(((zend_class_entry*)NULL)->constants_table) + sizeof(((zend_class_entry*)NULL)->default_properties_count) + sizeof(((zend_class_entry*)NULL)->default_static_members_count) + sizeof(((zend_class_entry*)NULL)->constructor) + sizeof(((zend_class_entry*)NULL)->destructor) + sizeof(((zend_class_entry*)NULL)->clone) + sizeof(((zend_class_entry*)NULL)->__get) + sizeof(((zend_class_entry*)NULL)->__set) + sizeof(((zend_class_entry*)NULL)->__unset) + sizeof(((zend_class_entry*)NULL)->__isset) + sizeof(((zend_class_entry*)NULL)->__call) + sizeof(((zend_class_entry*)NULL)->__callstatic) + sizeof(((zend_class_entry*)NULL)->__tostring) + sizeof(((zend_class_entry*)NULL)->__debugInfo) + sizeof(((zend_class_entry*)NULL)->serialize_func) + sizeof(((zend_class_entry*)NULL)->unserialize_func) + sizeof(((zend_class_entry*)NULL)->iterator_funcs) + sizeof(((zend_class_entry*)NULL)->create_object) + sizeof(((zend_class_entry*)NULL)->get_iterator) + sizeof(((zend_class_entry*)NULL)->interface_gets_implemented) + sizeof(((zend_class_entry*)NULL)->get_static_method) + sizeof(((zend_class_entry*)NULL)->serialize) + sizeof(((zend_class_entry*)NULL)->unserialize) + sizeof(((zend_class_entry*)NULL)->interfaces) + sizeof(((zend_class_entry*)NULL)->num_interfaces) + sizeof(((zend_class_entry*)NULL)->traits) + sizeof(((zend_class_entry*)NULL)->num_traits) + sizeof(((zend_class_entry*)NULL)->trait_aliases) + sizeof(((zend_class_entry*)NULL)->trait_precedences) + sizeof(((zend_class_entry*)NULL)->info)  ), assert_count = 41;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","name","name_length","parent","refcount","ce_flags","function_table","properties_info","default_properties_table","default_static_members_table","static_members_table","constants_table","default_properties_count","default_static_members_count","constructor","destructor","clone","__get","__set","__unset","__isset","__call","__callstatic","__tostring","__debugInfo","serialize_func","unserialize_func","iterator_funcs","create_object","get_iterator","interface_gets_implemented","get_static_method","serialize","unserialize","interfaces","num_interfaces","traits","num_traits","trait_aliases","trait_precedences","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
		
	/* PROCESS(char,type) */

	assert(sizeof(char) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,name_length) */

	assert(sizeof(zend_uint) == sizeof(src->name_length));
		
	
	
		add_assoc_long_ex(dst, ("name_length"), (sizeof("name_length")), src->name_length);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_length", sizeof("name_length"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name_length"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_length", sizeof("name_length"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_length);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,name,name_length) */
 
	
	/* PROC_ZSTRING_N(,name,name_length,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("name"), (sizeof("name")), ZSTR_U(src->name), src->name_length + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_length + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("name"), (sizeof("name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("name"), (sizeof("name")), (char *) ZSTR_S(src->name), src->name_length + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	if (src->parent) {
		
		
#ifdef IS_UNICODE
		add_assoc_unicodel_ex(dst, ("parent"), (sizeof("parent")), ZSTR_U(src->parent->name), src->parent->name_length, 1);
#else
		add_assoc_stringl_ex(dst, ("parent"), (sizeof("parent")), (char *) src->parent->name, src->parent->name_length, 1);
#endif
	}
	else {
		
	add_assoc_null_ex(dst, ("parent"), (sizeof("parent")));
	
	assert(src->parent == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "parent", sizeof("parent"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "parent"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "parent", sizeof("parent"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->parent);
	xc_autocheck_done_count ++;

#endif


	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(int,refcount) */

	assert(sizeof(int) == sizeof(src->refcount));
		
	
	
		add_assoc_long_ex(dst, ("refcount"), (sizeof("refcount")), src->refcount);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#else
	
	
	/* STRUCT_P(int,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(int,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(int) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_int(
		
		
		
		
		dasm, zv,  src->refcount
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("refcount"), (sizeof("refcount")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("refcount"), (sizeof("refcount")));
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,constants_updated) */

	assert(sizeof(zend_bool) == sizeof(src->constants_updated));
		
	
	
		add_assoc_bool_ex(dst, ("constants_updated"), (sizeof("constants_updated")), src->constants_updated ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_updated", sizeof("constants_updated"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_updated"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_updated", sizeof("constants_updated"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_updated);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,ce_flags) */

	assert(sizeof(zend_uint) == sizeof(src->ce_flags));
		
	
	
		add_assoc_long_ex(dst, ("ce_flags"), (sizeof("ce_flags")), src->ce_flags);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ce_flags", sizeof("ce_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "ce_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ce_flags", sizeof("ce_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ce_flags);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,properties_info,HashTable_zend_property_info) */

	assert(sizeof(HashTable) == sizeof(src->properties_info));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`properties_info'),SRC(`properties_info'),properties_info,HashTable_zend_property_info,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->properties_info)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zend_property_info(
		
		
		
		
		dasm, zv, & src->properties_info
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("properties_info"), (sizeof("properties_info")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "properties_info", sizeof("properties_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "properties_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "properties_info", sizeof("properties_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->properties_info);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2_4
	
	if (src->default_properties_table) {
		int i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->default_properties_count;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zval_ptr_nullable (dasm, zv, &(src->default_properties_table[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("default_properties_table"), (sizeof("default_properties_table")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("default_properties_table"), (sizeof("default_properties_table")));
	
	assert(src->default_properties_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_table", sizeof("default_properties_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_table", sizeof("default_properties_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_properties_count) */

	assert(sizeof(int) == sizeof(src->default_properties_count));
		
	
	
		add_assoc_long_ex(dst, ("default_properties_count"), (sizeof("default_properties_count")), src->default_properties_count);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties_count", sizeof("default_properties_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties_count", sizeof("default_properties_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties_count);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->default_static_members_table) {
		int i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->default_static_members_count;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zval_ptr_nullable (dasm, zv, &(src->default_static_members_table[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("default_static_members_table"), (sizeof("default_static_members_table")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zval_ptr_nullable : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("default_static_members_table"), (sizeof("default_static_members_table")));
	
	assert(src->default_static_members_table == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_table", sizeof("default_static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_table", sizeof("default_static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_table);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,default_static_members_count) */

	assert(sizeof(int) == sizeof(src->default_static_members_count));
		
	
	
		add_assoc_long_ex(dst, ("default_static_members_count"), (sizeof("default_static_members_count")), src->default_static_members_count);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members_count", sizeof("default_static_members_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members_count", sizeof("default_static_members_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members_count);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members_table", sizeof("static_members_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members_table", sizeof("static_members_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members_table);
	xc_autocheck_done_count ++;

#endif


#else
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "builtin_functions", sizeof("builtin_functions"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "builtin_functions"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "builtin_functions", sizeof("builtin_functions"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->builtin_functions);
	xc_autocheck_done_count ++;

#endif


	
	
	/* STRUCT(HashTable,default_properties,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_properties));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_properties'),SRC(`default_properties'),default_properties,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_properties)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zval_ptr(
		
		
		
		
		dasm, zv, & src->default_properties
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("default_properties"), (sizeof("default_properties")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_properties", sizeof("default_properties"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_properties"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_properties", sizeof("default_properties"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_properties);
	xc_autocheck_done_count ++;

#endif



#	ifdef ZEND_ENGINE_2_1
	
	
	/* STRUCT(HashTable,default_static_members,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->default_static_members));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`default_static_members'),SRC(`default_static_members'),default_static_members,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->default_static_members)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zval_ptr(
		
		
		
		
		dasm, zv, & src->default_static_members
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("default_static_members"), (sizeof("default_static_members")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "default_static_members", sizeof("default_static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "default_static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "default_static_members", sizeof("default_static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->default_static_members);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif


#	elif defined(ZEND_ENGINE_2)
	
	
	/* STRUCT_P(HashTable,static_members,HashTable_zval_ptr) */

	if (src->static_members) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_members'),SRC(`static_members'),static_members,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_members)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zval_ptr(
		
		
		
		
		dasm, zv,  src->static_members
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("static_members"), (sizeof("static_members")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("static_members"), (sizeof("static_members")));
	
	assert(src->static_members == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_members", sizeof("static_members"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "static_members"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_members", sizeof("static_members"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_members);
	xc_autocheck_done_count ++;

#endif



#	endif
#endif /* ZEND_ENGINE_2_4 */

#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT(HashTable,constants_table,HashTable_zval_ptr) */

	assert(sizeof(HashTable) == sizeof(src->constants_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`constants_table'),SRC(`constants_table'),constants_table,HashTable_zval_ptr,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->constants_table)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zval_ptr(
		
		
		
		
		dasm, zv, & src->constants_table
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("constants_table"), (sizeof("constants_table")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constants_table", sizeof("constants_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constants_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constants_table", sizeof("constants_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constants_table);
	xc_autocheck_done_count ++;

#endif




#ifdef ZEND_ENGINE_2_2
		
	
	add_assoc_null_ex(dst, ("interfaces"), (sizeof("interfaces")));
	
	assert(src->interfaces == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif



	
	
	add_assoc_long_ex(dst, ("num_interfaces"), (sizeof("num_interfaces")), 0);
	
	assert(src->num_interfaces == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif




#	ifdef ZEND_ENGINE_2_4
		
	
	add_assoc_null_ex(dst, ("traits"), (sizeof("traits")));
	
	assert(src->traits == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "traits", sizeof("traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "traits", sizeof("traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->traits);
	xc_autocheck_done_count ++;

#endif



	
	
	add_assoc_long_ex(dst, ("num_traits"), (sizeof("num_traits")), 0);
	
	assert(src->num_traits == 0);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_traits", sizeof("num_traits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_traits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_traits", sizeof("num_traits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_traits);
	xc_autocheck_done_count ++;

#endif



	
	if (src->trait_aliases) {
		size_t i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					src->trait_aliases[i];
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_trait_alias_ptr (dasm, zv, &(src->trait_aliases[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("trait_aliases"), (sizeof("trait_aliases")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_alias_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("trait_aliases"), (sizeof("trait_aliases")));
	
	assert(src->trait_aliases == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_aliases", sizeof("trait_aliases"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_aliases"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_aliases", sizeof("trait_aliases"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_aliases);
	xc_autocheck_done_count ++;

#endif



	}

	
	if (src->trait_precedences) {
		size_t i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					src->trait_precedences[i];
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_trait_precedence_ptr (dasm, zv, &(src->trait_precedences[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("trait_precedences"), (sizeof("trait_precedences")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_trait_precedence_ptr : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("trait_precedences"), (sizeof("trait_precedences")));
	
	assert(src->trait_precedences == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "trait_precedences", sizeof("trait_precedences"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "trait_precedences"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "trait_precedences", sizeof("trait_precedences"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->trait_precedences);
	xc_autocheck_done_count ++;

#endif



	}

#	endif
#else
	
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interfaces", sizeof("interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interfaces", sizeof("interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interfaces);
	xc_autocheck_done_count ++;

#endif


	
		
	/* PROCESS(zend_uint,num_interfaces) */

	assert(sizeof(zend_uint) == sizeof(src->num_interfaces));
		
	
	
		add_assoc_long_ex(dst, ("num_interfaces"), (sizeof("num_interfaces")), src->num_interfaces);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_interfaces", sizeof("num_interfaces"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "num_interfaces"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_interfaces", sizeof("num_interfaces"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_interfaces);
	xc_autocheck_done_count ++;

#endif



	

#endif

#	ifdef ZEND_ENGINE_2_4
	
	
	

	
	/* PROC_STRING(info.user.filename) */
 
	
	
	
	
	
	
	
	
	if (src->info.user.filename == NULL) {
		
		
			add_assoc_null_ex(dst, ("info.user.filename"), (sizeof("info.user.filename")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("info.user.filename"), (sizeof("info.user.filename")), (char *) src->info.user.filename, strlen(src->info.user.filename) + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,info.user.line_start) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_start));
		
	
	
		add_assoc_long_ex(dst, ("info.user.line_start"), (sizeof("info.user.line_start")), src->info.user.line_start);
		
	
	

	

		
	/* PROCESS(zend_uint,info.user.line_end) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.line_end));
		
	
	
		add_assoc_long_ex(dst, ("info.user.line_end"), (sizeof("info.user.line_end")), src->info.user.line_end);
		
	
	

	

		
	/* PROCESS(zend_uint,info.user.doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->info.user.doc_comment_len));
		
	
	
		add_assoc_long_ex(dst, ("info.user.doc_comment_len"), (sizeof("info.user.doc_comment_len")), src->info.user.doc_comment_len);
		
	
	

	

	
	/* PROC_ZSTRING_L(,info.user.doc_comment,info.user.doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,info.user.doc_comment,info.user.doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->info.user.doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("info.user.doc_comment"), (sizeof("info.user.doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("info.user.doc_comment"), (sizeof("info.user.doc_comment")), ZSTR_U(src->info.user.doc_comment), src->info.user.doc_comment_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("info.user.doc_comment"), (sizeof("info.user.doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("info.user.doc_comment"), (sizeof("info.user.doc_comment")), (char *) ZSTR_S(src->info.user.doc_comment), src->info.user.doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->info.user.doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("info.user.doc_comment"), (sizeof("info.user.doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("info.user.doc_comment"), (sizeof("info.user.doc_comment")), (char *) ZSTR_S(src->info.user.doc_comment), src->info.user.doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif


#	else
	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
			add_assoc_null_ex(dst, ("filename"), (sizeof("filename")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("filename"), (sizeof("filename")), (char *) src->filename, strlen(src->filename) + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
		add_assoc_long_ex(dst, ("line_start"), (sizeof("line_start")), src->line_start);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
		add_assoc_long_ex(dst, ("line_end"), (sizeof("line_end")), src->line_end);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,doc_comment_len) */

	assert(sizeof(zend_uint) == sizeof(src->doc_comment_len));
		
	
	
		add_assoc_long_ex(dst, ("doc_comment_len"), (sizeof("doc_comment_len")), src->doc_comment_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("doc_comment"), (sizeof("doc_comment")), ZSTR_U(src->doc_comment), src->doc_comment_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("doc_comment"), (sizeof("doc_comment")), (char *) ZSTR_S(src->doc_comment), src->doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("doc_comment"), (sizeof("doc_comment")), (char *) ZSTR_S(src->doc_comment), src->doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

#	endif

	/* # NOT DONE */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize_func", sizeof("serialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize_func", sizeof("serialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize_func);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize_func", sizeof("unserialize_func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize_func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize_func", sizeof("unserialize_func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize_func);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "iterator_funcs", sizeof("iterator_funcs"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "iterator_funcs"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "iterator_funcs", sizeof("iterator_funcs"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->iterator_funcs);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "create_object", sizeof("create_object"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "create_object"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "create_object", sizeof("create_object"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->create_object);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_iterator", sizeof("get_iterator"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_iterator"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_iterator", sizeof("get_iterator"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_iterator);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "interface_gets_implemented", sizeof("interface_gets_implemented"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "interface_gets_implemented"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "interface_gets_implemented", sizeof("interface_gets_implemented"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->interface_gets_implemented);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_ENGINE_2_3
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "get_static_method", sizeof("get_static_method"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "get_static_method"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "get_static_method", sizeof("get_static_method"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->get_static_method);
	xc_autocheck_done_count ++;

#endif


#	endif
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "serialize", sizeof("serialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "serialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "serialize", sizeof("serialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->serialize);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "unserialize", sizeof("unserialize"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "unserialize"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "unserialize", sizeof("unserialize"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->unserialize);
	xc_autocheck_done_count ++;

#endif


#	endif
	/* deal with it inside xc_fix_method */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constructor", sizeof("constructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "constructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constructor", sizeof("constructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "destructor", sizeof("destructor"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "destructor"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "destructor", sizeof("destructor"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->destructor);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "clone", sizeof("clone"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "clone"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "clone", sizeof("clone"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->clone);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__get", sizeof("__get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__get", sizeof("__get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__set", sizeof("__set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__set", sizeof("__set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__set);
	xc_autocheck_done_count ++;

#endif


/* should be >5.1 */
#	ifdef ZEND_ENGINE_2_1
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__unset", sizeof("__unset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__unset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__unset", sizeof("__unset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__unset);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__isset", sizeof("__isset"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__isset"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__isset", sizeof("__isset"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__isset);
	xc_autocheck_done_count ++;

#endif


#	endif
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__call", sizeof("__call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__call", sizeof("__call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__call);
	xc_autocheck_done_count ++;

#endif


#	ifdef ZEND_CALLSTATIC_FUNC_NAME
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__callstatic", sizeof("__callstatic"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__callstatic"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__callstatic", sizeof("__callstatic"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__callstatic);
	xc_autocheck_done_count ++;

#endif


#	endif
# if defined(ZEND_ENGINE_2_2) || PHP_MAJOR_VERSION >= 6
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__tostring", sizeof("__tostring"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__tostring"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__tostring", sizeof("__tostring"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__tostring);
	xc_autocheck_done_count ++;

#endif


# endif
# if defined(ZEND_ENGINE_2_6)
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "__debugInfo", sizeof("__debugInfo"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "__debugInfo"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "__debugInfo", sizeof("__debugInfo"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->__debugInfo);
	xc_autocheck_done_count ++;

#endif


# endif
#	ifndef ZEND_ENGINE_2_4
	/* # NOT DONE */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "module", sizeof("module"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "module"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "module", sizeof("module"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->module);
	xc_autocheck_done_count ++;

#endif


#	endif
#else /* ZEND_ENGINE_2 */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_function_call", sizeof("handle_function_call"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_function_call"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_function_call", sizeof("handle_function_call"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_function_call);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_get", sizeof("handle_property_get"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_get"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_get", sizeof("handle_property_get"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_get);
	xc_autocheck_done_count ++;

#endif


	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handle_property_set", sizeof("handle_property_set"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "handle_property_set"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handle_property_set", sizeof("handle_property_set"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handle_property_set);
	xc_autocheck_done_count ++;

#endif


#endif
		
	
	/* STRUCT(HashTable,function_table,HashTable_zend_function) */

	assert(sizeof(HashTable) == sizeof(src->function_table));
	
	
	
	/* STRUCT_P_EX(HashTable,DST(`function_table'),SRC(`function_table'),function_table,HashTable_zend_function,&) */

	
	

	
	assert(sizeof(HashTable) == sizeof((& src->function_table)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zend_function(
		
		
		
		
		dasm, zv, & src->function_table
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("function_table"), (sizeof("function_table")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_table", sizeof("function_table"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_class_entry : %s\n"
				, __FILE__, __LINE__
				, "function_table"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_table", sizeof("function_table"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_table);
	xc_autocheck_done_count ++;

#endif



	
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_class_entry", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_class_entry : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4


#else

	
	

/* {{{ xc_dasm_znode */
	
 	  	 	static void inline 	xc_dasm_znode( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const znode * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((znode*)NULL)->op_type) + sizeof(((znode*)NULL)->u) + sizeof(((znode*)NULL)->EA)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "op_type","u","EA" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(xc_op_type,op_type) */

	assert(sizeof(xc_op_type) == sizeof(src->op_type));
			
	
	
		add_assoc_long_ex(dst, ("op_type"), (sizeof("op_type")), src->op_type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_type", sizeof("op_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_znode : %s\n"
				, __FILE__, __LINE__
				, "op_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_type", sizeof("op_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_type);
	xc_autocheck_done_count ++;

#endif




	


#ifdef IS_CV
#	define XCACHE_IS_CV IS_CV
#else
/* compatible with zend optimizer */
#	define XCACHE_IS_CV 16
#endif
	assert(src->op_type == IS_CONST ||
		src->op_type == IS_VAR ||
		src->op_type == XCACHE_IS_CV ||
		src->op_type == IS_TMP_VAR ||
		src->op_type == IS_UNUSED);
		
	
	

	switch (src->op_type) {
		case IS_CONST:
			
	
	/* STRUCT(zval,u.constant) */

	assert(sizeof(zval) == sizeof(src->u.constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`u.constant'),SRC(`u.constant'),u.constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->u.constant)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zval(
		
		
		
		
		dasm, zv, & src->u.constant
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("u.constant"), (sizeof("u.constant")), zv);
		
	} while (0);
	

	
	

	

			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case XCACHE_IS_CV:
				
	/* PROCESS(zend_uint,u.var) */

	assert(sizeof(zend_uint) == sizeof(src->u.var));
		
	
	
		add_assoc_long_ex(dst, ("u.var"), (sizeof("u.var")), src->u.var);
		
	
	

	

				
	/* PROCESS(zend_uint,u.EA.type) */

	assert(sizeof(zend_uint) == sizeof(src->u.EA.type));
		
	
	
		add_assoc_long_ex(dst, ("u.EA.type"), (sizeof("u.EA.type")), src->u.EA.type);
		
	
	

	

			break;
		case IS_UNUSED:
				
	/* PROCESS(zend_uint,u.var) */

	assert(sizeof(zend_uint) == sizeof(src->u.var));
		
	
	
		add_assoc_long_ex(dst, ("u.var"), (sizeof("u.var")), src->u.var);
		
	
	

	

				
	/* PROCESS(zend_uint,u.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->u.opline_num));
		
	
	
		add_assoc_long_ex(dst, ("u.opline_num"), (sizeof("u.opline_num")), src->u.opline_num);
		
	
	

	

#ifndef ZEND_ENGINE_2
				
	/* PROCESS(zend_uint,u.fetch_type) */

	assert(sizeof(zend_uint) == sizeof(src->u.fetch_type));
		
	
	
		add_assoc_long_ex(dst, ("u.fetch_type"), (sizeof("u.fetch_type")), src->u.fetch_type);
		
	
	

	

#endif
				
	/* PROCESS(zend_uint,u.EA.type) */

	assert(sizeof(zend_uint) == sizeof(src->u.EA.type));
		
	
	
		add_assoc_long_ex(dst, ("u.EA.type"), (sizeof("u.EA.type")), src->u.EA.type);
		
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "u", sizeof("u"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_znode : %s\n"
				, __FILE__, __LINE__
				, "u"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "u", sizeof("u"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->u);
	xc_autocheck_done_count ++;

#endif


#if 0
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "EA", sizeof("EA"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_znode : %s\n"
				, __FILE__, __LINE__
				, "EA"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "EA", sizeof("EA"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->EA);
	xc_autocheck_done_count ++;

#endif


#endif
#undef XCACHE_IS_CV

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_znode", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_znode : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zend_op */
	
		/* export:  	  	 	void 	xc_dasm_zend_op( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_op * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_zend_op( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_op * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op*)NULL)->handler) + sizeof(((zend_op*)NULL)->op1) + sizeof(((zend_op*)NULL)->op2) + sizeof(((zend_op*)NULL)->result) + sizeof(((zend_op*)NULL)->extended_value) + sizeof(((zend_op*)NULL)->lineno) + sizeof(((zend_op*)NULL)->opcode) + sizeof(((zend_op*)NULL)->op1_type) + sizeof(((zend_op*)NULL)->op2_type) + sizeof(((zend_op*)NULL)->result_type)  ), assert_count = 10;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "handler","op1","op2","result","extended_value","lineno","opcode","op1_type","op2_type","result_type" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(xc_opcode,opcode) */

	assert(sizeof(xc_opcode) == sizeof(src->opcode));
			
	
	
		add_assoc_long_ex(dst, ("opcode"), (sizeof("opcode")), src->opcode);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcode", sizeof("opcode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcode", sizeof("opcode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcode);
	xc_autocheck_done_count ++;

#endif




	

#ifdef ZEND_ENGINE_2_4
	
	switch (src->opcode) {
	case ZEND_BIND_TRAITS:
		((zend_op *) src)->op2_type = IS_UNUSED;
		break;
	}
	
	#ifndef NDEBUG
	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->result_type & ~EXT_TYPE_UNUSED)) {
		case IS_CONST:
			
					
	/* PROCESS(zend_uint,result.constant) */

	assert(sizeof(zend_uint) == sizeof(src->result.constant));
		
	
	
		add_assoc_long_ex(dst, ("result.constant"), (sizeof("result.constant")), src->result.constant);
		
	
	

	

			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,result.var) */

	assert(sizeof(zend_uint) == sizeof(src->result.var));
		
	
	
		add_assoc_long_ex(dst, ("result.var"), (sizeof("result.var")), src->result.var);
		
	
	

	

			break;
		case IS_UNUSED:
				
	/* PROCESS(zend_uint,result.var) */

	assert(sizeof(zend_uint) == sizeof(src->result.var));
		
	
	
		add_assoc_long_ex(dst, ("result.var"), (sizeof("result.var")), src->result.var);
		
	
	

	

				
	/* PROCESS(zend_uint,result.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->result.opline_num));
		
	
	
		add_assoc_long_ex(dst, ("result.opline_num"), (sizeof("result.opline_num")), src->result.opline_num);
		
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op1_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op1_type )) {
		case IS_CONST:
			
				{
					zval *zv;
					zval *srczv = &dasm->active_op_array_src->literals[src->op1.constant].constant;
					ALLOC_ZVAL(zv);
					MAKE_COPY_ZVAL(&srczv, zv);
					add_assoc_zval_ex(dst, ("op1.constant"), (sizeof("op1.constant")), zv);
				}
				
			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,op1.var) */

	assert(sizeof(zend_uint) == sizeof(src->op1.var));
		
	
	
		add_assoc_long_ex(dst, ("op1.var"), (sizeof("op1.var")), src->op1.var);
		
	
	

	

			break;
		case IS_UNUSED:
				
	/* PROCESS(zend_uint,op1.var) */

	assert(sizeof(zend_uint) == sizeof(src->op1.var));
		
	
	
		add_assoc_long_ex(dst, ("op1.var"), (sizeof("op1.var")), src->op1.var);
		
	
	

	

				
	/* PROCESS(zend_uint,op1.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->op1.opline_num));
		
	
	
		add_assoc_long_ex(dst, ("op1.opline_num"), (sizeof("op1.opline_num")), src->op1.opline_num);
		
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	#ifndef NDEBUG
	switch ((src->op2_type )) {
	case IS_CONST:
	case IS_VAR:
	case IS_CV:
	case IS_TMP_VAR:
	case IS_UNUSED:
		break;

	default:
		assert(0);
	}
#endif

		
	
	

	switch ((src->op2_type )) {
		case IS_CONST:
			
				{
					zval *zv;
					zval *srczv = &dasm->active_op_array_src->literals[src->op2.constant].constant;
					ALLOC_ZVAL(zv);
					MAKE_COPY_ZVAL(&srczv, zv);
					add_assoc_zval_ex(dst, ("op2.constant"), (sizeof("op2.constant")), zv);
				}
				
			
			break;
		
		case IS_VAR:
		case IS_TMP_VAR:
		case IS_CV:
				
	/* PROCESS(zend_uint,op2.var) */

	assert(sizeof(zend_uint) == sizeof(src->op2.var));
		
	
	
		add_assoc_long_ex(dst, ("op2.var"), (sizeof("op2.var")), src->op2.var);
		
	
	

	

			break;
		case IS_UNUSED:
				
	/* PROCESS(zend_uint,op2.var) */

	assert(sizeof(zend_uint) == sizeof(src->op2.var));
		
	
	
		add_assoc_long_ex(dst, ("op2.var"), (sizeof("op2.var")), src->op2.var);
		
	
	

	

				
	/* PROCESS(zend_uint,op2.opline_num) */

	assert(sizeof(zend_uint) == sizeof(src->op2.opline_num));
		
	
	
		add_assoc_long_ex(dst, ("op2.opline_num"), (sizeof("op2.opline_num")), src->op2.opline_num);
		
	
	

	

			break;
		
	}
	
	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(znode,result) */

	assert(sizeof(znode) == sizeof(src->result));
	
	
	
	/* STRUCT_P_EX(znode,DST(`result'),SRC(`result'),result,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->result)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_znode(
		
		
		
		
		dasm, zv, & src->result
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("result"), (sizeof("result")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result", sizeof("result"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result", sizeof("result"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op1) */

	assert(sizeof(znode) == sizeof(src->op1));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op1'),SRC(`op1'),op1,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op1)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_znode(
		
		
		
		
		dasm, zv, & src->op1
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("op1"), (sizeof("op1")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1", sizeof("op1"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1", sizeof("op1"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1);
	xc_autocheck_done_count ++;

#endif



	
	
	/* STRUCT(znode,op2) */

	assert(sizeof(znode) == sizeof(src->op2));
	
	
	
	/* STRUCT_P_EX(znode,DST(`op2'),SRC(`op2'),op2,,&) */

	
	

	
	assert(sizeof(znode) == sizeof((& src->op2)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_znode(
		
		
		
		
		dasm, zv, & src->op2
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("op2"), (sizeof("op2")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2", sizeof("op2"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2", sizeof("op2"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2);
	xc_autocheck_done_count ++;

#endif



#endif
		
	/* PROCESS(ulong,extended_value) */

	assert(sizeof(ulong) == sizeof(src->extended_value));
		
	
	
		add_assoc_long_ex(dst, ("extended_value"), (sizeof("extended_value")), src->extended_value);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "extended_value", sizeof("extended_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "extended_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "extended_value", sizeof("extended_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->extended_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
		add_assoc_long_ex(dst, ("lineno"), (sizeof("lineno")), src->lineno);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uchar,op1_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op1_type));
		
	
	
		add_assoc_long_ex(dst, ("op1_type"), (sizeof("op1_type")), src->op1_type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op1_type", sizeof("op1_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op1_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op1_type", sizeof("op1_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op1_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,op2_type) */

	assert(sizeof(zend_uchar) == sizeof(src->op2_type));
		
	
	
		add_assoc_long_ex(dst, ("op2_type"), (sizeof("op2_type")), src->op2_type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op2_type", sizeof("op2_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "op2_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op2_type", sizeof("op2_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op2_type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uchar,result_type) */

	assert(sizeof(zend_uchar) == sizeof(src->result_type));
		
	
	
		add_assoc_long_ex(dst, ("result_type"), (sizeof("result_type")), src->result_type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "result_type", sizeof("result_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "result_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "result_type", sizeof("result_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->result_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(opcode_handler_t,handler) */

	assert(sizeof(opcode_handler_t) == sizeof(src->handler));
	/* is copying enough? */
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "handler", sizeof("handler"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "handler"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "handler", sizeof("handler"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->handler);
	xc_autocheck_done_count ++;

#endif


	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_op", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_op : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#ifdef ZEND_ENGINE_2_4

	
	

/* {{{ xc_dasm_zend_literal */
	
 	  	 	static void inline 	xc_dasm_zend_literal( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_literal * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_literal*)NULL)->constant) + sizeof(((zend_literal*)NULL)->hash_value) + sizeof(((zend_literal*)NULL)->cache_slot)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "constant","hash_value","cache_slot" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(zval,constant) */

	assert(sizeof(zval) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zval,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zval) == sizeof((& src->constant)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zval(
		
		
		
		
		dasm, zv, & src->constant
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("constant"), (sizeof("constant")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif



		
	/* PROCESS(zend_ulong,hash_value) */

	assert(sizeof(zend_ulong) == sizeof(src->hash_value));
		
	
	
		add_assoc_long_ex(dst, ("hash_value"), (sizeof("hash_value")), src->hash_value);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hash_value", sizeof("hash_value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "hash_value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hash_value", sizeof("hash_value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hash_value);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,cache_slot) */

	assert(sizeof(zend_uint) == sizeof(src->cache_slot));
		
	
	
		add_assoc_long_ex(dst, ("cache_slot"), (sizeof("cache_slot")), src->cache_slot);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cache_slot", sizeof("cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cache_slot", sizeof("cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cache_slot);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_literal", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_literal : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif

	
	

/* {{{ xc_dasm_zend_op_array */
	
		/* export:  	  	 	void 	xc_dasm_zend_op_array( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_op_array * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_zend_op_array( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const zend_op_array * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((zend_op_array*)NULL)->type) + sizeof(((zend_op_array*)NULL)->function_name) + sizeof(((zend_op_array*)NULL)->scope) + sizeof(((zend_op_array*)NULL)->fn_flags) + sizeof(((zend_op_array*)NULL)->prototype) + sizeof(((zend_op_array*)NULL)->num_args) + sizeof(((zend_op_array*)NULL)->required_num_args) + sizeof(((zend_op_array*)NULL)->arg_info) + sizeof(((zend_op_array*)NULL)->refcount) + sizeof(((zend_op_array*)NULL)->opcodes) + sizeof(((zend_op_array*)NULL)->last) + sizeof(((zend_op_array*)NULL)->vars) + sizeof(((zend_op_array*)NULL)->last_var) + sizeof(((zend_op_array*)NULL)->T) + sizeof(((zend_op_array*)NULL)->nested_calls) + sizeof(((zend_op_array*)NULL)->used_stack) + sizeof(((zend_op_array*)NULL)->brk_cont_array) + sizeof(((zend_op_array*)NULL)->last_brk_cont) + sizeof(((zend_op_array*)NULL)->try_catch_array) + sizeof(((zend_op_array*)NULL)->last_try_catch) + sizeof(((zend_op_array*)NULL)->has_finally_block) + sizeof(((zend_op_array*)NULL)->static_variables) + sizeof(((zend_op_array*)NULL)->this_var) + sizeof(((zend_op_array*)NULL)->filename) + sizeof(((zend_op_array*)NULL)->line_start) + sizeof(((zend_op_array*)NULL)->line_end) + sizeof(((zend_op_array*)NULL)->doc_comment) + sizeof(((zend_op_array*)NULL)->doc_comment_len) + sizeof(((zend_op_array*)NULL)->early_binding) + sizeof(((zend_op_array*)NULL)->literals) + sizeof(((zend_op_array*)NULL)->last_literal) + sizeof(((zend_op_array*)NULL)->run_time_cache) + sizeof(((zend_op_array*)NULL)->last_cache_slot) + sizeof(((zend_op_array*)NULL)->reserved)  ), assert_count = 34;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","function_name","scope","fn_flags","prototype","num_args","required_num_args","arg_info","refcount","opcodes","last","vars","last_var","T","nested_calls","used_stack","brk_cont_array","last_brk_cont","try_catch_array","last_try_catch","has_finally_block","static_variables","this_var","filename","line_start","line_end","doc_comment","doc_comment_len","early_binding","literals","last_literal","run_time_cache","last_cache_slot","reserved" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
		dasm->active_op_array_src = src;
	
	{
	
	do {
	
	/* Common elements */
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING(,function_name) */
 
	
	/* PROC_ZSTRING_N(,function_name,,strlen) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->function_name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("function_name"), (sizeof("function_name")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("function_name"), (sizeof("function_name")), ZSTR_U(src->function_name), xc_zstrlen_uchar (src->function_name) + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("function_name"), (sizeof("function_name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("function_name"), (sizeof("function_name")), (char *) ZSTR_S(src->function_name), xc_zstrlen_char (src->function_name) + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "function_name", sizeof("function_name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "function_name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "function_name", sizeof("function_name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->function_name);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->function_name) == NULL) {
		
		
			add_assoc_null_ex(dst, ("function_name"), (sizeof("function_name")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("function_name"), (sizeof("function_name")), (char *) ZSTR_S(src->function_name), xc_zstrlen_char (src->function_name) + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,fn_flags) */

	assert(sizeof(zend_uint) == sizeof(src->fn_flags));
		
	
	
		add_assoc_long_ex(dst, ("fn_flags"), (sizeof("fn_flags")), src->fn_flags);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "fn_flags", sizeof("fn_flags"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "fn_flags"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "fn_flags", sizeof("fn_flags"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->fn_flags);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->arg_info) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->num_args;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_arg_info (dasm, zv, &(src->arg_info[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("arg_info"), (sizeof("arg_info")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_arg_info : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("arg_info"), (sizeof("arg_info")));
	
	assert(src->arg_info == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_info", sizeof("arg_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_info", sizeof("arg_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_info);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,num_args) */

	assert(sizeof(zend_uint) == sizeof(src->num_args));
		
	
	
		add_assoc_long_ex(dst, ("num_args"), (sizeof("num_args")), src->num_args);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "num_args", sizeof("num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "num_args", sizeof("num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->num_args);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,required_num_args) */

	assert(sizeof(zend_uint) == sizeof(src->required_num_args));
		
	
	
		add_assoc_long_ex(dst, ("required_num_args"), (sizeof("required_num_args")), src->required_num_args);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "required_num_args", sizeof("required_num_args"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "required_num_args"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "required_num_args", sizeof("required_num_args"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->required_num_args);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,pass_rest_by_reference) */

	assert(sizeof(zend_bool) == sizeof(src->pass_rest_by_reference));
		
	
	
		add_assoc_bool_ex(dst, ("pass_rest_by_reference"), (sizeof("pass_rest_by_reference")), src->pass_rest_by_reference ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "pass_rest_by_reference", sizeof("pass_rest_by_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "pass_rest_by_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "pass_rest_by_reference", sizeof("pass_rest_by_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->pass_rest_by_reference);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
	if (src->arg_types) {
		
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	

		
		do {
			int i;
			zval *zv;
			ALLOC_INIT_ZVAL(zv);
			array_init(zv);
			for (i = 0; i < src->arg_types[0]; i ++) {
				add_next_index_long(zv, src->arg_types[i + 1]);
			}
			add_assoc_zval_ex(dst, ZEND_STRS("arg_types"), zv);
		} while (0);
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif


	}
	else {
		
	
	add_assoc_null_ex(dst, ("arg_types"), (sizeof("arg_types")));
	
	assert(src->arg_types == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "arg_types", sizeof("arg_types"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "arg_types"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "arg_types", sizeof("arg_types"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->arg_types);
	xc_autocheck_done_count ++;

#endif



	}
#endif
#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(unsigned char,return_reference) */

	assert(sizeof(unsigned char) == sizeof(src->return_reference));
		
	
	
		add_assoc_long_ex(dst, ("return_reference"), (sizeof("return_reference")), src->return_reference);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "return_reference", sizeof("return_reference"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "return_reference"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "return_reference", sizeof("return_reference"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->return_reference);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* END of common elements */
#ifdef IS_UNICODE
	#endif

	
	
	/* STRUCT_P(zend_uint,refcount) */

	if (src->refcount) {
		
		
	
	/* STRUCT_P_EX(zend_uint,DST(`refcount'),SRC(`refcount'),refcount,) */

	
	

	
	assert(sizeof(zend_uint) == sizeof(( src->refcount)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_uint(
		
		
		
		
		dasm, zv,  src->refcount
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("refcount"), (sizeof("refcount")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("refcount"), (sizeof("refcount")));
	
	assert(src->refcount == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

#ifdef ZEND_ENGINE_2_4
		
	if (src->literals) {
		int i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->last_literal;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_literal (dasm, zv, &(src->literals[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("literals"), (sizeof("literals")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_literal : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("literals"), (sizeof("literals")));
	
	assert(src->literals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literals", sizeof("literals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "literals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literals", sizeof("literals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literals);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_literal) */

	assert(sizeof(int) == sizeof(src->last_literal));
		
	
	
		add_assoc_long_ex(dst, ("last_literal"), (sizeof("last_literal")), src->last_literal);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_literal", sizeof("last_literal"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_literal"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_literal", sizeof("last_literal"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_literal);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
	if (src->opcodes) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->last;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_op (dasm, zv, &(src->opcodes[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("opcodes"), (sizeof("opcodes")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("opcodes"), (sizeof("opcodes")));
	
	assert(src->opcodes == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "opcodes", sizeof("opcodes"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "opcodes"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "opcodes", sizeof("opcodes"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->opcodes);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(zend_uint,last) */

	assert(sizeof(zend_uint) == sizeof(src->last));
		
	
	
		add_assoc_long_ex(dst, ("last"), (sizeof("last")), src->last);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last", sizeof("last"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last", sizeof("last"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last);
	xc_autocheck_done_count ++;

#endif



	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,size) */

	assert(sizeof(zend_uint) == sizeof(src->size));
		
	
	
		add_assoc_long_ex(dst, ("size"), (sizeof("size")), src->size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef IS_CV
	
	if (src->vars) {
		int i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->last_var;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_compiled_variable (dasm, zv, &(src->vars[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("vars"), (sizeof("vars")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_compiled_variable : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("vars"), (sizeof("vars")));
	
	assert(src->vars == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "vars", sizeof("vars"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "vars"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "vars", sizeof("vars"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->vars);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_var) */

	assert(sizeof(int) == sizeof(src->last_var));
		
	
	
		add_assoc_long_ex(dst, ("last_var"), (sizeof("last_var")), src->last_var);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_var", sizeof("last_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_var", sizeof("last_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_var);
	xc_autocheck_done_count ++;

#endif



	

#	ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,size_var) */

	assert(sizeof(zend_uint) == sizeof(src->size_var));
		
	
	
		add_assoc_long_ex(dst, ("size_var"), (sizeof("size_var")), src->size_var);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size_var", sizeof("size_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "size_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size_var", sizeof("size_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size_var);
	xc_autocheck_done_count ++;

#endif



	

#	endif
#else
		
		
		
#endif

		
	/* PROCESS(zend_uint,T) */

	assert(sizeof(zend_uint) == sizeof(src->T));
		
	
	
		add_assoc_long_ex(dst, ("T"), (sizeof("T")), src->T);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "T", sizeof("T"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "T"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "T", sizeof("T"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->T);
	xc_autocheck_done_count ++;

#endif



	


#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_uint,nested_calls) */

	assert(sizeof(zend_uint) == sizeof(src->nested_calls));
		
	
	
		add_assoc_long_ex(dst, ("nested_calls"), (sizeof("nested_calls")), src->nested_calls);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "nested_calls", sizeof("nested_calls"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "nested_calls"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "nested_calls", sizeof("nested_calls"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->nested_calls);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,used_stack) */

	assert(sizeof(zend_uint) == sizeof(src->used_stack));
		
	
	
		add_assoc_long_ex(dst, ("used_stack"), (sizeof("used_stack")), src->used_stack);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "used_stack", sizeof("used_stack"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "used_stack"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "used_stack", sizeof("used_stack"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->used_stack);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	if (src->brk_cont_array) {
		last_brk_cont_t i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->last_brk_cont;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_brk_cont_element (dasm, zv, &(src->brk_cont_array[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("brk_cont_array"), (sizeof("brk_cont_array")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_brk_cont_element : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("brk_cont_array"), (sizeof("brk_cont_array")));
	
	assert(src->brk_cont_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "brk_cont_array", sizeof("brk_cont_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "brk_cont_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "brk_cont_array", sizeof("brk_cont_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->brk_cont_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(last_brk_cont_t,last_brk_cont) */

	assert(sizeof(last_brk_cont_t) == sizeof(src->last_brk_cont));
		
	
	
		add_assoc_long_ex(dst, ("last_brk_cont"), (sizeof("last_brk_cont")), src->last_brk_cont);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_brk_cont", sizeof("last_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_brk_cont", sizeof("last_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_brk_cont);
	xc_autocheck_done_count ++;

#endif




	

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,current_brk_cont) */

	assert(sizeof(zend_uint) == sizeof(src->current_brk_cont));
		
	
	
		add_assoc_long_ex(dst, ("current_brk_cont"), (sizeof("current_brk_cont")), src->current_brk_cont);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "current_brk_cont", sizeof("current_brk_cont"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "current_brk_cont"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "current_brk_cont", sizeof("current_brk_cont"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->current_brk_cont);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifndef ZEND_ENGINE_2
		
	/* PROCESS(zend_bool,uses_globals) */

	assert(sizeof(zend_bool) == sizeof(src->uses_globals));
		
	
	
		add_assoc_bool_ex(dst, ("uses_globals"), (sizeof("uses_globals")), src->uses_globals ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_globals", sizeof("uses_globals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_globals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_globals", sizeof("uses_globals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_globals);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifdef ZEND_ENGINE_2
	
	if (src->try_catch_array) {
		int i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->last_try_catch;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_zend_try_catch_element (dasm, zv, &(src->try_catch_array[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("try_catch_array"), (sizeof("try_catch_array")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_try_catch_element : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("try_catch_array"), (sizeof("try_catch_array")));
	
	assert(src->try_catch_array == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "try_catch_array", sizeof("try_catch_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "try_catch_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "try_catch_array", sizeof("try_catch_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->try_catch_array);
	xc_autocheck_done_count ++;

#endif



	}

		
	/* PROCESS(int,last_try_catch) */

	assert(sizeof(int) == sizeof(src->last_try_catch));
		
	
	
		add_assoc_long_ex(dst, ("last_try_catch"), (sizeof("last_try_catch")), src->last_try_catch);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_try_catch", sizeof("last_try_catch"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_try_catch"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_try_catch", sizeof("last_try_catch"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_try_catch);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_5
		
	/* PROCESS(zend_bool,has_finally_block) */

	assert(sizeof(zend_bool) == sizeof(src->has_finally_block));
		
	
	
		add_assoc_bool_ex(dst, ("has_finally_block"), (sizeof("has_finally_block")), src->has_finally_block ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "has_finally_block", sizeof("has_finally_block"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "has_finally_block"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "has_finally_block", sizeof("has_finally_block"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->has_finally_block);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	
	/* STRUCT_P(HashTable,static_variables,HashTable_zval_ptr) */

	if (src->static_variables) {
		
		
	
	/* STRUCT_P_EX(HashTable,DST(`static_variables'),SRC(`static_variables'),static_variables,HashTable_zval_ptr) */

	
	

	
	assert(sizeof(HashTable) == sizeof(( src->static_variables)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_HashTable_zval_ptr(
		
		
		
		
		dasm, zv,  src->static_variables
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("static_variables"), (sizeof("static_variables")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("static_variables"), (sizeof("static_variables")));
	
	assert(src->static_variables == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "static_variables", sizeof("static_variables"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "static_variables"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "static_variables", sizeof("static_variables"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->static_variables);
	xc_autocheck_done_count ++;

#endif




#ifndef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "start_op", sizeof("start_op"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "start_op"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "start_op", sizeof("start_op"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->start_op);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,backpatch_count) */

	assert(sizeof(int) == sizeof(src->backpatch_count));
		
	
	
		add_assoc_long_ex(dst, ("backpatch_count"), (sizeof("backpatch_count")), src->backpatch_count);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "backpatch_count", sizeof("backpatch_count"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "backpatch_count"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "backpatch_count", sizeof("backpatch_count"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->backpatch_count);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_3
		
	/* PROCESS(zend_uint,this_var) */

	assert(sizeof(zend_uint) == sizeof(src->this_var));
		
	
	
		add_assoc_long_ex(dst, ("this_var"), (sizeof("this_var")), src->this_var);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "this_var", sizeof("this_var"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "this_var"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "this_var", sizeof("this_var"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->this_var);
	xc_autocheck_done_count ++;

#endif



	

#endif

#ifndef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_bool,done_pass_two) */

	assert(sizeof(zend_bool) == sizeof(src->done_pass_two));
		
	
	
		add_assoc_bool_ex(dst, ("done_pass_two"), (sizeof("done_pass_two")), src->done_pass_two ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "done_pass_two", sizeof("done_pass_two"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "done_pass_two"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "done_pass_two", sizeof("done_pass_two"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->done_pass_two);
	xc_autocheck_done_count ++;

#endif



	

#endif
	/* 5.0 <= ver < 5.3 */
#if defined(ZEND_ENGINE_2) && !defined(ZEND_ENGINE_2_3)
		
	/* PROCESS(zend_bool,uses_this) */

	assert(sizeof(zend_bool) == sizeof(src->uses_this));
		
	
	
		add_assoc_bool_ex(dst, ("uses_this"), (sizeof("uses_this")), src->uses_this ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "uses_this", sizeof("uses_this"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "uses_this"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "uses_this", sizeof("uses_this"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->uses_this);
	xc_autocheck_done_count ++;

#endif



	

#endif

	
	/* PROC_STRING(filename) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filename", sizeof("filename"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "filename"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filename", sizeof("filename"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filename);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filename == NULL) {
		
		
			add_assoc_null_ex(dst, ("filename"), (sizeof("filename")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("filename"), (sizeof("filename")), (char *) src->filename, strlen(src->filename) + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
	
		
	/* PROC_STRING(script_encoding) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "script_encoding", sizeof("script_encoding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "script_encoding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "script_encoding", sizeof("script_encoding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->script_encoding);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->script_encoding == NULL) {
		
		
			add_assoc_null_ex(dst, ("script_encoding"), (sizeof("script_encoding")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("script_encoding"), (sizeof("script_encoding")), (char *) src->script_encoding, strlen(src->script_encoding) + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

	
#endif
#ifdef ZEND_ENGINE_2
		
	/* PROCESS(zend_uint,line_start) */

	assert(sizeof(zend_uint) == sizeof(src->line_start));
		
	
	
		add_assoc_long_ex(dst, ("line_start"), (sizeof("line_start")), src->line_start);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_start", sizeof("line_start"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_start"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_start", sizeof("line_start"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_start);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,line_end) */

	assert(sizeof(zend_uint) == sizeof(src->line_end));
		
	
	
		add_assoc_long_ex(dst, ("line_end"), (sizeof("line_end")), src->line_end);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "line_end", sizeof("line_end"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "line_end"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "line_end", sizeof("line_end"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->line_end);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,doc_comment_len) */

	assert(sizeof(int) == sizeof(src->doc_comment_len));
		
	
	
		add_assoc_long_ex(dst, ("doc_comment_len"), (sizeof("doc_comment_len")), src->doc_comment_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment_len", sizeof("doc_comment_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment_len", sizeof("doc_comment_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_ZSTRING_L(,doc_comment,doc_comment_len) */
 
	
	/* PROC_ZSTRING_N(,doc_comment,doc_comment_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
		if (UG(unicode)) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("doc_comment"), (sizeof("doc_comment")), ZSTR_U(src->doc_comment), src->doc_comment_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("doc_comment"), (sizeof("doc_comment")), (char *) ZSTR_S(src->doc_comment), src->doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "doc_comment", sizeof("doc_comment"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "doc_comment"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "doc_comment", sizeof("doc_comment"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->doc_comment);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->doc_comment) == NULL) {
		
		
			add_assoc_null_ex(dst, ("doc_comment"), (sizeof("doc_comment")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("doc_comment"), (sizeof("doc_comment")), (char *) ZSTR_S(src->doc_comment), src->doc_comment_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

#endif
#ifdef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_uint,early_binding) */

	assert(sizeof(zend_uint) == sizeof(src->early_binding));
		
	
	
		add_assoc_long_ex(dst, ("early_binding"), (sizeof("early_binding")), src->early_binding);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "early_binding", sizeof("early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "early_binding", sizeof("early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->early_binding);
	xc_autocheck_done_count ++;

#endif



	
;
#endif

	/* reserved */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "reserved", sizeof("reserved"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "reserved"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "reserved", sizeof("reserved"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->reserved);
	xc_autocheck_done_count ++;

#endif


#if defined(HARDENING_PATCH) && HARDENING_PATCH
		
	/* PROCESS(zend_bool,created_by_eval) */

	assert(sizeof(zend_bool) == sizeof(src->created_by_eval));
		
	
	
		add_assoc_bool_ex(dst, ("created_by_eval"), (sizeof("created_by_eval")), src->created_by_eval ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "created_by_eval", sizeof("created_by_eval"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "created_by_eval"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "created_by_eval", sizeof("created_by_eval"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->created_by_eval);
	xc_autocheck_done_count ++;

#endif



	

#endif
#ifdef ZEND_ENGINE_2_4
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "run_time_cache", sizeof("run_time_cache"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "run_time_cache"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "run_time_cache", sizeof("run_time_cache"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->run_time_cache);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(int,last_cache_slot) */

	assert(sizeof(int) == sizeof(src->last_cache_slot));
		
	
	
		add_assoc_long_ex(dst, ("last_cache_slot"), (sizeof("last_cache_slot")), src->last_cache_slot);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "last_cache_slot", sizeof("last_cache_slot"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "last_cache_slot"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "last_cache_slot", sizeof("last_cache_slot"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->last_cache_slot);
	xc_autocheck_done_count ++;

#endif



	

#endif
	} while (0);
	

#ifdef ZEND_ENGINE_2
		
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "prototype", sizeof("prototype"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "prototype"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "prototype", sizeof("prototype"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->prototype);
	xc_autocheck_done_count ++;

#endif



#endif

#ifdef ZEND_ENGINE_2
	
	if (src->scope) {
		
		
#ifdef IS_UNICODE
		add_assoc_unicodel_ex(dst, ("scope"), (sizeof("scope")), ZSTR_U(src->scope->name), src->scope->name_length, 1);
#else
		add_assoc_stringl_ex(dst, ("scope"), (sizeof("scope")), (char *) src->scope->name, src->scope->name_length, 1);
#endif
	}
	else {
		
	add_assoc_null_ex(dst, ("scope"), (sizeof("scope")));
	
	assert(src->scope == NULL);

	}

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "scope", sizeof("scope"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_zend_op_array : %s\n"
				, __FILE__, __LINE__
				, "scope"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "scope", sizeof("scope"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->scope);
	xc_autocheck_done_count ++;

#endif


	
#endif

	
	}
	
	
		dasm->active_op_array_src = NULL;
	

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_zend_op_array", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_zend_op_array : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef HAVE_XCACHE_CONSTANT

	
	

/* {{{ xc_dasm_xc_constinfo_t */
	
 	  	 	static void inline 	xc_dasm_xc_constinfo_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_constinfo_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_constinfo_t*)NULL)->key) + sizeof(((xc_constinfo_t*)NULL)->key_size) + sizeof(((xc_constinfo_t*)NULL)->h) + sizeof(((xc_constinfo_t*)NULL)->constant)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","constant" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
		add_assoc_long_ex(dst, ("key_size"), (sizeof("key_size")), src->key_size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("key"), (sizeof("key")), ZSTR_U(src->key), src->key_size-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_size-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_size-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
		add_assoc_long_ex(dst, ("h"), (sizeof("h")), src->h);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
	
	/* STRUCT(zend_constant,constant) */

	assert(sizeof(zend_constant) == sizeof(src->constant));
	
	
	
	/* STRUCT_P_EX(zend_constant,DST(`constant'),SRC(`constant'),constant,,&) */

	
	

	
	assert(sizeof(zend_constant) == sizeof((& src->constant)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_constant(
		
		
		
		
		dasm, zv, & src->constant
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("constant"), (sizeof("constant")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constant", sizeof("constant"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constant"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constant", sizeof("constant"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constant);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_constinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_constinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_dasm_xc_op_array_info_detail_t */
	
 	  	 	static void inline 	xc_dasm_xc_op_array_info_detail_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_op_array_info_detail_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_detail_t*)NULL)->index) + sizeof(((xc_op_array_info_detail_t*)NULL)->info)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "index","info" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,index) */

	assert(sizeof(zend_uint) == sizeof(src->index));
		
	
	
		add_assoc_long_ex(dst, ("index"), (sizeof("index")), src->index);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "index", sizeof("index"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "index"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "index", sizeof("index"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->index);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,info) */

	assert(sizeof(zend_uint) == sizeof(src->info));
		
	
	
		add_assoc_long_ex(dst, ("info"), (sizeof("info")), src->info);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "info", sizeof("info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "info", sizeof("info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->info);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_op_array_info_detail_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_op_array_info_detail_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_xc_op_array_info_t */
	
 	  	 	static void inline 	xc_dasm_xc_op_array_info_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_op_array_info_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_op_array_info_t*)NULL)->literalinfo_cnt) + sizeof(((xc_op_array_info_t*)NULL)->literalinfos)  ), assert_count = 2;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "literalinfo_cnt","literalinfos" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
		#ifdef ZEND_ENGINE_2_4
		
	/* PROCESS(zend_uint,literalinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->literalinfo_cnt));
		
	
	
		add_assoc_long_ex(dst, ("literalinfo_cnt"), (sizeof("literalinfo_cnt")), src->literalinfo_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfo_cnt", sizeof("literalinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfo_cnt", sizeof("literalinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->literalinfos) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->literalinfo_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_op_array_info_detail_t (dasm, zv, &(src->literalinfos[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("literalinfos"), (sizeof("literalinfos")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("literalinfos"), (sizeof("literalinfos")));
	
	assert(src->literalinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "literalinfos", sizeof("literalinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "literalinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "literalinfos", sizeof("literalinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->literalinfos);
	xc_autocheck_done_count ++;

#endif



	}

#else
		
	/* PROCESS(zend_uint,oplineinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->oplineinfo_cnt));
		
	
	
		add_assoc_long_ex(dst, ("oplineinfo_cnt"), (sizeof("oplineinfo_cnt")), src->oplineinfo_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfo_cnt", sizeof("oplineinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfo_cnt", sizeof("oplineinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->oplineinfos) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->oplineinfo_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_op_array_info_detail_t (dasm, zv, &(src->oplineinfos[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("oplineinfos"), (sizeof("oplineinfos")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_detail_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("oplineinfos"), (sizeof("oplineinfos")));
	
	assert(src->oplineinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineinfos", sizeof("oplineinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "oplineinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineinfos", sizeof("oplineinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_op_array_info_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_op_array_info_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	



	
	

/* {{{ xc_dasm_xc_funcinfo_t */
	
		/* export:  	  	 	void 	xc_dasm_xc_funcinfo_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_funcinfo_t * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_xc_funcinfo_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_funcinfo_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_funcinfo_t*)NULL)->key) + sizeof(((xc_funcinfo_t*)NULL)->key_size) + sizeof(((xc_funcinfo_t*)NULL)->h) + sizeof(((xc_funcinfo_t*)NULL)->op_array_info) + sizeof(((xc_funcinfo_t*)NULL)->func)  ), assert_count = 5;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","op_array_info","func" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
		add_assoc_long_ex(dst, ("key_size"), (sizeof("key_size")), src->key_size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("key"), (sizeof("key")), ZSTR_U(src->key), src->key_size-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_size-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_size-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
		add_assoc_long_ex(dst, ("h"), (sizeof("h")), src->h);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_xc_op_array_info_t(
		
		
		
		
		dasm, zv, & src->op_array_info
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("op_array_info"), (sizeof("op_array_info")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT(zend_function,func) */

	assert(sizeof(zend_function) == sizeof(src->func));
	
	
	
	/* STRUCT_P_EX(zend_function,DST(`func'),SRC(`func'),func,,&) */

	
	

	
	assert(sizeof(zend_function) == sizeof((& src->func)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_function(
		
		
		
		
		dasm, zv, & src->func
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("func"), (sizeof("func")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "func", sizeof("func"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "func"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "func", sizeof("func"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->func);
	xc_autocheck_done_count ++;

#endif




		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_funcinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_funcinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_xc_classinfo_t */
	
		/* export:  	  	 	void 	xc_dasm_xc_classinfo_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_classinfo_t * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_xc_classinfo_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_classinfo_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_classinfo_t*)NULL)->key) + sizeof(((xc_classinfo_t*)NULL)->key_size) + sizeof(((xc_classinfo_t*)NULL)->h) + sizeof(((xc_classinfo_t*)NULL)->methodinfo_cnt) + sizeof(((xc_classinfo_t*)NULL)->methodinfos) + sizeof(((xc_classinfo_t*)NULL)->cest)  ), assert_count = 6;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_size","h","methodinfo_cnt","methodinfos","cest" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_size) */

	assert(sizeof(zend_uint) == sizeof(src->key_size));
		
	
	
		add_assoc_long_ex(dst, ("key_size"), (sizeof("key_size")), src->key_size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_size", sizeof("key_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_size", sizeof("key_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_size);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	
	/* PROC_ZSTRING_N(type,key,key_size) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("key"), (sizeof("key")), ZSTR_U(src->key), src->key_size-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_size-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_size-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
		add_assoc_long_ex(dst, ("h"), (sizeof("h")), src->h);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_uint,methodinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->methodinfo_cnt));
		
	
	
		add_assoc_long_ex(dst, ("methodinfo_cnt"), (sizeof("methodinfo_cnt")), src->methodinfo_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfo_cnt", sizeof("methodinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfo_cnt", sizeof("methodinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->methodinfos) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->methodinfo_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_op_array_info_t (dasm, zv, &(src->methodinfos[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("methodinfos"), (sizeof("methodinfos")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_op_array_info_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("methodinfos"), (sizeof("methodinfos")));
	
	assert(src->methodinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "methodinfos", sizeof("methodinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "methodinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "methodinfos", sizeof("methodinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->methodinfos);
	xc_autocheck_done_count ++;

#endif



	}

	
	
#ifdef ZEND_ENGINE_2
	
	
	/* STRUCT_P(zend_class_entry,cest) */

	if (src->cest) {
		
		
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof(( src->cest)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_class_entry(
		
		
		
		
		dasm, zv,  src->cest
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("cest"), (sizeof("cest")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("cest"), (sizeof("cest")));
	
	assert(src->cest == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#else
	
	
	/* STRUCT(zend_class_entry,cest) */

	assert(sizeof(zend_class_entry) == sizeof(src->cest));
	
	
	
	/* STRUCT_P_EX(zend_class_entry,DST(`cest'),SRC(`cest'),cest,,&) */

	
	

	
	assert(sizeof(zend_class_entry) == sizeof((& src->cest)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_class_entry(
		
		
		
		
		dasm, zv, & src->cest
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("cest"), (sizeof("cest")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "cest", sizeof("cest"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "cest"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "cest", sizeof("cest"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->cest);
	xc_autocheck_done_count ++;

#endif



#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(int,oplineno) */

	assert(sizeof(int) == sizeof(src->oplineno));
		
	
	
		add_assoc_long_ex(dst, ("oplineno"), (sizeof("oplineno")), src->oplineno);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "oplineno", sizeof("oplineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "oplineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "oplineno", sizeof("oplineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->oplineno);
	xc_autocheck_done_count ++;

#endif



	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_classinfo_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_classinfo_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#ifdef ZEND_ENGINE_2_1

	
	

/* {{{ xc_dasm_xc_autoglobal_t */
	
 	  	 	static void inline 	xc_dasm_xc_autoglobal_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_autoglobal_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_autoglobal_t*)NULL)->key) + sizeof(((xc_autoglobal_t*)NULL)->key_len) + sizeof(((xc_autoglobal_t*)NULL)->h)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "key","key_len","h" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(zend_uint,key_len) */

	assert(sizeof(zend_uint) == sizeof(src->key_len));
		
	
	
		add_assoc_long_ex(dst, ("key_len"), (sizeof("key_len")), src->key_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key_len", sizeof("key_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key_len", sizeof("key_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key_len);
	xc_autocheck_done_count ++;

#endif



	

#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,type) */

	assert(sizeof(zend_uchar) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

#endif
	
		
	/* PROC_ZSTRING_L(type,key,key_len) */
 
	
	/* PROC_ZSTRING_N(type,key,key_len,len) */

#ifdef IS_UNICODE
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
		if (src->type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("key"), (sizeof("key")), ZSTR_U(src->key), src->key_len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "key", sizeof("key"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "key"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "key", sizeof("key"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->key);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->key) == NULL) {
		
		
			add_assoc_null_ex(dst, ("key"), (sizeof("key")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("key"), (sizeof("key")), (char *) ZSTR_S(src->key), src->key_len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

	
		
	/* PROCESS(ulong,h) */

	assert(sizeof(ulong) == sizeof(src->h));
		
	
	
		add_assoc_long_ex(dst, ("h"), (sizeof("h")), src->h);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "h", sizeof("h"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "h"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "h", sizeof("h"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->h);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_autoglobal_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_autoglobal_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


#ifdef XCACHE_ERROR_CACHING

	
	

/* {{{ xc_dasm_xc_compilererror_t */
	
 	  	 	static void inline 	xc_dasm_xc_compilererror_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_compilererror_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_compilererror_t*)NULL)->type) + sizeof(((xc_compilererror_t*)NULL)->lineno) + sizeof(((xc_compilererror_t*)NULL)->error_len) + sizeof(((xc_compilererror_t*)NULL)->error)  ), assert_count = 4;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "type","lineno","error_len","error" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
				
	/* PROCESS(int,type) */

	assert(sizeof(int) == sizeof(src->type));
		
	
	
		add_assoc_long_ex(dst, ("type"), (sizeof("type")), src->type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "type", sizeof("type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "type", sizeof("type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->type);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(uint,lineno) */

	assert(sizeof(uint) == sizeof(src->lineno));
		
	
	
		add_assoc_long_ex(dst, ("lineno"), (sizeof("lineno")), src->lineno);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "lineno", sizeof("lineno"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "lineno"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "lineno", sizeof("lineno"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->lineno);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(int,error_len) */

	assert(sizeof(int) == sizeof(src->error_len));
		
	
	
		add_assoc_long_ex(dst, ("error_len"), (sizeof("error_len")), src->error_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error_len", sizeof("error_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error_len", sizeof("error_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(error,error_len) */
 
	/* PROC_STRING_N(error,error_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "error", sizeof("error"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "error"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "error", sizeof("error"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->error);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->error == NULL) {
		
		
			add_assoc_null_ex(dst, ("error"), (sizeof("error")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("error"), (sizeof("error")), (char *) src->error, src->error_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_compilererror_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_compilererror_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	

#endif


	
	

/* {{{ xc_dasm_xc_entry_data_php_t */
	
		/* export:  	  	 	void 	xc_dasm_xc_entry_data_php_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_data_php_t * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_xc_entry_data_php_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_data_php_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_data_php_t*)NULL)->next) + sizeof(((xc_entry_data_php_t*)NULL)->hvalue) + sizeof(((xc_entry_data_php_t*)NULL)->md5) + sizeof(((xc_entry_data_php_t*)NULL)->refcount) + sizeof(((xc_entry_data_php_t*)NULL)->hits) + sizeof(((xc_entry_data_php_t*)NULL)->size) + sizeof(((xc_entry_data_php_t*)NULL)->op_array_info) + sizeof(((xc_entry_data_php_t*)NULL)->op_array) + sizeof(((xc_entry_data_php_t*)NULL)->constinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->constinfos) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->funcinfos) + sizeof(((xc_entry_data_php_t*)NULL)->classinfo_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->classinfos) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobal_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->autoglobals) + sizeof(((xc_entry_data_php_t*)NULL)->compilererror_cnt) + sizeof(((xc_entry_data_php_t*)NULL)->compilererrors) + sizeof(((xc_entry_data_php_t*)NULL)->have_references)  ), assert_count = 19;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","hvalue","md5","refcount","hits","size","op_array_info","op_array","constinfo_cnt","constinfos","funcinfo_cnt","funcinfos","classinfo_cnt","classinfos","autoglobal_cnt","autoglobals","compilererror_cnt","compilererrors","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			

	/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(xc_hash_value_t,hvalue) */

	assert(sizeof(xc_hash_value_t) == sizeof(src->hvalue));
		
	
	
		add_assoc_long_ex(dst, ("hvalue"), (sizeof("hvalue")), src->hvalue);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hvalue", sizeof("hvalue"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hvalue"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hvalue", sizeof("hvalue"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hvalue);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(xc_md5sum_t,md5) */

	assert(sizeof(xc_md5sum_t) == sizeof(src->md5));
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "md5", sizeof("md5"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "md5"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "md5", sizeof("md5"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->md5);
	xc_autocheck_done_count ++;

#endif


	

		
	/* PROCESS(zend_ulong,refcount) */

	assert(sizeof(zend_ulong) == sizeof(src->refcount));
		
	
	
		add_assoc_long_ex(dst, ("refcount"), (sizeof("refcount")), src->refcount);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
		add_assoc_long_ex(dst, ("hits"), (sizeof("hits")), src->hits);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
		add_assoc_long_ex(dst, ("size"), (sizeof("size")), src->size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


	
		
	
	/* STRUCT(xc_op_array_info_t,op_array_info) */

	assert(sizeof(xc_op_array_info_t) == sizeof(src->op_array_info));
	
	
	
	/* STRUCT_P_EX(xc_op_array_info_t,DST(`op_array_info'),SRC(`op_array_info'),op_array_info,,&) */

	
	

	
	assert(sizeof(xc_op_array_info_t) == sizeof((& src->op_array_info)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_xc_op_array_info_t(
		
		
		
		
		dasm, zv, & src->op_array_info
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("op_array_info"), (sizeof("op_array_info")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array_info", sizeof("op_array_info"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array_info"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array_info", sizeof("op_array_info"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array_info);
	xc_autocheck_done_count ++;

#endif



	
	
	
	
	/* STRUCT_P(zend_op_array,op_array) */

	if (src->op_array) {
		
		
	
	/* STRUCT_P_EX(zend_op_array,DST(`op_array'),SRC(`op_array'),op_array,) */

	
	

	
	assert(sizeof(zend_op_array) == sizeof(( src->op_array)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zend_op_array(
		
		
		
		
		dasm, zv,  src->op_array
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("op_array"), (sizeof("op_array")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("op_array"), (sizeof("op_array")));
	
	assert(src->op_array == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "op_array", sizeof("op_array"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "op_array"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "op_array", sizeof("op_array"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->op_array);
	xc_autocheck_done_count ++;

#endif




#ifdef HAVE_XCACHE_CONSTANT
		
	/* PROCESS(zend_uint,constinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->constinfo_cnt));
		
	
	
		add_assoc_long_ex(dst, ("constinfo_cnt"), (sizeof("constinfo_cnt")), src->constinfo_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfo_cnt", sizeof("constinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfo_cnt", sizeof("constinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->constinfos) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->constinfo_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_constinfo_t (dasm, zv, &(src->constinfos[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("constinfos"), (sizeof("constinfos")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_constinfo_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("constinfos"), (sizeof("constinfos")));
	
	assert(src->constinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "constinfos", sizeof("constinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "constinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "constinfos", sizeof("constinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->constinfos);
	xc_autocheck_done_count ++;

#endif



	}

#endif

		
	/* PROCESS(zend_uint,funcinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->funcinfo_cnt));
		
	
	
		add_assoc_long_ex(dst, ("funcinfo_cnt"), (sizeof("funcinfo_cnt")), src->funcinfo_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfo_cnt", sizeof("funcinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfo_cnt", sizeof("funcinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->funcinfos) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->funcinfo_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_funcinfo_t (dasm, zv, &(src->funcinfos[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("funcinfos"), (sizeof("funcinfos")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_funcinfo_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("funcinfos"), (sizeof("funcinfos")));
	
	assert(src->funcinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "funcinfos", sizeof("funcinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "funcinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "funcinfos", sizeof("funcinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->funcinfos);
	xc_autocheck_done_count ++;

#endif



	}


		
	/* PROCESS(zend_uint,classinfo_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->classinfo_cnt));
		
	
	
		add_assoc_long_ex(dst, ("classinfo_cnt"), (sizeof("classinfo_cnt")), src->classinfo_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfo_cnt", sizeof("classinfo_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfo_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfo_cnt", sizeof("classinfo_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfo_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
	if (src->classinfos) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->classinfo_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_classinfo_t (dasm, zv, &(src->classinfos[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("classinfos"), (sizeof("classinfos")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_classinfo_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("classinfos"), (sizeof("classinfos")));
	
	assert(src->classinfos == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "classinfos", sizeof("classinfos"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "classinfos"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "classinfos", sizeof("classinfos"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->classinfos);
	xc_autocheck_done_count ++;

#endif



	}

#ifdef ZEND_ENGINE_2_1
		
	/* PROCESS(zend_uint,autoglobal_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->autoglobal_cnt));
		
	
	
		add_assoc_long_ex(dst, ("autoglobal_cnt"), (sizeof("autoglobal_cnt")), src->autoglobal_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobal_cnt", sizeof("autoglobal_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobal_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobal_cnt", sizeof("autoglobal_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobal_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->autoglobals) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->autoglobal_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_autoglobal_t (dasm, zv, &(src->autoglobals[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("autoglobals"), (sizeof("autoglobals")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_autoglobal_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("autoglobals"), (sizeof("autoglobals")));
	
	assert(src->autoglobals == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "autoglobals", sizeof("autoglobals"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "autoglobals"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "autoglobals", sizeof("autoglobals"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->autoglobals);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifdef XCACHE_ERROR_CACHING
		
	/* PROCESS(zend_uint,compilererror_cnt) */

	assert(sizeof(zend_uint) == sizeof(src->compilererror_cnt));
		
	
	
		add_assoc_long_ex(dst, ("compilererror_cnt"), (sizeof("compilererror_cnt")), src->compilererror_cnt);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererror_cnt", sizeof("compilererror_cnt"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererror_cnt"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererror_cnt", sizeof("compilererror_cnt"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererror_cnt);
	xc_autocheck_done_count ++;

#endif



	

	
		
	if (src->compilererrors) {
		zend_uint i; 
		
	

		
			zval *arr;
			ALLOC_INIT_ZVAL(arr);
			array_init(arr);

			for (i = 0;
					i < src->compilererror_cnt;
					++i) {
				zval *zv;

				ALLOC_INIT_ZVAL(zv);
				array_init(zv);
				xc_dasm_xc_compilererror_t (dasm, zv, &(src->compilererrors[i]) TSRMLS_CC);
				add_next_index_zval(arr, zv);
			}
			add_assoc_zval_ex(dst, ("compilererrors"), (sizeof("compilererrors")), arr);
				
		
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_compilererror_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif


		
		
	}
	else {
		
	
	add_assoc_null_ex(dst, ("compilererrors"), (sizeof("compilererrors")));
	
	assert(src->compilererrors == NULL);

	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "compilererrors", sizeof("compilererrors"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "compilererrors"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "compilererrors", sizeof("compilererrors"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->compilererrors);
	xc_autocheck_done_count ++;

#endif



	}

	
#endif
#ifndef ZEND_COMPILE_DELAYED_BINDING
		
	/* PROCESS(zend_bool,have_early_binding) */

	assert(sizeof(zend_bool) == sizeof(src->have_early_binding));
		
	
	
		add_assoc_bool_ex(dst, ("have_early_binding"), (sizeof("have_early_binding")), src->have_early_binding ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_early_binding", sizeof("have_early_binding"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_early_binding"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_early_binding", sizeof("have_early_binding"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_early_binding);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
		add_assoc_bool_ex(dst, ("have_references"), (sizeof("have_references")), src->have_references ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_data_php_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	


		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_entry_data_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_entry_data_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_xc_entry_t */
	
 	  	 	static void inline 	xc_dasm_xc_entry_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_t*)NULL)->next) + sizeof(((xc_entry_t*)NULL)->size) + sizeof(((xc_entry_t*)NULL)->ctime) + sizeof(((xc_entry_t*)NULL)->atime) + sizeof(((xc_entry_t*)NULL)->dtime) + sizeof(((xc_entry_t*)NULL)->hits) + sizeof(((xc_entry_t*)NULL)->ttl) + sizeof(((xc_entry_t*)NULL)->name)  ), assert_count = 8;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "next","size","ctime","atime","dtime","hits","ttl","name" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			/* skip */
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "next", sizeof("next"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "next"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "next", sizeof("next"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->next);
	xc_autocheck_done_count ++;

#endif


		
	/* PROCESS(size_t,size) */

	assert(sizeof(size_t) == sizeof(src->size));
		
	
	
		add_assoc_long_ex(dst, ("size"), (sizeof("size")), src->size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "size", sizeof("size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "size", sizeof("size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->size);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(time_t,ctime) */

	assert(sizeof(time_t) == sizeof(src->ctime));
		
	
	
		add_assoc_long_ex(dst, ("ctime"), (sizeof("ctime")), src->ctime);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ctime", sizeof("ctime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ctime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ctime", sizeof("ctime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ctime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,atime) */

	assert(sizeof(time_t) == sizeof(src->atime));
		
	
	
		add_assoc_long_ex(dst, ("atime"), (sizeof("atime")), src->atime);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "atime", sizeof("atime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "atime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "atime", sizeof("atime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->atime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,dtime) */

	assert(sizeof(time_t) == sizeof(src->dtime));
		
	
	
		add_assoc_long_ex(dst, ("dtime"), (sizeof("dtime")), src->dtime);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dtime", sizeof("dtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "dtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dtime", sizeof("dtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(long,ttl) */

	assert(sizeof(long) == sizeof(src->ttl));
		
	
	
		add_assoc_long_ex(dst, ("ttl"), (sizeof("ttl")), src->ttl);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ttl", sizeof("ttl"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "ttl"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ttl", sizeof("ttl"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ttl);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(zend_ulong,hits) */

	assert(sizeof(zend_ulong) == sizeof(src->hits));
		
	
	
		add_assoc_long_ex(dst, ("hits"), (sizeof("hits")), src->hits);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "hits", sizeof("hits"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "hits"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "hits", sizeof("hits"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->hits);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name", sizeof("name"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_t : %s\n"
				, __FILE__, __LINE__
				, "name"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name", sizeof("name"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name);
	xc_autocheck_done_count ++;

#endif

 
		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_entry_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_entry_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_xc_entry_php_t */
	
		/* export:  	  	 	void 	xc_dasm_xc_entry_php_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_php_t * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_xc_entry_php_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_php_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_php_t*)NULL)->entry) + sizeof(((xc_entry_php_t*)NULL)->php) + sizeof(((xc_entry_php_t*)NULL)->refcount) + sizeof(((xc_entry_php_t*)NULL)->file_mtime) + sizeof(((xc_entry_php_t*)NULL)->file_size) + sizeof(((xc_entry_php_t*)NULL)->file_device) + sizeof(((xc_entry_php_t*)NULL)->file_inode) + sizeof(((xc_entry_php_t*)NULL)->filepath_len) + sizeof(((xc_entry_php_t*)NULL)->filepath) + sizeof(((xc_entry_php_t*)NULL)->dirpath_len) + sizeof(((xc_entry_php_t*)NULL)->dirpath)  ), assert_count = 11;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","php","refcount","file_mtime","file_size","file_device","file_inode","filepath_len","filepath","dirpath_len","dirpath" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_xc_entry_t(
		
		
		
		
		dasm, zv, & src->entry
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("entry"), (sizeof("entry")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif



	
	
	

			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
		add_assoc_long_ex(dst, ("entry.name.str.len"), (sizeof("entry.name.str.len")), src->entry.name.str.len);
		
	
	

	

		
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
			add_assoc_null_ex(dst, ("entry.name.str.val"), (sizeof("entry.name.str.val")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("entry.name.str.val"), (sizeof("entry.name.str.val")), (char *) src->entry.name.str.val, src->entry.name.str.len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

		
	
	
	


	
	
	/* STRUCT_P(xc_entry_data_php_t,php) */

	if (src->php) {
		
		
	
	/* STRUCT_P_EX(xc_entry_data_php_t,DST(`php'),SRC(`php'),php,) */

	
	

	
	assert(sizeof(xc_entry_data_php_t) == sizeof(( src->php)[0]));
	
	
	
		
	
	
	/* allocate */
	
	
	
	
	
	


	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_xc_entry_data_php_t(
		
		
		
		
		dasm, zv,  src->php
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("php"), (sizeof("php")), zv);
		
	} while (0);
	

	
	

	}
	else {
		
		
	add_assoc_null_ex(dst, ("php"), (sizeof("php")));
	
	assert(src->php == NULL);

	}
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "php", sizeof("php"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "php"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "php", sizeof("php"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->php);
	xc_autocheck_done_count ++;

#endif




		
	/* PROCESS(long,refcount) */

	assert(sizeof(long) == sizeof(src->refcount));
		
	
	
		add_assoc_long_ex(dst, ("refcount"), (sizeof("refcount")), src->refcount);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "refcount", sizeof("refcount"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "refcount"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "refcount", sizeof("refcount"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->refcount);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(time_t,file_mtime) */

	assert(sizeof(time_t) == sizeof(src->file_mtime));
		
	
	
		add_assoc_long_ex(dst, ("file_mtime"), (sizeof("file_mtime")), src->file_mtime);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_mtime", sizeof("file_mtime"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_mtime"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_mtime", sizeof("file_mtime"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_mtime);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_size) */

	assert(sizeof(size_t) == sizeof(src->file_size));
		
	
	
		add_assoc_long_ex(dst, ("file_size"), (sizeof("file_size")), src->file_size);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_size", sizeof("file_size"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_size"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_size", sizeof("file_size"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_size);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_device) */

	assert(sizeof(size_t) == sizeof(src->file_device));
		
	
	
		add_assoc_long_ex(dst, ("file_device"), (sizeof("file_device")), src->file_device);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_device", sizeof("file_device"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_device"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_device", sizeof("file_device"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_device);
	xc_autocheck_done_count ++;

#endif



	

		
	/* PROCESS(size_t,file_inode) */

	assert(sizeof(size_t) == sizeof(src->file_inode));
		
	
	
		add_assoc_long_ex(dst, ("file_inode"), (sizeof("file_inode")), src->file_inode);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "file_inode", sizeof("file_inode"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "file_inode"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "file_inode", sizeof("file_inode"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->file_inode);
	xc_autocheck_done_count ++;

#endif



	


		
	/* PROCESS(size_t,filepath_len) */

	assert(sizeof(size_t) == sizeof(src->filepath_len));
		
	
	
		add_assoc_long_ex(dst, ("filepath_len"), (sizeof("filepath_len")), src->filepath_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath_len", sizeof("filepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath_len", sizeof("filepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(filepath,filepath_len) */
 
	/* PROC_STRING_N(filepath,filepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "filepath", sizeof("filepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "filepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "filepath", sizeof("filepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->filepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->filepath == NULL) {
		
		
			add_assoc_null_ex(dst, ("filepath"), (sizeof("filepath")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("filepath"), (sizeof("filepath")), (char *) src->filepath, src->filepath_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(size_t,dirpath_len) */

	assert(sizeof(size_t) == sizeof(src->dirpath_len));
		
	
	
		add_assoc_long_ex(dst, ("dirpath_len"), (sizeof("dirpath_len")), src->dirpath_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath_len", sizeof("dirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath_len", sizeof("dirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_STRING_L(dirpath,dirpath_len) */
 
	/* PROC_STRING_N(dirpath,dirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "dirpath", sizeof("dirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "dirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "dirpath", sizeof("dirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->dirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->dirpath == NULL) {
		
		
			add_assoc_null_ex(dst, ("dirpath"), (sizeof("dirpath")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("dirpath"), (sizeof("dirpath")), (char *) src->dirpath, src->dirpath_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

#ifdef IS_UNICODE
		
	/* PROCESS(int,ufilepath_len) */

	assert(sizeof(int) == sizeof(src->ufilepath_len));
		
	
	
		add_assoc_long_ex(dst, ("ufilepath_len"), (sizeof("ufilepath_len")), src->ufilepath_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath_len", sizeof("ufilepath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath_len", sizeof("ufilepath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(ufilepath,ufilepath_len) */
 
	/* PROC_USTRING_N(ufilepath,ufilepath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "ufilepath", sizeof("ufilepath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "ufilepath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "ufilepath", sizeof("ufilepath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->ufilepath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->ufilepath == NULL) {
		
		
			add_assoc_null_ex(dst, ("ufilepath"), (sizeof("ufilepath")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("ufilepath"), (sizeof("ufilepath")), (char *) src->ufilepath, src->ufilepath_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

		
	/* PROCESS(int,udirpath_len) */

	assert(sizeof(int) == sizeof(src->udirpath_len));
		
	
	
		add_assoc_long_ex(dst, ("udirpath_len"), (sizeof("udirpath_len")), src->udirpath_len);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath_len", sizeof("udirpath_len"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath_len"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath_len", sizeof("udirpath_len"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath_len);
	xc_autocheck_done_count ++;

#endif



	

	
	/* PROC_USTRING_L(udirpath,udirpath_len) */
 
	/* PROC_USTRING_N(udirpath,udirpath_len + 1) */
 
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "udirpath", sizeof("udirpath"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_php_t : %s\n"
				, __FILE__, __LINE__
				, "udirpath"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "udirpath", sizeof("udirpath"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->udirpath);
	xc_autocheck_done_count ++;

#endif


	
	
	
	
	
	
	
	
	if (src->udirpath == NULL) {
		
		
			add_assoc_null_ex(dst, ("udirpath"), (sizeof("udirpath")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("udirpath"), (sizeof("udirpath")), (char *) src->udirpath, src->udirpath_len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

#endif

		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_entry_php_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_entry_php_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


	
	

/* {{{ xc_dasm_xc_entry_var_t */
	
		/* export:  	  	 	void 	xc_dasm_xc_entry_var_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_var_t * const src 		TSRMLS_DC 	); 	 :export */
	
 	  	 	void 	xc_dasm_xc_entry_var_t( 		 		 		 		 		xc_dasm_t *dasm, zval *dst, const xc_entry_var_t * const src 		TSRMLS_DC 	) 	
	{
		
		
#ifndef NDEBUG
		
			/* {{{ init assert */
			
			
						
				
			
			
				
			
			int xc_autocheck_assert_size = (  sizeof(((xc_entry_var_t*)NULL)->entry) + sizeof(((xc_entry_var_t*)NULL)->value) + sizeof(((xc_entry_var_t*)NULL)->have_references)  ), assert_count = 3;
			int xc_autocheck_done_size = 0, xc_autocheck_done_count = 0;
			
				const char *xc_autocheck_assert_names[] = { "entry","value","have_references" };
				size_t xc_autocheck_assert_names_count = sizeof(xc_autocheck_assert_names) / sizeof(xc_autocheck_assert_names[0]);
			
			zend_bool xc_autocheck_skip = 0;
			HashTable xc_autocheck_done_names;
			zend_hash_init(&xc_autocheck_done_names, 0, NULL, NULL, 0);
			/* }}} */
			
			
			do {
		
#endif

		

		

		
			
	
	/* STRUCT(xc_entry_t,entry) */

	assert(sizeof(xc_entry_t) == sizeof(src->entry));
	
	
	
	/* STRUCT_P_EX(xc_entry_t,DST(`entry'),SRC(`entry'),entry,,&) */

	
	

	
	assert(sizeof(xc_entry_t) == sizeof((& src->entry)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_xc_entry_t(
		
		
		
		
		dasm, zv, & src->entry
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("entry"), (sizeof("entry")), zv);
		
	} while (0);
	

	
	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "entry", sizeof("entry"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "entry"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "entry", sizeof("entry"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->entry);
	xc_autocheck_done_count ++;

#endif




#ifdef IS_UNICODE
		
	/* PROCESS(zend_uchar,name_type) */

	assert(sizeof(zend_uchar) == sizeof(src->name_type));
		
	
	
		add_assoc_long_ex(dst, ("name_type"), (sizeof("name_type")), src->name_type);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "name_type", sizeof("name_type"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "name_type"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "name_type", sizeof("name_type"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->name_type);
	xc_autocheck_done_count ++;

#endif



	

#endif
		
	
	

#ifdef IS_UNICODE
		if (src->name_type == IS_UNICODE) {
				
	/* PROCESS(int32_t,entry.name.ustr.len) */

	assert(sizeof(int32_t) == sizeof(src->entry.name.ustr.len));
		
	
	
		add_assoc_long_ex(dst, ("entry.name.ustr.len"), (sizeof("entry.name.ustr.len")), src->entry.name.ustr.len);
		
	
	

	

		}
		else {
				
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
		add_assoc_long_ex(dst, ("entry.name.str.len"), (sizeof("entry.name.str.len")), src->entry.name.str.len);
		
	
	

	

		}
#else
			
	/* PROCESS(int,entry.name.str.len) */

	assert(sizeof(int) == sizeof(src->entry.name.str.len));
		
	
	
		add_assoc_long_ex(dst, ("entry.name.str.len"), (sizeof("entry.name.str.len")), src->entry.name.str.len);
		
	
	

	

#endif
		
#ifdef IS_UNICODE
			
	/* PROC_ZSTRING_L(name_type,entry.name.uni.val,entry.name.uni.len) */
 
	
	/* PROC_ZSTRING_N(name_type,entry.name.uni.val,entry.name.uni.len,len) */

#ifdef IS_UNICODE
	
	
	
		if (src->name_type == IS_UNICODE) {
			
	
	
	
	
	
	
	
	
	if (ZSTR_U(src->entry.name.uni.val) == NULL) {
		
		
			add_assoc_null_ex(dst, ("entry.name.uni.val"), (sizeof("entry.name.uni.val")));
		
	}
	else {
		
		
		
		
		
		
			
				add_assoc_unicodel_ex(dst, ("entry.name.uni.val"), (sizeof("entry.name.uni.val")), ZSTR_U(src->entry.name.uni.val), src->entry.name.uni.len + 1-1, 1);
				
		
	}
	
	
	
	
	
	
	

		}
		else {
			
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
			add_assoc_null_ex(dst, ("entry.name.uni.val"), (sizeof("entry.name.uni.val")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("entry.name.uni.val"), (sizeof("entry.name.uni.val")), (char *) ZSTR_S(src->entry.name.uni.val), src->entry.name.uni.len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

		}
	
#else
	
	
	
	
	
	
	
	
	
	
	if (ZSTR_S(src->entry.name.uni.val) == NULL) {
		
		
			add_assoc_null_ex(dst, ("entry.name.uni.val"), (sizeof("entry.name.uni.val")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("entry.name.uni.val"), (sizeof("entry.name.uni.val")), (char *) ZSTR_S(src->entry.name.uni.val), src->entry.name.uni.len + 1-1, 1);
					
			
		
	}
	
	
	
	
	
	
	

#endif
	

#else
			
	/* PROC_STRING_L(entry.name.str.val,entry.name.str.len) */
 
	/* PROC_STRING_N(entry.name.str.val,entry.name.str.len + 1) */
 
	
	
	
	
	
	
	
	
	if (src->entry.name.str.val == NULL) {
		
		
			add_assoc_null_ex(dst, ("entry.name.str.val"), (sizeof("entry.name.str.val")));
		
	}
	else {
		
		
		
		
		
		
			 				
					add_assoc_stringl_ex(dst, ("entry.name.str.val"), (sizeof("entry.name.str.val")), (char *) src->entry.name.str.val, src->entry.name.str.len + 1-1, 1);
				
			
		
	}
	
	
	
	
	
	
	

#endif
		
	
	
	

	
	
	
	
	/* STRUCT_P_EX(zval_ptr,dst->value,src->value,value,,&) */

	
	

	
	assert(sizeof(zval_ptr) == sizeof((& src->value)[0]));
	

	do {
		zval *zv;
		ALLOC_INIT_ZVAL(zv);
		array_init(zv);
	

	xc_dasm_zval_ptr(
		
		
		
		
		dasm, zv, & src->value
		TSRMLS_CC
	);

	
		
			add_assoc_zval_ex(dst, ("value"), (sizeof("value")), zv);
		
	} while (0);
	

	
	

		
	/* PROCESS(zend_bool,have_references) */

	assert(sizeof(zend_bool) == sizeof(src->have_references));
		
	
	
		add_assoc_bool_ex(dst, ("have_references"), (sizeof("have_references")), src->have_references ? 1 : 0);
		
	
	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "have_references", sizeof("have_references"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "have_references"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "have_references", sizeof("have_references"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->have_references);
	xc_autocheck_done_count ++;

#endif



	

	
	
	
#ifndef NDEBUG
				if (zend_u_hash_exists(&xc_autocheck_done_names, IS_STRING, "value", sizeof("value"))) {
			fprintf(stderr
				, "duplicate field at %s #%d xc_dasm_xc_entry_var_t : %s\n"
				, __FILE__, __LINE__
				, "value"
				);
		}
		else {
			zend_uchar b = 1;
			zend_hash_add(&xc_autocheck_done_names, "value", sizeof("value"), (void*)&b, sizeof(b), NULL);
		}
	
#endif

	
#ifndef NDEBUG
			xc_autocheck_done_size += (int) sizeof(src->value);
	xc_autocheck_done_count ++;

#endif



		
		
#ifndef NDEBUG
		
		/* {{{ autocheck */
		if (!xc_autocheck_skip) {
			int name_check_errors = xc_check_names(__FILE__, __LINE__, "xc_dasm_xc_entry_var_t", xc_autocheck_assert_names, xc_autocheck_assert_names_count, &xc_autocheck_done_names);

			if (xc_autocheck_done_count != assert_count) {
				fprintf(stderr
					, "count assertion failed at %s #%d xc_dasm_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_count, assert_count, xc_autocheck_done_count - assert_count
					);
			}
			if (xc_autocheck_done_size != xc_autocheck_assert_size) {
				fprintf(stderr
					, "size assertion failed at %s #%d xc_dasm_xc_entry_var_t : unexpected:%d - expecting:%d = %d != 0\n"
					, __FILE__, __LINE__
					, xc_autocheck_done_size, xc_autocheck_assert_size, xc_autocheck_done_size - xc_autocheck_assert_size
					);
			}
			if (name_check_errors || xc_autocheck_done_count != assert_count || xc_autocheck_done_size != xc_autocheck_assert_size) {
				assert(0);
			}
		}
		zend_hash_destroy(&xc_autocheck_done_names);
		/* }}} */
		
#endif

		
			
			
			
		
		
		
#ifndef NDEBUG
		
			} while (0);
		
#endif

		
	}
/* }}} */
	


#endif /* HAVE_XCACHE_DISASSEMBLER */


